SystemOrganization addCategory: #'Tests-Bugs'!
SystemOrganization addCategory: #'Tests-Compiler'!
SystemOrganization addCategory: #'Tests-Dependencies'!
SystemOrganization addCategory: #'Tests-Digital Signatures'!
SystemOrganization addCategory: #'Tests-Environments'!
SystemOrganization addCategory: #'Tests-Exceptions'!
SystemOrganization addCategory: #'Tests-FilePackage'!
SystemOrganization addCategory: #'Tests-Files'!
SystemOrganization addCategory: #'Tests-Finalization'!
SystemOrganization addCategory: #'Tests-Hex'!
SystemOrganization addCategory: #'Tests-Installer-Core'!
SystemOrganization addCategory: #'Tests-Localization'!
SystemOrganization addCategory: #'Tests-Monticello'!
SystemOrganization addCategory: #'Tests-Monticello-Mocks'!
SystemOrganization addCategory: #'Tests-Monticello-Utils'!
SystemOrganization addCategory: #'Tests-Object Events'!
SystemOrganization addCategory: #'Tests-ObjectsAsMethods'!
SystemOrganization addCategory: #'Tests-PrimCallController'!
SystemOrganization addCategory: #'Tests-Release'!
SystemOrganization addCategory: #'Tests-System-Object Storage'!
SystemOrganization addCategory: #'Tests-System-Support'!
SystemOrganization addCategory: #'Tests-Utilities'!
SystemOrganization addCategory: #'Tests-VM'!
SystemOrganization addCategory: #'Tests-System-Digital Signatures'!
SystemOrganization addCategory: #'Tests-System-Preferences'!
(PackageInfo named: 'Tests') postscript: 'PackageOrganizer default unregisterPackageNamed: ''Test-Monticello-Mocks''.
{ MCMockPackageInfo. MCEmptyPackageInfo. MCDirtyPackageInfo } do: [ :each | 
	each initialize ]
'!

TestSuite subclass: #InstallerTestSuite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Installer-Core'!

!InstallerTestSuite methodsFor: 'initialize-release' stamp: 'cmm 8/31/2013 16:16'!
ensureTestMethods
	"Ensure InstallerTest has test methods for each externally-loadable package defined by Installer.  By generating these methods, they don't have to be maintained separately."
	^ (Installer methodsInCategory: 'package-definitions') do:
		[ : each | (InstallerTest canUnderstand: each) ifFalse:
			[ InstallerTest 
				compile:
					(String streamContents:
						[ : stream | stream
							 nextPutAll: 'test'; nextPutAll: each;
							 cr; tab;
							 nextPutAll: 'Installer new merge: #'; nextPutAll: each ])
				classified: '*generated' ] ]! !

!InstallerTestSuite methodsFor: 'initialize-release' stamp: 'cmm 8/8/2013 22:35'!
initialize
	super initialize.
	self ensureTestMethods! !

Notification subclass: #MyTestNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Exceptions'!

Notification subclass: #ParserRemovedUnusedTemps
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Exceptions'!

!InflateStream methodsFor: '*Tests-Compression' stamp: 'ar 12/4/1998 02:03'!
profile
	"Profile the decompression speed"
	MessageTally spyOn:[self decompressAll].! !

Object subclass: #AbstractObjectsAsMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-ObjectsAsMethods'!

!AbstractObjectsAsMethod methodsFor: 'as yet unclassified' stamp: 'md 3/1/2006 14:25'!
flushCache! !

!AbstractObjectsAsMethod methodsFor: 'as yet unclassified' stamp: 'md 3/1/2006 14:23'!
methodClass: aMethodClass! !

!AbstractObjectsAsMethod methodsFor: 'as yet unclassified' stamp: 'md 3/1/2006 14:23'!
selector: aSymbol! !

AbstractObjectsAsMethod subclass: #ObjectsAsMethodsExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-ObjectsAsMethods'!

!ObjectsAsMethodsExample methodsFor: 'as yet unclassified' stamp: 'ar 5/17/2003 20:16'!
add: a with: b
	^a + b! !

!ObjectsAsMethodsExample methodsFor: 'as yet unclassified' stamp: 'ar 5/17/2003 20:16'!
answer42
	^42! !

!ObjectsAsMethodsExample methodsFor: 'as yet unclassified' stamp: 'md 3/1/2006 19:37'!
run: oldSelector with: arguments in: aReceiver
	^self perform: oldSelector withArguments: arguments! !

Object subclass: #BadEqualer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Utilities'!

!BadEqualer commentStamp: 'mjr 8/20/2003 13:28' prior: 0!
I am an object that doesn't always report #= correctly.  Used for testing the EqualityTester.!

!BadEqualer methodsFor: 'comparing' stamp: 'mjr 8/20/2003 18:56'!
= other 
	self class = other class
		ifFalse: [^ false].
	^ 100 atRandom < 30 ! !

Object subclass: #BadHasher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Utilities'!

!BadHasher commentStamp: 'mjr 8/20/2003 13:28' prior: 0!
I am an object that doesn't always hash correctly.  I am used for testing the HashTester.!

!BadHasher methodsFor: 'comparing' stamp: 'mjr 8/20/2003 18:56'!
hash
	"answer with a different hash some of the time"
	100 atRandom < 30
		ifTrue: [^ 1]. 
	^ 2! !

Object subclass: #ExceptionTester
	instanceVariableNames: 'log suiteLog iterationsBeforeTimeout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Exceptions'!

!ExceptionTester methodsFor: 'accessing' stamp: 'dtl 6/1/2004 21:53'!
basicANSISignaledExceptionTestSelectors

	^#( simpleIsNestedTest simpleOuterTest doubleOuterTest doubleOuterPassTest doublePassOuterTest simplePassTest simpleResignalAsTest simpleResumeTest simpleRetryTest simpleRetryUsingTest simpleReturnTest)! !

!ExceptionTester methodsFor: 'accessing' stamp: 'brp 10/21/2004 17:54'!
basicTestSelectors
	^ #(#simpleEnsureTest #simpleEnsureTestWithNotification #simpleEnsureTestWithUparrow #simpleEnsureTestWithError #signalFromHandlerActionTest #resumableFallOffTheEndHandler #nonResumableFallOffTheEndHandler #doubleResumeTest #simpleTimeoutWithZeroDurationTest #simpleTimeoutTest simpleNoTimeoutTest)! !

!ExceptionTester methodsFor: 'logging' stamp: 'tfei 6/8/1999 09:17'!
clearLog

	log := nil! !

!ExceptionTester methodsFor: 'logging' stamp: 'tfei 6/7/1999 15:16'!
contents

	^( self log
		inject: (WriteStream on: (String new: 80))
		into: 
			[:result :item |
			result 
				cr; 
				nextPutAll: item;
				yourself] ) contents! !

!ExceptionTester methodsFor: 'pseudo actions' stamp: 'tfei 6/8/1999 09:13'!
doSomething

	self log: self doSomethingString! !

!ExceptionTester methodsFor: 'pseudo actions' stamp: 'tfei 6/8/1999 09:14'!
doSomethingElse

	self log: self doSomethingElseString! !

!ExceptionTester methodsFor: 'accessing' stamp: 'tfei 6/8/1999 09:14'!
doSomethingElseString

	^'Do something else.'! !

!ExceptionTester methodsFor: 'pseudo actions' stamp: 'tfei 6/8/1999 09:14'!
doSomethingExceptional

	self log: self doSomethingExceptionalString! !

!ExceptionTester methodsFor: 'accessing' stamp: 'tfei 6/8/1999 09:14'!
doSomethingExceptionalString

	^'Do something exceptional.'! !

!ExceptionTester methodsFor: 'accessing' stamp: 'tfei 6/8/1999 09:13'!
doSomethingString

	^'Do something.'! !

!ExceptionTester methodsFor: 'pseudo actions' stamp: 'tfei 6/8/1999 09:15'!
doYetAnotherThing

	self log: self doYetAnotherThingString! !

!ExceptionTester methodsFor: 'accessing' stamp: 'tfei 6/8/1999 09:15'!
doYetAnotherThingString

	^'Do yet another thing.'! !

!ExceptionTester methodsFor: 'signaledException tests' stamp: 'dtl 6/1/2004 21:51'!
doubleOuterPassTest
	"uses #resume"

	[[[self doSomething.
	MyTestNotification signal.
	self doSomethingExceptional]
		on: MyTestNotification
		do: [:ex | ex outer.
			self doSomethingElse]]
			on: MyTestNotification
			do: [:ex | ex pass.
				self doSomethingExceptional]]
				on: MyTestNotification
				do: [:ex | self doYetAnotherThing. ex resume]! !

!ExceptionTester methodsFor: 'signaledException results' stamp: 'dtl 6/1/2004 21:56'!
doubleOuterPassTestResults

	^OrderedCollection new
		add: self doSomethingString;
		add: self doYetAnotherThingString;
		add: self doSomethingElseString;
		yourself! !

!ExceptionTester methodsFor: 'signaledException tests' stamp: 'dtl 6/1/2004 21:49'!
doubleOuterTest
	"uses #resume"

	[[[self doSomething.
	MyTestNotification signal.
	self doSomethingExceptional]
		on: MyTestNotification
		do: [:ex | ex outer.
			self doSomethingExceptional]]
			on: MyTestNotification
			do: [:ex | ex outer.
				self doSomethingElse]]
				on: MyTestNotification
				do: [:ex | self doYetAnotherThing. ex resume]! !

!ExceptionTester methodsFor: 'signaledException tests' stamp: 'dtl 6/1/2004 21:52'!
doublePassOuterTest
	"uses #resume"

	[[[self doSomething.
	MyTestNotification signal.
	self doSomethingExceptional]
		on: MyTestNotification
		do: [:ex | ex pass.
			self doSomethingExceptional]]
			on: MyTestNotification
			do: [:ex | ex outer.
				self doSomethingElse]]
				on: MyTestNotification
				do: [:ex | self doYetAnotherThing. ex resume]! !

!ExceptionTester methodsFor: 'signaledException results' stamp: 'dtl 6/1/2004 21:56'!
doublePassOuterTestResults

	^OrderedCollection new
		add: self doSomethingString;
		add: self doYetAnotherThingString;
		add: self doSomethingElseString;
		yourself! !

!ExceptionTester methodsFor: 'tests' stamp: 'tfei 11/14/1999 17:26'!
doubleResumeTest

       [self doSomething.
       MyResumableTestError signal.
       self doSomethingElse.
       MyResumableTestError signal.
       self doYetAnotherThing]
               on: MyResumableTestError
               do: [:ex | ex resume].! !

!ExceptionTester methodsFor: 'results' stamp: 'tfei 11/14/1999 17:29'!
doubleResumeTestResults

       ^OrderedCollection new
               add: self doSomethingString;
               add: self doSomethingElseString;
               add: self doYetAnotherThingString;
               yourself! !

!ExceptionTester methodsFor: 'accessing' stamp: 'brp 10/21/2004 17:15'!
iterationsBeforeTimeout

	^ iterationsBeforeTimeout! !

!ExceptionTester methodsFor: 'accessing' stamp: 'brp 10/21/2004 17:16'!
iterationsBeforeTimeout: anInteger

	iterationsBeforeTimeout := anInteger! !

!ExceptionTester methodsFor: 'accessing' stamp: 'tfei 6/7/1999 15:03'!
log

	log == nil
		ifTrue: [log := OrderedCollection new].
	^log! !

!ExceptionTester methodsFor: 'logging' stamp: 'tfei 6/7/1999 15:03'!
log: aString

	self log add: aString! !

!ExceptionTester methodsFor: 'logging' stamp: 'tfei 6/12/1999 23:07'!
logTest: aSelector

	self suiteLog add: aSelector! !

!ExceptionTester methodsFor: 'logging' stamp: 'tfei 6/8/1999 09:38'!
logTestResult: aString

	| index |
	index := self suiteLog size.
	self suiteLog 
		at: index
		put: ((self suiteLog at: index), ' ', aString)! !

!ExceptionTester methodsFor: 'pseudo actions' stamp: 'tfei 6/8/1999 09:16'!
methodWithError

	MyTestError signal: self testString! !

!ExceptionTester methodsFor: 'pseudo actions' stamp: 'tfei 6/8/1999 09:16'!
methodWithNotification

	MyTestNotification signal: self testString! !

!ExceptionTester methodsFor: 'tests' stamp: 'tfei 6/7/1999 13:43'!
nonResumableFallOffTheEndHandler
	
	[self doSomething.
	MyTestError signal.
	self doSomethingElse]
		on: MyTestError
		do: [:ex | self doSomethingExceptional].
	self doYetAnotherThing! !

!ExceptionTester methodsFor: 'results' stamp: 'tfei 6/8/1999 09:21'!
nonResumableFallOffTheEndHandlerResults

	^OrderedCollection new
		add: self doSomethingString;
		add: self doSomethingExceptionalString;
		add: self doYetAnotherThingString;
		yourself! !

!ExceptionTester methodsFor: 'tests' stamp: 'tfei 6/9/1999 16:07'!
resumableFallOffTheEndHandler

	[self doSomething.
	MyTestNotification signal.
	self doSomethingElse]
		on: MyTestNotification
		do: [:ex | self doSomethingExceptional].
	self doYetAnotherThing! !

!ExceptionTester methodsFor: 'results' stamp: 'tfei 8/19/1999 02:39'!
resumableFallOffTheEndHandlerResults

	^OrderedCollection new
		add: self doSomethingString;
		add: self doSomethingExceptionalString;
		add: self doYetAnotherThingString;
		yourself! !

!ExceptionTester methodsFor: 'suites' stamp: 'tfei 6/13/1999 01:25'!
runAllTests
	"ExceptionTester new runAllTests"

	self
		runBasicTests;
		runBasicANSISignaledExceptionTests! !

!ExceptionTester methodsFor: 'suites' stamp: 'tfei 6/12/1999 23:54'!
runBasicANSISignaledExceptionTests

	self basicANSISignaledExceptionTestSelectors
		do:
			[:eachTestSelector |
			self runTest: eachTestSelector]! !

!ExceptionTester methodsFor: 'suites' stamp: 'tfei 6/9/1999 16:06'!
runBasicTests

	self basicTestSelectors
		do:
			[:eachTestSelector |
			self runTest: eachTestSelector]! !

!ExceptionTester methodsFor: 'testing' stamp: 'brp 10/21/2004 17:40'!
runTest: aSelector

	| actualResult expectedResult |
	[ self 
		logTest: aSelector;
		clearLog;
		perform: aSelector ]
			on: MyTestError do: 
				[ :ex | self log: 'Unhandled Exception'.
					ex return: nil ].

	actualResult	:= self log.
	expectedResult := self perform: (aSelector, #Results) asSymbol.

	actualResult = expectedResult
		ifTrue: [self logTestResult: 'succeeded']
		ifFalse: [self logTestResult: 'failed' ].
! !

!ExceptionTester methodsFor: 'tests' stamp: 'tfei 8/19/1999 01:39'!
signalFromHandlerActionTest

	[self doSomething.
	MyTestError signal.
	self doSomethingElse]
		on: MyTestError
		do:
			[self doYetAnotherThing.
			MyTestError signal]! !

!ExceptionTester methodsFor: 'results' stamp: 'tfei 8/19/1999 01:51'!
signalFromHandlerActionTestResults

	^OrderedCollection new
		add: self doSomethingString;
		add: self doYetAnotherThingString;
		add: 'Unhandled Exception';
		yourself! !

!ExceptionTester methodsFor: 'tests' stamp: 'tfei 6/8/1999 09:44'!
simpleEnsureTest

	[self doSomething.
	self doSomethingElse]
		ensure:
			[self doYetAnotherThing].
	! !

!ExceptionTester methodsFor: 'results' stamp: 'tfei 6/8/1999 09:47'!
simpleEnsureTestResults

	^OrderedCollection new
		add: self doSomethingString;
		add: self doSomethingElseString;
		add: self doYetAnotherThingString;
		yourself! !

!ExceptionTester methodsFor: 'tests' stamp: 'tfei 6/8/1999 12:50'!
simpleEnsureTestWithError

	[self doSomething.
	MyTestError signal.
	self doSomethingElse]
		ensure:
			[self doYetAnotherThing].
	! !

!ExceptionTester methodsFor: 'results' stamp: 'tfei 6/9/1999 17:44'!
simpleEnsureTestWithErrorResults

	^OrderedCollection new
		add: self doSomethingString;
		add: 'Unhandled Exception';
		add: self doYetAnotherThingString;
		yourself! !

!ExceptionTester methodsFor: 'tests' stamp: 'tfei 6/8/1999 10:15'!
simpleEnsureTestWithNotification

	[self doSomething.
	self methodWithNotification.
	self doSomethingElse]
		ensure:
			[self doYetAnotherThing].
	! !

!ExceptionTester methodsFor: 'results' stamp: 'tfei 6/8/1999 10:13'!
simpleEnsureTestWithNotificationResults

	^OrderedCollection new
		add: self doSomethingString;
		add: self doSomethingElseString;
		add: self doYetAnotherThingString;
		yourself! !

!ExceptionTester methodsFor: 'tests' stamp: 'tfei 6/9/1999 16:04'!
simpleEnsureTestWithUparrow

	[self doSomething.
	true ifTrue: [^nil].
	self doSomethingElse]
		ensure:
			[self doYetAnotherThing].
	! !

!ExceptionTester methodsFor: 'results' stamp: 'tfei 6/8/1999 18:55'!
simpleEnsureTestWithUparrowResults

	^OrderedCollection new
		add: self doSomethingString;
"		add: self doSomethingElseString;"
		add: self doYetAnotherThingString;
		yourself! !

!ExceptionTester methodsFor: 'signaledException tests' stamp: 'tfei 6/13/1999 01:27'!
simpleIsNestedTest
	"uses resignalAs:"

	[self doSomething.
	MyTestError signal.
	self doSomethingElse]
		on: MyTestError
		do:
			[:ex |
			ex isNested "expecting to detect handler in #runTest:"
				ifTrue:
					[self doYetAnotherThing.
					ex resignalAs: MyTestNotification new]]! !

!ExceptionTester methodsFor: 'signaledException results' stamp: 'tfei 6/13/1999 01:09'!
simpleIsNestedTestResults

	^OrderedCollection new
		add: self doSomethingString;
		add: self doYetAnotherThingString;
		add: self doSomethingElseString;
		yourself! !

!ExceptionTester methodsFor: 'tests' stamp: 'brp 10/22/2004 12:00'!
simpleNoTimeoutTest

	[ self doSomething ]
		valueWithin: 1 day onTimeout:
			[ self doSomethingElse ].
	! !

!ExceptionTester methodsFor: 'results' stamp: 'brp 10/21/2004 16:54'!
simpleNoTimeoutTestResults

	^OrderedCollection new
		add: self doSomethingString;
		yourself! !

!ExceptionTester methodsFor: 'signaledException tests' stamp: 'tpr 5/27/2004 21:50'!
simpleOuterTest
	"uses #resume"

	[[self doSomething.
	MyTestNotification signal.
	"self doSomethingElse"
	self doSomethingExceptional]
		on: MyTestNotification
		do: [:ex | ex outer. self doSomethingElse]]
				on: MyTestNotification
				do: [:ex | self doYetAnotherThing. ex resume]! !

!ExceptionTester methodsFor: 'signaledException results' stamp: 'tfei 6/13/1999 01:10'!
simpleOuterTestResults

	^OrderedCollection new
		add: self doSomethingString;
		add: self doYetAnotherThingString;
		add: self doSomethingElseString;
		yourself! !

!ExceptionTester methodsFor: 'signaledException tests' stamp: 'tfei 6/13/1999 00:37'!
simplePassTest

	[self doSomething.
	MyTestError signal.
	self doSomethingElse]
		on: MyTestError
		do:
			[:ex |
			self doYetAnotherThing.
			ex pass "expecting handler in #runTest:"]! !

!ExceptionTester methodsFor: 'signaledException results' stamp: 'tfei 6/13/1999 01:10'!
simplePassTestResults

	^OrderedCollection new
		add: self doSomethingString;
		add: self doYetAnotherThingString;
		add: 'Unhandled Exception';
		yourself! !

!ExceptionTester methodsFor: 'signaledException tests' stamp: 'tfei 6/13/1999 02:12'!
simpleResignalAsTest
	"ExceptionTester new simpleResignalAsTest"

	[self doSomething.
	MyTestNotification signal.
	self doSomethingElse]
		on: MyTestNotification
		do:
			[:ex | ex resignalAs: MyTestError new]! !

!ExceptionTester methodsFor: 'signaledException results' stamp: 'tfei 6/13/1999 01:11'!
simpleResignalAsTestResults

	^OrderedCollection new
		add: self doSomethingString;
		add: 'Unhandled Exception';
		yourself! !

!ExceptionTester methodsFor: 'signaledException tests' stamp: 'nice 12/27/2009 21:06'!
simpleResumeTest
	"see if we can resume twice"
	
	[ | it |
	self doSomething.
	it := MyResumableTestError signal.
	it = 3 ifTrue: [self doSomethingElse].
	it := MyResumableTestError signal.
	it = 3 ifTrue: [self doSomethingElse].
	]
		on: MyResumableTestError
		do:
			[:ex |
			self doYetAnotherThing.
			ex resume: 3]! !

!ExceptionTester methodsFor: 'signaledException results' stamp: 'RAA 12/8/2000 12:59'!
simpleResumeTestResults

	"see if we can resume twice"

	^OrderedCollection new
			add: self doSomethingString;
			add: self doYetAnotherThingString;
			add: self doSomethingElseString;
			add: self doYetAnotherThingString;
			add: self doSomethingElseString;
			yourself! !

!ExceptionTester methodsFor: 'signaledException tests' stamp: 'tfei 6/13/1999 01:02'!
simpleRetryTest

	| theMeaningOfLife |
	theMeaningOfLife := nil.
	[self doSomething.
	theMeaningOfLife == nil
		ifTrue: [MyTestError signal]
		ifFalse: [self doSomethingElse]]
			on: MyTestError
			do:
				[:ex |
				theMeaningOfLife := 42.
				self doYetAnotherThing.
				ex retry]! !

!ExceptionTester methodsFor: 'signaledException results' stamp: 'tfei 6/13/1999 01:23'!
simpleRetryTestResults

	^OrderedCollection new
			add: self doSomethingString;
			add: self doYetAnotherThingString;
			add: self doSomethingString;
			add: self doSomethingElseString;
			yourself! !

!ExceptionTester methodsFor: 'signaledException tests' stamp: 'tfei 6/13/1999 01:03'!
simpleRetryUsingTest

	[self doSomething.
	MyTestError signal.
	self doSomethingElse]
		on: MyTestError
		do:
			[:ex | ex retryUsing: [self doYetAnotherThing]]! !

!ExceptionTester methodsFor: 'signaledException results' stamp: 'tfei 6/13/1999 01:23'!
simpleRetryUsingTestResults

	^OrderedCollection new
			add: self doSomethingString;
			add: self doYetAnotherThingString;
			yourself! !

!ExceptionTester methodsFor: 'signaledException tests' stamp: 'tfei 6/13/1999 00:59'!
simpleReturnTest

	| it |
	it :=
		[self doSomething.
		MyTestError signal.
		self doSomethingElse]
			on: MyTestError
			do: [:ex | ex return: 3].
	it = 3 ifTrue: [self doYetAnotherThing]! !

!ExceptionTester methodsFor: 'signaledException results' stamp: 'tfei 6/13/1999 02:22'!
simpleReturnTestResults

	^OrderedCollection new
		add: self doSomethingString;
		add: self doYetAnotherThingString;
		yourself! !

!ExceptionTester methodsFor: 'tests' stamp: 'brp 10/22/2004 12:00'!
simpleTimeoutTest

	| n |
	[1 to: 1000000 do: [ :i | n := i. self doSomething ] ]
		valueWithin: 50 milliSeconds onTimeout:
			[ self iterationsBeforeTimeout: n.
			self doSomethingElse ]! !

!ExceptionTester methodsFor: 'results' stamp: 'brp 10/21/2004 17:44'!
simpleTimeoutTestResults

	| things |
	things := OrderedCollection new: self iterationsBeforeTimeout.

	self iterationsBeforeTimeout timesRepeat: [ things add: self  doSomethingString ].
	things add: self doSomethingElseString.

	^ things! !

!ExceptionTester methodsFor: 'tests' stamp: 'brp 10/22/2004 12:00'!
simpleTimeoutWithZeroDurationTest

	[ self doSomething ]
		valueWithin: 0 seconds onTimeout:
			[ self doSomethingElse ].
	! !

!ExceptionTester methodsFor: 'results' stamp: 'brp 10/21/2004 16:52'!
simpleTimeoutWithZeroDurationTestResults

	^OrderedCollection new
		add: self doSomethingElseString;
		yourself! !

!ExceptionTester methodsFor: 'accessing' stamp: 'tfei 6/8/1999 09:30'!
suiteLog

	suiteLog == nil
		ifTrue: [suiteLog := OrderedCollection new].
	^suiteLog! !

!ExceptionTester methodsFor: 'accessing' stamp: 'tfei 6/8/1999 09:15'!
testString

	^'This is only a test.'! !

!ExceptionTester methodsFor: 'tests' stamp: 'tfei 6/7/1999 14:28'!
warningTest

	self log: 'About to signal warning.'.
	Warning signal: 'Ouch'.
	self log: 'Warning signal handled and resumed.'! !

Object subclass: #FakeObjectOut
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-System-Support'!

!FakeObjectOut commentStamp: 'fbs 9/2/2013 11:08' prior: 0!
RecentMessagesTest uses me to show how it behaves when recent submissions contain references to methods in classes no longer in the image.!

!FakeObjectOut methodsFor: 'as yet unclassified' stamp: 'fbs 9/2/2013 11:07'!
doesNotUnderstand: aMessage
	^ aMessage sendTo: self class ! !

!FakeObjectOut methodsFor: 'as yet unclassified' stamp: 'fbs 9/2/2013 11:07'!
isInMemory
	^ false.! !

Object subclass: #MCMock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello-Mocks'!

!MCMock class methodsFor: 'as yet unclassified' stamp: 'cwp 7/21/2003 19:40'!
wantsChangeSetLogging
	^ false! !

MCMock subclass: #MCMockClassA
	instanceVariableNames: 'ivar'
	classVariableNames: 'CVar'
	poolDictionaries: ''
	category: 'Tests-Monticello-Mocks'!

!MCMockClassA commentStamp: 'cwp 8/10/2003 16:43' prior: 0!
This is a mock class. The Monticello tests manipulated it to simulate a developer modifying code in the image.!

MCMockClassA subclass: #MCMockASubclass
	instanceVariableNames: 'x'
	classVariableNames: 'Y'
	poolDictionaries: ''
	category: 'Tests-Monticello-Mocks'!

!MCMockASubclass methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
variables
	^ x + Y + MCMockClassA! !

!MCMockASubclass methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
variables2
	^ ivar + CVar! !

!MCMockClassA class methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 02:31'!
cVar
	^ CVar! !

!MCMockClassA class methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 02:31'!
initialize
	CVar := #initialized! !

!MCMockClassA class methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
one

	^ 1! !

!MCMockClassA class methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 02:32'!
touchCVar
	CVar := #touched! !

!MCMockClassA methodsFor: 'numeric' stamp: ''!
a
	^ 'a'! !

!MCMockClassA methodsFor: 'numeric' stamp: ''!
b
	^ 'b'! !

!MCMockClassA methodsFor: 'numeric' stamp: ''!
c
	^ 'c'! !

!MCMockClassA methodsFor: 'as yet classified' stamp: ''!
d
	^ 'd'! !

!MCMockClassA methodsFor: 'boolean' stamp: 'cwp 7/13/2003 02:49'!
falsehood
	^ false! !

!MCMockClassA methodsFor: 'boolean' stamp: 'ab 7/7/2003 23:21'!
moreTruth

	^ true! !

!MCMockClassA methodsFor: 'numeric' stamp: 'cwp 8/2/2003 17:26'!
one
	^ 1! !

!MCMockClassA methodsFor: 'drag''n''drop' stamp: 'avi 9/23/2003 17:14'!
q! !

!MCMockClassA methodsFor: 'boolean' stamp: ''!
truth
	^ true! !

!MCMockClassA methodsFor: 'numeric' stamp: 'avi 9/11/2004 15:59'!
two
	^ 2! !

MCMock subclass: #MCMockDependentItem
	instanceVariableNames: 'name provides requires'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello-Mocks'!

!MCMockDependentItem methodsFor: 'as yet unclassified' stamp: 'bf 5/20/2005 16:15'!
<= other
	^ self name <= other name! !

!MCMockDependentItem methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
name

	^ name! !

!MCMockDependentItem methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
name: aString

	name := aString! !

!MCMockDependentItem methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
provides: anArray

	provides := anArray! !

!MCMockDependentItem methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
provisions

	^ provides ifNil: [#()]! !

!MCMockDependentItem methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
requirements

	^ requires ifNil: [#()]! !

!MCMockDependentItem methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
requires: anArray

	requires := anArray! !

Object subclass: #MCMockClassD
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello-Mocks'!

!MCMockClassD methodsFor: 'as yet unclassified' stamp: 'cwp 7/8/2003 21:21'!
one
	^ 1! !

Object variableSubclass: #MCMockClassE
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello-Mocks'!

!MCMockClassE class methodsFor: 'as yet unclassified' stamp: 'cwp 7/8/2003 21:22'!
two
	^ 2! !

Object subclass: #MCMockClassF
	instanceVariableNames: ''
	classVariableNames: 'Foo'
	poolDictionaries: ''
	category: 'Tests-Monticello-Mocks'!

Object variableWordSubclass: #MCMockClassG
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello-Mocks'!

Object variableByteSubclass: #MCMockClassH
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello-Mocks'!

Object weakSubclass: #MCMockClassI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello-Mocks'!

Object subclass: #MCMockDependency
	instanceVariableNames: 'name children hasResolution'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello-Utils'!

!MCMockDependency class methodsFor: 'instance creation' stamp: 'cwp 11/7/2004 14:43'!
fromTree: anArray 
	^ self new initializeWithTree: anArray! !

!MCMockDependency methodsFor: 'comparing' stamp: 'cwp 11/7/2004 13:32'!
= other
	^ self name = other name! !

!MCMockDependency methodsFor: 'accessing' stamp: 'cwp 11/7/2004 14:43'!
children
	^ children collect: [:ea | self class fromTree: ea]! !

!MCMockDependency methodsFor: 'resolving' stamp: 'cwp 11/7/2004 14:42'!
hasResolution
	^ hasResolution! !

!MCMockDependency methodsFor: 'comparing' stamp: 'cwp 11/7/2004 13:33'!
hash
	^ self name hash! !

!MCMockDependency methodsFor: 'accessing' stamp: 'cwp 11/7/2004 14:46'!
initializeWithTree: expr
	expr isSymbol
		ifTrue: [name := expr.
				children := Array new.
				hasResolution := true.]
		ifFalse: [name := expr first.
				expr second isSymbol
					ifTrue: [hasResolution := false.
							children := Array new]
					ifFalse: [hasResolution := true.
							children := expr second]]! !

!MCMockDependency methodsFor: 'mocks' stamp: 'cwp 11/7/2004 14:41'!
mockVersionInfo
	^ MCVersionInfo
		name: self name
		id: (self uuidForName: name)
		message: ''
		date: nil
		time: nil
		author: ''
		ancestors: #()! !

!MCMockDependency methodsFor: 'accessing' stamp: 'cwp 11/7/2004 14:38'!
name
	^ name! !

!MCMockDependency methodsFor: 'resolving' stamp: 'cwp 11/7/2004 14:16'!
resolve
	^ self hasResolution
		ifTrue: [MCVersion new
					setPackage: MCSnapshotResource mockPackage
					info: self mockVersionInfo
					snapshot: MCSnapshotResource current snapshot
					dependencies: self children]
		ifFalse: [nil]! !

!MCMockDependency methodsFor: 'mocks' stamp: 'nk 2/22/2005 21:17'!
uuidForName: aName 
	| nm id |
	nm := aName asString.
	id := '00000000-0000-0000-0000-0000000000' 
				, (nm size = 1 ifTrue: [nm , '0'] ifFalse: [nm]).
	^UUID fromString: id! !

Object subclass: #PreferencesTestExample
	instanceVariableNames: ''
	classVariableNames: 'BooleanPref ColorPref NumericPref TextPref'
	poolDictionaries: ''
	category: 'Tests-System-Preferences'!

!PreferencesTestExample commentStamp: 'ar 3/3/2009 22:40' prior: 0!
This class provides an example for how to use preference pragmas.!

!PreferencesTestExample class methodsFor: 'preferences' stamp: 'ar 8/4/2009 20:52'!
booleanPref
	<preference: 'Boolean Preference Example'
		category: 'Examples'
		description: 'A simple example for a boolean preference  (see PreferenceExample>>booleanPref)'
		type: #Boolean>
	^BooleanPref! !

!PreferencesTestExample class methodsFor: 'preferences' stamp: 'ar 3/3/2009 22:35'!
booleanPref: aBool
	BooleanPref := aBool.
	self inform: 'The new preference value is: ', aBool asString.! !

!PreferencesTestExample class methodsFor: 'preferences' stamp: 'ar 8/4/2009 20:52'!
colorPref
	<preference: 'Color Preference Example'
		category: 'Examples'
		description: 'A simple example for a color preference (see PreferenceExample>>colorPref)'
		type: #Color>
	^ColorPref! !

!PreferencesTestExample class methodsFor: 'preferences' stamp: 'ar 3/3/2009 22:36'!
colorPref: aColor
	ColorPref := aColor.
	self inform: 'The new preference value is: ', aColor asString.! !

!PreferencesTestExample class methodsFor: 'preferences' stamp: 'ar 3/5/2009 20:09'!
initialize	"PreferenceExample initialize"
	"Initialize the default values and register preferences"
	TextPref := 'Hello World'.
	NumericPref := 1234.
	BooleanPref := true.
	ColorPref := Color green.! !

!PreferencesTestExample class methodsFor: 'preferences' stamp: 'ar 8/4/2009 20:52'!
numericPref
	<preference: 'Numeric Preference Example'
		category: 'Examples'
		description: 'A simple example for a numeric preference (see PreferenceExample>>numericPref)'
		type: #Number>
	^NumericPref! !

!PreferencesTestExample class methodsFor: 'preferences' stamp: 'ar 3/3/2009 22:36'!
numericPref: aNumber
	NumericPref := aNumber.
	self inform: 'The new preference value is: ', aNumber asString.! !

!PreferencesTestExample class methodsFor: 'preferences' stamp: 'ar 8/4/2009 20:52'!
textPref
	<preference: 'Textual Preference Example'
		category: 'Examples'
		description: 'A simple example for a textual preference (see PreferenceExample>>textPref)'
		type: #String>
	^TextPref! !

!PreferencesTestExample class methodsFor: 'preferences' stamp: 'mt 8/27/2015 08:50'!
textPref: aString
	TextPref := aString.! !

Object subclass: #PrimCallControllerAbstract
	instanceVariableNames: 'treatedMethods logStream changeStatusOfFailedCallsFlag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-PrimCallController'!

!PrimCallControllerAbstract commentStamp: 'fbs 7/25/2013 07:16' prior: 0!
A PrimCallController (PCC) serves for switching external prim calls (primitiveExternalCall) on and off: this is an abstract class, instantiate one of the subclasses PCCByLiterals and PCCByCompilation.

External prim calls are used to access internal and external modules (plugins) as shown by
	Smalltalk listLoadedModules.
	Smalltalk listBuiltinModules.
Note: not loaded external modules (since they have not been called so far) are not shown by these methods.

Highlight: dis/en-abling prims by a PCC works for both internal and external modules!!


To help you choosing the right subclass, some properties are listed in the following table:

Functionality/Property							|	PCCByLiterals	PCCByCompilation
------------------------------------------------------------------------------------------------------
testing plugins									|		suited			not suited
permanent disabling of external prim calls		|		no				yes
------------------------------------------------------------------------------------------------------
method changes visible in changeset				|		no				yes
enabling survives snapshot/compilation			|		yes				yes
disabling survives snapshot/compilation			|		no				yes
speed disabling									|		fast				medium
speed enabling									|		fast				slow
CompiledMethod pointer valid after en/dis-abling	|		yes				no
									
Important: Be careful with mixing the use of different PCCs!! PCCByLiterals does not see prims disabled by PCCByCompilation and vice versa. For playing around you should start with PCCByLiterals; use PCCByCompilation only, if you know what you are doing!!

In protocols 'ui controlling', 'ui logging' and 'ui querying' (please look into this class) are the most important user interface methods. Thereafter the methods in 'ui testing' could be of interest.


Useful expressions:

Controlling:
	"Factorial example"
	| pcc tDisabled tEnabled tEnabled2 |
	pcc := PCCByLiterals new logStream: Transcript. "logStream set here for more info"
	pcc disableCallsIntoModule: 'LargeIntegers'.
	tDisabled := [1000 factorial] timeToRun.
	pcc enableDisabled.
	tEnabled := [1000 factorial] timeToRun.
	tEnabled2 := [1000 factorial] timeToRun.
	{tDisabled. tEnabled. tEnabled2}
Note: You shouldn't switch off module 'LargeIntegers' for a longer time, since this slows down your system.

Querying:
	PCCByLiterals new methodsWithCall.								"all calls"
	PCCByLiterals new methodsWithCall: 'prim1'.						"call in all modules or without module"
	PCCByLiterals new methodsWithCallIntoModule: nil.				"all calls without module"
	PCCByLiterals new methodsWithCallIntoModule: 'LargeIntegers'.	"all calls into module 'LargeIntegers'"
	PCCByLiterals new
		methodsWithCallIntoModule: 'LargeIntegers'
		forClass: Integer.							"all calls into module 'LargeIntegers' in class Integer"
	PCCByLiterals new
		methodsWithCallIntoModule: 'LargeIntegers'
		forClasses: Integer withAllSubclasses.		"all calls into module 'LargeIntegers' in class Integer withAllSubclasses"

	| pcc | (pcc := PCCByLiterals new) methodsWithCall
			collect: [:mRef | {mRef. pcc extractCallModuleNames: mRef}].


Structure:
 treatedMethods				Dictionary of MethodReferences->#disabled/#enabled
								-- contains changed methods and how they are changed last
 logStream					WriteStream -- shows info about changed methods ifNotNil
 changeStatusOfFailedCalls	Boolean -- if status of failed calls should be changed, default is false!

PrimCallControllerAbstract subclass: #PCCByCompilation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-PrimCallController'!

!PCCByCompilation commentStamp: 'sr 6/16/2004 09:00' prior: 0!
This class is for switching external prim calls (primitiveExternalCall) on and off.

It is best suited for permanently switching plugin calls off while preserving the possibility to switch them on later. For plugin testing purposes you probably should use PCCByLiterals for temporarily switch on/off them instead.

It works on a source code basis by compilation:
	Disabling works by putting an enabled prim call into a special comment followed by a recompile to transform it into a disabled one.
	Enabling works by pulling the disabled prim call out of the special comment followed by a recompile to transform it into an enabled one.

As a consequence, enabling of prims only works with method sources containing the mentioned special comment, which normally has been generated by this tool for disabling the corresponding prim.

Please look into superclass PrimCallControllerAbstract for more info and the user interface.

Structure:
 No instVars here: look into superclass.

Implementation note:
To harden it for sunit testing purposes some special accessing of the source code has been necessary: to avoid accessing different processes a sources file at once, followed by generating garbage, the process priority of actions leading to these accesses has been increased (sunit tests run in the background). A better solution would be to introduce a source file locking mechanism.!

!PCCByCompilation methodsFor: 'string constants' stamp: 'sr 6/7/2004 03:30'!
comment
	^ '{prim disabled by ', self className, '} '! !

!PCCByCompilation methodsFor: 'private' stamp: 'sr 6/7/2004 03:26'!
disabled2EnabledPrimMethodString: aSourceString 
	| start stop primString extract |
	extract := self extractDisabledPrimStringFrom: aSourceString.
	primString := extract at: 1.
	start := extract at: 2.
	stop := start + primString size - 1.
	^ aSourceString
		copyReplaceFrom: start
		to: stop
		with: (self disabled2EnabledPrimString: primString)! !

!PCCByCompilation methodsFor: 'private' stamp: 'sr 6/7/2004 03:26'!
disabled2EnabledPrimString: aDisabledPrimString
	"remove comment quotes and comment after first comment quote"
	| enabledPrimString |
	enabledPrimString := aDisabledPrimString copyFrom: self comment size + 2 to: aDisabledPrimString size - 1.
	^ enabledPrimString! !

!PCCByCompilation methodsFor: 'string constants' stamp: 'sr 6/7/2004 03:31'!
disabledPrimStartString
	^ '"', self comment, self enabledPrimStartString! !

!PCCByCompilation methodsFor: 'string constants' stamp: 'sr 6/7/2004 03:31'!
disabledPrimStopChar
	"end of disabling comment"
	^ $"! !

!PCCByCompilation methodsFor: 'private' stamp: 'sr 6/7/2004 03:28'!
enabled2DisabledPrimMethodString: aSourceString 
	| start stop primString extract |
	extract := self extractEnabledPrimStringFrom: aSourceString.
	primString := extract at: 1.
	start := extract at: 2.
	stop := start + primString size - 1.
	^ aSourceString
		copyReplaceFrom: start
		to: stop
		with: (self enabled2DisabledPrimString: primString)! !

!PCCByCompilation methodsFor: 'private' stamp: 'sr 6/7/2004 03:28'!
enabled2DisabledPrimString: anEnabledPrimString 
	| disabledPrimString |
	disabledPrimString := '"' , self comment , anEnabledPrimString , '"'.
	^ disabledPrimString! !

!PCCByCompilation methodsFor: 'string constants' stamp: 'sr 6/7/2004 03:31'!
enabledPrimStartString
	^ '<primitive:'! !

!PCCByCompilation methodsFor: 'string constants' stamp: 'sr 6/7/2004 03:31'!
enabledPrimStopChar
	^ $>! !

!PCCByCompilation methodsFor: 'ui testing' stamp: 'sr 6/11/2004 07:26'!
existsCallIn: aMethodRef 
	"Here existsCompiledCallIn: (see also comment there) is sufficient to 
	query for enabled and failed, but not for disabled prim calls: so check 
	for disabled ones in sources, too."
	^ (self existsCompiledCallIn: aMethodRef)
		or: [self existsDisabledCallIn: aMethodRef]! !

!PCCByCompilation methodsFor: 'ui testing' stamp: 'nice 12/26/2009 19:02'!
existsDisabledCallIn: aMethodRef 
	| src |
	^ (self existsCompiledCallIn: aMethodRef) not
		and: ["higher priority to avoid source file accessing errors"
			src := [aMethodRef sourceString]
				valueAt: self higherPriority.
			self methodSourceContainsDisabledCall: src]! !

!PCCByCompilation methodsFor: 'ui querying' stamp: 'sr 6/11/2004 06:33'!
extractCallModuleNames: aMethodRef 
	^ (self existsCompiledCallIn: aMethodRef)
		ifTrue: [self extractCallModuleNamesFromLiterals: aMethodRef]
		ifFalse: [| src | 
			"try source"
			"higher priority to avoid source file accessing errors"
			[src := aMethodRef sourceString]
				valueAt: self higherPriority.
			self extractCallNamesFromPrimString: ((self extractDisabledPrimStringFrom: src)
					ifNil: ["no disabled prim string found"
						^ nil]) first]! !

!PCCByCompilation methodsFor: 'private' stamp: 'sr 6/7/2004 03:28'!
extractCallNamesFromPrimString: aString
	"method works for both enabled and disabled prim strings"
	"<primitive: 'doSomething' module:'ModuleFoo'"
	| tokens |
	tokens := aString findTokens: ''''.
	^ (tokens at: 2) -> (tokens at: 4 ifAbsent: [nil])! !

!PCCByCompilation methodsFor: 'private' stamp: 'sr 6/11/2004 07:10'!
extractDisabledPrimStringFrom: aSourceString 
	| startString start stop |
	startString := self disabledPrimStartString.
	start := aSourceString findString: startString.
	start = 0
		ifTrue: [^ nil].
	stop := aSourceString indexOf: self disabledPrimStopChar startingAt: start + startString size.
	stop = 0
		ifTrue: [^ nil].
	^ {aSourceString copyFrom: start to: stop. start}! !

!PCCByCompilation methodsFor: 'private' stamp: 'sr 6/7/2004 03:29'!
extractEnabledPrimStringFrom: aSourceString 
	| startString start stop |
	startString := self enabledPrimStartString.
	start := aSourceString findString: startString.
	start = 0
		ifTrue: [^ nil].
	stop := aSourceString indexOf: self enabledPrimStopChar startingAt: start + startString size.
	stop = 0
		ifTrue: [^ nil].
	^ {aSourceString copyFrom: start to: stop. start}! !

!PCCByCompilation methodsFor: 'private' stamp: 'sr 6/7/2004 03:29'!
higherPriority
	"this priority seems to be necessary to avoid source file accessing errors"
	^ Processor userSchedulingPriority + 1! !

!PCCByCompilation methodsFor: 'private' stamp: 'sr 6/11/2004 07:06'!
methodSourceContainsDisabledCall: methodSource 
	^ (methodSource findString: self disabledPrimStartString)
		~= 0! !

!PCCByCompilation methodsFor: 'ui querying' stamp: 'sr 6/14/2004 21:38'!
methodsWithCall
	"Expensive!! For just querying the system unaffected by an instance of 
	this class use PCCByLiterals instead."
	^ self methodsWithCompiledCall , self methodsWithDisabledCall! !

!PCCByCompilation methodsFor: 'ui querying' stamp: 'nice 12/17/2013 23:26'!
methodsWithDisabledCall
	"Answer a SortedCollection of all the methods that contain, in source  
	code, the substring indicating a disabled prim."
	"The alternative implementation  
		^ SystemNavigation new allMethodsWithSourceString: self disabledPrimStartString
									matchCase: true  
	also searches in class comments."
	| list string |
	string := self disabledPrimStartString.
	list := Set new.
	'Searching all method source code...'
		displayProgressFrom: 0
		to: Smalltalk classNames size * 2 "classes with their metaclasses"
		during: [:bar | | classCount |
			classCount := 0.
			SystemNavigation default
				allBehaviorsDo: [:class | 
					bar value: (classCount := classCount + 1).
					class
						selectorsDo: [:sel | 
							| src | 
							"higher priority to avoid source file accessing  
							errors"
							src := [class sourceCodeAt: sel]
								valueAt: self higherPriority.
							(src
								findString: string
								startingAt: 1
								caseSensitive: true) > 0
								ifTrue: [list add: (MethodReference class: class selector: sel)]]]].
	^ list asSortedCollection! !

!PCCByCompilation methodsFor: 'private user interface' stamp: 'ul 9/29/2012 09:46'!
privateDisableCallIn: aMethodRef 
	"Disables enabled or failed external prim call by recompiling method 
	with prim call commented out, will be called by superclass."
	| src newMethodSource |
	"higher priority to avoid source file accessing errors"
	src := [aMethodRef sourceString]
		valueAt: self higherPriority.
	newMethodSource := self enabled2DisabledPrimMethodString: src.
	"higher priority to avoid source file accessing errors"
	[aMethodRef actualClass
		compile: newMethodSource
		classified: (aMethodRef actualClass whichCategoryIncludesSelector: aMethodRef methodSymbol)
		withStamp: aMethodRef timeStamp
		notifying: nil]
		valueAt: self higherPriority! !

!PCCByCompilation methodsFor: 'private user interface' stamp: 'ul 9/29/2012 09:46'!
privateEnableCallIn: aMethodRef 
	"Enables disabled external prim call by recompiling method with prim  
	call taken from disabling comment, will be called by superclass."
	| src newMethodSource |
	"higher priority to avoid source file accessing errors"
	src := [aMethodRef sourceString]
		valueAt: self higherPriority.
	newMethodSource := self disabled2EnabledPrimMethodString: src.
	"higher priority to avoid source file accessing errors"
	[aMethodRef actualClass
		compile: newMethodSource
		classified: (aMethodRef actualClass whichCategoryIncludesSelector: aMethodRef methodSymbol)
		withStamp: aMethodRef timeStamp
		notifying: nil]
		valueAt: self higherPriority! !

PrimCallControllerAbstract subclass: #PCCByLiterals
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-PrimCallController'!

!PCCByLiterals commentStamp: 'sr 6/16/2004 09:14' prior: 0!
This class is for switching external prim calls (primitiveExternalCall) on and off.

It is best suited for plugin testing purposes with temporarily switching plugin calls off and on. For permanently switching plugin calls off while preserving the possibility to switch them on later, you should use PCCByCompilation instead.

It works by manipulating literals in the CompiledMethods:
	Disabling works by changing the function index in the first literal of the CompiledMethod to a negative value (-2). This leads to a fast fail (value -2 is used for disabling to make a difference to the standard failed value of -1).
	Enabling works by changing the function index in the first literal of the CompiledMethod to 0, followed by flushing the method cache. This enforces a fresh lookup.

Please look into superclass PrimCallControllerAbstract for more info and the user interface.

Structure:
 No instVars here: look into superclass.!

!PCCByLiterals methodsFor: 'ui testing' stamp: 'sr 6/11/2004 07:04'!
existsCallIn: aMethodRef 
	"Here >>existsCompiledCallIn: (see also comment there) is sufficient to 
	query for all enabled, failed and disabled prim calls; for the by 
	compiler version it is not sufficient for disabled ones."
	^ self existsCompiledCallIn: aMethodRef! !

!PCCByLiterals methodsFor: 'ui testing' stamp: 'sr 6/11/2004 07:30'!
existsDisabledCallIn: aMethodRef 
	^ (self existsCompiledCallIn: aMethodRef)
		and: [(aMethodRef compiledMethod literals first at: 4)
				= -2]! !

!PCCByLiterals methodsFor: 'ui querying' stamp: 'sr 6/11/2004 07:04'!
extractCallModuleNames: aMethodRef 
	^ (self existsCallIn: aMethodRef)
		ifTrue: [self extractCallModuleNamesFromLiterals: aMethodRef]! !

!PCCByLiterals methodsFor: 'ui querying' stamp: 'sr 6/11/2004 07:05'!
methodsWithCall
	^ self methodsWithCompiledCall! !

!PCCByLiterals methodsFor: 'ui querying' stamp: 'sr 6/14/2004 21:24'!
methodsWithDisabledCall
	^ self methodsWithCompiledCall
		select: [:mRef | (mRef compiledMethod literals first at: 4)
				= -2]! !

!PCCByLiterals methodsFor: 'private user interface' stamp: 'sr 6/14/2004 01:35'!
privateDisableCallIn: aMethodRef 
	"Disables enabled or failed external prim call by filling function ref 
	literal with special fail value, will be called by superclass."
	aMethodRef compiledMethod literals first at: 4 put: -2! !

!PCCByLiterals methodsFor: 'private user interface' stamp: 'sr 6/14/2004 02:07'!
privateEnableCallIn: aMethodRef
	"Enables disabled external prim call."
	self privateEnableViaLiteralIn: aMethodRef! !

!PrimCallControllerAbstract methodsFor: 'private user interface' stamp: 'sr 6/15/2004 19:49'!
blockSelectCallName: callName

	^ [:mRef | (self extractCallModuleNames: mRef) key = callName]! !

!PrimCallControllerAbstract methodsFor: 'private user interface' stamp: 'sr 6/15/2004 20:45'!
blockSelectFailedCall
	"Precondition: mRef references compiledCall."
	^ [:mRef | (mRef compiledMethod literals first at: 4)
		= -1]! !

!PrimCallControllerAbstract methodsFor: 'private user interface' stamp: 'sr 6/15/2004 19:50'!
blockSelectModuleName: moduleNameOrNil

	^ [:mRef | (self extractCallModuleNames: mRef) value = moduleNameOrNil]! !

!PrimCallControllerAbstract methodsFor: 'private user interface' stamp: 'md 2/16/2006 14:02'!
changeCallCompiledMethod: aCompiledMethod enable: enableFlag 
	"Enables disabled or disables enabled external prim call by recompiling 
	method with prim call taken from comment."
	|  methodRef |
	methodRef := aCompiledMethod methodReference.
	enableFlag
		ifTrue: [self enableCallIn: methodRef]
		ifFalse: [self disableCallIn: methodRef]! !

!PrimCallControllerAbstract methodsFor: 'private user interface' stamp: 'fbs 5/21/2013 22:34'!
changeCallMethod: selector class: classOrSymbol enable: enableFlag 
	"Enables disabled or disables enabled external prim call by recompiling  
	method with prim call taken from comment."
	| methodRef |
	methodRef := MethodReference
				class: (classOrSymbol isSymbol
						ifTrue: [Smalltalk at: classOrSymbol]
						ifFalse: [classOrSymbol])
				selector: selector.
	enableFlag
		ifTrue: [self enableCallIn: methodRef]
		ifFalse: [self disableCallIn: methodRef]! !

!PrimCallControllerAbstract methodsFor: 'ui controlling' stamp: 'sr 6/15/2004 17:39'!
changeStatusOfFailedCalls
	"En/dis-able not only dis/en-abled calls, but also failed ones. Using this 
	feature can hide serious problems."
	changeStatusOfFailedCallsFlag := true! !

!PrimCallControllerAbstract methodsFor: 'accessing' stamp: 'sr 6/11/2004 04:52'!
changeStatusOfFailedCallsFlag
	^changeStatusOfFailedCallsFlag! !

!PrimCallControllerAbstract methodsFor: 'ui controlling' stamp: 'sr 6/15/2004 01:15'!
disableCallIn: aMethodRef 
	"Disables enabled external prim call."
	(self existsEnabledCallIn: aMethodRef)
		ifFalse: [self changeStatusOfFailedCallsFlag
				ifTrue: [(self existsFailedCallIn: aMethodRef)
						ifFalse: [^ self error: 'no enabled or failed prim call found']]
				ifFalse: [^ self error: 'no enabled prim call found']].
	self privateDisableCallIn: aMethodRef.
	self treatedMethods at: aMethodRef put: #disabled.
	self logStream
		ifNotNil: [self log: 'Call ' , (self extractCallModuleNames: aMethodRef) printString , ' in ' , aMethodRef actualClass name , '>>' , aMethodRef methodSymbol , ' disabled.']! !

!PrimCallControllerAbstract methodsFor: 'ui controlling' stamp: 'sr 6/15/2004 17:30'!
disableCallInCompiledMethod: aCompiledMethod 
	"Disables external prim call."
	self changeCallCompiledMethod: aCompiledMethod enable: false! !

!PrimCallControllerAbstract methodsFor: 'ui controlling' stamp: 'sr 6/15/2004 17:31'!
disableCallInMethod: selector class: classOrSymbol 
	"Disables external prim call."
	self
		changeCallMethod: selector
		class: classOrSymbol
		enable: false! !

!PrimCallControllerAbstract methodsFor: 'ui controlling' stamp: 'sr 6/15/2004 01:35'!
disableCallsIntoModule: aModule 
	"Disables enabled external prim calls in aModule."
	| methods |
	methods := self methodsWithEnabledCallIntoModule: aModule.
	self changeStatusOfFailedCallsFlag
		ifTrue: [methods
				addAll: (self methodsWithFailedCallIntoModule: aModule)].
	methods isEmpty
		ifTrue: [^ self error: 'no enabled '
					, (self changeStatusOfFailedCallsFlag	ifTrue: ['or failed ']	ifFalse: [''])
					, 'prim calls for module ' , aModule , ' found'].
	methods
		do: [:mRef | self disableCallIn: mRef]! !

!PrimCallControllerAbstract methodsFor: 'ui controlling' stamp: 'sr 6/15/2004 02:01'!
disableCallsIntoModule: aModule forClasses: classes 
	"Disables enabled external prim calls in aModule for classes."
	| methods |
	methods := self methodsWithEnabledCallIntoModule: aModule forClasses: classes.
	self changeStatusOfFailedCallsFlag
		ifTrue: [methods
				addAll: (self methodsWithFailedCallIntoModule: aModule forClasses: classes)].
	methods isEmpty
		ifTrue: [^ self error: 'no enabled '
					, (self changeStatusOfFailedCallsFlag	ifTrue: ['or failed ']	ifFalse: [''])
					, 'prim calls for module ' , aModule , ' in given classes found'].
	methods
		do: [:mRef | self disableCallIn: mRef]! !

!PrimCallControllerAbstract methodsFor: 'ui controlling' stamp: 'sr 6/11/2004 06:44'!
disableEnabled
	"Disables these external prim calls, which are formerly enabled by self."
	self treatedMethods
		keysAndValuesDo: [:mRef :status | status == #enabled
				ifTrue: [self disableCallIn: mRef]]! !

!PrimCallControllerAbstract methodsFor: 'ui controlling' stamp: 'sr 6/14/2004 02:05'!
enableCallIn: aMethodRef 
	"Enables disabled external prim call."
	(self existsDisabledCallIn: aMethodRef)
		ifTrue: [self privateEnableCallIn: aMethodRef]
		ifFalse: [self changeStatusOfFailedCallsFlag
				ifTrue: [(self existsFailedCallIn: aMethodRef)
						ifTrue: [self privateEnableViaLiteralIn: aMethodRef]
						ifFalse: [^ self error: 'no disabled or failed prim call found']]
				ifFalse: [^ self error: 'no disabled prim call found']].
	self treatedMethods at: aMethodRef put: #enabled.
	self logStream
		ifNotNil: [self log: 'Call ' , (self extractCallModuleNames: aMethodRef) printString , ' in ' , aMethodRef actualClass name , '>>' , aMethodRef methodSymbol , ' enabled.']! !

!PrimCallControllerAbstract methodsFor: 'ui controlling' stamp: 'sr 6/15/2004 17:31'!
enableCallInCompiledMethod: aCompiledMethod 
	"Enables disabled external prim call."
	self changeCallCompiledMethod: aCompiledMethod enable: true! !

!PrimCallControllerAbstract methodsFor: 'ui controlling' stamp: 'sr 6/15/2004 17:31'!
enableCallInMethod: selector class: classOrSymbol 
	"Enables disabled external prim call."
	self
		changeCallMethod: selector
		class: classOrSymbol
		enable: true! !

!PrimCallControllerAbstract methodsFor: 'ui controlling' stamp: 'sr 6/15/2004 01:36'!
enableCallsIntoModule: aModule 
	"Enables disabled external prim calls in aModule."
	| methods |
	methods := self methodsWithDisabledCallIntoModule: aModule.
	self changeStatusOfFailedCallsFlag
		ifTrue: [methods
				addAll: (self methodsWithFailedCallIntoModule: aModule)].
	methods isEmpty
		ifTrue: [^ self error: 'no disabled '
					, (self changeStatusOfFailedCallsFlag	ifTrue: ['or failed ']	ifFalse: [''])
					, 'prim calls for module ' , aModule , ' found'].
	methods
		do: [:mRef | self enableCallIn: mRef]! !

!PrimCallControllerAbstract methodsFor: 'ui controlling' stamp: 'sr 6/15/2004 02:01'!
enableCallsIntoModule: aModule forClasses: classes 
	"Enables disabled external prim calls in aModule for classes."
	| methods |
	methods := self methodsWithDisabledCallIntoModule: aModule forClasses: classes.
	self changeStatusOfFailedCallsFlag
		ifTrue: [methods
				addAll: (self methodsWithFailedCallIntoModule: aModule forClasses: classes)].
	methods isEmpty
		ifTrue: [^ self error: 'no disabled '
					, (self changeStatusOfFailedCallsFlag	ifTrue: ['or failed ']	ifFalse: [''])
					, 'prim calls for module ' , aModule , ' in given classes found'].
	methods
		do: [:mRef | self enableCallIn: mRef]! !

!PrimCallControllerAbstract methodsFor: 'ui controlling' stamp: 'sr 6/11/2004 06:42'!
enableDisabled
	"Enables these external prim calls, which are formerly disabled by self."
	self treatedMethods
		keysAndValuesDo: [:mRef :status | status == #disabled
				ifTrue: [self enableCallIn: mRef]]! !

!PrimCallControllerAbstract methodsFor: 'ui testing' stamp: 'sr 6/11/2004 07:31'!
existsCallIn: aMethodRef

	self subclassResponsibility! !

!PrimCallControllerAbstract methodsFor: 'private user interface' stamp: 'sr 6/11/2004 06:31'!
existsCompiledCallIn: aMethodRef 
	"This just means that there is a compiled in external prim call: from the 
	by compiler subclass point of view disabled prim calls not visible by 
	this method are also prim calls."
	^ aMethodRef compiledMethod primitive = 117! !

!PrimCallControllerAbstract methodsFor: 'ui testing' stamp: 'sr 6/9/2004 02:12'!
existsDisabledCallIn: aMethodRef 
	self subclassResponsibility! !

!PrimCallControllerAbstract methodsFor: 'ui testing' stamp: 'sr 6/11/2004 06:34'!
existsEnabledCallIn: aMethodRef 
	^ (self existsCompiledCallIn: aMethodRef)
		and: [(aMethodRef compiledMethod literals first at: 4)
				>= 0]! !

!PrimCallControllerAbstract methodsFor: 'ui testing' stamp: 'sr 6/15/2004 20:46'!
existsFailedCallIn: aMethodRef 
	^ (self existsCompiledCallIn: aMethodRef)
		and: [self blockSelectFailedCall value: aMethodRef]! !

!PrimCallControllerAbstract methodsFor: 'ui querying' stamp: 'sr 6/10/2004 21:15'!
extractCallModuleNames: aMethodRef
	"Returns prim call and module name as call->module Association."
	self subclassResponsibility! !

!PrimCallControllerAbstract methodsFor: 'private' stamp: 'sr 6/10/2004 21:32'!
extractCallModuleNamesFromLiterals: aMethodRef 
	| firstLiteral |
	firstLiteral := aMethodRef compiledMethod literals first.
	^ (firstLiteral at: 2)
		-> (firstLiteral at: 1)! !

!PrimCallControllerAbstract methodsFor: 'initialize-release' stamp: 'sr 6/11/2004 05:39'!
initialize
	treatedMethods := Dictionary new.
"	logStream := Transcript."
	changeStatusOfFailedCallsFlag := false! !

!PrimCallControllerAbstract methodsFor: 'logging' stamp: 'sr 6/11/2004 05:12'!
log: aString 
	self logStream
		ifNotNil: [self logStream cr; show: '[' , self className , '] ' , aString]! !

!PrimCallControllerAbstract methodsFor: 'accessing' stamp: 'sr 6/11/2004 04:12'!
logStream
	^logStream! !

!PrimCallControllerAbstract methodsFor: 'ui logging' stamp: 'sr 6/11/2004 04:17'!
logStream: aStreamOrNil 
	"If aStreamOrNil is notNil, there will be shown dis/en-abling prim call 
	info; nil means no logging."
	logStream := aStreamOrNil! !

!PrimCallControllerAbstract methodsFor: 'ui querying' stamp: 'sr 6/14/2004 21:27'!
methodsWithCall
	"Returns all methods containing external prim calls."
	self subclassResponsibility! !

!PrimCallControllerAbstract methodsFor: 'ui querying' stamp: 'sr 6/15/2004 02:15'!
methodsWithCall: primName
	^ self methodsWithCall: primName enabled: nil! !

!PrimCallControllerAbstract methodsFor: 'private user interface' stamp: 'sr 6/15/2004 19:59'!
methodsWithCall: callName enabled: enabledFlag 
	^ (self methodsWithCallEnabled: enabledFlag)
		select: (self blockSelectCallName: callName)! !

!PrimCallControllerAbstract methodsFor: 'ui querying' stamp: 'sr 6/15/2004 02:12'!
methodsWithCall: primName intoModule: moduleNameOrNil
	^ self methodsWithCall: primName intoModule: moduleNameOrNil enabled: nil! !

!PrimCallControllerAbstract methodsFor: 'private user interface' stamp: 'sr 6/15/2004 20:24'!
methodsWithCall: callName intoModule: moduleNameOrNil enabled: enabledFlag 
	^ ((self methodsWithCallEnabled: enabledFlag)
		select: (self blockSelectCallName: callName))
		select: (self blockSelectModuleName: moduleNameOrNil)! !

!PrimCallControllerAbstract methodsFor: 'private user interface' stamp: 'sr 6/14/2004 19:17'!
methodsWithCallEnabled: enabledFlag 
	^ enabledFlag
		ifNil: [self methodsWithCall]
		ifNotNil: [enabledFlag
				ifTrue: [self methodsWithEnabledCall]
				ifFalse: [self methodsWithDisabledCall]]! !

!PrimCallControllerAbstract methodsFor: 'private user interface' stamp: 'fbs 5/21/2013 22:35'!
methodsWithCallForClass: class enabled: enabledFlag 
	^ class selectors
		collect: [:sel | MethodReference class: class selector: sel]
		thenSelect: (enabledFlag
				ifNil: [[:mRef | self existsCallIn: mRef]]
				ifNotNil: [enabledFlag
						ifTrue: [[:mRef | self existsEnabledCallIn: mRef]]
						ifFalse: [[:mRef | self existsDisabledCallIn: mRef]]])! !

!PrimCallControllerAbstract methodsFor: 'private user interface' stamp: 'sr 6/13/2004 20:00'!
methodsWithCallForClasses: classes enabled: enabledFlag 
	| result |
	result := OrderedCollection new.
	classes
		do: [:class | result
				addAll: (self methodsWithCallForClass: class enabled: enabledFlag)].
	^ result! !

!PrimCallControllerAbstract methodsFor: 'ui querying' stamp: 'sr 6/14/2004 19:20'!
methodsWithCallIntoModule: moduleNameOrNil
	^ self methodsWithCallIntoModule: moduleNameOrNil enabled: nil! !

!PrimCallControllerAbstract methodsFor: 'private user interface' stamp: 'sr 6/15/2004 19:55'!
methodsWithCallIntoModule: moduleNameOrNil enabled: enabledFlag 
	^ (self methodsWithCallEnabled: enabledFlag)
		select: (self blockSelectModuleName: moduleNameOrNil)! !

!PrimCallControllerAbstract methodsFor: 'ui querying' stamp: 'sr 6/14/2004 19:30'!
methodsWithCallIntoModule: moduleNameOrNil forClass: class 
	^ self methodsWithCallIntoModule: moduleNameOrNil forClasses: {class}! !

!PrimCallControllerAbstract methodsFor: 'ui querying' stamp: 'sr 6/14/2004 19:30'!
methodsWithCallIntoModule: moduleNameOrNil forClasses: classes 
	^ self
		methodsWithCallIntoModule: moduleNameOrNil
		forClasses: classes
		enabled: nil! !

!PrimCallControllerAbstract methodsFor: 'private user interface' stamp: 'sr 6/15/2004 19:57'!
methodsWithCallIntoModule: moduleNameOrNil forClasses: classes enabled: enabledFlag 
	^ (self methodsWithCallForClasses: classes enabled: enabledFlag)
		select: (self blockSelectModuleName: moduleNameOrNil)! !

!PrimCallControllerAbstract methodsFor: 'ui querying' stamp: 'sr 6/14/2004 21:36'!
methodsWithCompiledCall
	"Returns all methods containing compiled in external prim calls.  
	If the by compilation subclass has disabled some, this method does *not*  
	return all methods containing prim calls (use >>methodsWithCall in this 
	case). "
	^ (SystemNavigation new
		allMethodsSelect: [:method | method primitive = 117])
		reject: [:method | method actualClass == ProtoObject]! !

!PrimCallControllerAbstract methodsFor: 'ui querying' stamp: 'sr 6/14/2004 21:28'!
methodsWithDisabledCall
	"Returns all methods containing disabled external prim calls."
	self subclassResponsibility! !

!PrimCallControllerAbstract methodsFor: 'ui querying' stamp: 'sr 6/11/2004 06:24'!
methodsWithDisabledCall: primName
	^ self methodsWithCall: primName enabled: false! !

!PrimCallControllerAbstract methodsFor: 'ui querying' stamp: 'sr 6/11/2004 06:25'!
methodsWithDisabledCall: primName intoModule: moduleNameOrNil
	^ self methodsWithCall: primName intoModule: moduleNameOrNil enabled: false! !

!PrimCallControllerAbstract methodsFor: 'ui querying' stamp: 'sr 6/11/2004 06:25'!
methodsWithDisabledCallIntoModule: moduleNameOrNil
	^ self methodsWithCallIntoModule: moduleNameOrNil enabled: false! !

!PrimCallControllerAbstract methodsFor: 'ui querying' stamp: 'sr 6/11/2004 06:24'!
methodsWithDisabledCallIntoModule: moduleNameOrNil forClass: class 
	^ self methodsWithDisabledCallIntoModule: moduleNameOrNil forClasses: {class}! !

!PrimCallControllerAbstract methodsFor: 'ui querying' stamp: 'sr 6/11/2004 06:20'!
methodsWithDisabledCallIntoModule: moduleNameOrNil forClasses: classes 
	^ self
		methodsWithCallIntoModule: moduleNameOrNil
		forClasses: classes
		enabled: false! !

!PrimCallControllerAbstract methodsFor: 'ui querying' stamp: 'sr 6/14/2004 21:28'!
methodsWithEnabledCall
	"Returns all methods containing enabled external prim calls."
	^ self methodsWithCompiledCall
		select: [:mRef | (mRef compiledMethod literals first at: 4)
				>= 0]! !

!PrimCallControllerAbstract methodsFor: 'ui querying' stamp: 'sr 6/11/2004 06:15'!
methodsWithEnabledCall: primName
	^ self methodsWithCall: primName enabled: true! !

!PrimCallControllerAbstract methodsFor: 'ui querying' stamp: 'sr 6/11/2004 06:16'!
methodsWithEnabledCall: primName intoModule: moduleNameOrNil
	^ self methodsWithCall: primName intoModule: moduleNameOrNil enabled: true! !

!PrimCallControllerAbstract methodsFor: 'ui querying' stamp: 'sr 6/11/2004 06:11'!
methodsWithEnabledCallIntoModule: moduleNameOrNil
	^ self methodsWithCallIntoModule: moduleNameOrNil enabled: true! !

!PrimCallControllerAbstract methodsFor: 'ui querying' stamp: 'sr 6/11/2004 05:46'!
methodsWithEnabledCallIntoModule: moduleNameOrNil forClass: class 
	^ self methodsWithEnabledCallIntoModule: moduleNameOrNil forClasses: {class}! !

!PrimCallControllerAbstract methodsFor: 'ui querying' stamp: 'sr 6/11/2004 06:07'!
methodsWithEnabledCallIntoModule: moduleNameOrNil forClasses: classes 
	^ self
		methodsWithCallIntoModule: moduleNameOrNil
		forClasses: classes
		enabled: true! !

!PrimCallControllerAbstract methodsFor: 'ui querying' stamp: 'sr 6/15/2004 20:47'!
methodsWithFailedCall
	"Returns all methods containing failed external prim calls."
	^ self methodsWithCompiledCall select: self blockSelectFailedCall! !

!PrimCallControllerAbstract methodsFor: 'ui querying' stamp: 'fbs 5/21/2013 22:35'!
methodsWithFailedCallForClass: class 
	^ class selectors
		collect: [:sel | MethodReference class: class selector: sel]
		thenSelect: [:mRef | self existsFailedCallIn: mRef]! !

!PrimCallControllerAbstract methodsFor: 'ui querying' stamp: 'sr 6/15/2004 01:44'!
methodsWithFailedCallForClasses: classes
	| result |
	result := OrderedCollection new.
	classes
		do: [:class | result
				addAll: (self methodsWithFailedCallForClass: class)].
	^ result! !

!PrimCallControllerAbstract methodsFor: 'ui querying' stamp: 'sr 6/15/2004 19:58'!
methodsWithFailedCallIntoModule: moduleNameOrNil 
	^ self methodsWithFailedCall
		select: (self blockSelectModuleName: moduleNameOrNil)! !

!PrimCallControllerAbstract methodsFor: 'ui querying' stamp: 'sr 6/15/2004 02:19'!
methodsWithFailedCallIntoModule: moduleNameOrNil forClass: class 
	^ self methodsWithFailedCallIntoModule: moduleNameOrNil forClasses: {class}! !

!PrimCallControllerAbstract methodsFor: 'ui querying' stamp: 'sr 6/15/2004 19:58'!
methodsWithFailedCallIntoModule: moduleNameOrNil forClasses: classes
	^ (self methodsWithFailedCallForClasses: classes)
		select: (self blockSelectModuleName: moduleNameOrNil)! !

!PrimCallControllerAbstract methodsFor: 'ui controlling' stamp: 'sr 6/15/2004 17:41'!
preserveStatusOfFailedCalls
	"Do not en/dis-able failed calls (default)."
	changeStatusOfFailedCallsFlag := false! !

!PrimCallControllerAbstract methodsFor: 'private user interface' stamp: 'sr 6/14/2004 01:34'!
privateDisableCallIn: aMethodRefWithExternalCall
	"Disables enabled or failed external prim call."
	self subclassResponsibility! !

!PrimCallControllerAbstract methodsFor: 'private user interface' stamp: 'sr 6/14/2004 01:33'!
privateEnableCallIn: aMethodRefWithExternalCall
	"Enables disabled external prim call."
	self subclassResponsibility! !

!PrimCallControllerAbstract methodsFor: 'private user interface' stamp: 'sr 6/14/2004 02:09'!
privateEnableViaLiteralIn: aMethodRef 
	"Enables external prim call by filling function ref literal with zero for 
	'non called'."
	aMethodRef compiledMethod literals first at: 4 put: 0.
	Object flushCache! !

!PrimCallControllerAbstract methodsFor: 'ui controlling' stamp: 'sr 6/11/2004 06:45'!
switchStored
	"Disables enabled and enables disabled (see corresponding method 
	comments). "
	self treatedMethods
		keysAndValuesDo: [:mRef :status | status == #enabled
				ifTrue: [self disableCallIn: mRef]
				ifFalse: [self enableCallIn: mRef]]! !

!PrimCallControllerAbstract methodsFor: 'accessing' stamp: 'sr 6/2/2004 05:27'!
treatedMethods
	^treatedMethods! !

Object subclass: #PrototypeTester
	instanceVariableNames: 'prototype'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Utilities'!

!PrototypeTester commentStamp: 'mjr 8/20/2003 13:09' prior: 0!
I am a simple holder of a prototype object and hand out copies when requested.!

PrototypeTester subclass: #EqualityTester
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Utilities'!

!EqualityTester commentStamp: 'mjr 8/20/2003 13:04' prior: 0!
I provide a simple way to test the equality properties of any object.!

!EqualityTester methodsFor: 'as yet unclassified' stamp: 'mjr 8/20/2003 18:56'!
resultFor: runs 
	"Test that equality is the same over runs and answer the result"
	1
		to: runs
		do: [:i | self prototype = self prototype
				ifFalse: [^ false]]. 
	^ true! !

PrototypeTester subclass: #HashTester
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Utilities'!

!HashTester commentStamp: 'mjr 8/20/2003 12:48' prior: 0!
I provide a simple way to test the hash properties of any object.  

I am given an object that should be tested and I treat it like a prototype.  I take a copy of it when I am given it so that it can't change whilst I am holding on to it.  I can then test that multiple copies of this object all hash to the same value.!

!HashTester methodsFor: 'as yet unclassified' stamp: 'mjr 8/20/2003 18:56'!
resultFor: runs 
	"Test that the hash is the same over runs and answer the result"
	| hash |
	hash := self prototype hash.
	1
		to: runs
		do: [:i | hash = self prototype hash
				ifFalse: [^ false]].
	^ true ! !

!PrototypeTester class methodsFor: 'as yet unclassified' stamp: 'mjr 8/20/2003 13:08'!
defaultRuns
"the default number of times to test"
	^ 50! !

!PrototypeTester class methodsFor: 'as yet unclassified' stamp: 'mjr 8/20/2003 13:08'!
with: aPrototype
	^self new prototype:aPrototype! !

!PrototypeTester methodsFor: 'as yet unclassified' stamp: 'mjr 8/20/2003 18:56'!
prototype
	"Get a prototype"
	^ prototype copy ! !

!PrototypeTester methodsFor: 'as yet unclassified' stamp: 'mjr 8/20/2003 18:56'!
prototype: aPrototype 
	"Set my prototype"
	prototype := aPrototype copy ! !

!PrototypeTester methodsFor: 'as yet unclassified' stamp: 'mjr 8/20/2003 18:57'!
result
	"Perform the test the default number of times"
	^ self resultFor: self class defaultRuns ! !

Object subclass: #UserInterfaceThemeTestObject
	instanceVariableNames: 'testColor unknownProperty'
	classVariableNames: 'ApplyCounter'
	poolDictionaries: ''
	category: 'Tests-System-Preferences'!

!UserInterfaceThemeTestObject class methodsFor: 'as yet unclassified' stamp: 'mt 7/3/2016 15:14'!
applyCounter
	^ ApplyCounter! !

!UserInterfaceThemeTestObject class methodsFor: 'as yet unclassified' stamp: 'mt 7/3/2016 15:21'!
applyUserInterfaceTheme
	ApplyCounter := (ApplyCounter ifNil: [0]) + 1.! !

!UserInterfaceThemeTestObject class methodsFor: 'benchmark' stamp: 'mt 7/25/2016 17:58'!
benchLookup
	"
	Microsoft Surface Pro 3, Windows 10 v1511, CogVM r201606301459, Squeak 5.1alpha #16138
	   '210,000 per second. 4.76 microseconds per run.' -- leaves enough room for quirky morphs that keep on drawing themselves based on direct theme lookup.
	
	I think this setup is really heavy. Morphs should not look-up things that often. They can cache. Anyway:
	- link through 3 themes
	- look up superclasses up to ProtoObject (for each theme!!)
	
	self benchLookup"
	
	| c t1 t2 t3 m result |
	c := UserInterfaceTheme current.
	m := UserInterfaceThemeTestObject new.
	t1 := UserInterfaceTheme new name: #benchmarkOne.
	t2 := UserInterfaceTheme new name: #benchmarkTwo.
	t3 := UserInterfaceTheme new name: #benchmarkThree.
	
	t3 set: #testColor for: ProtoObject to: Color white.
	t1 link: t2.
	t2 link: t3.
	
	t1 apply.
	
	result := OrderedCollection new.
	
	[
		3 timesRepeat: [result add: [m getTestColor] bench].
	] ensure: [c apply].

	result explore.! !

!UserInterfaceThemeTestObject class methodsFor: 'as yet unclassified' stamp: 'mt 7/3/2016 15:12'!
resetApplyCounter
	ApplyCounter := 0.! !

!UserInterfaceThemeTestObject class methodsFor: 'preferences' stamp: 'mt 7/1/2016 14:38'!
themeProperties

	^ super themeProperties, {
		{#testColor. 'test'. 'Some test property'}
	}! !

!UserInterfaceThemeTestObject methodsFor: 'updating' stamp: 'mt 7/1/2016 15:39'!
applyUserInterfaceTheme

	self testColor: self userInterfaceTheme testColor.
	self unknownProperty: self userInterfaceTheme unknownProperty.! !

!UserInterfaceThemeTestObject methodsFor: 'visual properties' stamp: 'mt 7/1/2016 14:43'!
canApplyUserInterfaceTheme
	^ true! !

!UserInterfaceThemeTestObject methodsFor: 'updating' stamp: 'mt 7/1/2016 15:49'!
getTestColor

	^ self userInterfaceTheme testColor! !

!UserInterfaceThemeTestObject methodsFor: 'updating' stamp: 'mt 7/3/2016 12:02'!
getTestColorViaPerform

	^ self userInterfaceTheme perform: #testColor! !

!UserInterfaceThemeTestObject methodsFor: 'accessing' stamp: 'mt 7/1/2016 14:41'!
testColor

	^ testColor! !

!UserInterfaceThemeTestObject methodsFor: 'accessing' stamp: 'mt 7/1/2016 14:41'!
testColor: anObject

	testColor := anObject! !

!UserInterfaceThemeTestObject methodsFor: 'accessing' stamp: 'mt 7/1/2016 15:03'!
unknownProperty

	^ unknownProperty! !

!UserInterfaceThemeTestObject methodsFor: 'accessing' stamp: 'mt 7/1/2016 15:03'!
unknownProperty: anObject

	unknownProperty := anObject! !

Object subclass: #WantsChangeSetLogging
	instanceVariableNames: ''
	classVariableNames: 'WantsChangeSetLoggingFlag'
	poolDictionaries: ''
	category: 'Tests-System-Support'!

!WantsChangeSetLogging commentStamp: 'fbs 9/2/2013 11:08' prior: 0!
RecentMessagesTest uses me to show how it behaves when classes don't want to log to a change set.!

!WantsChangeSetLogging class methodsFor: 'instance creation' stamp: 'fbs 9/2/2013 10:25'!
no
	 WantsChangeSetLoggingFlag := false.! !

!WantsChangeSetLogging class methodsFor: 'compiling' stamp: 'nice 9/25/2013 00:48'!
wantsChangeSetLogging
	^ WantsChangeSetLoggingFlag ifNil: [^true]! !

!WantsChangeSetLogging class methodsFor: 'instance creation' stamp: 'fbs 9/2/2013 10:24'!
yes
	 WantsChangeSetLoggingFlag := true.! !

MCDefinition subclass: #MCMockDefinition
	instanceVariableNames: 'token'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello-Utils'!

!MCMockDefinition class methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
token: aString

	^ self new token: aString! !

!MCMockDefinition class methodsFor: 'as yet unclassified' stamp: 'cwp 7/21/2003 19:46'!
wantsChangeSetLogging
	^ false! !

!MCMockDefinition methodsFor: 'as yet unclassified' stamp: 'ab 7/19/2003 18:25'!
= definition
	^definition token = token! !

!MCMockDefinition methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
asString

	^ token! !

!MCMockDefinition methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
description

	^ token first! !

!MCMockDefinition methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
hash

	^ token hash! !

!MCMockDefinition methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
printString

	^ token! !

!MCMockDefinition methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
summary

	^ token! !

!MCMockDefinition methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
token

	^ token! !

!MCMockDefinition methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
token: aString

	token := aString! !

TestResource subclass: #MCSnapshotResource
	instanceVariableNames: 'snapshot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello'!

!MCSnapshotResource class methodsFor: 'as yet unclassified' stamp: 'cwp 8/1/2003 20:18'!
mockPackage
	^ (MCPackage new name: self mockPackageName)! !

!MCSnapshotResource class methodsFor: 'as yet unclassified' stamp: 'avi 2/22/2004 13:54'!
mockPackageName
	^ MCMockPackageInfo new packageName! !

!MCSnapshotResource class methodsFor: 'as yet unclassified' stamp: 'cwp 7/14/2003 15:19'!
takeSnapshot
	^ self mockPackage snapshot! !

!MCSnapshotResource methodsFor: 'as yet unclassified' stamp: 'cwp 7/14/2003 14:50'!
definitions
	^ snapshot definitions! !

!MCSnapshotResource methodsFor: 'as yet unclassified' stamp: 'cwp 7/14/2003 15:20'!
setUp
	snapshot := self class takeSnapshot.! !

!MCSnapshotResource methodsFor: 'as yet unclassified' stamp: 'cwp 7/14/2003 14:51'!
snapshot
	^ snapshot! !

SharedPool subclass: #MCMockAPoolDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello-Mocks'!

MCMock subclass: #MCMockClassB
	instanceVariableNames: 'ivarb'
	classVariableNames: 'CVar'
	poolDictionaries: 'MCMockAPoolDictionary'
	category: 'Tests-Monticello-Mocks'!

MCMockClassB class
	instanceVariableNames: 'ciVar'!

!MCMockClassB commentStamp: '' prior: 0!
This comment has a bang!! Bang!! Bang!!!

MCMockClassB class
	instanceVariableNames: 'ciVar'!

!MCMockClassB methodsFor: 'numeric' stamp: 'ab 7/7/2003 23:21'!
two

	^ 2! !

!Decompiler class methodsFor: '*Tests' stamp: 'fbs 7/12/2013 20:50'!
recompileAllTest
	"[Decompiler recompileAllTest]"
	"decompile every method and compile it back; if the decompiler is correct then the system should keep running.  :)"
	
	SystemNavigation default allBehaviorsDo: [ :behavior |
		UIManager default informUser: (behavior printString) during: [
			behavior selectors do: [ :sel |
				| decompiled ast compiled |
				decompiled := Decompiler new decompile: sel in: behavior.
				ast := Compiler new compile: decompiled in: behavior notifying: nil ifFail: [ self error: 'failed' ].
				compiled := ast generate: (behavior compiledMethodAt: sel) trailer.
				behavior addSelector: sel withMethod: compiled. ] ] ]! !

ClassTestCase subclass: #EventManagerTest
	instanceVariableNames: 'eventSource eventListener succeeded'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Object Events'!

!EventManagerTest methodsFor: 'private' stamp: 'jws 9/7/2000 16:37'!
addArg1: arg1
addArg2: arg2

	eventListener
		add: arg1;
		add: arg2! !

!EventManagerTest methodsFor: 'private' stamp: 'JWS 9/7/2000 17:19'!
getFalse

	^false! !

!EventManagerTest methodsFor: 'private' stamp: 'JWS 9/7/2000 17:19'!
getFalse: anArg

	^false! !

!EventManagerTest methodsFor: 'private' stamp: 'JWS 9/7/2000 17:19'!
getTrue

	^true! !

!EventManagerTest methodsFor: 'private' stamp: 'JWS 9/7/2000 17:19'!
getTrue: anArg

	^true! !

!EventManagerTest methodsFor: 'private' stamp: 'JWS 9/7/2000 17:20'!
heardEvent

	succeeded := true! !

!EventManagerTest methodsFor: 'running' stamp: 'JWS 9/7/2000 17:19'!
setUp

	super setUp.
	eventSource := EventManager new.
	eventListener := Bag new.
	succeeded := false! !

!EventManagerTest methodsFor: 'running' stamp: 'jws 11/28/2000 16:25'!
tearDown

	eventSource releaseActionMap.
	eventSource := nil.
	eventListener := nil.
	super tearDown.
! !

!EventManagerTest methodsFor: 'running-dependent action' stamp: 'ar 8/26/2009 21:37'!
testBlockReceiverNoArgs
	eventSource when: #anEvent evaluate:[self heardEvent].
	eventSource triggerEvent: #anEvent.
	self should: [succeeded]! !

!EventManagerTest methodsFor: 'running-dependent action' stamp: 'ar 8/26/2009 21:37'!
testBlockReceiverOneArg
	eventSource when: #anEvent: evaluate:[:arg1| eventListener add: arg1].
	eventSource triggerEvent: #anEvent: with: 9.
	self should: [eventListener includes: 9]! !

!EventManagerTest methodsFor: 'running-dependent action' stamp: 'ar 8/26/2009 21:38'!
testBlockReceiverTwoArgs
	eventSource when: #anEvent:info: evaluate:[:arg1 :arg2| self addArg1: arg1 addArg2: arg2].
	eventSource triggerEvent: #anEvent:info: withArguments: #( 9 42 ).
	self should: [(eventListener includes: 9) and: [eventListener includes: 42]]! !

!EventManagerTest methodsFor: 'running-copying' stamp: 'SqR 11/12/2000 19:38'!
testCopy
	"Ensure that the actionMap is zapped when
	you make a copy of anEventManager"

	eventSource when: #blah send: #yourself to: eventListener.
	self assert: eventSource actionMap keys isEmpty not.
	self assert: eventSource copy actionMap keys isEmpty! !

!EventManagerTest methodsFor: 'running-broadcast query' stamp: 'JWS 9/7/2000 17:21'!
testMultipleValueSuppliers

	eventSource
		when: #needsValue
		send: #getFalse
		to: self.
	eventSource
		when: #needsValue
		send: #getTrue
		to: self.
	succeeded := eventSource triggerEvent: #needsValue.
	self should: [succeeded]! !

!EventManagerTest methodsFor: 'running-broadcast query' stamp: 'JWS 9/7/2000 17:21'!
testMultipleValueSuppliersEventHasArguments

	eventSource
		when: #needsValue:
		send: #getFalse:
		to: self.
	eventSource
		when: #needsValue:
		send: #getTrue:
		to: self.
	succeeded := eventSource triggerEvent: #needsValue: with: 'kolme'.
	self should: [succeeded]! !

!EventManagerTest methodsFor: 'running-dependent action' stamp: 'jws 9/7/2000 16:39'!
testNoArgumentEvent

	eventSource when: #anEvent send: #heardEvent to: self.
	eventSource triggerEvent: #anEvent.
	self should: [succeeded]! !

!EventManagerTest methodsFor: 'running-dependent action supplied arguments' stamp: 'JWS 9/7/2000 17:20'!
testNoArgumentEventDependentSuppliedArgument

	eventSource when: #anEvent send: #add: to: eventListener with: 'boundValue'.
	eventSource triggerEvent: #anEvent.
	self should: [eventListener includes: 'boundValue']! !

!EventManagerTest methodsFor: 'running-dependent action supplied arguments' stamp: 'JWS 9/7/2000 17:21'!
testNoArgumentEventDependentSuppliedArguments

	eventSource 
		when: #anEvent 
		send: #addArg1:addArg2: 
		to: self 
		withArguments: #('hello' 'world').
	eventSource triggerEvent: #anEvent.
	self should: [(eventListener includes: 'hello') and: [eventListener includes: 'world']]! !

!EventManagerTest methodsFor: 'running-broadcast query' stamp: 'JWS 9/7/2000 17:22'!
testNoValueSupplier

	succeeded := eventSource 
		triggerEvent: #needsValue
		ifNotHandled: [true].
	self should: [succeeded]! !

!EventManagerTest methodsFor: 'running-broadcast query' stamp: 'JWS 9/7/2000 17:22'!
testNoValueSupplierHasArguments

	succeeded := eventSource 
		triggerEvent: #needsValue:
		with: 'nelja'
		ifNotHandled: [true].
	self should: [succeeded]! !

!EventManagerTest methodsFor: 'running-dependent action' stamp: 'JWS 9/7/2000 17:20'!
testOneArgumentEvent

	eventSource when: #anEvent: send: #add: to: eventListener.
	eventSource triggerEvent: #anEvent: with: 9.
	self should: [eventListener includes: 9]! !

!EventManagerTest methodsFor: 'running-remove actions' stamp: 'SqR 2/19/2001 14:01'!
testRemoveActionsForEvent

	eventSource
		when: #anEvent send: #size to: eventListener;
		when: #anEvent send: #getTrue to: self;
		when: #anEvent: send: #fizzbin to: self.
	eventSource removeActionsForEvent: #anEvent.
	self shouldnt: [eventSource hasActionForEvent: #anEvent]! !

!EventManagerTest methodsFor: 'running-remove actions' stamp: 'SqR 2/19/2001 14:01'!
testRemoveActionsTwiceForEvent

	eventSource
		when: #anEvent send: #size to: eventListener;
		when: #anEvent send: #getTrue to: self;
		when: #anEvent: send: #fizzbin to: self.
	eventSource removeActionsForEvent: #anEvent.
	self assert: (eventSource hasActionForEvent: #anEvent) not.
	eventSource removeActionsForEvent: #anEvent.
	self assert: (eventSource hasActionForEvent: #anEvent) not.! !

!EventManagerTest methodsFor: 'running-remove actions' stamp: 'SqR 2/19/2001 14:10'!
testRemoveActionsWithReceiver

	| action |
	eventSource
		when: #anEvent send: #size to: eventListener;
		when: #anEvent send: #getTrue to: self;
		when: #anEvent: send: #fizzbin to: self.
	eventSource removeActionsWithReceiver: self.
	action := eventSource actionForEvent: #anEvent.
	self assert: (action respondsTo: #receiver).
	self assert: ((action receiver == self) not)! !

!EventManagerTest methodsFor: 'running-dependent value' stamp: 'JWS 9/7/2000 17:21'!
testReturnValueWithManyListeners

	| value newListener |
	newListener := 'busybody'.
	eventSource
		when: #needsValue
		send: #yourself
		to: eventListener.
	eventSource
		when: #needsValue
		send: #yourself
		to: newListener.
	value := eventSource triggerEvent: #needsValue.
	self should: [value == newListener]! !

!EventManagerTest methodsFor: 'running-dependent value' stamp: 'JWS 9/7/2000 17:21'!
testReturnValueWithNoListeners

	| value |
	value := eventSource triggerEvent: #needsValue.
	self should: [value == nil]! !

!EventManagerTest methodsFor: 'running-dependent value' stamp: 'JWS 9/7/2000 17:21'!
testReturnValueWithOneListener

	| value |
	eventSource
		when: #needsValue
		send: #yourself
		to: eventListener.
	value := eventSource triggerEvent: #needsValue.
	self should: [value == eventListener]! !

!EventManagerTest methodsFor: 'running-broadcast query' stamp: 'jws 11/28/2000 15:52'!
testSingleValueSupplier

	eventSource
		when: #needsValue
		send: #getTrue
		to: self.
	succeeded := eventSource triggerEvent: #needsValue.
	self should: [succeeded]! !

!EventManagerTest methodsFor: 'running-dependent action' stamp: 'JWS 9/7/2000 17:20'!
testTwoArgumentEvent

	eventSource when: #anEvent:info: send: #addArg1:addArg2: to: self.
	eventSource triggerEvent: #anEvent:info: withArguments: #( 9 42 ).
	self should: [(eventListener includes: 9) and: [eventListener includes: 42]]! !

ClassTestCase subclass: #FileDirectoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Files'!

!FileDirectoryTest methodsFor: 'create/delete tests' stamp: 'nk 11/13/2002 19:39'!
deleteDirectory
	
	(self myDirectory exists) ifTrue:
		[self myDirectory containingDirectory deleteDirectory: self myLocalDirectoryName]! !

!FileDirectoryTest methodsFor: 'resources' stamp: 'hg 2/2/2002 16:44'!
myAssuredDirectory

	^self myDirectory assureExistence! !

!FileDirectoryTest methodsFor: 'resources' stamp: 'hg 2/2/2002 16:42'!
myDirectory

	^FileDirectory default directoryNamed: self myLocalDirectoryName! !

!FileDirectoryTest methodsFor: 'resources' stamp: 'hg 2/2/2002 16:42'!
myLocalDirectoryName

	^'zTestDir'! !

!FileDirectoryTest methodsFor: 'resources' stamp: 'nk 11/13/2002 19:56'!
tearDown

	[ self deleteDirectory ] on: Error do: [ :ex | ]! !

!FileDirectoryTest methodsFor: 'existence tests' stamp: 'mha 7/30/2009 11:24'!
testAttemptExistenceCheckWhenFile
	"How should a FileDirectory instance respond with an existent file name?"
	
	| directory filename |
	
	filename := 'aTestFile'.
	FileDirectory default forceNewFileNamed: filename.
	directory := FileDirectory default directoryNamed: filename.
	self shouldnt: [directory exists] description: 'Files are not directories.'.
	
	"clean up disk"
	FileDirectory default deleteFileNamed: filename ifAbsent: [ ]! !

!FileDirectoryTest methodsFor: 'create/delete tests' stamp: 'aka 5/21/2003 00:31'!
testDeleteDirectory
	"Test deletion of a directory"
	
	| aContainingDirectory preTestItems |
	aContainingDirectory := self myDirectory containingDirectory.
	preTestItems := aContainingDirectory fileAndDirectoryNames.
	
	self assert: self myAssuredDirectory exists.
	aContainingDirectory deleteDirectory: self myLocalDirectoryName.

	self shouldnt: 
		[aContainingDirectory directoryNames 
			includes: self myLocalDirectoryName ]
		description: 'Should successfully delete directory.'.
	self should: 
		[preTestItems = aContainingDirectory fileAndDirectoryNames]
		description: 'Should only delete the indicated directory.'.

	
	! !

!FileDirectoryTest methodsFor: 'existence tests' stamp: 'aka 5/20/2003 23:33'!
testDirectoryExists

	self assert: self myAssuredDirectory exists.
	self should: [self myDirectory containingDirectory 
					directoryExists: self myLocalDirectoryName].

	self myDirectory containingDirectory deleteDirectory: self myLocalDirectoryName.
	self shouldnt: [self myDirectory containingDirectory 
						directoryExists: self myLocalDirectoryName]! !

!FileDirectoryTest methodsFor: 'existence tests' stamp: 'nice 12/27/2009 20:37'!
testDirectoryExistsWhenLikeNamedFileExists

[ | testFileName |
testFileName := self myAssuredDirectory fullNameFor: 'zDirExistsTest.testing'.
(FileStream newFileNamed: testFileName) close.

self should: [FileStream isAFileNamed: testFileName].
self shouldnt: [(FileDirectory on: testFileName) exists]]
ensure: [self myAssuredDirectory deleteFileNamed: 'zDirExistsTest.testing']

! !

!FileDirectoryTest methodsFor: 'existence tests' stamp: 'hg 2/2/2002 16:44'!
testDirectoryNamed

	self should: [(self myDirectory containingDirectory 
					directoryNamed: self myLocalDirectoryName) pathName 
						= self myDirectory pathName]! !

!FileDirectoryTest methodsFor: 'existence tests' stamp: 'fbs 11/23/2013 20:36'!
testDirectoryNicknames

	| defaultDirectory |
	defaultDirectory := FileDirectory default.
	#('/.' '/../../.' '/././.') 
		collect: [ :each | each copyReplaceAll: '/' with: FileDirectory slash ]
		thenDo: [:each |
			self assert: (defaultDirectory directoryExists: defaultDirectory fullName, each) description: 'Nickname of "', each, '"'. ]! !

!FileDirectoryTest methodsFor: 'tests' stamp: 'ul 2/28/2010 22:16'!
testEquality

	self assert: FileDirectory default = FileDirectory default.
	self deny: FileDirectory default = FileDirectory default containingDirectory.
	self deny: FileDirectory default = nil! !

!FileDirectoryTest methodsFor: 'existence tests' stamp: 'tpr 8/15/2003 16:30'!
testExists

	self should: [FileDirectory default exists]
		description: 'Should know default directory exists.'.
	self should: [self myAssuredDirectory exists]
		description: 'Should know created directory exists.'.

	self myDirectory containingDirectory deleteDirectory: self myLocalDirectoryName.
	self shouldnt: [(self myDirectory containingDirectory directoryNamed: self myLocalDirectoryName) exists]
		description: 'Should know that recently deleted directory no longer exists.'.! !

!FileDirectoryTest methodsFor: 'existence tests' stamp: 'aka 5/20/2003 14:26'!
testNonExistentDirectory

	| directory parentDirectory |
	directory :=FileDirectory default
				directoryNamed: 'nonExistentFolder'.
	self shouldnt: [directory exists] 
		description: 'A FileDirectory instance should know if it points to a non-existent directory.'.

	parentDirectory :=FileDirectory default.
	self shouldnt: [parentDirectory directoryExists: 'nonExistentFolder'] 
		description: 'A FileDirectory instance should know when a directory of the given name doesn''t exist'.
! !

!FileDirectoryTest methodsFor: 'existence tests' stamp: 'CdG 10/19/2005 22:41'!
testOldFileOrNoneNamed

	| file |
	file := self myAssuredDirectory oldFileOrNoneNamed: 'test.txt'.
	[self assert: file isNil.
	
	"Reproduction of Mantis #1049"
	(self myAssuredDirectory fileNamed: 'test.txt')
		nextPutAll: 'foo';
		close.
		
	file := self myAssuredDirectory oldFileOrNoneNamed: 'test.txt'.
	self assert: file notNil]
		ensure: [
			file ifNotNil: [file close].
			self myAssuredDirectory deleteFileNamed: 'test.txt' ifAbsent: nil]
	
! !

!FileDirectoryTest methodsFor: 'tests' stamp: 'nice 7/30/2013 01:52'!
testRelativeNameIfAbsoluteFor
	| cwd notcwd |
	cwd := FileDirectory default.
	self assert: (cwd relativeNameIfAbsoluteFor: cwd fullName) = cwd class currentDirectoryNickname. 
	self assert: (cwd relativeNameIfAbsoluteFor: cwd fullName, cwd slash) = cwd class currentDirectoryNickname. 
	self assert: (cwd relativeNameIfAbsoluteFor: cwd fullName, cwd slash, 'foo', cwd slash, 'bar') = ('foo', cwd slash, 'bar').
	notcwd := cwd fullName copy. "Argh!!!!!!"
	notcwd at: notcwd size put: (($a to: $z) detect: [:i| notcwd last ~= i]).
	self assert: (cwd relativeNameIfAbsoluteFor: notcwd) = notcwd! !

!FileDirectoryTest methodsFor: 'tests' stamp: 'eem 9/15/2014 12:17'!
testRelativePaths
	| myDirViaContainer |
	self assert: (FileDirectory default on: self myLocalDirectoryName) fullName = self myDirectory fullName.
	self assert: (FileDirectory default on: self myLocalDirectoryName) = self myDirectory.
	myDirViaContainer := FileDirectory default localName, FileDirectory default slash, self myLocalDirectoryName.
	self assert: (FileDirectory default containingDirectory on: myDirViaContainer) fullName = self myDirectory fullName.
	self assert: (FileDirectory default containingDirectory on: myDirViaContainer) = self myDirectory! !

ClassTestCase subclass: #FileStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Files'!

!FileStreamTest methodsFor: 'as yet unclassified' stamp: 'ar 3/29/2010 20:56'!
testCachingNextChunkPut
	"Ensure that nextChunkPut:/nextChunk works properly on a caching file"
	| file text read |
	[file := FileStream forceNewFileNamed: 'testCachingNextChunkPut'.
	text := 'this is a chunkful of text'.
	file nextChunkPut: text.
	read := [file position: 0; nextChunkText] valueWithin: 1 seconds onTimeout:[''].
	self assert: read = text.
	] ensure:[file close. FileDirectory default deleteFileNamed: file name ifAbsent:[]].! !

!FileStreamTest methodsFor: 'as yet unclassified' stamp: 'mha 7/30/2009 11:25'!
testDetectFileDo
	"Mantis #1838"
	
	| filename |
	filename := 'filestream.tst'.
	
	[(FileDirectory default forceNewFileNamed: filename)
		nextPutAll: '42';
		close.
		
	FileStream 
		detectFile: [FileDirectory default oldFileNamed: filename]
		do: [:file |
			self assert: file notNil.
			self deny: file closed.
			self assert: file contentsOfEntireFile = '42']]
	
		ensure: [FileDirectory default deleteFileNamed: filename ifAbsent: [] ]! !

!FileStreamTest methodsFor: 'as yet unclassified' stamp: 'jcg 4/15/2010 16:27'!
testFileTruncation
	"Ensure that nextChunkPut:/nextChunk works properly on a caching file"
	| file |
	file := nil.
	[	
		file := FileDirectory default forceNewFileNamed: 'TruncationTest.txt'.
		file nextPutAll: '1234567890'.
	] ensure: [file close].
	[
		file := FileDirectory default oldFileNamed: 'TruncationTest.txt'.
		self should: [file contents = '1234567890'].
		file truncate: 4.
	] ensure: [file close].
	[
		file := FileDirectory default readOnlyFileNamed: 'TruncationTest.txt'.
		self should: [file contents = '1234'].
	] ensure: [
		file close.
		FileDirectory default deleteFileNamed: file name ifAbsent:[]
	].
! !

!FileStreamTest methodsFor: 'as yet unclassified' stamp: 'ar 3/29/2010 20:56'!
testNextChunkOutOfBounds
	"Ensure that nextChunkPut:/nextChunk works properly on a caching file"
	| file text read |
	[file := FileStream forceNewFileNamed: 'testNextChunkOutOfBounds'.
	text := 'this is a chunkful of text'.
	file nextChunkPut: text.
	read := [file position: 999999; nextChunkText] valueWithin: 1 seconds onTimeout:[nil].
	self assert: read = ''.
	] ensure:[file close. FileDirectory default deleteFileNamed: file name ifAbsent:[]].! !

!FileStreamTest methodsFor: 'as yet unclassified' stamp: 'nice 12/27/2009 20:37'!
testNextLine
	| filename lines text |
	filename := 'filestream.tst'.
	lines := #('line 1' ' and line 2' '' 'fourth').
	text := lines first , String cr , lines second , String crlf , lines third , String lf , lines fourth.
	
	[ | file |
	(StandardFileStream forceNewFileNamed: filename)
		nextPutAll: text;
		close.
		
	file := StandardFileStream readOnlyFileNamed: filename.
	lines do: [:e |
		self assert: file nextLine = e].
	self assert: file nextLine = nil.
	file close]
		ensure: [FileDirectory default deleteFileNamed: filename ifAbsent: [] ]! !

!FileStreamTest methodsFor: 'as yet unclassified' stamp: 'ar 4/2/2010 00:43'!
testPositionPastEndIsAtEnd
	"Tests that a file positioned after its end responds true to #atEnd"

	| filename file |
	filename := 'filestream.tst'.
	file := StandardFileStream forceNewFileNamed: filename.
	[
		file position: 1000.
		self assert: file atEnd.
	] ensure:[
		file close.
		FileDirectory default deleteFileNamed: filename ifAbsent:[].
	].! !

!FileStreamTest methodsFor: 'as yet unclassified' stamp: 'nice 3/15/2010 20:37'!
testReadIntoStartingAtCount
	| filename file |
	filename := 'filestream.tst'.
	[ | writeBuffer readBuffer bytesRead |
	writeBuffer := (ByteArray new: 2500)
		 atAllPut: 1 ;
		 yourself.
	(StandardFileStream forceNewFileNamed: filename)
		 binary ;
		 nextPutAll: writeBuffer ;
		 close.
	file := StandardFileStream readOnlyFileNamed: filename.
	readBuffer := ByteArray new: 400.
	bytesRead := file
		readInto: readBuffer
		startingAt: 10
		count: 100.
	self assert: bytesRead = 100.
	"quick test"
	self assert: (readBuffer occurrencesOf: 1) = 100.
	"compare test"
	1 to: readBuffer size do:
		[ : n | self assert:
			(readBuffer at: n) = ((n between: 10 	and: 10 + 100 - 1)
				ifTrue: [ writeBuffer at: n ]
				ifFalse: [ 0 ]) ] ]
	ensure:
		[ file ifNotNil: [ file close ].
		FileDirectory default
			deleteFileNamed: filename
			ifAbsent: [ "ok" ] ]! !

ClassTestCase subclass: #MethodReferenceTest
	instanceVariableNames: 'env'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-System-Support'!

!MethodReferenceTest methodsFor: 'private' stamp: 'fbs 5/21/2013 23:23'!
createClass: aSymbol
	| builder |
	builder := ClassBuilder new.
	^ builder
		name: aSymbol
		inEnvironment: env
		subclassOf: Object
		type: #normal
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'Test'.! !

!MethodReferenceTest methodsFor: 'running' stamp: 'nice 10/28/2016 09:20'!
setUp
	| g p |
	env := Environment withName: 'test'.
	g := self createClass: #Griffle.
	p := self createClass: #Plonk.
	g compile: 'foo ^ 1'.
	g organization classify: #foo under: #accessing.
	g class compile: 'classFoo ^ 1'.
	g compile: 'bar ^ 1'.
	p compile: 'foo ^ 2'.
	self createClass: #Unused.! !

!MethodReferenceTest methodsFor: 'running' stamp: 'nice 10/28/2016 09:19'!
tearDown
	env destroy.
	env := nil! !

!MethodReferenceTest methodsFor: 'tests' stamp: 'fbs 5/22/2013 07:25'!
testActualClassIsScopedToEnvironment
	| mref |
	mref := MethodReference class: (env at: #Griffle) selector: #foo environment: env.
	self assert: (env at: #Griffle) equals: mref actualClass.! !

!MethodReferenceTest methodsFor: 'tests' stamp: 'fbs 5/22/2013 07:46'!
testCanReferToMethodInSpecificEnvironment
	| mref |
	mref := MethodReference class: self class selector: #testReferencedEnvironmentDefaultsToSmalltalkGlobals environment: env.
	self assert: env equals: mref environment.! !

!MethodReferenceTest methodsFor: 'tests' stamp: 'fbs 5/22/2013 07:37'!
testCategory
	| mref |
	mref := MethodReference class: (env at: #Griffle) selector: #foo environment: env.
	self assert: #accessing equals: mref category.! !

!MethodReferenceTest methodsFor: 'Running' stamp: 'fbs 5/21/2013 22:31'!
testEquals
	| aMethodReference anotherMethodReference |
	aMethodReference := MethodReference new.
	anotherMethodReference := MethodReference new.
	"Two fresh instances should be equals between them"
	self assert: MethodReference new equals: MethodReference new.
	self assert: MethodReference new hash equals: MethodReference new hash.

	"Two instances representing the same method (same class and  
	same selector) should be equals"
	self assert: (MethodReference class: String selector: #foo) equals: (MethodReference class: String selector: #foo).
	self assert: (MethodReference class: String selector: #foo) hash equals: (MethodReference class: String selector: #foo) hash.! !

!MethodReferenceTest methodsFor: 'Running' stamp: 'fbs 5/21/2013 22:33'!
testNotEquals
	self
		deny: (MethodReference class: String selector: #foo) = (MethodReference class: String class selector: #foo)
		description: 'Different classes, same selector -> no more equals'.
	self
		deny: (MethodReference class: String selector: #foo) = (MethodReference class: String selector: #bar)
		description: 'Same class, different selectors -> no more equals'.! !

!MethodReferenceTest methodsFor: 'tests' stamp: 'fbs 5/22/2013 07:23'!
testReferencedEnvironmentDefaultsToSmalltalkGlobals
	| mref |
	mref := MethodReference class: self class selector: #testReferencedEnvironmentDefaultsToSmalltalkGlobals.
	self assert: Smalltalk globals equals: mref environment.! !

ClassTestCase subclass: #PrimCallControllerAbstractTest
	instanceVariableNames: 'pcc doNotMakeSlowTestsFlag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-PrimCallController'!

!PrimCallControllerAbstractTest commentStamp: 'sr 6/15/2004 19:20' prior: 0!
PrimCallController tests.

Tests are here, but this class isAbstract and won't be tested.
Tests are done in the subclasses, which inherit the tests here.

If you want to perform some more very slow tests, change doNotMakeSlowTestsFlag in >>setUp.!

PrimCallControllerAbstractTest subclass: #PCCByCompilationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-PrimCallController'!

!PCCByCompilationTest commentStamp: 'sr 6/14/2004 22:05' prior: 0!
PCCByCompilation tests.

Tests are in the superclass and inherited from there.!

!PCCByCompilationTest class methodsFor: 'Testing' stamp: 'sr 6/7/2004 12:01'!
isAbstract
	^ false! !

!PCCByCompilationTest methodsFor: 'test methods' stamp: 'sr 6/11/2004 05:36'!
cDisabledExternalCallWithoutModule
	"{prim disabled by PCCByCompilation} <primitive: 'primGetModuleName'>"
	^ 'Hello World!!'! !

!PCCByCompilationTest methodsFor: 'test methods' stamp: 'sr 6/13/2004 23:54'!
cDisabledRealExternalCall
	"{prim disabled by PCCByCompilation} <primitive: 'primGetModuleName' module:'LargeIntegers'>"
	^ 'Hello World!!'! !

!PCCByCompilationTest methodsFor: 'test methods' stamp: 'sr 6/13/2004 23:54'!
cDisabledRealExternalCallNaked
	"{prim disabled by PCCByCompilation} <primitive: 'primGetModuleName' module:'LargeIntegers'>"! !

!PCCByCompilationTest methodsFor: 'test methods' stamp: 'sr 6/13/2004 23:54'!
cDisabledRealExternalCallOrPrimitiveFailed
	"{prim disabled by PCCByCompilation} <primitive: 'primGetModuleName' module:'LargeIntegers'>"
	self primitiveFailed! !

!PCCByCompilationTest methodsFor: 'example module' stamp: 'sr 6/15/2004 20:49'!
cExternalCall1
	<primitive: 'prim1' module: 'CPCCT'>
! !

!PCCByCompilationTest methodsFor: 'example module' stamp: 'sr 6/15/2004 20:49'!
cExternalCall2
		<primitive:'prim2'module:'CPCCT'>
		self primitiveFailed! !

!PCCByCompilationTest methodsFor: 'test methods' stamp: 'sr 6/7/2004 09:48'!
cExternalCallWithoutModule
	<primitive: 'primGetModuleName'>
	^ 'Hello World!!'! !

!PCCByCompilationTest methodsFor: 'test methods' stamp: 'sr 6/15/2004 20:48'!
cFailedCall
	<primitive: 'primGetModuleName' module:'CFailModule'>
	^ 'failed call'! !

!PCCByCompilationTest methodsFor: 'test methods' stamp: 'sr 6/7/2004 09:48'!
cNoExternalCall
	^ 'Hello World!!'! !

!PCCByCompilationTest methodsFor: 'test methods' stamp: 'sr 6/13/2004 21:14'!
cRealExternalCall
	<primitive: 'primGetModuleName' module:'LargeIntegers'>
	^ 'Hello World!!'! !

!PCCByCompilationTest methodsFor: 'test methods' stamp: 'sr 6/13/2004 21:14'!
cRealExternalCallNaked
	<primitive: 'primGetModuleName' module:'LargeIntegers'>! !

!PCCByCompilationTest methodsFor: 'test methods' stamp: 'sr 6/15/2004 20:49'!
cRealExternalCallOrPrimitiveFailed
	<primitive: 'primGetModuleName' module:'LargeIntegers'>
	self primitiveFailed! !

!PCCByCompilationTest methodsFor: 'test methods' stamp: 'sr 6/15/2004 04:35'!
cSingularExternalCall
	<primitive: 'cSingularExternalCall' module:'COne'>
	^ 'Hello World!!'! !

!PCCByCompilationTest methodsFor: 'constants' stamp: 'sr 6/11/2004 05:22'!
classToBeTested
	^ PCCByCompilation! !

!PCCByCompilationTest methodsFor: 'constants' stamp: 'sr 6/7/2004 10:36'!
disabledCallSelectors
	^ #(#cDisabledRealExternalCall #cDisabledRealExternalCallNaked #cDisabledRealExternalCallOrPrimitiveFailed #cDisabledExternalCallWithoutModule )! !

!PCCByCompilationTest methodsFor: 'constants' stamp: 'sr 6/7/2004 10:34'!
enabledCallSelectors
	^ #(#cRealExternalCall #cRealExternalCallNaked #cRealExternalCallOrPrimitiveFailed #cExternalCallWithoutModule )! !

!PCCByCompilationTest methodsFor: 'constants' stamp: 'sr 6/7/2004 08:44'!
exampleModuleName
	^ 'CPCCT'! !

!PCCByCompilationTest methodsFor: 'constants' stamp: 'sr 6/15/2004 02:42'!
failModuleName
	^ 'CFailModule'! !

!PCCByCompilationTest methodsFor: 'constants' stamp: 'sr 6/14/2004 00:14'!
failedCallSelector
	^ #cFailedCall! !

!PCCByCompilationTest methodsFor: 'constants' stamp: 'sr 6/7/2004 08:40'!
methodSelectorsToExampleModule
	^ #(#cExternalCall1 #cExternalCall2 )! !

!PCCByCompilationTest methodsFor: 'constants' stamp: 'sr 6/7/2004 08:47'!
moduleNameNotWithSingularCallName
	^ 'CNotOne'! !

!PCCByCompilationTest methodsFor: 'constants' stamp: 'sr 6/7/2004 08:47'!
moduleNameWithSingularCallName
	^ 'COne'! !

!PCCByCompilationTest methodsFor: 'constants' stamp: 'sr 6/7/2004 09:52'!
noExternalCallSelector
	^ #cNoExternalCall! !

!PCCByCompilationTest methodsFor: 'constants' stamp: 'sr 6/7/2004 10:28'!
realExternalCallOrPrimitiveFailedSelector
	^ #cRealExternalCallOrPrimitiveFailed! !

!PCCByCompilationTest methodsFor: 'constants' stamp: 'sr 6/7/2004 10:54'!
singularCallName
	"occurrs exactly once as prim call name in >>cSingularExternalCall"
	^ 'cSingularExternalCall'! !

!PCCByCompilationTest methodsFor: 'constants' stamp: 'sr 6/14/2004 23:33'!
singularCallSelector
	^ #cSingularExternalCall! !

PrimCallControllerAbstractTest subclass: #PCCByLiteralsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-PrimCallController'!

!PCCByLiteralsTest commentStamp: 'sr 6/14/2004 22:05' prior: 0!
PCCByLiterals tests.

Tests are in the superclass and inherited from there.!

!PCCByLiteralsTest class methodsFor: 'Testing' stamp: 'sr 6/7/2004 12:01'!
isAbstract
	^ false! !

!PCCByLiteralsTest methodsFor: 'constants' stamp: 'sr 6/11/2004 05:23'!
classToBeTested
	^ PCCByLiterals! !

!PCCByLiteralsTest methodsFor: 'constants' stamp: 'sr 6/7/2004 10:37'!
disabledCallSelectors
	^ #(#lDisabledRealExternalCall #lDisabledRealExternalCallNaked #lDisabledRealExternalCallOrPrimitiveFailed #lDisabledExternalCallWithoutModule )! !

!PCCByLiteralsTest methodsFor: 'constants' stamp: 'sr 6/7/2004 10:34'!
enabledCallSelectors
	^ #(#lRealExternalCall #lRealExternalCallNaked #lRealExternalCallOrPrimitiveFailed #lExternalCallWithoutModule )! !

!PCCByLiteralsTest methodsFor: 'constants' stamp: 'sr 6/7/2004 08:45'!
exampleModuleName
	^ 'LPCCT'! !

!PCCByLiteralsTest methodsFor: 'constants' stamp: 'sr 6/15/2004 02:42'!
failModuleName
	^ 'LFailModule'! !

!PCCByLiteralsTest methodsFor: 'constants' stamp: 'sr 6/14/2004 00:12'!
failedCallSelector
	^ #lFailedCall! !

!PCCByLiteralsTest methodsFor: 'test methods' stamp: 'sr 6/7/2004 08:51'!
lDisabledExternalCallWithoutModule
	<primitive: 'primGetModuleName'>
	^ 'Hello World!!'! !

!PCCByLiteralsTest methodsFor: 'test methods' stamp: 'sr 6/13/2004 21:14'!
lDisabledRealExternalCall
	<primitive: 'primGetModuleName' module:'LargeIntegers'>
	^ 'Hello World!!'! !

!PCCByLiteralsTest methodsFor: 'test methods' stamp: 'sr 6/13/2004 21:14'!
lDisabledRealExternalCallNaked
	<primitive: 'primGetModuleName' module:'LargeIntegers'>! !

!PCCByLiteralsTest methodsFor: 'test methods' stamp: 'sr 6/13/2004 21:14'!
lDisabledRealExternalCallOrPrimitiveFailed
	<primitive: 'primGetModuleName' module:'LargeIntegers'> "primitiveExternalCall" 
	self primitiveFailed! !

!PCCByLiteralsTest methodsFor: 'example module' stamp: 'sr 6/7/2004 08:39'!
lExternalCall1
	<primitive: 'prim1' module: 'LPCCT'>
! !

!PCCByLiteralsTest methodsFor: 'example module' stamp: 'sr 6/7/2004 08:39'!
lExternalCall2
		<primitive:'prim2'module:'LPCCT'>
		self primitiveFailed! !

!PCCByLiteralsTest methodsFor: 'test methods' stamp: 'sr 6/7/2004 09:59'!
lExternalCallWithoutModule
	<primitive: 'primGetModuleName'> "primitiveExternalCall" 
	^ 'Hello World!!'! !

!PCCByLiteralsTest methodsFor: 'test methods' stamp: 'sr 6/15/2004 02:41'!
lFailedCall
	<primitive: 'primGetModuleName' module:'LFailModule'>
	^ 'failed call'! !

!PCCByLiteralsTest methodsFor: 'test methods' stamp: 'sr 6/7/2004 09:57'!
lNoExternalCall
	^ 'Hello World!!'! !

!PCCByLiteralsTest methodsFor: 'test methods' stamp: 'sr 6/13/2004 21:14'!
lRealExternalCall
	<primitive: 'primGetModuleName' module:'LargeIntegers'>
	^ 'Hello World!!'! !

!PCCByLiteralsTest methodsFor: 'test methods' stamp: 'sr 6/13/2004 21:14'!
lRealExternalCallNaked
	<primitive: 'primGetModuleName' module:'LargeIntegers'>! !

!PCCByLiteralsTest methodsFor: 'test methods' stamp: 'sr 6/13/2004 21:14'!
lRealExternalCallOrPrimitiveFailed
	<primitive: 'primGetModuleName' module:'LargeIntegers'>
	self primitiveFailed! !

!PCCByLiteralsTest methodsFor: 'test methods' stamp: 'sr 6/7/2004 10:52'!
lSingularExternalCall
	<primitive: 'lSingularExternalCall' module:'LOne'>
	^ 'Hello World!!'! !

!PCCByLiteralsTest methodsFor: 'constants' stamp: 'sr 6/7/2004 08:41'!
methodSelectorsToExampleModule
	^ #(#lExternalCall1 #lExternalCall2 )! !

!PCCByLiteralsTest methodsFor: 'constants' stamp: 'sr 6/7/2004 08:47'!
moduleNameNotWithSingularCallName
	^ 'LNotOne'! !

!PCCByLiteralsTest methodsFor: 'constants' stamp: 'sr 6/7/2004 08:47'!
moduleNameWithSingularCallName
	^ 'LOne'! !

!PCCByLiteralsTest methodsFor: 'constants' stamp: 'sr 6/7/2004 10:16'!
noExternalCallSelector
	^ #lNoExternalCall! !

!PCCByLiteralsTest methodsFor: 'constants' stamp: 'sr 6/7/2004 10:29'!
realExternalCallOrPrimitiveFailedSelector
	^ #lRealExternalCallOrPrimitiveFailed! !

!PCCByLiteralsTest methodsFor: 'tests' stamp: 'sr 6/7/2004 11:30'!
setUp
	super setUp.
	"disable external calls"
	(self class selectors
		select: [:sel | sel beginsWith: 'lDisabled'])
		do: [:sel | (self class >> sel) literals first at: 4 put: -2]! !

!PCCByLiteralsTest methodsFor: 'constants' stamp: 'sr 6/7/2004 10:54'!
singularCallName
	"occurrs exactly once as prim call name in >>lSingularExternalCall"
	^ 'lSingularExternalCall'! !

!PCCByLiteralsTest methodsFor: 'constants' stamp: 'sr 6/14/2004 23:32'!
singularCallSelector
	^ #lSingularExternalCall! !

!PrimCallControllerAbstractTest class methodsFor: 'Testing' stamp: 'sr 6/7/2004 11:59'!
isAbstract
	^ true! !

!PrimCallControllerAbstractTest methodsFor: 'helper' stamp: 'sr 6/14/2004 22:56'!
avoidSlowTest

	^ doNotMakeSlowTestsFlag and: [pcc class = PCCByCompilation]! !

!PrimCallControllerAbstractTest methodsFor: 'constants' stamp: 'sr 6/7/2004 08:46'!
compiledMethodsToExampleModule
	^ self methodSelectorsToExampleModule
		collect: [:sel | self class >> sel]! !

!PrimCallControllerAbstractTest methodsFor: 'helper' stamp: 'fbs 5/21/2013 22:35'!
disabledCallRefs
	^ self disabledCallSelectors
		collect: [:sel | MethodReference class: self class selector: sel]! !

!PrimCallControllerAbstractTest methodsFor: 'helper' stamp: 'fbs 5/21/2013 22:35'!
enabledCallRefs
	^ self enabledCallSelectors
		collect: [:sel | MethodReference class: self class selector: sel]! !

!PrimCallControllerAbstractTest methodsFor: 'constants' stamp: 'fbs 5/21/2013 22:35'!
failedCallRef
	^ MethodReference class: self class selector: self failedCallSelector! !

!PrimCallControllerAbstractTest methodsFor: 'constants' stamp: 'fbs 5/21/2013 22:36'!
methodRefsToExampleModule
	^ self methodSelectorsToExampleModule
		collect: [:sym | MethodReference class: self class selector: sym]! !

!PrimCallControllerAbstractTest methodsFor: 'constants' stamp: 'fbs 5/21/2013 22:36'!
noExternalCallRef
	^ MethodReference class: self class selector: self noExternalCallSelector! !

!PrimCallControllerAbstractTest methodsFor: 'constants' stamp: 'sr 6/7/2004 08:47'!
numOfCallsExampleModule
	^ self methodSelectorsToExampleModule size! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/15/2004 04:37'!
setUp
	super setUp.
	pcc := self classToBeTested new.
	"set failed call"
	(self class >> self failedCallSelector) literals first at: 4 put: -1.
	"set it to false for some very slow tests..."
	doNotMakeSlowTestsFlag := true! !

!PrimCallControllerAbstractTest methodsFor: 'constants' stamp: 'fbs 5/21/2013 22:36'!
singularCallRef
	^ MethodReference class: self class selector: self singularCallSelector! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/15/2004 03:54'!
testChangeFailedCallFailing
	pcc preserveStatusOfFailedCalls.
	self
		should: [pcc enableCallIn: self failedCallRef]
		raise: TestResult error.
	self
		should: [pcc disableCallIn: self failedCallRef]
		raise: TestResult error! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/14/2004 00:41'!
testChangeFailedCallSucceedingDisable
	pcc changeStatusOfFailedCalls.
	pcc disableCallIn: self failedCallRef.
	self
		assert: (pcc existsDisabledCallIn: self failedCallRef).
	"necessary for PCCByCompilation (to make it visible for initialization again)"
	pcc enableCallIn: self failedCallRef! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/14/2004 00:34'!
testChangeFailedCallSucceedingEnable
	pcc changeStatusOfFailedCalls.
	pcc enableCallIn: self failedCallRef.
	self
		assert: (pcc existsEnabledCallIn: self failedCallRef)! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/15/2004 02:43'!
testDisableCallsIntoModule
	"wrong module"
	self
		should: [pcc disableCallsIntoModule: 'totallyRandom4711']
		raise: TestResult error.
	"precondition: all enabled"
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = self numOfCallsExampleModule.
	"disabling"
	pcc disableCallsIntoModule: self exampleModuleName.
	"now all disabled"
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = 0.
	"not enabled!!"
	self
		should: [pcc disableCallsIntoModule: self exampleModuleName]
		raise: TestResult error.
	"enabling"
	self methodRefsToExampleModule
		do: [:ref | pcc enableCallIn: ref].
	"all enabled now"
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = self numOfCallsExampleModule.
	"not enabled!!"
	self
		should: [pcc disableCallsIntoModule: self failModuleName]
		raise: TestResult error.
	pcc changeStatusOfFailedCalls.
	pcc disableCallsIntoModule: self failModuleName.
	self assert: (pcc existsDisabledCallIn: self failedCallRef).
	"postcondition"
	pcc enableCallIn: self failedCallRef
! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/15/2004 03:24'!
testDisableCallsIntoModuleForClasses
	"wrong module"
	self
		should: [pcc disableCallsIntoModule: 'totallyRandom4711' forClasses: {self class}]
		raise: TestResult error.
	"precondition: all enabled"
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = self numOfCallsExampleModule.
	"disabling"
	pcc disableCallsIntoModule: self exampleModuleName forClasses: {self class}.
	"now all disabled"
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = 0.
	"not enabled!!"
	self
		should: [pcc disableCallsIntoModule: self exampleModuleName forClasses: {self class}]
		raise: TestResult error.
	"enabling"
	self methodRefsToExampleModule
		do: [:ref | pcc enableCallIn: ref].
	"all enabled now"
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = self numOfCallsExampleModule.
	"not enabled!!"
	self
		should: [pcc disableCallsIntoModule: self failModuleName forClasses: {self class}]
		raise: TestResult error.
	pcc changeStatusOfFailedCalls.
	pcc disableCallsIntoModule: self failModuleName forClasses: {self class}.
	self assert: (pcc existsDisabledCallIn: self failedCallRef).
	"postcondition"
	pcc enableCallIn: self failedCallRef
! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/15/2004 02:43'!
testEnableCallsIntoModule
	self avoidSlowTest
		ifTrue: [^ self].
	"wrong module"
	self
		should: [pcc enableCallsIntoModule: 'totallyRandom4711']
		raise: TestResult error.
	"precondition: all enabled"
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = self numOfCallsExampleModule.
	"not disabled!!"
	self
		should: [pcc enableCallsIntoModule: self exampleModuleName]
		raise: TestResult error.
	"disabling"
	self methodRefsToExampleModule
		do: [:ref | pcc disableCallIn: ref].
	"now all disabled"
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = 0.
	"enabling"
	"now this should work"
	pcc enableCallsIntoModule: self exampleModuleName.
	"all enabled now"
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = self numOfCallsExampleModule.
	"not disabled!!"
	self
		should: [pcc enableCallsIntoModule: self failModuleName]
		raise: TestResult error.
	pcc changeStatusOfFailedCalls.
	pcc enableCallsIntoModule: self failModuleName.
	self assert: (pcc existsEnabledCallIn: self failedCallRef)
! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/15/2004 03:43'!
testEnableCallsIntoModuleForClasses
	"wrong module"
	self
		should: [pcc enableCallsIntoModule: 'totallyRandom4711' forClasses: {self class}]
		raise: TestResult error.
	"precondition: all enabled"
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = self numOfCallsExampleModule.
	"not disabled!!"
	self
		should: [pcc enableCallsIntoModule: self exampleModuleName forClasses: {self class}]
		raise: TestResult error.
	"disabling"
	self methodRefsToExampleModule
		do: [:ref | pcc disableCallIn: ref].
	"now all disabled"
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = 0.
	"enabling"
	"now this should work"
	pcc enableCallsIntoModule: self exampleModuleName forClasses: {self class}.
	"all enabled now"
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = self numOfCallsExampleModule.
	"not disabled!!"
	self
		should: [pcc enableCallsIntoModule: self failModuleName forClasses: {self class}]
		raise: TestResult error.
	pcc changeStatusOfFailedCalls.
	pcc enableCallsIntoModule: self failModuleName forClasses: {self class}.
	self assert: (pcc existsEnabledCallIn: self failedCallRef)
! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/11/2004 06:45'!
testEnableDisableCallIn
	| refs |
	refs := self methodRefsToExampleModule.
	"wrong call"
	self
		should: [pcc disableCallIn: self wrongCallRef]
		raise: TestResult error.
	"wrong class"
	self
		should: [pcc disableCallIn: self wrongClassRef]
		raise: TestResult error.
	"wrong call"
	self
		should: [pcc enableCallIn: self wrongCallRef]
		raise: TestResult error.
	"wrong class"
	self
		should: [pcc enableCallIn: self wrongClassRef]
		raise: TestResult error.
	"no external call"
	self
		should: [pcc enableCallIn: self noExternalCallRef]
		raise: TestResult error.
	"precondition: all enabled"
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = self numOfCallsExampleModule.
	"not disabled!!"
	self
		should: [refs
				do: [:ref1 | pcc enableCallIn: ref1]]
		raise: TestResult error.
	"disabling"
	refs
		do: [:ref2 | pcc disableCallIn: ref2].
	"now all disabled"
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = 0.
	"not enabled!!"
	self
		should: [refs
				do: [:ref3 | pcc disableCallIn: ref3]]
		raise: TestResult error.
	"enabling"
	"now this should work"
	refs
		do: [:ref4 | pcc enableCallIn: ref4].
	"all enabled now"
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = self numOfCallsExampleModule.
	"try caches"
	pcc disableEnabled.
	"all disabled"
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = 0.
	pcc enableDisabled.
	"all enabled"
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = self numOfCallsExampleModule! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/14/2004 00:07'!
testEnableDisableCallInCompiledMethod
	"Note: >>compiledMethodsToExampleModule has to be called frequently,  
	since the CMs are changing with a successful compile!!"
	"precondition: all enabled"
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = self numOfCallsExampleModule.
	"not disabled!!"
	self
		should: [self compiledMethodsToExampleModule
				do: [:cm1 | pcc enableCallInCompiledMethod: cm1]]
		raise: TestResult error.
	"disabling"
	self compiledMethodsToExampleModule
		do: [:cm2 | pcc disableCallInCompiledMethod: cm2].
	"now all disabled"
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = 0.
	"not enabled!!"
	self
		should: [self compiledMethodsToExampleModule
				do: [:cm3 | pcc disableCallInCompiledMethod: cm3]]
		raise: TestResult error.
	"enabling"
	"now this should work"
	self compiledMethodsToExampleModule
		do: [:cm4 | pcc enableCallInCompiledMethod: cm4].
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = self numOfCallsExampleModule.
	"try caches"
	pcc disableEnabled.
	"all disabled"
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = 0.
	pcc enableDisabled.
	"all enabled"
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = self numOfCallsExampleModule! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/11/2004 06:57'!
testEnableDisableCallInMethodClass
	| sels |
	sels := self methodSelectorsToExampleModule.
	"wrong call"
	self
		should: [pcc disableCallInMethod: #nonExistingCall class: self class]
		raise: TestResult error.
	"wrong class"
	self
		should: [pcc disableCallInMethod: sels first class: Integer]
		raise: TestResult error.
	"wrong call"
	self
		should: [pcc enableCallInMethod: #nonExistingCall class: self class]
		raise: TestResult error.
	"wrong class"
	self
		should: [pcc enableCallInMethod: sels first class: Integer]
		raise: TestResult error.
	self
		should: [pcc enableCallInMethod: self noExternalCallSelector class: self class]
		raise: TestResult error.
	"precondition: all enabled"
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = self numOfCallsExampleModule.
	"not disabled!!"
	self
		should: [sels
				do: [:sel1 | pcc enableCallInMethod: sel1 class: self class]]
		raise: TestResult error.
	"disabling"
	sels
		do: [:sel2 | pcc disableCallInMethod: sel2 class: self class].
	"now all disabled"
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = 0.
	"not enabled!!"
	self
		should: [sels
				do: [:sel3 | pcc disableCallInMethod: sel3 class: self class]]
		raise: TestResult error.
	"enabling"
	"now this should work"
	sels
		do: [:sel4 | pcc enableCallInMethod: sel4 class: self class].
	"all enabled now"
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = self numOfCallsExampleModule.
	"try caches"
	pcc disableEnabled.
	"all disabled"
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = 0.
	pcc enableDisabled.
	"all enabled"
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = self numOfCallsExampleModule! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/15/2004 03:46'!
testExistsCallIn
	self
		deny: (pcc existsCallIn: self noExternalCallRef).
	self enabledCallRefs , self disabledCallRefs , {self failedCallRef}
		do: [:callRef | self
				assert: (pcc existsCallIn: callRef)]! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/15/2004 03:47'!
testExistsDisabledCallIn
	self
		deny: (pcc existsDisabledCallIn: self noExternalCallRef).
	self
		deny: (pcc existsDisabledCallIn: self failedCallRef).
	self enabledCallRefs
		do: [:callRef | self
				deny: (pcc existsDisabledCallIn: callRef)].
	self disabledCallRefs
		do: [:disabledRef | self
				assert: (pcc existsDisabledCallIn: disabledRef)]! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/15/2004 03:48'!
testExistsEnabledCallIn
	self
		deny: (pcc existsEnabledCallIn: self noExternalCallRef).
	self
		deny: (pcc existsEnabledCallIn: self failedCallRef).
	self enabledCallRefs
		do: [:callRef | self
				assert: (pcc existsEnabledCallIn: callRef)].
	self disabledCallRefs
		do: [:disabledRef | self
				deny: (pcc existsEnabledCallIn: disabledRef)]! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/15/2004 03:49'!
testExistsFailedCallIn
	self
		deny: (pcc existsFailedCallIn: self noExternalCallRef).
	self enabledCallRefs , self disabledCallRefs
		do: [:callRef | self
				deny: (pcc existsFailedCallIn: callRef)].
	self
		assert: (pcc existsFailedCallIn: self failedCallRef)! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/14/2004 23:25'!
testMethodsWithCallAndMethodsWithDisabledCall
	| methodRefs disabledMethodRefs enabledMethodRefs failedMethodRefs |
	self avoidSlowTest
		ifTrue: [^ self].
	disabledMethodRefs := pcc methodsWithDisabledCall.
	self assert: disabledMethodRefs size > 0.
	enabledMethodRefs := pcc methodsWithEnabledCall.
	self assert: enabledMethodRefs size > 0.
	failedMethodRefs := pcc methodsWithFailedCall.
	self assert: failedMethodRefs size > 0.
	methodRefs := pcc methodsWithCall.
	self assert: methodRefs size = (disabledMethodRefs size + enabledMethodRefs size + failedMethodRefs size)! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/14/2004 22:54'!
testMethodsWithCallIntoModule
	| methodRefs |
	self avoidSlowTest ifTrue: [^ self].
	"precondition: all enabled"
	pcc disableCallIn: self methodRefsToExampleModule first.
	methodRefs := pcc methodsWithCallIntoModule: self exampleModuleName.
	self assert: methodRefs size = self numOfCallsExampleModule.
	"postcondition"
	pcc enableCallIn: self methodRefsToExampleModule first! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/14/2004 22:32'!
testMethodsWithCallIntoModuleForClass
	"precondition: all enabled"
	| methodRefs |
	pcc disableCallIn: self methodRefsToExampleModule first.
	methodRefs := pcc methodsWithCallIntoModule: self exampleModuleName forClass: self class.
	self assert: methodRefs size = self numOfCallsExampleModule.
	"postcondition"
	pcc enableCallIn: self methodRefsToExampleModule first.
	methodRefs := pcc methodsWithCallIntoModule: nil forClass: self class.
	self
		assert: (methodRefs size = 2
				and: [| methodCoreStrings | 
					methodCoreStrings := methodRefs
								collect: [:mRef | mRef methodSymbol allButFirst asString].
					(methodCoreStrings includes: 'ExternalCallWithoutModule')
						and: [methodCoreStrings includes: 'DisabledExternalCallWithoutModule']])! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/14/2004 22:31'!
testMethodsWithCallIntoModuleForClasses
	"precondition: all enabled"
	| methodRefs |
	pcc disableCallIn: self methodRefsToExampleModule first.
	methodRefs := pcc methodsWithCallIntoModule: self exampleModuleName forClasses: {self class}.
	self assert: methodRefs size = self numOfCallsExampleModule.
	"postcondition"
	pcc enableCallIn: self methodRefsToExampleModule first.
	methodRefs := pcc methodsWithCallIntoModule: nil forClasses: {self class}.
	self
		assert: (methodRefs size = 2
				and: [| methodCoreStrings | 
					methodCoreStrings := methodRefs
								collect: [:mRef | mRef methodSymbol allButFirst asString].
					(methodCoreStrings includes: 'ExternalCallWithoutModule')
						and: [methodCoreStrings includes: 'DisabledExternalCallWithoutModule']])! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/15/2004 03:36'!
testMethodsWithCallX
	| methodRefs |
	self avoidSlowTest
		ifTrue: [^ self].
	methodRefs := pcc methodsWithCall: self singularCallName.
	self assert: methodRefs size = 1! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/15/2004 03:34'!
testMethodsWithCallXIntoModule
	| methodRefs |
	self avoidSlowTest
		ifTrue: [^ self].
	methodRefs := pcc methodsWithCall: self singularCallName intoModule: self moduleNameWithSingularCallName.
	self assert: methodRefs size = 1.
	methodRefs := pcc methodsWithCall: self singularCallName intoModule: self moduleNameNotWithSingularCallName.
	self assert: methodRefs isEmpty! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/14/2004 23:04'!
testMethodsWithDisabledCallIntoModule
	| methodRefs |
	self avoidSlowTest ifTrue: [^ self].
	"precondition: all enabled"
	pcc disableCallIn: self methodRefsToExampleModule first.
	methodRefs := pcc methodsWithDisabledCallIntoModule: self exampleModuleName.
	self assert: methodRefs size = 1.
	"postcondition"
	pcc enableCallIn: self methodRefsToExampleModule first! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/14/2004 22:37'!
testMethodsWithDisabledCallIntoModuleForClass
	"precondition: all enabled"
	| methodRefs |
	self methodRefsToExampleModule
		do: [:ref | pcc disableCallIn: ref].
	methodRefs := pcc methodsWithDisabledCallIntoModule: self exampleModuleName forClass: self class.
	self assert: methodRefs size = self numOfCallsExampleModule.
	"postcondition"
	self methodRefsToExampleModule
		do: [:ref | pcc enableCallIn: ref].
	methodRefs := pcc methodsWithDisabledCallIntoModule: nil forClass: self class.
	self assert: methodRefs size = 1 & (methodRefs first methodSymbol allButFirst = 'DisabledExternalCallWithoutModule')! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/11/2004 06:46'!
testMethodsWithDisabledCallIntoModuleForClasses
	"precondition: all enabled"
	| methodRefs |
	self methodRefsToExampleModule
		do: [:ref | pcc disableCallIn: ref].
	methodRefs := pcc methodsWithDisabledCallIntoModule: self exampleModuleName forClasses: {self class}.
	self assert: methodRefs size = self numOfCallsExampleModule.
	"postcondition"
	self methodRefsToExampleModule
		do: [:ref | pcc enableCallIn: ref].
	methodRefs := pcc methodsWithDisabledCallIntoModule: nil forClasses: {self class}.
	self assert: methodRefs size = 1 & (methodRefs first methodSymbol allButFirst = 'DisabledExternalCallWithoutModule')! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/14/2004 23:38'!
testMethodsWithDisabledCallX
	| methodRefs |
	self avoidSlowTest
		ifTrue: [^ self].
	"precondition: all enabled"
	pcc disableCallIn: self singularCallRef.
	methodRefs := pcc methodsWithDisabledCall: self singularCallName.
	self assert: methodRefs size = 1 & (methodRefs first methodSymbol = self singularCallName).
	"postcondition"
	pcc enableCallIn: self singularCallRef! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/14/2004 23:42'!
testMethodsWithDisabledCallXIntoModule
	"precondition: all enabled"
	| methodRefs |
	self avoidSlowTest
		ifTrue: [^ self].
	"precondition: all enabled"
	pcc disableCallIn: self singularCallRef.
	methodRefs := pcc methodsWithDisabledCall: self singularCallName intoModule: self moduleNameWithSingularCallName.
	self assert: methodRefs size = 1.
	methodRefs := pcc methodsWithDisabledCall: self singularCallName intoModule: self moduleNameNotWithSingularCallName.
	self assert: methodRefs isEmpty.
	"postcondition"
	pcc enableCallIn: self singularCallRef! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/11/2004 07:13'!
testMethodsWithEnabledCall
	| methodRefs |
	methodRefs := pcc methodsWithEnabledCall.
	self assert: methodRefs size > 0! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/11/2004 07:17'!
testMethodsWithEnabledCallIntoModule
	| methodRefs |
	methodRefs := pcc methodsWithEnabledCallIntoModule: self exampleModuleName.
	self assert: methodRefs size = self numOfCallsExampleModule! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/14/2004 22:43'!
testMethodsWithEnabledCallIntoModuleForClass
	"precondition: all enabled"
	| methodRefs |
	methodRefs := pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class.
	self assert: methodRefs size = self numOfCallsExampleModule.
	methodRefs := pcc methodsWithEnabledCallIntoModule: nil forClass: self class.
	self assert: methodRefs size = 1 & (methodRefs first methodSymbol allButFirst = 'ExternalCallWithoutModule')! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/11/2004 07:12'!
testMethodsWithEnabledCallIntoModuleForClasses
	"precondition: all enabled"
	| methodRefs |
	methodRefs := pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClasses: {self class}.
	self assert: methodRefs size = self numOfCallsExampleModule.
	methodRefs := pcc methodsWithEnabledCallIntoModule: nil forClasses: {self class}.
	self assert: methodRefs size = 1 & (methodRefs first methodSymbol allButFirst = 'ExternalCallWithoutModule')! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/11/2004 06:16'!
testMethodsWithEnabledCallX
	| methodRefs |
	methodRefs := pcc methodsWithEnabledCall: self singularCallName.
	self assert: methodRefs size = 1 & (methodRefs first methodSymbol = self singularCallName)! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/11/2004 07:17'!
testMethodsWithEnabledCallXIntoModule
	"precondition: all enabled"
	| methodRefs |
	methodRefs := pcc methodsWithEnabledCall: self singularCallName intoModule: self moduleNameWithSingularCallName.
	self assert: methodRefs size = 1.
	methodRefs := pcc methodsWithEnabledCall: self singularCallName intoModule: self moduleNameNotWithSingularCallName.
	self assert: methodRefs isEmpty! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/15/2004 03:07'!
testMethodsWithFailedCall
	| methodRefs |
	methodRefs := pcc methodsWithFailedCall.
	self assert: methodRefs size >= 1 & ((methodRefs
				select: [:mRef | mRef methodSymbol = self failedCallSelector]) size = 1)! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/15/2004 03:11'!
testMethodsWithFailedCallForClass
	| methodRefs |
	methodRefs := pcc methodsWithFailedCallForClass: self class.
	self assert: methodRefs size = 1 & (methodRefs asArray first methodSymbol = self failedCallSelector)! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/15/2004 02:54'!
testMethodsWithFailedCallIntoModule
	| methodRefs |
	methodRefs := pcc methodsWithFailedCallIntoModule: self failModuleName.
	self assert: methodRefs size = 1 & (methodRefs first methodSymbol = self failedCallSelector)! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/15/2004 03:13'!
testMethodsWithFailedCallIntoModuleForClass
	| methodRefs |
	methodRefs := pcc methodsWithFailedCallIntoModule: self failModuleName forClass: self class.
	self assert: methodRefs size = 1 & (methodRefs first methodSymbol = self failedCallSelector)! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'fbs 11/5/2013 22:59'!
testSwitchPrimCallOffOn
	| res |
	pcc disableCallInMethod: self realExternalCallOrPrimitiveFailedSelector class: self class.
	self
		should: [self perform: self realExternalCallOrPrimitiveFailedSelector]
		raise: TestResult error.
	pcc enableCallInMethod: self realExternalCallOrPrimitiveFailedSelector class: self class.
	res := self perform: self realExternalCallOrPrimitiveFailedSelector.
	self assert: res isString! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/11/2004 06:46'!
testSwitchStored
	| refs |
	"all enabled, precondition"
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = self numOfCallsExampleModule.
	refs := self methodRefsToExampleModule.
	"fill cache"
	refs
		do: [:ref | pcc disableCallIn: ref].
	"enable one"
	pcc enableCallIn: refs first.
	self
		assert: (pcc existsEnabledCallIn: refs first).
	self
		assert: (pcc existsDisabledCallIn: refs second).
	"switching"
	pcc switchStored.
	"now the checks go vice versa"
	self
		assert: (pcc existsDisabledCallIn: refs first).
	self
		assert: (pcc existsEnabledCallIn: refs second).
	pcc enableCallIn: refs first.
	self
		assert: (pcc existsEnabledCallIn: refs first)! !

!PrimCallControllerAbstractTest methodsFor: 'tests' stamp: 'sr 6/11/2004 06:46'!
testTryCaches
	| refs |
	"all enabled, precondition"
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = self numOfCallsExampleModule.
	refs := self methodRefsToExampleModule.
	"fill cache"
	refs
		do: [:ref | pcc disableCallIn: ref].
	"try caches"
	pcc enableDisabled.
	"all enabled"
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = self numOfCallsExampleModule.
	pcc disableEnabled.
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = 0.
	pcc enableDisabled.
	"all enabled, postcondition"
	self assert: (pcc methodsWithEnabledCallIntoModule: self exampleModuleName forClass: self class) size = self numOfCallsExampleModule! !

!PrimCallControllerAbstractTest methodsFor: 'constants' stamp: 'fbs 5/21/2013 22:36'!
wrongCallRef
	^ MethodReference class: self class selector: #nonExistingCall! !

!PrimCallControllerAbstractTest methodsFor: 'constants' stamp: 'fbs 5/21/2013 22:36'!
wrongClassRef
	^ MethodReference class: Integer selector: self methodSelectorsToExampleModule first! !

ClassTestCase subclass: #SecureHashAlgorithmTest
	instanceVariableNames: 'hash'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Digital Signatures'!

!SecureHashAlgorithmTest commentStamp: '<historical>' prior: 0!
This is the unit test for the class SecureHashAlgorithm. Unit tests are a good way to exercise the functionality of your system in a repeatable and automatic manner. They are therefore recommended if you plan to release anything. For more information, see: 
	- http://www.c2.com/cgi/wiki?UnitTest
	- http://minnow.cc.gatech.edu/squeak/1547
	- the sunit class category!

!SecureHashAlgorithmTest methodsFor: 'testing - examples' stamp: 'ar 2/25/2010 23:40'!
testEmptyInput
	self assert: ((SecureHashAlgorithm new hashMessage: '') radix: 16)
			= 'DA39A3EE5E6B4B0D3255BFEF95601890AFD80709'! !

!SecureHashAlgorithmTest methodsFor: 'testing - examples' stamp: 'md 4/21/2003 12:23'!
testExample1

	"This is the first example from the specification document (FIPS PUB 180-1)"

	hash := SecureHashAlgorithm new hashMessage: 'abc'.
	self assert: (hash = 16rA9993E364706816ABA3E25717850C26C9CD0D89D).
		! !

!SecureHashAlgorithmTest methodsFor: 'testing - examples' stamp: 'md 4/21/2003 12:23'!
testExample2

	"This is the second example from the specification document (FIPS PUB 180-1)"

	hash := SecureHashAlgorithm new hashMessage:
		'abcdbcdecdefdefgefghfghighijhijkijkljklmklmnlmnomnopnopq'.
	self assert: (hash = 16r84983E441C3BD26EBAAE4AA1F95129E5E54670F1).! !

!SecureHashAlgorithmTest methodsFor: 'testing - examples' stamp: 'md 4/21/2003 12:25'!
testExample3

	"This is the third example from the specification document (FIPS PUB 180-1). 
	This example may take several minutes."

	hash := SecureHashAlgorithm new hashMessage: (String new: 1000000 withAll: $a).
	self assert: (hash = 16r34AA973CD4C4DAA4F61EEB2BDBAD27316534016F).! !

Preferences subclass: #PreferencesTestPreferences
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-System-Preferences'!

!PreferencesTestPreferences class methodsFor: 'class initialization' stamp: 'mt 8/27/2015 11:10'!
initialize

	super initialize.
	self initializeDictionaryOfPreferences.! !

LongTestCase subclass: #BytecodeDecodingTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Compiler'!

!BytecodeDecodingTests methodsFor: 'tests' stamp: 'eem 5/13/2016 12:19'!
testPCPreviousTo
	"Check that the pcPreviousTo machinery answers the truth for all bytecodes."
	self systemNavigation allSelect:
		[:m| | ec is prevPC prevBlockCreationPC exclude |
		m isQuick ifFalse:
			[ec := m encoderClass.
			 is:= InstructionStream on: m.
			 exclude := OrderedCollection new.
			 m embeddedBlockClosures do:
				[:ebc| | followingpc |
				followingpc := ebc endPC + (ec bytecodeSize: (m at: ebc endPC)).
				exclude addLast: ebc startpc; addLast: followingpc..
				self assert: nil
					equals: (ec pcPreviousTo: ebc startpc in: m for: nil).
				self assert: (ec pcOfBlockCreationBytecodeForBlockStartingAt: ebc startpc in: m)
					equals: (ec pcPreviousTo: followingpc in: m for: nil)].
			 is scanFor:
				[:b|
				(exclude includes: is pc) ifFalse:
					[self assert: prevPC
						equals: (ec pcPreviousTo: is pc in: m for: nil)].
				prevPC := is pc.
				b = ec createClosureCode ifTrue: [prevBlockCreationPC := prevPC].
				false].].
		 false]! !

!BytecodeDecodingTests methodsFor: 'tests' stamp: 'eem 5/13/2016 11:52'!
testWillReallyStore
	"Check that the willReallyStore machinery answers the truth for all bytecodes."
	self systemNavigation allSelect:
		[:m| | is sawITV pnac |
		m isQuick ifFalse:
			[sawITV := false. pnac := m encoderClass pushNewArrayCode.
			 is:= InstructionStream on: m.
			 is scanFor:
				[:b|
				sawITV
					ifTrue:
						[self assert: (m encoderClass isSyntheticStoreAt: is pc in: m for: nil)]
					ifFalse:
						[self deny: (m encoderClass isSyntheticStoreAt: is pc in: m for: nil)].
				"The only bytecode following a pushNewArrayCode that creates an empty array should be a synthetic store."
				sawITV := b = pnac and: [is secondByte <= 127].
				false]].
		 false]! !

LongTestCase subclass: #DecompilerTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Compiler'!

!DecompilerTests commentStamp: 'sd 9/26/2004 13:24' prior: 0!
Apparently the decompiler does not really work totally.
Here are a bunch of methods that can help improving the decompiler:
	- blockingClasses return class for which it is impossible to decompile methods 
	- failures are problems that lead to a DNU
	- decompilerDiscrepancies are the results of running decompileTestHelper..as you see the pattern 	
	is quite present.!

DecompilerTests subclass: #DecompilerTestFailuresCollector
	instanceVariableNames: 'failures'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Compiler'!

!DecompilerTestFailuresCollector commentStamp: '<historical>' prior: 0!
(| dtfc |
dtfc := DecompilerTestFailuresCollector new.
(dtfc class superclass organization listAtCategoryNamed: #tests) do:
	[:s| dtfc perform: s].
dtfc failures)

(Transcript nextPut: ${.
self do: [:mr| Transcript print: mr actualClass; nextPut: $.; space; store: mr methodSymbol; nextPut: $.; cr; flush].
Transcript nextPut: $}; flush)

eem 7/1/2009 16:13
{AdditionalMethodState. #keysAndValuesDo:.
AdditionalMethodState. #propertyKeysAndValuesDo:.
AdditionalMethodState. #at:ifAbsent:.
AdditionalMethodState. #removeKey:ifAbsent:.
AdditionalMethodState. #at:ifAbsentPut:.
AdditionalMethodState. #setMethod:.
AdditionalMethodState. #at:put:.
AdditionalMethodState. #pragmas.
AdditionalMethodState. #includesProperty:.
AdditionalMethodState. #properties.
AdditionalMethodState. #hasLiteralSuchThat:.
AdditionalMethodState. #propertyValueAt:ifAbsent:.
AdditionalMethodState. #hasLiteralThorough:.
Array. #hasLiteralSuchThat:.
BitBltSimulation. #initDither8Lookup.
BlockNode. #sizeCodeExceptLast:.
BlockNode. #emitCodeExceptLast:encoder:.
Categorizer. #changeFromCategorySpecs:.
Categorizer. #elementCategoryDict.
CColorPicker. #colors:.
CCustomDrawListCostume. #drawListOn:in:.
ChangeList. #browseCurrentVersionsOfSelections.
ClosureTests. #testToDoInsideTemp.
Cogit. #computeMaximumSizes.
Cogit. #outputInstructionsAt:.
Cogit. #generateMapAt:start:.
CogVMSimulator. #printFrameThing:at:.
CogVMSimulator. #str:n:cmp:.
CoInterpreter. #validStackPageBaseFrames.
CoInterpreter. #markAndTraceTraceLog.
CoInterpreter. #mapTraceLog.
CoInterpreter. #checkStackIntegrity.
CoInterpreter. #mapStackPages.
CoInterpreter. #updateStackZoneReferencesToCompiledCodePreCompaction.
CoInterpreter. #ceActivateFailingPrimitiveMethod:.
CoInterpreterStackPages. #initializeStack:numSlots:pageSize:stackLimitOffset:stackPageHeadroom:.
CompiledMethod. #=.
CompiledMethod. #getPreambleFrom:at:.
CompiledMethod. #hasLiteralThorough:.
CompiledMethod. #hasLiteralSuchThat:.
CPopUpMenuCostume. #drawMenu:on:in:.
CroquetParticipant. #dropFiles:.
CTextParagraph. #selectionRectsFrom:to:.
CWheelWidgetCostume. #drawOn:in:.
Dictionary. #scanFor:.
Float. #printPaddedWith:to:.
FMSound. #mixSampleCount:into:startingAt:leftVol:rightVol:.
Form. #transformColors:.
FTPClient. #getDataInto:.
GIFReadWriter. #nextImageWithPlugin.
GraphMorph. #drawDataOn:.
GZipReadStream. #on:from:to:.
HTTPServiceDispatcher. #errorReportFor:stack:on:.
HttpUrl. #checkAuthorization:retry:.
Integer. #benchSwitch:.
Interpreter. #primitiveClosureValueWithArgs.
Interpreter. #primitivePerformAt:.
Interpreter. #primitiveDoPrimitiveWithArgs.
Interpreter. #primitiveNewMethod.
InterpreterStackPages. #initializeStack:numSlots:pageSize:stackLimitOffset:stackPageHeadroom:.
JPEGReadWriter. #decodeBlockInto:component:dcTable:acTable:.
KeyedIdentitySet. #scanFor:.
KeyedSet. #scanFor:.
LargeIntegersPlugin. #isNormalized:.
LargeIntegersPlugin. #cBytesCopyFrom:to:len:.
LargeIntegersPlugin. #cDigitMultiply:len:with:len:into:.
LiteralDictionary. #scanFor:.
LoopedSampledSound. #mixSampleCount:into:startingAt:leftVol:rightVol:.
MethodDictionary. #scanFor:.
MP4BoxInfoParser. #parseMP4BoxOutput:.
MP4BoxNHMLTrack. #computeDTSDeltas.
MultiByteBinaryOrTextStream. #next:.
MultiByteFileStream. #next:.
MViewPane. #reconstructEnabledDocuments.
MViewPane. #reconstructOpenDocuments.
MViewPane. #reconstructSelectionList.
NewParagraph. #selectionRectsFrom:to:.
Object. #instanceFields.
OldSocket. #getResponseNoLF.
PasteUpMorph. #dropFiles:.
PlotMorphGrid. #bestStep:.
PluckedSound. #reset.
PluggableDictionary. #scanFor:.
PluggableSet. #scanFor:.
PluggableTabButtonMorph. #calculateArcLengths.
PluggableTabButtonMorph. #drawTabOn:.
PNGReadWriter. #copyPixelsGray:.
PNMReadWriter. #readPlainRGB.
PNMReadWriter. #readBWreverse:.
PNMReadWriter. #nextPutRGB:.
PNMReadWriter. #nextPutBW:reverse:.
PopUpMenu. #readKeyboard.
QFloorFan. #initialize.
QMinimalForum. #demoDesksUnused.
QNetVidReorderingBuffer. #popFramesForCTS:.
QNetVidTrackStreamer. #sampleIndexWithCTS:.
QServiceProvider. #statusReport.
QServicesPane. #forumMenuInto:.
QUserListItem. #drawOn:in:.
QVMProfiler. #computeHistograms:.
QVMProfiler. #selectSymbolsInRange.
QwaqParticipantUI. #onDropFiles:.
RelativeInstructionPrinter. #print:.
RemoteHandMorph. #appendNewDataToReceiveBuffer.
SchizophrenicClosureFormatStackInterpreter. #primitiveClosureValueWithArgs.
Set. #do:.
Set. #scanFor:.
SHParserST80. #isBinary.
ShootoutMall. #processVisitors.
ShortIntegerArray. #writeOn:.
SparseLargeArray. #analyzeSpaceSaving.
StackInterpreter. #validStackPageBaseFrames.
StackInterpreter. #divorceAllFrames.
StackInterpreter. #checkStackIntegrity.
StackInterpreter. #primitiveDoPrimitiveWithArgs.
StackInterpreter. #reverseDisplayFrom:to:.
StackInterpreter. #printOop:.
StackInterpreter. #mapStackPages.
StackInterpreter. #primitiveNewMethod.
StackInterpreter. #primitiveClosureValueWithArgs.
StrikeFontSet. #displayStringR2L:on:from:to:at:kern:.
String. #howManyMatch:.
Text. #asHtmlFragmentTextStyle:useBreaks:.
TextURL. #actOnClickFor:.
TFractalTerrain. #heightAt:.
TFractalTerrain. #makeFaces.
TFractalTerrain. #makeVertices.
TFractalTerrain. #makeTextureUV.
TFractalTerrain. #makeVertexNormals.
TFrame. #computeUnionSphere.
TMethod. #emitCCommentOn:.
TRFBStreamOutput. #handleRequest:.
TTCFontReader. #processCharacterMappingTable:.
TTContourConstruction. #segmentsDo:.
TTensor. #projectionIntegrate:.
TTFontReader. #processHorizontalMetricsTable:length:.
TTFontReader. #processCharacterMappingTable:.
TWaves. #step.
Vector. #copyFrom:.
Vector. #asVector3.
VectorColor. #copyFrom:.
WeakKeyDictionary. #scanForNil:.
WeakKeyDictionary. #scanFor:.
WeakSet. #scanFor:.
WeakSet. #scanForLoadedSymbol:.
}!

!DecompilerTestFailuresCollector methodsFor: 'accessing' stamp: 'ul 5/6/2015 16:36'!
assert: aBoolean description: aString resumable: resumableBoolean

	| method |
	aBoolean ifTrue: [ ^self ].
	method := thisContext sender home tempAt: 1.
	self noteFailure: TestFailure for: method! !

!DecompilerTestFailuresCollector methodsFor: 'utilities' stamp: 'ul 5/6/2015 16:38'!
checkDecompileMethod: oldMethod
	
	[ super checkDecompileMethod: oldMethod ]
		on: Error
		do: [ :error | self noteFailure: error class for: oldMethod ]! !

!DecompilerTestFailuresCollector methodsFor: 'accessing' stamp: 'ul 5/6/2015 16:45'!
computeFailures
	
	| tests |
	failures := nil.
	tests := (DecompilerTests organization listAtCategoryNamed: #tests) select: [ :s |
		(s beginsWith: 'testDecompilerInClasses') ].
	CurrentReadOnlySourceFiles cacheDuring: [
		tests
			do: [ :each | self perform: each ]
			displayingProgress: 'Computing failures...' ].
	^self decompilerFailures! !

!DecompilerTestFailuresCollector methodsFor: 'accessing' stamp: 'ul 5/6/2015 16:53'!
decompilerFailures

	failures ifNil: [ ^#() ].
	^failures asArray sort: [ :a :b |
		| r |
		r := a first compare: b first caseSensitive: false.
		r = 1 or: [ r = 2 and: [
			(a second compare: b second caseSensitive: false) <= 2 ] ] ]! !

!DecompilerTestFailuresCollector methodsFor: 'accessing' stamp: 'ul 5/6/2015 16:23'!
errorClassForFailureFor: class selector: selector

	^nil! !

!DecompilerTestFailuresCollector methodsFor: 'utilities' stamp: 'ul 5/6/2015 16:24'!
exceptionClassForFailureFor: class  selector: selector
	
	^nil! !

!DecompilerTestFailuresCollector methodsFor: 'accessing' stamp: 'eem 11/10/2008 15:47'!
failures
	^failures! !

!DecompilerTestFailuresCollector methodsFor: 'utilities' stamp: 'ul 5/6/2015 16:40'!
noteFailure: exceptionClass for: method

	(failures ifNil: [ failures := OrderedCollection new ]) add: {
		method methodClass name.
		method selector.
		exceptionClass name }! !

!DecompilerTests methodsFor: 'utilities' stamp: 'eem 9/27/2011 08:51'!
checkDecompileMethod: oldMethod
	
	| cls selector oldMethodNode methodNode newMethod oldCodeString newCodeString |
	cls := oldMethod methodClass.
	selector := oldMethod selector.
	oldMethodNode := (cls decompilerClass new withTempNames: oldMethod methodNode schematicTempNamesString)
							decompile: selector
							in: cls
							method: oldMethod methodForDecompile.
	[oldMethodNode properties includesKey: #warning] whileTrue:
		[oldMethodNode properties removeKey: #warning].
	oldCodeString := oldMethodNode decompileString.
	methodNode := [cls newCompiler
						compile: oldCodeString
						in: cls
						notifying: nil
						ifFail: []]
						on: SyntaxErrorNotification
						do: [:ex|
							ex errorMessage = 'Cannot store into' ifTrue:
								[ex return: #badStore].
							ex pass].
	"Ignore cannot store into block arg errors; they're not our issue."
	methodNode ~~ #badStore ifTrue:
		[newMethod := methodNode generate.
		 newCodeString := ((cls decompilerClass new withTempNames: methodNode schematicTempNamesString)
								decompile: selector
								in: cls
								method: newMethod methodForDecompile) decompileString.
		 "(StringHolder new textContents:
			(TextDiffBuilder buildDisplayPatchFrom: oldCodeString to: newCodeString))
				openLabel: 'Decompilation Differences for ', cls name,'>>',selector"
		 "(StringHolder new textContents:
			(TextDiffBuilder buildDisplayPatchFrom: oldMethod abstractSymbolic to: newMethod abstractSymbolic))
				openLabel: 'Bytecode Differences for ', cls name,'>>',selector"
		 self assert: oldCodeString = newCodeString
			description: cls name asString, ' ', selector asString
			resumable: true]! !

!DecompilerTests methodsFor: 'utilities' stamp: 'ul 3/27/2011 17:27'!
classNames
	
	^Smalltalk globals classAndTraitNames! !

!DecompilerTests methodsFor: 'utilities' stamp: 'ul 5/6/2015 15:57'!
decompileClassesSelect: aBlock

	CurrentReadOnlySourceFiles cacheDuring: [
		(self classNames select: aBlock) do: [ :cn |
			| class |
			(class := Smalltalk classNamed: cn) selectorsAndMethodsDo: [ :selector :method |
			(self exceptionClassForFailureFor: class  selector: selector)
				ifNil: [ self checkDecompileMethod: method ]
				ifNotNil: [ :exceptionClass |
					self
						should: [ self checkDecompileMethod: method ]
						raise: exceptionClass ] ] ] ]! !

!DecompilerTests methodsFor: 'utilities' stamp: 'eem 8/31/2010 14:26'!
decompileStringForParseTree: aMethodNode
	"Renumber the temps in the tree in parse tree order to eliminate that as a source of extraneous difference."
	| visited count counter |
	visited := IdentitySet new.
	count := 0.
	counter := [:temp|
				(visited includes: temp) ifFalse:
					[temp name: 't', (count := count + 1) printString.
					 visited add: temp]].
	aMethodNode nodesDo:
		[:node|
		(node == aMethodNode or: [node isBlockNode and: [node optimized not]]) ifTrue:
			[node arguments do: counter].
		node isTemp ifTrue:
			[counter value: node]].
	
	aMethodNode nodesDo:
		[:node|
		(node == aMethodNode or: [node isBlockNode and: [node optimized not]]) ifTrue:
			[node temporaries do: counter.
			 node temporaries: (node temporaries asSortedCollection: ParseNode tempSortBlock) asArray]].
	^aMethodNode decompileString! !

!DecompilerTests methodsFor: 'utilities' stamp: 'mt 8/17/2016 08:59'!
decompilerFailures
	"Here is the list of failures: either a syntax error, a hard error or some failure to decompile correctly.
	 Collected via 
		DecompilerTestFailuresCollector new computeFailures."

	"class name, selector, error class name or nil"
	^  #(
		#(Behavior toolIconSelector: TestFailure) 
		#(BrowserCommentTextMorph showPane SyntaxErrorNotification) 
		#(ClassDescription replaceSilently:to: SyntaxErrorNotification) 
		#(CodeHolder getSelectorAndSendQuery:to:with: SyntaxErrorNotification) 
		#(Date printOn: TestFailure) 
		#(DecompilerTests testDecompileUnreachableParameter Error) 
		#(FontImporterTool fontFromFamily: SyntaxErrorNotification) "same-name block-local temps in optimized blocks"
		#(HttpUrl checkAuthorization:retry: TestFailure) 
		#(LargeNegativeIntegerTest testReplaceFromToWithStartingAt SyntaxErrorNotification) "same-name block-local temps in optimized blocks"
		#(LargePositiveIntegerTest testReplaceFromToWithStartingAt SyntaxErrorNotification) "same-name block-local temps in optimized blocks"
		#(MailComposition breakLinesInMessage: SyntaxErrorNotification) 
		#(MCConfigurationBrowser post SyntaxErrorNotification) 
		#(MVCToolBuilder setLayout:in: SyntaxErrorNotification) "same-name block-local temps in optimized blocks"
		#(ParagraphEditor inOutdent:delta: SyntaxErrorNotification) 
		#(PNGReadWriter copyPixelsGray: SyntaxErrorNotification) 
		#(ProtoObjectTest testIfNilIfNotNil SyntaxErrorNotification) 
		#(ProtoObjectTest testIfNotNil SyntaxErrorNotification) 
		#(ProtoObjectTest testIfNotNilIfNil SyntaxErrorNotification) 
		#(RxsCharSet enumerablePartPredicateIgnoringCase: SyntaxErrorNotification) 
		#(ScaledDecimalTest testConvertFromFraction SyntaxErrorNotification) "local/non-local temps"
		#(SHMCClassDefinition withAllSuperclassesDo: SyntaxErrorNotification) "same-name block-local temps in optimized blocks"
		#(StandardScriptingSystem holderWithAlphabet SyntaxErrorNotification) "same-name block-local temps in optimized blocks"
		#(SyntaxMorph mouseEnterDragging: SyntaxErrorNotification) 
		#(SystemWindow convertAlignment SyntaxErrorNotification) 
		#(TextEditor inOutdent:delta: SyntaxErrorNotification) 
		#(TextURL actOnClickFor: TestFailure) 
		#(TTContourConstruction segmentsDo: SyntaxErrorNotification) "Worth fixing; these two are mistaken conversion from a whileTrue: to a to:do: but the index is used outside the whileTrue:"
		#(TTFontReader processHorizontalMetricsTable:length: SyntaxErrorNotification)
		#(WeakSet scanForLoadedSymbol: TestFailure))! !

!DecompilerTests methodsFor: 'utilities' stamp: 'ul 5/6/2015 15:59'!
exceptionClassForFailureFor: class selector: selector
	
	^self decompilerFailures
		detect: [ :each | each first = class name and: [ each second = selector ] ]
		ifFound: [ :each | each third ifNotNil: [ Smalltalk classNamed: each third ] ]
		ifNone: [ nil ]! !

!DecompilerTests methodsFor: 'testing' stamp: 'fbs 6/27/2013 20:53'!
expectedFailures
	^ #(testDecompileUnreachableParameter)! !

!DecompilerTests methodsFor: 'initialize-release' stamp: 'nice 9/8/2010 00:52'!
tearDown
	self class removeSelector: #loopWithMovingLimit! !

!DecompilerTests methodsFor: 'tests' stamp: 'fbs 11/5/2013 22:43'!
testDecompileAnswerToDoLoop
	"This is a non regression test for Compiler-nice.224."
	"DecompilerTests new testDecompileAnswerToDoLoop"
	| sourceCode mn decompiledCode  |
	sourceCode := '^nil to: 3 do: [:i| i class]'.
	mn := self class newCompiler compileNoPattern: sourceCode in: self class notifying: nil ifFail: [self error: 'failed'].
	decompiledCode := mn generateWithTempNames decompileWithTemps asString.
	
	"This to avoid getting fooled by changes in decompilation due to code formatting preferences."
	decompiledCode := decompiledCode copyReplaceAll: {Character cr. Character tab. Character tab } with: ' '.
	decompiledCode := decompiledCode copyReplaceAll: '^ ' with: '^'.
	decompiledCode := decompiledCode copyReplaceAll: ' |' with: '|'.
	self
		assert: (decompiledCode endsWith: sourceCode)
		description: 'decompilation should match source'.! !

!DecompilerTests methodsFor: 'tests' stamp: 'fbs 11/5/2013 22:44'!
testDecompileLoopWithMovingLimit
	"This is a non regression test for http://bugs.squeak.org/view.php?id=7093"
	
	| decompiledCode sourceCode |
	sourceCode := 'loopWithMovingLimit
	"This loop might be decompiled as a to:do: but should not because it does modify its limit"
	| n i |
	n := 4.
	i := 1.
	[i <= n] whileTrue: [
		n := n - 1.
		i := i + 1].
	^n'.
	self class compile: sourceCode.
	self assert: (self class includesSelector: #loopWithMovingLimit).
	self assert: 2 equals: (self perform: #loopWithMovingLimit).
	decompiledCode := self class decompile: #loopWithMovingLimit.
	self class compile: decompiledCode decompileString.
	self
		assert: 2
		equals: (self perform: #loopWithMovingLimit)
		description: 'result from decompiledCode should not differ from sourceCode'.! !

!DecompilerTests methodsFor: 'failing decompile tests' stamp: 'fbs 11/5/2013 22:50'!
testDecompileUnreachableParameter
	"The call to #value: is unreachable because both blocks in the #ifTrue:ifFalse: send force a return."
	[self value: (true ifTrue: [^true] ifFalse: [^false])] decompile.! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesAAtoAM
	self decompileClassesSelect: [:cn| cn first = $A and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesANtoAZ
	self decompileClassesSelect: [:cn| cn first = $A and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesBAtoBM
	self decompileClassesSelect: [:cn| cn first = $B and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesBNtoBZ
	self decompileClassesSelect: [:cn| cn first = $B and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesCAtoCM
	self decompileClassesSelect: [:cn| cn first = $C and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesCNtoCZ
	self decompileClassesSelect: [:cn| cn first = $C and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesDAtoDM
	self decompileClassesSelect: [:cn| cn first = $D and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesDNtoDZ
	self decompileClassesSelect: [:cn| cn first = $D and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesEAtoEM
	self decompileClassesSelect: [:cn| cn first = $E and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesENtoEZ
	self decompileClassesSelect: [:cn| cn first = $E and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesFAtoFM
	self decompileClassesSelect: [:cn| cn first = $F and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesFNtoFZ
	self decompileClassesSelect: [:cn| cn first = $F and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesGAtoGM
	self decompileClassesSelect: [:cn| cn first = $G and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesGNtoGZ
	self decompileClassesSelect: [:cn| cn first = $G and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesHAtoHM
	self decompileClassesSelect: [:cn| cn first = $H and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesHNtoHZ
	self decompileClassesSelect: [:cn| cn first = $H and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesIAtoIM
	self decompileClassesSelect: [:cn| cn first = $I and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesINtoIZ
	self decompileClassesSelect: [:cn| cn first = $I and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesJAtoJM
	self decompileClassesSelect: [:cn| cn first = $J and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesJNtoJZ
	self decompileClassesSelect: [:cn| cn first = $J and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesKAtoKM
	self decompileClassesSelect: [:cn| cn first = $K and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesKNtoKZ
	self decompileClassesSelect: [:cn| cn first = $K and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesLAtoLM
	self decompileClassesSelect: [:cn| cn first = $L and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesLNtoLZ
	self decompileClassesSelect: [:cn| cn first = $L and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesMAtoMM
	self decompileClassesSelect: [:cn| cn first = $M and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesMNtoMZ
	self decompileClassesSelect: [:cn| cn first = $M and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesNAtoNM
	self decompileClassesSelect: [:cn| cn first = $N and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesNNtoNZ
	self decompileClassesSelect: [:cn| cn first = $N and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesOAtoOM
	self decompileClassesSelect: [:cn| cn first = $O and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesONtoOZ
	self decompileClassesSelect: [:cn| cn first = $O and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesPAtoPM
	self decompileClassesSelect: [:cn| cn first = $P and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesPNtoPZ
	self decompileClassesSelect: [:cn| cn first = $P and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesQAtoQM
	self decompileClassesSelect: [:cn| cn first = $Q and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesQNtoQZ
	self decompileClassesSelect: [:cn| cn first = $Q and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesRAtoRM
	self decompileClassesSelect: [:cn| cn first = $R and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesRNtoRZ
	self decompileClassesSelect: [:cn| cn first = $R and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesSAtoSM
	self decompileClassesSelect: [:cn| cn first = $S and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesSNtoSZ
	self decompileClassesSelect: [:cn| cn first = $S and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesTAtoTM
	self decompileClassesSelect: [:cn| cn first = $T and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesTNtoTZ
	self decompileClassesSelect: [:cn| cn first = $T and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesUAtoUM
	self decompileClassesSelect: [:cn| cn first = $U and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesUNtoUZ
	self decompileClassesSelect: [:cn| cn first = $U and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesVAtoVM
	self decompileClassesSelect: [:cn| cn first = $V and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesVNtoVZ
	self decompileClassesSelect: [:cn| cn first = $V and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesWAtoWM
	self decompileClassesSelect: [:cn| cn first = $W and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesWNtoWZ
	self decompileClassesSelect: [:cn| cn first = $W and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesXAtoXM
	self decompileClassesSelect: [:cn| cn first = $X and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesXNtoXZ
	self decompileClassesSelect: [:cn| cn first = $X and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesYAtoYM
	self decompileClassesSelect: [:cn| cn first = $Y and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesYNtoYZ
	self decompileClassesSelect: [:cn| cn first = $Y and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesZAtoZM
	self decompileClassesSelect: [:cn| cn first = $Z and: [cn second asUppercase <= $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'eem 9/23/2008 11:16'!
testDecompilerInClassesZNtoZZ
	self decompileClassesSelect: [:cn| cn first = $Z and: [cn second asUppercase > $M]]! !

!DecompilerTests methodsFor: 'tests' stamp: 'fbs 11/5/2013 22:50'!
testRemoteTemp
	| aBlock |
	aBlock := Compiler evaluate: '| x y |  [:a :b | x := a. y := b. x+y]'.
	
	"This should not fail."
	aBlock decompile
	! !

TestCase subclass: #AliasTest
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Environments'!

!AliasTest methodsFor: 'tests' stamp: 'cwp 3/9/2013 18:41'!
setUp
	value := Object new! !

!AliasTest methodsFor: 'tests' stamp: 'cwp 4/28/2013 12:26'!
testAsBindingOriginal
	| alias imported original |
	original := #Griffle => value.
	alias := original asBinding: #Plonk.
	imported := alias asBinding: #Griffle.
	self assert: imported == original! !

!AliasTest methodsFor: 'tests' stamp: 'cwp 4/1/2013 22:05'!
testAsBindingRead
	| alias imported |
	alias := (#Griffle => value) asBinding: #Plonk.
	imported := alias asBinding: #Nurp.
	self assert: imported key = #Nurp.
	self assert: imported value == value! !

!AliasTest methodsFor: 'tests' stamp: 'cwp 4/1/2013 22:05'!
testAsBindingWrite
	| alias imported global |
	global := Global key: #Griffle value: Object new.
	alias := global asBinding: #Plonk.
	imported := alias asBinding: #Nurp.
	imported value: value.
	self assert: global value == value! !

!AliasTest methodsFor: 'tests' stamp: 'cwp 4/1/2013 22:05'!
testCanAssign
	| alias |
	alias := Alias key: #Plonk source: #Giffle => value.
	self assert: alias canAssign! !

!AliasTest methodsFor: 'tests' stamp: 'cwp 4/1/2013 22:06'!
testIsSpecialRead
	| alias |
	alias := Alias key: #Plonk source: #Griffle => value.
	self assert: alias isSpecialReadBinding! !

!AliasTest methodsFor: 'tests' stamp: 'cwp 4/1/2013 22:06'!
testIsSpecialWrite
	| alias |
	alias := Alias key: #Plonk source: #Griffle => value.
	self assert: alias isSpecialWriteBinding! !

!AliasTest methodsFor: 'tests' stamp: 'cwp 4/1/2013 22:13'!
testLiteralEqual
	| global a1 a2 |
	global := #Giffle => value.
	a1 := global asBinding: #Plonk.
	a2 := global asBinding: #Nurp.
	self assert: (a1 literalEqual: a2)
	! !

!AliasTest methodsFor: 'tests' stamp: 'cwp 4/1/2013 22:18'!
testLiteralUnequal
	| a1 a2 |
	a1 := (#Giffle => value) asBinding: #Plonk.
	a2 := (#Giffle => value) asBinding: #Plonk.
	self deny: (a1 literalEqual: a2)
	! !

!AliasTest methodsFor: 'tests' stamp: 'cwp 3/9/2013 18:39'!
testRead
	| alias global |
	global := #Giffle -> value.
	alias := Alias key: #Plonk source: global.
	self assert: alias key == #Plonk.
	self assert: alias value == value.! !

!AliasTest methodsFor: 'tests' stamp: 'cwp 12/29/2013 17:44'!
testSource
	| alias source |
	source := #Griffle => value.
	alias := source asBinding: #Plonk.
	self assert: alias source == source! !

!AliasTest methodsFor: 'tests' stamp: 'cwp 4/1/2013 22:06'!
testWrite
	| alias global |
	global := #Giffle => Object new.
	alias := Alias key: #Plonk source: global.
	alias value: value.
	self assert: global value == value.
	self assert: alias value == value.! !

TestCase subclass: #ArrayLiteralTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Compiler'!

!ArrayLiteralTest methodsFor: 'initialize-release' stamp: 'avi 2/16/2004 21:09'!
tearDown
	self class removeSelector: #array! !

!ArrayLiteralTest methodsFor: 'tests' stamp: 'avi 2/16/2004 21:08'!
testReservedIdentifiers
	self class compile: 'array ^ #(nil true false)'.
	self assert: self array = {nil. true. false}.! !

!ArrayLiteralTest methodsFor: 'tests' stamp: 'avi 2/16/2004 21:09'!
testSymbols
	self class compile: 'array ^ #(#nil #true #false #''nil'' #''true'' #''false'')'.
	self assert: self array = {#nil. #true. #false. #nil. #true. #false}.! !

TestCase subclass: #BecomeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-VM'!

!BecomeTest methodsFor: 'Testing' stamp: 'brp 9/19/2003 15:28'!
testBecome
	"Test the two way become. Note. we cannot use string literals for this test"
	| a b c d |

	a := 'ab' copy.
	b := 'cd' copy.
	c := a.
	d := b.

	a become: b.

	self 
		assert: a = 'cd';
		assert: b = 'ab';
		assert: c = 'cd';
		assert: d = 'ab'.


! !

!BecomeTest methodsFor: 'Testing' stamp: 'brp 9/19/2003 15:28'!
testBecomeForward
	"Test the forward become."
	| a b c d |

	a := 'ab' copy.
	b := 'cd' copy.
	c := a.
	d := b.

	a becomeForward: b.

	self 
		assert: a = 'cd';
		assert: b = 'cd';
		assert: c = 'cd';
		assert: d = 'cd'.


! !

!BecomeTest methodsFor: 'Testing' stamp: 'brp 9/19/2003 17:36'!
testBecomeForwardDontCopyIdentityHash
	"Check that
		1. the argument to becomeForward: is NOT modified to have the receiver's identity hash.
		2. the receiver's identity hash is unchanged."

 	| a b hb |

	a := 'ab' copy.
	b := 'cd' copy.
	hb := b identityHash.

	a becomeForward: b copyHash: false.

	self 
		assert: a identityHash = hb;
		assert: b identityHash = hb.

! !

!BecomeTest methodsFor: 'Testing' stamp: 'brp 9/19/2003 15:29'!
testBecomeForwardHash

	| a b c hb |

	a := 'ab' copy.
	b := 'cd' copy.
	c := a.
	hb := b hash.

	a becomeForward: b.

	self 
		assert: a hash = hb;
		assert: b hash = hb;
		assert: c hash = hb.


! !

!BecomeTest methodsFor: 'Testing' stamp: 'brp 9/19/2003 15:27'!
testBecomeForwardIdentityHash
	"Check that
		1. the argument to becomeForward: is modified to have the receiver's identity hash.
		2. the receiver's identity hash is unchanged."

 	| a b ha |

	a := 'ab' copy.
	b := 'cd' copy.
	ha := a identityHash.

	a becomeForward: b.

	self 
		assert: a identityHash = ha;
		assert: b identityHash = ha.

! !

!BecomeTest methodsFor: 'Testing' stamp: 'brp 9/19/2003 15:30'!
testBecomeHash

	| a b c d ha hb |

	a := 'ab' copy.
	b := 'cd' copy.
	c := a.
	d := b.
	ha := a hash.
	hb := b hash.

	a become: b.

	self 
		assert: a hash = hb;
		assert: b hash = ha;
		assert: c hash = hb;
		assert: d hash = ha.


! !

!BecomeTest methodsFor: 'Testing' stamp: 'nice 7/27/2012 20:11'!
testBecomeIdentityHash
	| a b c d numberOfRetry newAIdentityHash newBIdentityHash oldAIdentityHash oldBIdentityHash |
	numberOfRetry := 0.
	
	[a := 'ab' copy.
	c := IdentitySet new: 1000.
	b := 'cd' copy.
	d := IdentitySet new: 1000.
	"Note: the sets are allocated with enough room to reduce probability that two different hash lead to same slot"
	"Note2: a & b creation are interleaved with c & d, because some VM allocate the same identityHash for two consecutively created objects"
	c add: a; add: b.
	d add: a.
	oldAIdentityHash := a identityHash.
	oldBIdentityHash := b identityHash.
	oldAIdentityHash = oldBIdentityHash and: [numberOfRetry < 10]]
		whileTrue: [numberOfRetry := numberOfRetry + 1].
	self assert: oldAIdentityHash ~= oldBIdentityHash description: 'The VM is spawning too many equal identityHash to be honest'.
	a become: b.
	newAIdentityHash := a identityHash.
	newBIdentityHash := b identityHash.
	self
		"The set c & d can still retrieve their elements because elements did not change their expected position"
		assert: (c includes: a);
		assert: (c includes: b);
		assert: (d includes: a);
		deny: (d includes: b);
		"Elements didn't change their expected position because identityHash did not change"
		assert: oldAIdentityHash = newAIdentityHash;
		assert: oldBIdentityHash = newBIdentityHash! !

TestCase subclass: #BindingPolicyTest
	instanceVariableNames: 'environment policy value notified notifiedBinding'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Environments'!

!BindingPolicyTest methodsFor: 'emulating' stamp: 'cwp 12/30/2013 18:10'!
addBinding: aBinding
	notified := #add.
	notifiedBinding := aBinding! !

!BindingPolicyTest methodsFor: 'tests' stamp: 'cwp 12/30/2013 18:12'!
bindingPolicyWithNamePolicy: aPolicy
	^ BindingPolicy
		environment: environment
		policy: aPolicy
		addSelector: #addBinding:
		removeSelector: #removeBinding:! !

!BindingPolicyTest methodsFor: 'emulating' stamp: 'cwp 12/30/2013 18:11'!
removeBinding: aBinding
	notified := #remove.
	notifiedBinding := aBinding! !

!BindingPolicyTest methodsFor: 'running' stamp: 'cwp 12/29/2013 18:05'!
setUp
	environment := Environment withName: #test.
	value := Object new! !

!BindingPolicyTest methodsFor: 'running' stamp: 'cwp 12/31/2013 12:14'!
tearDown
	environment destroy.
	environment := nil.
	value := nil.! !

!BindingPolicyTest methodsFor: 'tests' stamp: 'cwp 12/30/2013 18:12'!
testAddHonorsEnvironment
	| binding other |
	other := Environment withName: #other.
	policy := self bindingPolicyWithNamePolicy: AllNamePolicy new.
	binding := #Griffle => value.
	policy binding: binding addedTo: other notify: self.
	self assert: notified = nil! !

!BindingPolicyTest methodsFor: 'tests' stamp: 'cwp 12/30/2013 18:16'!
testAddHonorsName
	| binding |
	policy := self bindingPolicyWithNamePolicy: (ExplicitNamePolicy spec: #Griffle -> #Nurp).
	binding := #Griffle => value.
	policy binding: binding addedTo: environment notify: self.
	self assert: notified == #add! !

!BindingPolicyTest methodsFor: 'tests' stamp: 'cwp 12/30/2013 18:16'!
testAddHonorsPolicy
	| binding |
	policy := self bindingPolicyWithNamePolicy: (ExplicitNamePolicy spec: #Nurp).
	binding := #Griffle => value.
	policy binding: binding addedTo: environment notify: self.
	self assert: notified = nil! !

!BindingPolicyTest methodsFor: 'tests' stamp: 'cwp 12/30/2013 18:15'!
testAdded
	| binding |
	policy := self bindingPolicyWithNamePolicy: AllNamePolicy new.
	binding := #Griffle => value.
	policy binding: binding addedTo: environment notify: self.
	self assert: notified = #add.! !

!BindingPolicyTest methodsFor: 'tests' stamp: 'cwp 12/30/2013 18:16'!
testRemoveHonorsEnvironment
	| binding other |
	other := Environment withName: #other.
	policy := self bindingPolicyWithNamePolicy: AllNamePolicy new.
	binding := #Griffle => value.
	policy binding: binding removedFrom: other notify: self. 
	self assert: notified = nil! !

!BindingPolicyTest methodsFor: 'tests' stamp: 'cwp 12/30/2013 18:15'!
testRemoveHonorsName
	| binding |
	policy := self bindingPolicyWithNamePolicy: (ExplicitNamePolicy spec: #Griffle -> #Nurp).
	binding := #Griffle => value.
	policy binding: binding removedFrom: environment notify: self.
	self assert: notified = #remove.
	self assert: notifiedBinding key = #Nurp.
	self assert: notifiedBinding source == binding! !

!BindingPolicyTest methodsFor: 'tests' stamp: 'cwp 12/30/2013 18:15'!
testRemoveHonorsPolicy
	| binding |
	policy := self bindingPolicyWithNamePolicy: (ExplicitNamePolicy spec: #Nurp).
	binding := #Griffle => value.
	policy binding: binding removedFrom: environment notify: self.
	self assert: notified = nil! !

!BindingPolicyTest methodsFor: 'tests' stamp: 'cwp 12/30/2013 18:15'!
testRemoved
	| binding |
	policy := self bindingPolicyWithNamePolicy: AllNamePolicy new.
	binding := #Griffle => value.
	policy binding: binding removedFrom: environment notify: self.
	self assert: notified = #remove! !

TestCase subclass: #BitBltClipBugs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Bugs'!

!BitBltClipBugs methodsFor: 'as yet unclassified' stamp: 'fbs 11/5/2013 19:48'!
testDrawingWayOutside
	| f1 bb f2 |
	f1 := Form extent: 100@100 depth: 1.
	f2 := Form extent: 100@100 depth: 1.
	bb := BitBlt toForm: f1.
	bb combinationRule: 3.
	bb sourceForm: f2.
	bb destOrigin: SmallInteger maxVal squared asPoint.
	bb width: 100; height: 100.
	
	"This should not throw an exception:"
	bb copyBits.
! !

!BitBltClipBugs methodsFor: 'as yet unclassified' stamp: 'fbs 11/5/2013 19:48'!
testDrawingWayOutside2
	| f1 bb f2 |
	f1 := Form extent: 100@100 depth: 1.
	f2 := Form extent: 100@100 depth: 1.
	bb := BitBlt toForm: f1.
	bb combinationRule: 3.
	bb sourceForm: f2.
	bb destOrigin: 0@0.
	bb width: SmallInteger maxVal squared; height: SmallInteger maxVal squared.
	
	"This should not throw an exception:"
	bb copyBits.! !

!BitBltClipBugs methodsFor: 'as yet unclassified' stamp: 'fbs 11/5/2013 19:49'!
testDrawingWayOutside3
	| f1 bb f2 |
	f1 := Form extent: 100@100 depth: 1.
	f2 := Form extent: 100@100 depth: 1.
	bb := BitBlt toForm: f1.
	bb combinationRule: 3.
	bb sourceForm: f2.
	bb destOrigin: SmallInteger maxVal squared asPoint.
	bb width: SmallInteger maxVal squared; height: SmallInteger maxVal squared.
	
	"This should not throw an exception:"
	bb copyBits.
! !

!BitBltClipBugs methodsFor: 'as yet unclassified' stamp: 'fbs 11/5/2013 19:49'!
testDrawingWayOutside4
	| f1 bb f2 |
	f1 := Form extent: 100@100 depth: 1.
	f2 := Form extent: 100@100 depth: 1.
	bb := BitBlt toForm: f1.
	bb combinationRule: 3.
	bb sourceForm: f2.
	bb destOrigin: SmallInteger maxVal squared asPoint.
	bb width: 100; height: 100.
	bb sourceOrigin: SmallInteger maxVal squared asPoint.
	
	"This should not throw an exception:"
	bb copyBits.
! !

!BitBltClipBugs methodsFor: 'as yet unclassified' stamp: 'fbs 11/5/2013 19:49'!
testDrawingWayOutside5
	| f1 bb f2 |
	f1 := Form extent: 100@100 depth: 1.
	f2 := Form extent: 100@100 depth: 1.
	bb := BitBlt toForm: f1.
	bb combinationRule: 3.
	bb sourceForm: f2.
	bb destOrigin: 0@0.
	bb width: SmallInteger maxVal squared; height: SmallInteger maxVal squared.
	bb sourceOrigin: SmallInteger maxVal squared asPoint.
	
	"This should not throw an exception:"
	bb copyBits.! !

!BitBltClipBugs methodsFor: 'as yet unclassified' stamp: 'fbs 11/5/2013 19:49'!
testDrawingWayOutside6
	| f1 bb f2 |
	f1 := Form extent: 100@100 depth: 1.
	f2 := Form extent: 100@100 depth: 1.
	bb := BitBlt toForm: f1.
	bb combinationRule: 3.
	bb sourceForm: f2.
	bb destOrigin: SmallInteger maxVal squared asPoint.
	bb width: SmallInteger maxVal squared; height: SmallInteger maxVal squared.
	bb sourceOrigin: SmallInteger maxVal squared asPoint.
	
	"This should not throw an exception:"
	bb copyBits.
! !

!BitBltClipBugs methodsFor: 'as yet unclassified' stamp: 'fbs 11/5/2013 19:49'!
testFillingWayOutside
	| f1 bb |
	f1 := Form extent: 100@100 depth: 1.
	bb := BitBlt toForm: f1.
	bb combinationRule: 3.
	bb fillColor: Color black.
	bb destOrigin: SmallInteger maxVal squared asPoint.
	bb width: 100; height: 100.
	
	"This should not throw an exception:"
	bb copyBits.
! !

!BitBltClipBugs methodsFor: 'as yet unclassified' stamp: 'fbs 11/5/2013 19:50'!
testFillingWayOutside2
	| f1 bb |
	f1 := Form extent: 100@100 depth: 1.
	bb := BitBlt toForm: f1.
	bb combinationRule: 3.
	bb fillColor: Color black.
	bb destOrigin: 0@0.
	bb width: SmallInteger maxVal squared; height: SmallInteger maxVal squared.
	
	"This should not throw an exception:"
	bb copyBits.! !

!BitBltClipBugs methodsFor: 'as yet unclassified' stamp: 'fbs 11/5/2013 19:50'!
testFillingWayOutside3
	| f1 bb |
	f1 := Form extent: 100@100 depth: 1.
	bb := BitBlt toForm: f1.
	bb combinationRule: 3.
	bb fillColor: Color black.
	bb destOrigin: SmallInteger maxVal squared asPoint.
	bb width: SmallInteger maxVal squared; height: SmallInteger maxVal squared.
	
	"This should not throw an exception:"
	bb copyBits.
! !

TestCase subclass: #BitmapBugz
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Bugs'!

!BitmapBugz methodsFor: 'tests' stamp: 'ar 8/2/2003 19:21'!
testBitmapByteAt
	| bm |
	bm := Bitmap new: 1.
	1 to: 4 do:[:i|
		self should:[bm byteAt: i put: 1000] raise: Error.
	].! !

!BitmapBugz methodsFor: 'tests' stamp: 'ul 10/24/2010 06:02'!
testWriteOn

	| original binary copy |
	original := Bitmap new: 1.
	original byteAt: 1 put: 42.
	binary := ByteArray streamContents: [ :stream |
		original writeOn: stream ].
	copy := Bitmap newFromStream: binary readStream.
	self assert: original = copy! !

TestCase subclass: #BitmapStreamTests
	instanceVariableNames: 'random array stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Bugs'!

!BitmapStreamTests commentStamp: 'nk 3/7/2004 14:26' prior: 0!
This is an incomplete test suite for storing and reading various word- and short-word subclasses of ArrayedCollection.

It demonstrates some problems with filing in of certain kinds of arrayed objects, including:

ShortPointArray
ShortIntegerArray
ShortRunArray
WordArray
MatrixTransform2x3

In 3.6b-5331, I get 8 passed/6 failed/6 errors (not counting the MatrixTransform2x3 tests, which were added later).

I ran into problems when trying to read back the SqueakLogo flash character morph, after I'd done a 'save morph to disk' from its debug menu.

The words within the ShortPointArrays and ShortRunArrays were reversed.
!

!BitmapStreamTests class methodsFor: 'Accessing' stamp: 'topa 8/21/2015 10:44'!
testSelectors
	"The ImageSegment-based Bitmap Test is known to not work on SPUR VMs
	with the prospect of crashing. #expectedFailure does not cut it here,
	don't even try to run them"
	^ super testSelectors copyWithout: #testMatrixTransform2x3WithImageSegment! !

!BitmapStreamTests methodsFor: 'tests-ShortRunArray' stamp: 'nk 3/17/2004 16:39'!
createSampleShortRunArray
	^ShortRunArray newFrom: { 0. 1. 1. 2. 2. 2. 3. 3. 3. 3 }! !

!BitmapStreamTests methodsFor: 'private' stamp: 'nk 3/7/2004 14:22'!
randomFloat
	"Answer a random 32-bit float"
	| w |
	random seed: (w := random nextValue).
	^w! !

!BitmapStreamTests methodsFor: 'private' stamp: 'nk 7/5/2003 16:33'!
randomShortInt
	^((random next * 65536) - 32768) truncated! !

!BitmapStreamTests methodsFor: 'private' stamp: 'nk 7/5/2003 16:00'!
randomShortPoint
	^(((random next * 65536) @ (random next * 65536)) - (32768 @ 32768)) truncated! !

!BitmapStreamTests methodsFor: 'private' stamp: 'nk 7/5/2003 18:26'!
randomWord
	"Answer a random 32-bit integer"
	| w |
	random seed: (w := random nextValue).
	^w truncated! !

!BitmapStreamTests methodsFor: 'Running' stamp: 'nk 7/5/2003 15:22'!
setUp
	random := Random new.! !

!BitmapStreamTests methodsFor: 'tests-MatrixTransform2x3' stamp: 'nk 3/7/2004 14:23'!
testMatrixTransform2x3WithImageSegment
	array := MatrixTransform2x3 new.
	1 to: 6 do: [ :i | array at: i put: self randomFloat ].
	self validateImageSegment
	! !

!BitmapStreamTests methodsFor: 'tests-MatrixTransform2x3' stamp: 'nk 3/7/2004 14:24'!
testMatrixTransform2x3WithRefStream
	array := MatrixTransform2x3 new.
	1 to: 6 do: [ :i | array at: i put: self randomFloat ].
	self validateRefStream
	! !

!BitmapStreamTests methodsFor: 'tests-MatrixTransform2x3' stamp: 'nk 3/7/2004 14:24'!
testMatrixTransform2x3WithRefStreamOnDisk
	array := MatrixTransform2x3 new.
	1 to: 6 do: [ :i | array at: i put: self randomFloat ].
	self validateRefStreamOnDisk	! !

!BitmapStreamTests methodsFor: 'tests-MatrixTransform2x3' stamp: 'nk 3/7/2004 14:25'!
testMatrixTransform2x3WithSmartRefStream
	array := MatrixTransform2x3 new.
	1 to: 6 do: [ :i | array at: i put: self randomFloat ].
	self validateSmartRefStream
	! !

!BitmapStreamTests methodsFor: 'tests-MatrixTransform2x3' stamp: 'nk 3/7/2004 14:25'!
testMatrixTransform2x3WithSmartRefStreamOnDisk
	array := MatrixTransform2x3 new.
	1 to: 6 do: [ :i | array at: i put: self randomFloat ].
	self validateSmartRefStreamOnDisk
	! !

!BitmapStreamTests methodsFor: 'tests-misc' stamp: 'bf 11/19/2009 18:56'!
testOtherClasses

	#(WordArrayForSegment FloatArray PointArray IntegerArray SoundBuffer String ShortPointArray ShortIntegerArray WordArray Array ByteArray Bitmap ColorArray ) do: [:s | | a |
		a := (Smalltalk at: s) new: 3.
		self assert: (a basicSize * a bytesPerBasicElement = a byteSize). ]
! !

!BitmapStreamTests methodsFor: 'tests-ShortIntegerArray' stamp: 'nice 1/18/2010 15:01'!
testShortIntegerArrayReadRefStream2
	| refStrm |
	refStrm := ReferenceStream on: #[20 6 17 83 104 111 114 116 73 110 116 101 103 101 114 65 114 114 97 121 0 0 0 2 0 0 0 1 0 2 0 3 ] readStream.
	self assert: (refStrm next = (ShortIntegerArray with: 0 with: 1 with: 2 with: 3)).! !

!BitmapStreamTests methodsFor: 'tests-ShortIntegerArray' stamp: 'nk 7/5/2003 18:06'!
testShortIntegerArrayWithImageSegment
	array := ShortIntegerArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomShortInt ].
	self validateImageSegment
	! !

!BitmapStreamTests methodsFor: 'tests-ShortIntegerArray' stamp: 'nk 3/17/2004 18:44'!
testShortIntegerArrayWithRefStream

	array := ShortIntegerArray with: 0 with: 1 with: 2 with: 3.
	self validateRefStream
	! !

!BitmapStreamTests methodsFor: 'tests-ShortIntegerArray' stamp: 'nice 1/18/2010 13:36'!
testShortIntegerArrayWithRefStream2
	array := ShortIntegerArray with: 0 with: 1 with: 2 with: 3.
	self validateRefStream.
	self assert: stream byteStream contents = #[20 6 17 83 104 111 114 116 73 110 116 101 103 101 114 65 114 114 97 121 0 0 0 2 0 0 0 1 0 2 0 3]
	
! !

!BitmapStreamTests methodsFor: 'tests-ShortIntegerArray' stamp: 'nk 7/5/2003 18:22'!
testShortIntegerArrayWithRefStreamOnDisk
	array := ShortIntegerArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomShortInt ].
	self validateRefStreamOnDisk
	! !

!BitmapStreamTests methodsFor: 'tests-ShortIntegerArray' stamp: 'nk 7/5/2003 16:32'!
testShortIntegerArrayWithSmartRefStream
	array := ShortIntegerArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomShortInt ].
	self validateSmartRefStream 
	! !

!BitmapStreamTests methodsFor: 'tests-ShortIntegerArray' stamp: 'nice 1/18/2010 13:37'!
testShortIntegerArrayWithSmartRefStream2
	array := ShortIntegerArray with: 0 with: 1 with: 2 with: 3.
	self validateSmartRefStream.
	self assert: (stream contents asByteArray last: 15) = #[0 0 0 2  0 0  0 1  0 2  0 3  33 13 13]
	
! !

!BitmapStreamTests methodsFor: 'tests-ShortIntegerArray' stamp: 'nk 7/5/2003 18:31'!
testShortIntegerArrayWithSmartRefStreamOnDisk
	array := ShortIntegerArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomShortInt ].
	self validateSmartRefStreamOnDisk
	! !

!BitmapStreamTests methodsFor: 'tests-ShortPointArray' stamp: 'nk 7/5/2003 18:12'!
testShortPointArrayWithImageSegment
	array := ShortPointArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomShortPoint ].
	self validateImageSegment 
	! !

!BitmapStreamTests methodsFor: 'tests-ShortPointArray' stamp: 'nk 7/5/2003 18:17'!
testShortPointArrayWithRefStream
	array := ShortPointArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomShortPoint ].
	self validateRefStream 
	! !

!BitmapStreamTests methodsFor: 'tests-ShortPointArray' stamp: 'nice 1/18/2010 13:37'!
testShortPointArrayWithRefStream2
	array := ShortPointArray with: 0@1 with: 2@3.
	self validateRefStream.
	self assert: stream byteStream contents = #[20 6 15 83 104 111 114 116 80 111 105 110 116 65 114 114 97 121  0 0 0 2  0 0  0 1  0 2  0 3 ]
	! !

!BitmapStreamTests methodsFor: 'tests-ShortPointArray' stamp: 'nk 7/5/2003 18:22'!
testShortPointArrayWithRefStreamOnDisk
	array := ShortPointArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomShortPoint ].
	self validateRefStreamOnDisk
	! !

!BitmapStreamTests methodsFor: 'tests-ShortPointArray' stamp: 'nk 7/5/2003 15:57'!
testShortPointArrayWithSmartRefStream
	array := ShortPointArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomShortPoint ].
	self validateSmartRefStream 
	! !

!BitmapStreamTests methodsFor: 'tests-ShortPointArray' stamp: 'nice 1/18/2010 13:38'!
testShortPointArrayWithSmartRefStream2
	array := ShortPointArray with: 0@1 with: 2@3.
	self validateSmartRefStream.
	self assert: (stream contents asByteArray last: 15) = #[0 0 0 2  0 0  0 1  0 2  0 3  33 13 13 ]
	! !

!BitmapStreamTests methodsFor: 'tests-ShortPointArray' stamp: 'nk 7/5/2003 18:31'!
testShortPointArrayWithSmartRefStreamOnDisk
	array := ShortPointArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomShortPoint ].
	self validateSmartRefStreamOnDisk
	! !

!BitmapStreamTests methodsFor: 'tests-ShortRunArray' stamp: 'nk 3/17/2004 16:39'!
testShortRunArrayWithImageSegment
	array := self createSampleShortRunArray.
	self validateImageSegment 
	! !

!BitmapStreamTests methodsFor: 'tests-ShortRunArray' stamp: 'nk 3/17/2004 16:39'!
testShortRunArrayWithRefStream
	array := self createSampleShortRunArray.
	self validateRefStream 
	! !

!BitmapStreamTests methodsFor: 'tests-ShortRunArray' stamp: 'nk 3/17/2004 16:39'!
testShortRunArrayWithRefStreamOnDisk
	array := self createSampleShortRunArray.
	self validateRefStreamOnDisk
	! !

!BitmapStreamTests methodsFor: 'tests-ShortRunArray' stamp: 'nk 3/17/2004 16:39'!
testShortRunArrayWithSmartRefStream
	array := self createSampleShortRunArray.
	self validateSmartRefStream 
	! !

!BitmapStreamTests methodsFor: 'tests-ShortRunArray' stamp: 'nice 1/18/2010 13:38'!
testShortRunArrayWithSmartRefStream2
	array := self createSampleShortRunArray.
	self validateSmartRefStream.
	self assert: (stream contents asByteArray last: 23) = #[0 0 0 4 0 1 0 0 0 2 0 1 0 3 0 2 0 4 0 3 33 13 13 ]

! !

!BitmapStreamTests methodsFor: 'tests-ShortRunArray' stamp: 'nk 3/17/2004 16:40'!
testShortRunArrayWithSmartRefStreamOnDisk
	array := self createSampleShortRunArray.
	self validateSmartRefStreamOnDisk
	! !

!BitmapStreamTests methodsFor: 'tests-WordArray' stamp: 'nk 7/5/2003 18:25'!
testWordArrayWithImageSegment
	array := WordArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomWord ].
	self validateImageSegment
	! !

!BitmapStreamTests methodsFor: 'tests-WordArray' stamp: 'nk 7/5/2003 18:27'!
testWordArrayWithRefStream
	array := WordArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomWord ].
	self validateRefStream
	! !

!BitmapStreamTests methodsFor: 'tests-WordArray' stamp: 'nk 7/5/2003 18:27'!
testWordArrayWithRefStreamOnDisk
	array := WordArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomWord ].
	self validateRefStreamOnDisk
	! !

!BitmapStreamTests methodsFor: 'tests-WordArray' stamp: 'nk 7/5/2003 18:27'!
testWordArrayWithSmartRefStream
	array := WordArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomWord ].
	self validateSmartRefStream
	! !

!BitmapStreamTests methodsFor: 'tests-WordArray' stamp: 'nk 7/5/2003 18:31'!
testWordArrayWithSmartRefStreamOnDisk
	array := WordArray new: 10.
	1 to: 10 do: [ :i | array at: i put: self randomWord ].
	self validateSmartRefStreamOnDisk
	! !

!BitmapStreamTests methodsFor: 'private' stamp: 'mha 7/30/2009 11:21'!
validateImageSegment
	"array is set up with an array."
	| other filename |
	filename := 'bitmapStreamTest.extSeg'.

	FileDirectory default deleteFileNamed: filename ifAbsent: [ ].

	(ImageSegment new copyFromRootsForExport: (Array with: array))
         writeForExport: filename.

	other := (FileDirectory default readOnlyFileNamed: filename)
		fileInObjectAndCode.

	self assert: array = other originalRoots first.
	
	"clean up disk"
	FileDirectory default deleteFileNamed: filename ifAbsent: [ ]! !

!BitmapStreamTests methodsFor: 'private' stamp: 'nk 7/5/2003 18:17'!
validateRefStream
	"array is set up with an array."
	| other rwstream |
	rwstream := RWBinaryOrTextStream on: (ByteArray new: array basicSize * 6).

	stream := ReferenceStream on: rwstream.
	stream nextPut: array; close.

	rwstream position: 0.
	stream := ReferenceStream on: rwstream.
	other := stream next.
	stream close.

	self assert: array = other! !

!BitmapStreamTests methodsFor: 'private' stamp: 'mha 7/30/2009 11:22'!
validateRefStreamOnDisk
	"array is set up with an array."
	| other filename |

	filename := 'bitmapStreamTest.ref'.
	FileDirectory default deleteFileNamed: filename ifAbsent: [ ].

	stream := ReferenceStream fileNamed: filename.
	stream nextPut: array; close.

	stream := ReferenceStream fileNamed: filename.
	other := stream next.
	stream close.

	self assert: array = other.
	
	"clean up disk"
	FileDirectory default deleteFileNamed: filename ifAbsent: [ ]! !

!BitmapStreamTests methodsFor: 'private' stamp: 'nk 7/5/2003 16:43'!
validateSmartRefStream
	"array is set up with an array."
	| other |
	stream := RWBinaryOrTextStream on: (ByteArray new: array basicSize * 6).
	stream binary.
	stream fileOutClass: nil andObject: array.
	stream position: 0.
	stream binary.
	other := stream fileInObjectAndCode.
	self assert: array = other! !

!BitmapStreamTests methodsFor: 'private' stamp: 'mha 7/30/2009 11:22'!
validateSmartRefStreamOnDisk
	"array is set up with an array."
	| other filename |

	filename := 'bitmapStreamTest.ref'.
	FileDirectory default deleteFileNamed: filename ifAbsent: [ ].

	stream := FileDirectory default fileNamed: filename.
	stream fileOutClass: nil andObject: array.
	stream close.

	stream := FileDirectory default fileNamed: filename.
	other := stream fileInObjectAndCode.
	stream close.

	self assert: array = other.
	
	"clean up disk"
	FileDirectory default deleteFileNamed: filename ifAbsent: [ ]! !

TestCase subclass: #BlockLocalTemporariesRemovalTest
	instanceVariableNames: 'sourceCode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Compiler'!

!BlockLocalTemporariesRemovalTest commentStamp: 'ul 11/15/2011 04:22' prior: 0!
I test if the parser can remove unused temporaries properly from methods and blocks. I implement several methods to be able to act like a TextEditor.!

!BlockLocalTemporariesRemovalTest methodsFor: 'test helper' stamp: 'pre 8/8/2016 17:46'!
assert: someCode isChangedDuringParsingTo: someOtherCode withRemovalOfTemporariesNamed: someTempNames 
	| failBlock |
	self sourceCode: someCode.
	failBlock := [ self fail ].
	[ self class
		compile: self sourceCode
		notifying: self
		trailer: CompiledMethodTrailer empty
		ifFail: failBlock ]
			on: UnusedVariable
			do:
				[ : aNotification | [ aNotification openMenuIn: nil ] 
					valueSupplyingAnswers: (someTempNames 
						collect: [:tempName | {tempName . true}]) , {{'*' . false }} ].
	self assert: self sourceCode = someOtherCode! !

!BlockLocalTemporariesRemovalTest methodsFor: 'requesting' stamp: 'lw 5/19/2011 18:36'!
correctFrom: start to: stop with: aString
	
	| loc |
	aString = '#insert period' ifTrue:
		[loc := start.
		[(loc := loc-1)>0 and: [(self sourceCode at: loc) isSeparator]]
			whileTrue: [loc := loc-1].
		^ self correctFrom: loc+1 to: loc with: '.'].
	
	self sourceCode: (self sourceCode copyReplaceFrom: start to: stop with: aString)! !

!BlockLocalTemporariesRemovalTest methodsFor: 'requesting' stamp: 'lw 5/26/2011 21:09'!
deselect! !

!BlockLocalTemporariesRemovalTest methodsFor: 'examples' stamp: 'lw 5/7/2011 12:56'!
methodWithBlockVariable

	| foo |
	[ | bar | ] value! !

!BlockLocalTemporariesRemovalTest methodsFor: 'requesting' stamp: 'lw 5/19/2011 18:16'!
nextTokenFrom: start direction: dir
	"simple token-finder for compiler automated corrections"
	| loc |
	loc := start + dir.
	[(loc between: 1 and: self sourceCode size) and: [(self sourceCode at: loc) isSeparator]]
		whileTrue: [loc := loc + dir].
	^ loc! !

!BlockLocalTemporariesRemovalTest methodsFor: 'requesting' stamp: 'lw 5/26/2011 20:49'!
select! !

!BlockLocalTemporariesRemovalTest methodsFor: 'requesting' stamp: 'lw 5/26/2011 20:49'!
selectFrom: aPoisition to: anotherPosition! !

!BlockLocalTemporariesRemovalTest methodsFor: 'requesting' stamp: 'lw 5/26/2011 21:09'!
selectInvisiblyFrom: userSelection to: last! !

!BlockLocalTemporariesRemovalTest methodsFor: 'requesting' stamp: 'lw 5/19/2011 17:54'!
selectionInterval

	^ Interval from: 0 to: 0! !

!BlockLocalTemporariesRemovalTest methodsFor: 'accessing' stamp: 'lw 5/19/2011 17:57'!
sourceCode
	^ sourceCode! !

!BlockLocalTemporariesRemovalTest methodsFor: 'accessing' stamp: 'lw 5/19/2011 17:57'!
sourceCode: anObject
	sourceCode := anObject! !

!BlockLocalTemporariesRemovalTest methodsFor: 'testing' stamp: 'ul 11/15/2011 15:51'!
testBlockTemporaries

	| someCode someOtherCode |
	
	someCode := 'test
	| temp |
	[ | foo | ]'.
	someOtherCode := 'test
	| temp |
	[  ]'.
	self assert: someCode isChangedDuringParsingTo: someOtherCode withRemovalOfTemporariesNamed: #('foo').
	
	someCode := 'test
	[ | foo | ]'.
	someOtherCode := 'test
	[  ]'.
	self assert: someCode isChangedDuringParsingTo: someOtherCode withRemovalOfTemporariesNamed: #('foo').
	
	someCode := 'test
	| temp |
	[ | foo | ]'.
	someOtherCode := 'test
	[  ]'.
	self assert: someCode isChangedDuringParsingTo: someOtherCode withRemovalOfTemporariesNamed: #('foo' 'temp').! !

!BlockLocalTemporariesRemovalTest methodsFor: 'testing' stamp: 'lw 5/27/2011 19:43'!
testComplex

	| someCode someOtherCode |
	
	someCode := 'removeUnusedTemps: methodNode
	"Scan for unused temp names, and prompt the user about the prospect of removing each one found"

	| madeChanges tempsMarkHolder unusedTempNames tempMarkHoldersToChange encoder requestor|
	encoder := requestor := 1.
	madeChanges := false.
	tempMarkHoldersToChange := OrderedCollection new.
	tempsMarkHolder := self collectTemporaryDeclarationsFrom: methodNode.
	unusedTempNames := encoder unusedTempNames select: 
		[ :temp | (encoder lookupVariable: temp ifAbsent: [ ]) isUndefTemp 
				and: [ UnusedVariable name: temp ]].
	tempsMarkHolder do: [ :currentBlock | ||
		tempMarkHoldersToChange add: currentBlock.
		unusedTempNames do: 
			[ :temp || someAdditionalTemps |
			(self 
				removeUnusedTemporaryNamed: temp 
				from: requestor text asString 
				lookingAt: currentBlock
				movingTempMarksOf: tempMarkHoldersToChange) ifTrue: [ madeChanges := true ]]].
	madeChanges
		ifTrue: [ self removeEmptyTempDeclarationsFrom: methodNode.
			ReparseAfterSourceEditing signal ]'.
	someOtherCode := 'removeUnusedTemps: methodNode
	"Scan for unused temp names, and prompt the user about the prospect of removing each one found"

	| madeChanges tempsMarkHolder unusedTempNames tempMarkHoldersToChange encoder requestor|
	encoder := requestor := 1.
	madeChanges := false.
	tempMarkHoldersToChange := OrderedCollection new.
	tempsMarkHolder := self collectTemporaryDeclarationsFrom: methodNode.
	unusedTempNames := encoder unusedTempNames select: 
		[ :temp | (encoder lookupVariable: temp ifAbsent: [ ]) isUndefTemp 
				and: [ UnusedVariable name: temp ]].
	tempsMarkHolder do: [ :currentBlock | 
		tempMarkHoldersToChange add: currentBlock.
		unusedTempNames do: 
			[ :temp |
			(self 
				removeUnusedTemporaryNamed: temp 
				from: requestor text asString 
				lookingAt: currentBlock
				movingTempMarksOf: tempMarkHoldersToChange) ifTrue: [ madeChanges := true ]]].
	madeChanges
		ifTrue: [ self removeEmptyTempDeclarationsFrom: methodNode.
			ReparseAfterSourceEditing signal ]'.
	self assert: someCode isChangedDuringParsingTo: someOtherCode withRemovalOfTemporariesNamed: #('someAdditionalTemps')! !

!BlockLocalTemporariesRemovalTest methodsFor: 'testing' stamp: 'lw 5/27/2011 19:31'!
testRegression

	| someCode someOtherCode |
	
	someCode := 'test
	| temp |'.
	someOtherCode := 'test
	'.
	self assert: someCode isChangedDuringParsingTo: someOtherCode withRemovalOfTemporariesNamed: #('temp').
	
	someCode :=  'test
	| temp |'.
	someOtherCode := 'test
	| temp |'.
	self assert: someCode isChangedDuringParsingTo: someOtherCode withRemovalOfTemporariesNamed: #().
	
	someCode :=  'test
	| temp temptemp |'.
	someOtherCode := 'test
	| temp |'.
	self assert: someCode isChangedDuringParsingTo: someOtherCode withRemovalOfTemporariesNamed: #('temptemp').
	! !

!BlockLocalTemporariesRemovalTest methodsFor: 'requesting' stamp: 'lw 5/19/2011 17:57'!
text

	^ self sourceCode! !

TestCase subclass: #ChangeSetClassChangesTest
	instanceVariableNames: 'saveCurrentChangeSet addedChangeSetAccessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Bugs'!

!ChangeSetClassChangesTest commentStamp: 'dtl 2/19/2005 13:21' prior: 0!
Class category changes are not being properly added to the default changeset in Squeak 3.7. This test case will pass in Squeak 3.6, and fail in Squeak 3.[7-9].
!

!ChangeSetClassChangesTest methodsFor: 'support' stamp: 'dtl 2/19/2005 13:08'!
isDefinition: firstString equivalentTo: secondString 
	"When a class definition is reconstructed with #fatDefForClass, it may 
	contain extra trailing space characters in parts of the definition. This 
	is probably a minor bug, but it should be overlooked for purposes of 
	testing the change set update mechanism. The expedient here is to just 
	remove spaces before comparing the definition strings."

	^ firstString notNil
		and: [(firstString copyReplaceAll: ' ''' with: '''')
				= (secondString copyReplaceAll: ' ''' with: '''')]! !

!ChangeSetClassChangesTest methodsFor: 'running' stamp: 'pre 7/1/2016 17:15'!
tearDown

	| deleteMePackage |
	(Smalltalk classNamed: #JunkClass) ifNotNil: [:c | c removeFromSystem: true].
	SystemOrganization removeCategory: #'DeleteMe-1'.
	SystemOrganization removeCategory: #'DeleteMe-2'.
	ChangeSet current removeClassChanges: 'JunkClass'.
	deleteMePackage := PackageOrganizer default packageNamed: 'DeleteMe' ifAbsent: [nil].
	deleteMePackage ifNotNil: [deleteMePackage workingCopy unload].! !

!ChangeSetClassChangesTest methodsFor: 'testing' stamp: 'stephaneducasse 2/3/2006 22:39'!
testAddInstanceVariable
	"Adding an instance variable to the class should result in a change
	record being added to the current change set."

	| saveClassDefinition |
	"Define a class and save its definition"
	Object subclass: #JunkClass
		instanceVariableNames: 'zzz'
		classVariableNames: ''
		poolDictionaries: ''
		category: 'DeleteMe-1'.
	saveClassDefinition := (Smalltalk classNamed: #JunkClass) definition.
	self assert: (self
		isDefinition: saveClassDefinition
		equivalentTo: (ChangeSet current fatDefForClass: (Smalltalk classNamed: #JunkClass))).

	"Redefine the class, adding one instance variable"
	Object subclass: #JunkClass
		instanceVariableNames: 'zzz aaa'
		classVariableNames: ''
		poolDictionaries: ''
		category: 'DeleteMe-1'.

	"Assert that the class definition has changed"
	self deny: (self
		isDefinition: (Smalltalk classNamed: #JunkClass) definition
		equivalentTo: saveClassDefinition).
	self deny: (self
		isDefinition: saveClassDefinition
		equivalentTo: (ChangeSet current fatDefForClass: (Smalltalk classNamed: #JunkClass))).
	self assert: (self
		isDefinition: (Smalltalk classNamed: #JunkClass) definition
		equivalentTo: (ChangeSet current fatDefForClass: (Smalltalk classNamed: #JunkClass))).

	"Assert that the change has been recorded in the current change set"
	self assert: (self
		isDefinition: (ChangeSet current changeRecorderFor: (Smalltalk classNamed: #JunkClass))
			priorDefinition
		equivalentTo: saveClassDefinition).
! !

!ChangeSetClassChangesTest methodsFor: 'testing' stamp: 'dtl 2/19/2005 11:55'!
testAddInstanceVariableAddsNewChangeRecord
	"Changing the class category for a class should result in a change
	record being updated in the current change set."

	"At the start of this test, JunkClass should not exist, and there should be
	no change records pertaining to it in the change set."
	self deny: (Smalltalk hasClassNamed: 'JunkClass').
	self assert: (ChangeSet current changeRecorderFor: (Smalltalk classNamed: #JunkClass))
		thisName = 'nil'.
	"Remove bogus change records created as side effect of preceding assert"
	ChangeSet current removeClassChanges: 'nil'.
	"Define a class and save its definition"
	Object subclass: #JunkClass
		instanceVariableNames: 'zzz'
		classVariableNames: ''
		poolDictionaries: ''
		category: 'DeleteMe-1'.

	"Forget about JunkClass in the change set"
	ChangeSet current removeClassChanges: 'JunkClass'.

	"Redefine the class, adding one instance variable"
	Object subclass: #JunkClass
		instanceVariableNames: 'zzz aaa'
		classVariableNames: ''
		poolDictionaries: ''
		category: 'DeleteMe-1'.

	"A change record should now exist in the change set"
	self assert: (self
		isDefinition: (ChangeSet current
			changeRecorderFor: (Smalltalk classNamed: #JunkClass)) priorDefinition
		equivalentTo:
'Object subclass: #JunkClass
	instanceVariableNames: ''zzz ''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''DeleteMe-1''')
! !

!ChangeSetClassChangesTest methodsFor: 'testing' stamp: 'stephaneducasse 2/3/2006 22:39'!
testChangeClassCategory
	"Changing the class category for a class should result in a change
	record being added to the current change set."

	| saveClassDefinition |
	"Define a class and save its definition"
	Object subclass: #JunkClass
		instanceVariableNames: 'zzz'
		classVariableNames: ''
		poolDictionaries: ''
		category: 'DeleteMe-1'.
	saveClassDefinition := (Smalltalk classNamed: #JunkClass) definition.
	self assert: saveClassDefinition =
		(ChangeSet current fatDefForClass: (Smalltalk classNamed: #JunkClass)).

	"Redefine the class, changing only the class category"
	Object subclass: #JunkClass
		instanceVariableNames: 'zzz'
		classVariableNames: ''
		poolDictionaries: ''
		category: 'DeleteMe-2'.

	"Assert that the class definition has changed"
	self deny: (self
		isDefinition: (Smalltalk classNamed: #JunkClass) definition
		equivalentTo: saveClassDefinition).
	self deny: (self
		isDefinition: saveClassDefinition
		equivalentTo: (ChangeSet current fatDefForClass: (Smalltalk classNamed: #JunkClass))).
	self assert: (self
		isDefinition: (Smalltalk classNamed: #JunkClass) definition
		equivalentTo: (ChangeSet current fatDefForClass: (Smalltalk classNamed: #JunkClass))).

	"Assert that the change has been recorded in the current change set"
	self assert: (self
		isDefinition: (ChangeSet current changeRecorderFor: (Smalltalk classNamed: #JunkClass))
			priorDefinition
		equivalentTo:
'Object subclass: #JunkClass
	instanceVariableNames: ''zzz ''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''DeleteMe-2''')! !

!ChangeSetClassChangesTest methodsFor: 'testing' stamp: 'dtl 2/19/2005 12:01'!
testChangeClassCategoryAddsNewChangeRecord
	"Changing the class category for a class should result in a change
	record being updated in the current change set."

	"At the start of this test, JunkClass should not exist, and there should be
	no change records pertaining to it in the change set."
	self deny: (Smalltalk hasClassNamed: 'JunkClass').
	self assert: (ChangeSet current changeRecorderFor: (Smalltalk classNamed: #JunkClass))
		thisName = 'nil'.
	"Remove bogus change records created as side effect of preceding assert"
	ChangeSet current removeClassChanges: 'nil'.
	"Define a class and save its definition"
	Object subclass: #JunkClass
		instanceVariableNames: 'zzz'
		classVariableNames: ''
		poolDictionaries: ''
		category: 'DeleteMe-1'.

	"Forget about JunkClass in the change set"
	ChangeSet current removeClassChanges: 'JunkClass'.

	"Redefine the class, changing only the class category"
	Object subclass: #JunkClass
		instanceVariableNames: 'zzz'
		classVariableNames: ''
		poolDictionaries: ''
		category: 'DeleteMe-2'.

	"A change record should now exist in the change set"
	self assert: (self
		isDefinition: (ChangeSet current
			changeRecorderFor: (Smalltalk classNamed: #JunkClass)) priorDefinition
		equivalentTo:
'Object subclass: #JunkClass
	instanceVariableNames: ''zzz ''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''DeleteMe-2''')! !

!ChangeSetClassChangesTest methodsFor: 'testing' stamp: 'wiz 8/13/2006 17:55'!
testInitialChangeSet
	"Run this to assure the initial changeset is named. Checks bug found in 3.9 7052."
	"self new testInitialChangeSet"
	"self run:  #testInitialChangeSet"

	self deny: (ChangeSet current printString = 'a ChangeSet named <no name -- garbage?>') .
	
^true! !

TestCase subclass: #ClassBindingTest
	instanceVariableNames: 'key value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Environments'!

!ClassBindingTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/8/2013 22:54'!
setUp
	key := Object new.
	value := Object new.! !

!ClassBindingTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/1/2013 21:56'!
testArrowBinding
	| binding |
	binding := #Griffle => self class.
	self assert: binding class = ClassBinding.
	self assert: binding key = #Griffle.
	self assert: binding value = self class.
	! !

!ClassBindingTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/28/2013 13:53'!
testAsBindingAlias
	| binding imported |
	binding := ClassBinding key: #Griffle value: value.
	imported := binding asBinding: #Plonk.
	self assert: imported class == Alias! !

!ClassBindingTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/28/2013 12:35'!
testAsBindingOriginal
	| binding imported |
	binding := ClassBinding key: #Griffle value: value.
	imported := binding asBinding: #Griffle.
	self assert: binding == imported! !

!ClassBindingTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/1/2013 22:04'!
testAsBindingRead
	| binding imported |
	binding := ClassBinding key: #Griffle value: value.
	imported := binding asBinding: #Plonk.
	self assert: imported key = #Plonk.
	self assert: imported value == value.! !

!ClassBindingTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/28/2013 13:53'!
testAsBindingWrite
	| binding imported |
	binding := ClassBinding key: #Griffle value: value.
	imported := binding asBinding: #Plonk.
	self
		should: [imported value: Object new]
		raise: AttemptToWriteReadOnlyGlobal
! !

!ClassBindingTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/1/2013 22:04'!
testCanAssign
	| binding |
	binding := ClassBinding key: key value: value.
	self deny: binding canAssign! !

!ClassBindingTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/1/2013 22:04'!
testIsSpecialRead
	| binding |
	binding := ClassBinding key: key value: value.
	self deny: binding isSpecialReadBinding! !

!ClassBindingTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/1/2013 22:05'!
testIsSpecialWrite
	| binding |
	binding := ClassBinding key: key value: value.
	self assert: binding isSpecialWriteBinding! !

!ClassBindingTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/1/2013 22:15'!
testLiteralEqual
	| b1 b2 |
	b1 := #Griffle => self class.
	b2 := #Plonk => self class.
	self assert: (b1 literalEqual: b2)! !

!ClassBindingTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/1/2013 22:19'!
testLiteralUnequal
	| b1 b2 |
	b1 := #Griffle => self class.
	b2 := #Griffle => self class superclass.
	self deny: (b1 literalEqual: b2)! !

!ClassBindingTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/1/2013 22:05'!
testRead
	| binding |
	binding := ClassBinding key: key value: value.
	self assert: binding key == key.
	self assert: binding value == value! !

!ClassBindingTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/1/2013 22:05'!
testResumeExceptionToWrite
	| binding |
	binding := ClassBinding key: key value: Object new.
	[binding value: value]
		on: AttemptToWriteReadOnlyGlobal
		do: [:ex | ex resume: true].
	self assert: binding value == value! !

!ClassBindingTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/29/2013 17:45'!
testSource
	| binding |
	binding := ClassBinding key: #Griffle value: value.
	self assert: binding source == binding! !

!ClassBindingTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/1/2013 22:05'!
testWriteRaisesException
	| binding |
	binding := ClassBinding key: key value: value.
	self
		should: [binding value: Object new]
		raise: AttemptToWriteReadOnlyGlobal.! !

TestCase subclass: #ClassRemovalTest
	instanceVariableNames: 'isClean'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Bugs'!

!ClassRemovalTest methodsFor: 'utility' stamp: 'ul 9/14/2012 04:03'!
className1

	^#ClassToBeRemoved! !

!ClassRemovalTest methodsFor: 'utility' stamp: 'ul 9/14/2012 04:03'!
className2

	^#ReferringClass! !

!ClassRemovalTest methodsFor: 'running' stamp: 'ul 9/14/2012 04:02'!
setUp

	isClean :=  (SystemOrganizer default listAtCategoryNamed: self systemCategoryName) isEmpty
		and: [ (Smalltalk hasClassNamed: self className1) not
		and: [ (Smalltalk hasClassNamed: self className2) not ] ]! !

!ClassRemovalTest methodsFor: 'utility' stamp: 'ul 9/14/2012 03:56'!
systemCategoryName

	^'ReferencedClassRemoveTest'! !

!ClassRemovalTest methodsFor: 'running' stamp: 'fbs 1/2/2013 12:44'!
tearDown

	isClean ifTrue: [
		Smalltalk removeClassNamed: self className1.
		Smalltalk removeClassNamed: self className2.
		SystemOrganizer default removeCategory: self systemCategoryName ]! !

!ClassRemovalTest methodsFor: 'tests' stamp: 'fbs 1/2/2013 12:41'!
testClassCanBeRemoved
	self 
		assert: isClean
		description: 'The system category or the classes about to be created already exist.'.
	"Create a class"	
	Object subclass: self className1
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self systemCategoryName.
	self assert: (Smalltalk hasClassNamed: self className1) description: self className1, ' not created'.
	"Remove the class"
	(Smalltalk at: self className1) removeFromSystem.
	self deny: (Smalltalk hasClassNamed: self className1) description: self className1, ' not removed'.! !

!ClassRemovalTest methodsFor: 'tests' stamp: 'fbs 1/2/2013 11:51'!
testClassRemovalAndRecompilationWontCreateDuplicateVariableBindings

	self 
		assert: isClean
		description: 'The system category or the classes about to be created already exist.'.
	"Create a class"	
	Object subclass: self className1
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self systemCategoryName.
	"Create another"
	Object subclass: self className2
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self systemCategoryName.
	"Compile a method in the second which references the first"
	(Smalltalk at: self className2)
		compile: 'foo ^', self className1
		classified: 'accessing'.
	"Remove the first class"
	(Smalltalk at: self className1) removeFromSystem.
	"Compile the first class again"
	Object subclass: self className1
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self systemCategoryName.
	self
		deny: (Smalltalk at: self className2) new foo isObsolete
		description: '#foo refers to an obsolete class'.
	self
		assert: (Smalltalk at: self className1) ==
			(Smalltalk at: self className2) new foo
		description: '#foo refers to a different class'! !

TestCase subclass: #ClassRenameFixTest
	instanceVariableNames: 'previousChangeSet testsChangeSet newClassName originalName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Bugs'!

!ClassRenameFixTest methodsFor: 'Private' stamp: 'md 9/6/2005 18:30'!
newUniqueClassName
	"Return a class name that is not used in the system."

	"self new newClassName"

	| baseName newName |
	baseName := 'AutoGeneratedClassForTestingSystemChanges'.
	1 to: 9999
		do: 
			[:number | 
			newName := baseName , number printString.
			(Smalltalk hasClassNamed: newName) ifFalse: [^newName asSymbol]].
	^self 
		error: 'Can no longer find a new and unique class name for the SystemChangeTest !!'! !

!ClassRenameFixTest methodsFor: 'Private' stamp: 'rw 8/23/2003 16:17'!
removeEverythingInSetFromSystem: aChangeSet 

	aChangeSet changedMessageList
		do: [:methodRef | methodRef actualClass removeSelector: methodRef methodSymbol].
	aChangeSet changedClasses
		do: [:each | each isMeta
				ifFalse: [each removeFromSystemUnlogged]]! !

!ClassRenameFixTest methodsFor: 'Tests' stamp: 'cmm 8/7/2005 18:21'!
renameClassUsing: aBlock

	| createdClass foundClasses |
	originalName := self newUniqueClassName.
	createdClass := Object 
		subclass: originalName
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'ClassRenameFix-GeneradClass'.
	newClassName := self newUniqueClassName.
	aBlock value: createdClass value: newClassName.
	self assert: (Smalltalk classNamed: originalName) isNil.
	self assert: (Smalltalk classNamed: newClassName) notNil.
	foundClasses := Smalltalk organization listAtCategoryNamed: 'ClassRenameFix-GeneradClass'.
	self assert: (foundClasses notEmpty).
	self assert: (foundClasses includes: newClassName).
	self assert: (createdClass name = newClassName).! !

!ClassRenameFixTest methodsFor: 'Running' stamp: 'cmm 8/7/2005 18:20'!
setUp

	previousChangeSet := ChangeSet current.
	testsChangeSet := ChangeSet new.
	ChangeSet newChanges: testsChangeSet.
	SystemChangeNotifier uniqueInstance
		notify: self
		ofSystemChangesOfItem: #class
		change: #Renamed
		using: #verifyRenameEvent:.
	super setUp! !

!ClassRenameFixTest methodsFor: 'Running' stamp: 'pk 5/13/2007 14:16'!
tearDown

	self removeEverythingInSetFromSystem: testsChangeSet.
	ChangeSet newChanges: previousChangeSet.
	ChangesOrganizer removeChangeSet: testsChangeSet.
	previousChangeSet := nil.
	testsChangeSet := nil.
	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self.
	super tearDown.! !

!ClassRenameFixTest methodsFor: 'Tests' stamp: 'rw 8/23/2003 16:45'!
testRenameClassUsingClass
	"self run: #testRenameClassUsingClass"

	self renameClassUsing: [:class :newName | class rename: newName].! !

!ClassRenameFixTest methodsFor: 'Running' stamp: 'cmm 8/7/2005 19:04'!
verifyRenameEvent: aRenamedEvent

	| renamedClass |
	self assert: aRenamedEvent isRenamed.
	renamedClass :=  aRenamedEvent item.
	self assert: (Smalltalk classNamed: newClassName) name = newClassName.
	self assert: renamedClass name = newClassName! !

TestCase subclass: #ClipboardTest
	instanceVariableNames: 'originalClipboardText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-System-Support'!

!ClipboardTest methodsFor: 'as yet unclassified' stamp: 'ul 8/19/2012 18:52'!
setUp
	"Store the contents of the default clipboard. This is necessary, because all Clipboard instances modify the contents of the system clipboard."

	originalClipboardText := Clipboard default clipboardText! !

!ClipboardTest methodsFor: 'as yet unclassified' stamp: 'ul 8/19/2012 18:52'!
tearDown
	"Restore the contents of the default clipboard. This is necessary, because all Clipboard instances modify the contents of the system clipboard."

	Clipboard default clipboardText: originalClipboardText! !

!ClipboardTest methodsFor: 'as yet unclassified' stamp: 'ul 8/19/2012 18:45'!
testClipboardText

	| uuidString clipboard |
	uuidString := UUID new asString36.
	clipboard := Clipboard new.
	clipboard clipboardText: uuidString.
	self assert: uuidString equals: clipboard clipboardText asString! !

!ClipboardTest methodsFor: 'as yet unclassified' stamp: 'ul 8/19/2012 18:49'!
testClipboardTextNotifyWith

	| uuidString clipboard subscriber notifiedText notifiedSource |
	uuidString := UUID new asString36.
	clipboard := Clipboard new.
	subscriber := [ :text :source | 
		notifiedText := text.
		notifiedSource := source ].
	clipboard 
		when: #contentChanged
		send: #value:value:
		to: subscriber.
	clipboard clipboardText: uuidString.
	self
		assert: uuidString equals: notifiedText;
		assert: nil equals: notifiedSource.
	clipboard clipboardText: uuidString reversed notifyWith: self.
	self
		assert: uuidString reversed equals: notifiedText;
		assert: self == notifiedSource.
	clipboard removeActionsWithReceiver: subscriber.
	clipboard clipboardText: uuidString.
	self
		assert: uuidString reversed equals: notifiedText;
		assert: self == notifiedSource! !

TestCase subclass: #ClosureCompilerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Compiler'!

!ClosureCompilerTest class methodsFor: 'code examples' stamp: 'eem 5/20/2008 09:40'!
methodWithCopiedAndAssignedTemps
	| blk "0w" a "0w" b "0w" c "0w" t "0w" r1 "0w" r2 "0w" |
	a := 1. "1w"
	b := 2. "1w"
	c := 4. "1w"
	t := 0. "1w"
	blk "5w" := ["2" t  "3w" := t "3r" + a "3r" + b "3r" + c "3r" ] "4".
	r1 "5w" := blk "5r" value.
	b "5w" := -100.
	r2 "5w" := blk "5r" value.
	^r1 "5r" -> r2 "5r" -> t "5r"

	"a: main(read(),write(0,1)), block(read(3),write()) => copy; no writes follow read
	 b: main(read(),write(0,1,5)), block(read(3),write()) => remote; write follows contained read
	 blk: main(read(5),write(0,5)), block(read(),write()) => no copy in blocks < 5
	 c: main(read(),write(0,1)), block(read(3),write()) => copy; no writes follow read
	 r1: main(read(5),write(0,5)), block(read(),write()) => no copy in blocks < 5
	 r2: main(read(5),write(0,5)), block(read(),write()) => no copy in blocks < 5
	 t: main(read(5),write(0,1)), block(read(3),write(3)) => remote; read follows contained write"


	"(Parser new
		encoderClass: EncoderForV3;
		parse: (self class sourceCodeAt: #methodWithCopiedAndAssignedTemps)
		class: self class) generateUsingClosures: #(0 0 0 0)"! !

!ClosureCompilerTest class methodsFor: 'code examples' stamp: 'eem 5/19/2008 20:45'!
methodWithCopiedAndPostClosedOverAssignedTemps
	| blk a b c r1 r2 |
	a := 1.
	b := 2.
	c := 4.
	blk := [a + b + c].
	r1 := blk value.
	b := nil.
	r2 := blk value.
	r1 -> r2

	"(Parser new
		encoderClass: EncoderForV3;
		parse: (self class sourceCodeAt: #methodWithCopiedAndPostClosedOverAssignedTemps)
		class: self class) generateUsingClosures: #(0 0 0 0)"! !

!ClosureCompilerTest class methodsFor: 'code examples' stamp: 'eem 5/19/2008 20:10'!
methodWithCopiedTemps
	| a b c r |
	a := 1.
	b := 2.
	c := 4.
	r := [a + b + c] value.
	b := nil.
	r

	"Parser new
		parse: (self class sourceCodeAt: #methodWithCopiedTemps)
		class: self class"

	"(Parser new
		encoderClass: EncoderForV3;
		parse: (self class sourceCodeAt: #methodWithCopiedTemps)
		class: self class) generateUsingClosures: #(0 0 0 0)"! !

!ClosureCompilerTest class methodsFor: 'code examples' stamp: 'eem 5/19/2008 14:24'!
methodWithOptimizedBlocks
	| s c |
	s := self isNil
			ifTrue: [| a | a := 'isNil'. a]
			ifFalse: [| b | b := 'notNil'. b].
	c := String new: s size.
	1 to: s size do:
		[:i| c at: i put: (s at: i)].
	^c

	"Parser new
		parse: (self class sourceCodeAt: #methodWithOptimizedBlocks)
		class: self class"! !

!ClosureCompilerTest class methodsFor: 'code examples' stamp: 'eem 5/19/2008 14:24'!
methodWithOptimizedBlocksA
	| s c |
	s := self isNil
			ifTrue: [| a | a := 'isNil'. a]
			ifFalse: [| a | a := 'notNil'. a].
	c := String new: s size.
	1 to: s size do:
		[:i| c at: i put: (s at: i)].
	^c

	"Parser new
		parse: (self class sourceCodeAt: #methodWithOptimizedBlocksA)
		class: self class"! !

!ClosureCompilerTest class methodsFor: 'code examples' stamp: 'eem 5/19/2008 14:12'!
methodWithVariousTemps
	| classes total totalLength |
	classes := self withAllSuperclasses.
	total := totalLength := 0.
	classes do: [:class| | className |
		className := class name.
		total := total + 1.
		totalLength := totalLength + className size].
	^total -> totalLength

	"Parser new
		parse: (self class sourceCodeAt: #methodWithVariousTemps)
		class: self class"! !

!ClosureCompilerTest methodsFor: 'source' stamp: 'eem 7/1/2009 10:51'!
closureCases
	^#(
'| n |
n := 1.
^n + n'

'| i |
i := 0.
[i := i + 1.
 i <= 10] whileTrue.
^i'

'[:c :s| | mn |
mn := Compiler new
		compile: (c sourceCodeAt: s)
		in: c
		notifying: nil
		ifFail: [self halt].
mn generate: #(0 0 0 0).
{mn blockExtentsToTempsMap.
  mn encoder schematicTempNames}]
			value: AbstractInstructionTests
			value: #runBinaryConditionalJumps:'

'inject: thisValue into: binaryBlock
	| nextValue |
	nextValue := thisValue.
	self do: [:each | nextValue := binaryBlock value: nextValue value: each].
	^nextValue'

'runBinaryConditionalJumps: assertPrintBar
	"CogIA32CompilerTests new runBinaryConditionalJumps: false"
	| mask reg1 reg2 reg3 |
	mask := 1 << self processor bitsInWord - 1.
	self concreteCompilerClass dataRegistersWithAccessorsDo:
		[:n :get :set|
		n = 0 ifTrue: [reg1 := get].
		n = 1 ifTrue: [reg2 := set].
		n = 2 ifTrue: [reg3 := set]].
	#(	(JumpAbove > unsigned)			(JumpBelowOrEqual <= unsigned)
		(JumpBelow < unsigned)			(JumpAboveOrEqual >= unsigned)
		(JumpGreater > signed)			(JumpLessOrEqual <= signed)
		(JumpLess < signed)				(JumpGreaterOrEqual >= signed)
		(JumpZero = signed)				(JumpNonZero ~= signed)) do:
		[:triple|
		[:opName :relation :signednessOrResult| | opcode jumpNotTaken jumpTaken nop memory bogus |
		self resetGen.
		opcode := CogRTLOpcodes classPool at: opName.
		self gen: CmpRR operand: 2 operand: 1.
		jumpTaken := self gen: opcode.
		self gen: MoveCqR operand: 0 operand: 0.
		jumpNotTaken := self gen: Jump.
		jumpTaken jmpTarget: (self gen: MoveCqR operand: 1 operand: 0).
		jumpNotTaken jmpTarget: (nop := self gen: Nop).
		memory := self generateInstructions.
		bogus := false.
		self pairs: (-2 to: 2)  do:
			[:a :b| | taken |
			self processor
				reset;
				perform: reg2 with: a signedIntToLong;
				perform: reg3 with: b signedIntToLong.
			[self processor singleStepIn: memory.
			 self processor pc ~= nop address] whileTrue.
			taken := (self processor perform: reg1) = 1.
			assertPrintBar
				ifTrue:
					[self assert: taken = (signednessOrResult == #unsigned
											ifTrue: [(a bitAnd: mask) perform: relation with: (b bitAnd: mask)]
											ifFalse: [a perform: relation with: b])]
				ifFalse:
					[Transcript
						nextPutAll: reg2; nextPut: $(; print: a; nextPutAll: '') ''; nextPutAll: relation; space;
						nextPutAll: reg3; nextPut: $(; print: b; nextPutAll: '') = '';
						print: taken; cr; flush.
					 taken = (signednessOrResult == #unsigned
											ifTrue: [(a bitAnd: mask) perform: relation with: (b bitAnd: mask)]
											ifFalse: [a perform: relation with: b]) ifFalse:
						[bogus := true]]].
			 bogus ifTrue:
				[self processor printRegistersOn: Transcript.
				 Transcript show: (self processor disassembleInstructionAt: jumpTaken address In: memory); cr]]
					valueWithArguments: triple]'

'mapFromBlockStartsIn: aMethod toTempVarsFrom: schematicTempNamesString constructor: aDecompilerConstructor
	| map |
	map := aMethod
				mapFromBlockKeys: aMethod startpcsToBlockExtents keys asSortedCollection
				toSchematicTemps: schematicTempNamesString.
	map keysAndValuesDo:
		[:startpc :tempNameTupleVector| | subMap tempVector numTemps |
		subMap := Dictionary new.
		"Find how many temp slots there are (direct & indirect temp vectors)
		 and for each indirect temp vector find how big it is."
		tempNameTupleVector do:
			[:tuple|
			tuple last isArray
				ifTrue:
					[subMap at: tuple last first put: tuple last last.
					 numTemps := tuple last first]
				ifFalse:
					[numTemps := tuple last]].
		"create the temp vector for this scope level."
		tempVector := Array new: numTemps.
		"fill it in with any indirect temp vectors"
		subMap keysAndValuesDo:
			[:index :size|
			tempVector at: index put: (Array new: size)].
		"fill it in with temp nodes."
		tempNameTupleVector do:
			[:tuple| | itv |
			tuple last isArray
				ifTrue:
					[itv := tempVector at: tuple last first.
					 itv at: tuple last last
						put: (aDecompilerConstructor
								codeTemp: tuple last last - 1
								named: tuple first)]
				ifFalse:
					[tempVector
						at: tuple last
						put: (aDecompilerConstructor
								codeTemp: tuple last - 1
								named: tuple first)]].
		"replace any indirect temp vectors with proper RemoteTempVectorNodes"
		subMap keysAndValuesDo:
			[:index :size|
			tempVector
				at: index
				put: (aDecompilerConstructor
						codeRemoteTemp: index
						remoteTemps: (tempVector at: index))].
		"and update the entry in the map"
		map at: startpc put: tempVector].
	^map'

 'gnuifyFrom: inFileStream to: outFileStream

"convert interp.c to use GNU features"

	| inData beforeInterpret inInterpret inInterpretVars beforePrimitiveResponse inPrimitiveResponse |

	inData := inFileStream upToEnd withSqueakLineEndings.
	inFileStream close.

	"print a header"
	outFileStream
		nextPutAll: ''/* This file has been post-processed for GNU C */'';
		cr; cr; cr.

	beforeInterpret := true.    "whether we are before the beginning of interpret()"
	inInterpret := false.     "whether we are in the middle of interpret"
	inInterpretVars := false.    "whether we are in the variables of interpret"
	beforePrimitiveResponse := true.  "whether we are before the beginning of primitiveResponse()"
	inPrimitiveResponse := false.   "whether we are inside of primitiveResponse"
	''Gnuifying''
		displayProgressAt: Sensor cursorPoint
		from: 1 to: (inData occurrencesOf: Character cr)
		during:
			[:bar | | lineNumber |
			lineNumber := 0.
			inData linesDo:
				[ :inLine | | outLine extraOutLine caseLabel |
				bar value: (lineNumber := lineNumber + 1).
				outLine := inLine. 	"print out one line for each input line; by default, print out the line that was input, but some rules modify it"
				extraOutLine := nil.   "occasionally print a second output line..."
				beforeInterpret ifTrue: [
					inLine = ''#include "sq.h"'' ifTrue: [
						outLine := ''#include "sqGnu.h"'' ].
					inLine = ''interpret(void) {'' ifTrue: [
						"reached the beginning of interpret"
						beforeInterpret := false.
						inInterpret := true.
						inInterpretVars := true ] ]
				ifFalse: [
				inInterpretVars ifTrue: [
					(inLine findString: ''register struct foo * foo = &fum;'') > 0 ifTrue: [
						outLine := ''register struct foo * foo FOO_REG = &fum;'' ].
					(inLine findString: '' localIP;'') > 0 ifTrue: [
						outLine := ''    char* localIP IP_REG;'' ].
					(inLine findString: '' localFP;'') > 0 ifTrue: [
						outLine := ''    char* localFP FP_REG;'' ].
					(inLine findString: '' localSP;'') > 0 ifTrue: [
						outLine := ''    char* localSP SP_REG;'' ].
					(inLine findString: '' currentBytecode;'') > 0 ifTrue: [
						outLine := ''    sqInt currentBytecode CB_REG;'' ].
					inLine isEmpty ifTrue: [
						"reached end of variables"
						inInterpretVars := false.
						outLine := ''    JUMP_TABLE;''.
						extraOutLine := inLine ] ]
				ifFalse: [
				inInterpret ifTrue: [
					"working inside interpret(); translate the switch statement"
					(inLine beginsWith: ''		case '') ifTrue: [
						caseLabel := (inLine findTokens: ''	 :'') second.
						outLine := ''		CASE('', caseLabel, '')'' ].
					inLine = ''			break;'' ifTrue: [
						outLine := ''			BREAK;'' ].
					inLine = ''}'' ifTrue: [
						"all finished with interpret()"
						inInterpret := false ] ]
				ifFalse: [
				beforePrimitiveResponse ifTrue: [
					(inLine beginsWith: ''primitiveResponse('') ifTrue: [
						"into primitiveResponse we go"
						beforePrimitiveResponse := false.
						inPrimitiveResponse := true.
						extraOutLine := ''    PRIM_TABLE;'' ] ]
				ifFalse: [
				inPrimitiveResponse ifTrue: [
					inLine = ''	switch (primitiveIndex) {'' ifTrue: [
						extraOutLine := outLine.
						outLine := ''	PRIM_DISPATCH;'' ].
					inLine = ''	switch (GIV(primitiveIndex)) {'' ifTrue: [
						extraOutLine := outLine.
						outLine := ''	PRIM_DISPATCH;'' ].
					(inLine beginsWith: ''	case '') ifTrue: [
						caseLabel := (inLine findTokens: ''	 :'') second.
						outLine := ''	CASE('', caseLabel, '')'' ].
					inLine = ''}'' ifTrue: [
						inPrimitiveResponse := false ] ]
				] ] ] ].

				outFileStream nextPutAll: outLine; cr.
				extraOutLine ifNotNil: [
					outFileStream nextPutAll: extraOutLine; cr ]]].

	outFileStream close' )! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 6/24/2008 12:28'!
doTestDebuggerTempAccessWith: one with: two
	"Test debugger access for temps"
	| outerContext local1 remote1 |
	outerContext := thisContext.
	local1 := 3.
	remote1 := 1/2.
	self assert: (Compiler new evaluate: 'one' in: thisContext to: self) == one.
	self assert: (Compiler new evaluate: 'two' in: thisContext to: self) == two.
	self assert: (Compiler new evaluate: 'local1' in: thisContext to: self) == local1.
	self assert: (Compiler new evaluate: 'remote1' in: thisContext to: self) == remote1.
	Compiler new evaluate: 'local1 := -3.0' in: thisContext to: self.
	self assert: local1 = -3.0.
	(1 to: 2) do:
		[:i| | local2 r1 r2 r3 r4 |
		local2 := i * 3.
		remote1 := local2 / 7.
		self assert: thisContext ~~ outerContext.
		self assert: (r1 := Compiler new evaluate: 'one' in: thisContext to: self) == one.
		self assert: (r2 := Compiler new evaluate: 'two' in: thisContext to: self) == two.
		self assert: (r3 := Compiler new evaluate: 'i' in: thisContext to: self) == i.
		self assert: (r4 := Compiler new evaluate: 'local2' in: thisContext to: self) == local2.
		self assert: (r4 := Compiler new evaluate: 'remote1' in: thisContext to: self) == remote1.
		self assert: (r4 := Compiler new evaluate: 'remote1' in: outerContext to: self) == remote1.
		Compiler new evaluate: 'local2 := 15' in: thisContext to: self.
		self assert: local2 = 15.
		Compiler new evaluate: 'local1 := 25' in: thisContext to: self.
		self assert: local1 = 25.
		{ r1. r2. r3. r4 } "placate the compiler"].
	self assert: local1 = 25.
	self assert: remote1 = (6/7)! !

!ClosureCompilerTest methodsFor: 'failures' stamp: 'pre 7/23/2016 14:13'!
expectedFailures

	^#(testDebuggerTempAccess testInjectIntoDecompilations testInjectIntoDecompiledDebugs)  ,
	(({CompiledMethod classPool at: #SecondaryBytecodeSetEncoderClass .
	   CompiledMethod classPool at: #PrimaryBytecodeSetEncoderClass}
		includes: EncoderForV3)
			ifFalse: [#(testSourceRangeAccessForBlueBookInjectInto)]
			ifTrue: [#()])
	! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 6/4/2008 16:58'!
supportTestSourceRangeAccessForDecompiledInjectInto: method source: source
	"Test debugger source range selection for inject:into:"
	^self
		supportTestSourceRangeAccessForInjectInto: method
		source: source
		selectionSequence: #(	':= t1'
								'do: [:t4 | t3 := t2 value: t3 value: t4]'
								'value: t3 value: t4'
								':= t2 value: t3 value: t4'
								']'
								'value: t3 value: t4'
								':= t2 value: t3 value: t4'
								']'
								'^t3')! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 6/4/2008 19:44'!
supportTestSourceRangeAccessForDecompiledNoBytecodeInjectInto: method source: source
	"Test debugger source range selection for inject:into:"
	^self
		supportTestSourceRangeAccessForInjectInto: method
		source: source
		selectionSequence: #(	'at: 1 put: t1'
								'do: [:t4 | t3 at: 1 put: (t2 value: (t3 at: 1) value: t4)]'
								'value: (t3 at: 1) value: t4'
								'at: 1 put: (t2 value: (t3 at: 1) value: t4)'
								']'
								'value: (t3 at: 1) value: t4'
								'at: 1 put: (t2 value: (t3 at: 1) value: t4)'
								']'
								'^t3 at: 1')! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 7/24/2009 20:53'!
supportTestSourceRangeAccessForInjectInto: method source: source
	"Test debugger source range selection for inject:into:"
	^self
		supportTestSourceRangeAccessForInjectInto: method
		source: source
		selectionSequence: #(	':= thisValue'
								'do: [:each | nextValue := binaryBlock value: nextValue value: each]'
								'value: nextValue value: each'
								':= binaryBlock value: nextValue value: each'
								'nextValue := binaryBlock value: nextValue value: each'
								'value: nextValue value: each'
								':= binaryBlock value: nextValue value: each'
								'nextValue := binaryBlock value: nextValue value: each'
								'^nextValue')! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 7/29/2008 17:16'!
supportTestSourceRangeAccessForInjectInto: method source: source selectionSequence: selections
	"Test debugger source range selection for inject:into:"
	| evaluationCount sourceMap debugTokenSequence debugCount |
	DebuggerMethodMap voidMapCache.
	evaluationCount := 0.
	sourceMap := method debuggerMap abstractSourceMap.
	debugTokenSequence := selections collect: [:string| Scanner new scanTokens: string].
	debugCount := 0.
	thisContext
		runSimulated: [(1 to: 2)
						withArgs:
							{	0.
								[:sum :each|
								 evaluationCount := evaluationCount + 1.
								 sum + each]}
						executeMethod: method]
		contextAtEachStep:
			[:ctxt| | range debugTokens |
			(ctxt method == method
			and: ["Exclude the send of #blockCopy: or #closureCopy:copiedValues: and braceWith:with:
				    to create the block, and the #new: and #at:'s for the indirect temp vector.
				   This for compilation without closure bytecodes. (Note that at:put:'s correspond to stores)"
				(ctxt willSend
					and: [(#(closureCopy:copiedValues: blockCopy: new: at: braceWith:with:) includes: ctxt selectorToSendOrSelf) not])
				"Exclude the store of the argument into the home context (for BlueBook blocks)
				 and the store of an indirection vector into an initial temp"
				or: [(ctxt willStore
					and: [(ctxt isBlock and: [ctxt pc = ctxt startpc]) not
					and: [(ctxt isBlock not
						and: [(method usesClosureBytecodes and: [ctxt abstractPC = 2])]) not]])
				or: [ctxt willReturn]]]) ifTrue:
				[debugTokens := debugTokenSequence at: (debugCount := debugCount + 1) ifAbsent: [#(bogusToken)].
				 self assert: (sourceMap includesKey: ctxt abstractPC).
				 range := sourceMap at: ctxt abstractPC ifAbsent: [(1 to: 0)].
				 self assert: (Scanner new scanTokens: (source copyFrom: range first to: range last)) = debugTokens]].
	self assert: evaluationCount = 2! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'fbs 11/5/2013 19:50'!
testBlockDoitDecompilation
	"Tests that decompile of a doit block with remote vars executes correcly"
	"Tests that decompilation of a Block, when 'method' of block is equivalent to that compiled by a DoIt, preserves the temp names "
	
	|blockSourceStream methodNode compiledMethod block decompiledBlock|
	blockSourceStream := '|x y| [:a :b | x := a. y := b. x + y]' readStream.
	methodNode := nil class evaluatorClass new 
			compileNoPattern: blockSourceStream in: nil class notifying: nil ifFail: [nil]..
	compiledMethod := methodNode generateWithTempNames.
	block := nil withArgs: #() executeMethod: compiledMethod.
	
	decompiledBlock := block decompile.
	self assert: '{[:a :b | 
x := a.
	y := b.
	x + y]}' equals: decompiledBlock printString
! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'Igor.Stasenko 12/20/2009 03:58'!
testBlockNumbering
	"Test that the compiler and CompiledMethod agree on the block numbering of a substantial doit."
	"self new testBlockNumbering"
	| methodNode method tempRefs |
	methodNode :=
		Parser new
			encoderClass: EncoderForV3PlusClosures;
			parse: 'foo
					| numCopiedValuesCounts |
					numCopiedValuesCounts := Dictionary new.
					0 to: 32 do: [:i| numCopiedValuesCounts at: i put: 0].
					Transcript clear.
					Smalltalk allClasses remove: GeniePlugin; do:
						[:c|
						{c. c class} do:
							[:b|
							Transcript nextPut: b name first; endEntry.
							b selectorsAndMethodsDo:
								[:s :m| | pn |
								m isQuick not ifTrue:
									[pn := b parserClass new
												encoderClass: EncoderForV3PlusClosures;
												parse: (b sourceCodeAt: s)
												class: b.
									 pn generate.
									 [pn accept: nil]
										on: MessageNotUnderstood
										do: [:ex| | msg numCopied |
											msg := ex message.
											(msg selector == #visitBlockNode:
											 and: [(msg argument instVarNamed: ''optimized'') not]) ifTrue:
												[numCopied := (msg argument computeCopiedValues: pn) size.
												 numCopiedValuesCounts
													at: numCopied
													put: (numCopiedValuesCounts at: numCopied) + 1].
											msg setSelector: #==.
											ex resume: nil]]]]].
					numCopiedValuesCounts'
			class: Object.
	method := methodNode generate.
	tempRefs := methodNode encoder blockExtentsToTempsMap.
	self assert: tempRefs keys asSet = method startpcsToBlockExtents values asSet! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'Igor.Stasenko 12/20/2009 03:58'!
testBlockNumberingForInjectInto
	"Test that the compiler and CompiledMethod agree on the block numbering of Collection>>inject:into:
	 and that temp names for inject:into: are recorded."
	"self new testBlockNumberingForInjectInto"
	| methodNode method tempRefs |
	methodNode := Parser new
						encoderClass: EncoderForV3PlusClosures;
						parse: (Collection sourceCodeAt: #inject:into:)
						class: Collection.
	method := methodNode generate.
	tempRefs := methodNode encoder blockExtentsToTempsMap.
	self assert: tempRefs keys asSet = method startpcsToBlockExtents values asSet.
	self assert: ((tempRefs includesKey: (0 to: 6))
				and: [(tempRefs at: (0 to: 6)) hasEqualElements: #(('thisValue' 1) ('binaryBlock' 2) ('nextValue' (3 1)))]).
	self assert: ((tempRefs includesKey: (2 to: 4))
				and: [(tempRefs at: (2 to: 4)) hasEqualElements: #(('each' 1) ('binaryBlock' 2) ('nextValue' (3 1)))])! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 6/24/2008 11:03'!
testDebuggerTempAccess
	self doTestDebuggerTempAccessWith: 1 with: 2! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'nice 9/19/2013 23:06'!
testDecompiledDoitMethodTempNames
	"self new testDecompiledDoitMethodTempNames"
	"Test that a decompiled doit that has been copied with temps decompiles to the input"
	| removeComments |
	removeComments := [:n| n comment: nil].
	self closureCases do:
		[:source| | mns m mps mnps |
		"Need to compare an ungenerated tree with the generated method's methodNode
		 because generating code alters the tree when it introduces remote temp vectors."
		mns := #(first last) collect:
					[:ignored|
					source first isLetter
						ifTrue:
							[self class newCompiler
								compile: source
								in: self class
								notifying: nil
								ifFail: [self error: 'compilation error']]
						ifFalse:
							[self class newCompiler
								compileNoPattern: source
								in: self class
								notifying: nil
								ifFail: [self error: 'compilation error']]].
		m := (mns last generateWithTempNames).
		removeComments value: mns first.
		mns first nodesDo: removeComments.
		self assert: (mnps := mns first printString) = (mps := m methodNode printString)]! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 5/19/2014 12:10'!
testInjectIntoDecompilations
	"Test various compilations decompile to the same code for a method sufficiently
	 simple that this is possible and sufficiently complex that the code generated
	 varies between the compilations."
	"self new testInjectIntoDecompilations"
	| source |
	source := (Collection sourceCodeAt: #inject:into:) asString.
	{ Encoder.
	   EncoderForV3.
	   EncoderForV3PlusClosures } do:
		[:encoderClass| | method |
		method := (Parser new
							encoderClass: encoderClass;
							parse: source
							class: Collection)
						generate.
		self assert: (Scanner new scanTokens: method decompileString)
					= #(inject: t1 into: t2
							| t3 |
							t3 ':=' t1 .
							self do: [ ':t4' | t3 ':=' t2 value: t3 value: t4 ] .
							^ t3)]! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 5/19/2014 12:10'!
testInjectIntoDecompiledDebugs
	"Test various debugs of the decompiled form debug correctly."
	"self new testInjectIntoDecompiledDebugs"
	| source |
	source := (Collection sourceCodeAt: #inject:into:) asString.
	{ Encoder.
	   EncoderForV3PlusClosures } do:
		[:encoderClass| | method |
		method := (Parser new
							encoderClass: encoderClass;
							parse: source
							class: Collection)
						generate.
		self supportTestSourceRangeAccessForDecompiledInjectInto: method source: method decompileString]! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 7/24/2009 11:51'!
testInlineBlockCollectionEM1
	| a1 b1 i1 a2 b2 i2 we wb |
	b1 := OrderedCollection new.
	i1 := 1.
	[a1 := i1.
	 i1 <= 3] whileTrue:
		[b1 add: [a1].
		i1 := i1 + 1].
	b1 := b1 asArray collect: [:b | b value].
	b2 := OrderedCollection new.
	i2 := 1.
	we := [a2 := i2. i2 <= 3].
	wb := [b2 add: [a2]. i2 := i2 + 1].
	we whileTrue: wb. "defeat optimization"
	b2 := b2 asArray collect: [:b | b value].
	self assert: b1 = b2! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 3/7/2009 11:25'!
testInlineBlockCollectionLR1
	"Test case from Lukas Renggli"
	| col |
	col := OrderedCollection new.
	1 to: 11 do: [ :each | col add: [ each ] ].
	self assert: (col collect: [ :each | each value ]) asArray = (1 to: 11) asArray! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 3/7/2009 11:39'!
testInlineBlockCollectionLR2
	"Test case from Lukas Renggli"
	| col |
	col := OrderedCollection new.
	1 to: 11 do: [ :each | #(1) do: [:ignored| col add: [ each ]] ].
	self assert: (col collect: [ :each | each value ]) asArray = (1 to: 11) asArray! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 3/9/2009 11:00'!
testInlineBlockCollectionLR3
	| col |
	col := OrderedCollection new.
	1 to: 11 do: [ :each | | i | i := each. col add: [ i ]. i := i + 1 ].
	self assert: (col collect: [ :each | each value ]) asArray = (2 to: 12) asArray! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 7/22/2009 16:55'!
testInlineBlockCollectionSD1
	| a1 b1 a2 b2 |
	b1 := OrderedCollection new.
	1 to: 3 do:
		[:i |
		a1 := i.
		b1 add: [a1]].
	b1 := b1 asArray collect: [:b | b value].
	b2 := OrderedCollection new.
	1 to: 3 do:
		[:i |
		a2 := i.
		b2 add: [a2]] yourself. "defeat optimization"
	b2 := b2 asArray collect: [:b | b value].
	self assert: b1 = b2! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'nice 9/19/2013 23:07'!
testMethodAndNodeTempNames
	"self new testMethodAndNodeTempNames"
	"Test that BytecodeAgnosticMethodNode>>blockExtentsToTempRefs answers the same
	 structure as CompiledMethod>>blockExtentsToTempRefs when the method has been
	 copied with the appropriate temps.  This tests whether doit methods are debuggable
	 since they carry their own temps."
	self closureCases do:
		[:source| | mn om m mbe obe |
		mn := source first isLetter
					ifTrue:
						[self class newCompiler
							compile: source
							in: self class
							notifying: nil
							ifFail: [self error: 'compilation error']]
					ifFalse:
						[self class newCompiler
							compileNoPattern: source
							in: self class
							notifying: nil
							ifFail: [self error: 'compilation error']].
		m := (om := mn generate) copyWithTempsFromMethodNode: mn.
		self assert: m holdsTempNames.
		self assert: m endPC = om endPC.
		mbe := m blockExtentsToTempsMap.
		obe := mn blockExtentsToTempsMap.
		self assert: mbe keys asSet = obe keys asSet.
		(mbe keys intersection: obe keys) do:
			[:interval|
			self assert: (mbe at: interval) = (obe at: interval)]]! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 9/5/2009 17:33'!
testOptimizedBlockLocalNilling1
	"Whether a block is optimized or not a block-local temp
	 should be nil at the start of each evaluation of the block."

	1 to: 3 do: [:i| | j |
		self assert: j isNil.
		j := i + 1.
		self assert: j isNil not]! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 9/5/2009 17:32'!
testOptimizedBlockLocalNilling2
	"Whether a block is optimized or not a block-local temp
	 should be nil at the start of each evaluation of the block."

	1 to: 6 do: [:i| | j k |
		self assert: j isNil.
		self assert: k isNil.
		i even
			ifTrue: [j := i + 2]
			ifFalse: [k := i + 1].
		self assert: (j isNil or: [k isNil]).
		self assert: (j isNil not or: [k isNil not])]! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'pre 7/23/2016 14:13'!
testSourceRangeAccessForBlueBookInjectInto
	"Test debugger source range selection for inject:into: for a version compiled with closures"
	"self new testSourceRangeAccessForBlueBookInjectInto"
	| source method |
	[source := (Collection sourceCodeAt: #inject:into:) asString.
	method := (Parser new
						encoderClass: EncoderForV3;
						parse: source
						class: Collection)
					generate: (Collection compiledMethodAt: #inject:into:) trailer.
	self supportTestSourceRangeAccessForInjectInto: method source: source.]
		on: Error
		do: [:e | self fail: e.]! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 6/4/2008 15:20'!
testSourceRangeAccessForClosureBytecodeInjectInto
	"Test debugger source range selection for inject:into: for a version compiled with closures"
	"self new testSourceRangeAccessForClosureBytecodeInjectInto"
	| source method |
	source := (Collection sourceCodeAt: #inject:into:) asString.
	method := (Parser new
						encoderClass: EncoderForV3PlusClosures;
						parse: source
						class: Collection)
					generate: (Collection compiledMethodAt: #inject:into:) trailer.
	self supportTestSourceRangeAccessForInjectInto: method source: source! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'eem 6/4/2008 11:40'!
testSourceRangeAccessForInjectInto
	"Test debugger source range selection for inject:into: for the current version of the method"
	"self new testSourceRangeAccessForInjectInto"
	self supportTestSourceRangeAccessForInjectInto: (Collection compiledMethodAt: #inject:into:)
		source: (Collection sourceCodeAt: #inject:into:) asString! !

!ClosureCompilerTest methodsFor: 'tests' stamp: 'Igor.Stasenko 12/20/2009 03:57'!
testTempNameAccessForInjectInto
	"self new testTempNameAccessForInjectInto"
	| methodNode method evaluationCount block debuggerMap |
	methodNode := Parser new
						encoderClass: EncoderForV3PlusClosures;
						parse: (Collection sourceCodeAt: #inject:into:)
						class: Collection.
	method := methodNode generate.
	debuggerMap := DebuggerMethodMap forMethod: method methodNode: methodNode.
	evaluationCount := 0.
	block := [:prev :each| | theContext tempNames |
			evaluationCount := evaluationCount + 1.
			theContext := thisContext sender.
			tempNames := debuggerMap tempNamesForContext: theContext.
			self assert: (tempNames hasEqualElements: tempNames).
			#('thisValue' 'each' 'binaryBlock' 'nextValue')
				with: { 0. each. block. prev}
				do: [:tempName :value|
					self assert: (debuggerMap namedTempAt: (tempNames indexOf: tempName) in: theContext) == value.
					tempName ~= 'each' ifTrue:
						[self assert: (debuggerMap namedTempAt: (tempNames indexOf: tempName) in: theContext home) == value]]].
	(1 to: 10) withArgs: { 0. block } executeMethod: method.
	self assert: evaluationCount = 10! !

ClosureCompilerTest subclass: #MethodHighlightingTests
	instanceVariableNames: 'creator timeStamp duration tracks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Compiler'!

!MethodHighlightingTests methodsFor: 'tests' stamp: 'ar 1/3/2010 14:23'!
asXML
	"self new asXML"
	"Convert the master index into external XML representation"
	
	^String streamContents:[:s| | writer |
		writer := self xmlWriter on: s.
		writer xmlDeclaration: '1.0'.
		writer startTag: 'recording'; endTag.
			writer tag: 'creator' pcData: creator.
			writer tag: 'timestamp' pcData: timeStamp.
			writer tag: 'duration' pcData: duration.
			writer startTag: 'tracks'; endTag.
				tracks do:[:tdata|
					writer startTag: 'track'; attribute: 'type' value: tdata value; endTag.
					writer pcData: tdata key.
					writer endTag: 'track'.
				].
			writer endTag: 'tracks'.
		writer endTag: 'recording'.
	].
! !

!MethodHighlightingTests methodsFor: 'tests' stamp: 'eem 9/5/2009 10:58'!
testMethodHighlighting
	| map before after method retpc |
	"Test the highlighting of the asXML method.  Test the highlighting of the return
	 statement which should include the whole block supplied to streamContents:."
	"DebuggerMethodMap voidMapCache"
	"DebuggerMethodMap forMethod: MethodHighlightingTests >> #asXML"
	method := MethodHighlightingTests >> #asXML.
	map := DebuggerMethodMap forMethod: method.
	retpc := method endPC.
	before := map rangeForPC: retpc contextIsActiveContext: false.
	map instVarNamed: 'abstractSourceRanges' put: nil.
	after := map rangeForPC: retpc contextIsActiveContext: false.
	self assert: before size > 500.
	self assert: before = after! !

TestCase subclass: #ClosureTests
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Compiler'!

!ClosureTests methodsFor: 'utilities' stamp: 'lr 3/9/2009 16:48'!
assertValues: anArray
	| values |
	values := collection collect: [ :each | each value ].
	self 
		assert: anArray asArray = values asArray
		description: 'Expected: ' , anArray asArray printString , 
			', but got ' , values asArray printString! !

!ClosureTests methodsFor: 'utilities' stamp: 'cwp 11/16/2009 08:12'!
evaluateCopyOf: aBlock
	aBlock copy value! !

!ClosureTests methodsFor: 'testing' stamp: 'lr 3/11/2009 17:35'!
methodArgument: anObject
	^ [ anObject ]
	! !

!ClosureTests methodsFor: 'utilities' stamp: 'cwp 11/16/2009 08:12'!
methodWithNonLocalReturn
	self evaluateCopyOf: [^ self].
	self signalFailure: 'Should never reach here'! !

!ClosureTests methodsFor: 'running' stamp: 'lr 3/9/2009 16:48'!
setUp
	super setUp.
	collection := OrderedCollection new! !

!ClosureTests methodsFor: 'testing' stamp: 'lr 3/11/2009 17:33'!
testBlockArgument
	| block block1 block2 |
	block := [ :arg | | temp | temp := arg. [ temp ] ].
	block1 := block value: 1.
	block2 := block value: 2.
	self assert: block1 value = 1.
	self assert: block2 value = 2! !

!ClosureTests methodsFor: 'testing' stamp: 'lr 3/11/2009 17:33'!
testBlockTemp
	| block block1 block2 |
	block := [ :arg | [ arg ] ].
	block1 := block value: 1.
	block2 := block value: 2.
	self assert: block1 value = 1.
	self assert: block2 value = 2! !

!ClosureTests methodsFor: 'testing' stamp: 'fbs 11/5/2013 22:29'!
testCopyNonLocalReturn
	"This should not fail."
	self methodWithNonLocalReturn! !

!ClosureTests methodsFor: 'testing' stamp: 'eem 4/26/2012 10:41'!
testIsClean
	| local |
	local := #testIsClean.

	self assert: [] isClean. "closes over nothing at all"
	self assert: [:a :b| a < b] isClean. "accesses only arguments"
	self assert: [:a :b| | s | s := a + b. s even] isClean. "accesses only local variables"

	self deny: [^nil] isClean. "closes over home (^-return)"
	self deny: [self] isClean. "closes over the receiver"
	self deny: [collection] isClean. "closes over the receiver (to access the inst var collection)"
	self deny: [local] isClean. "closes over local variable of outer context"! !

!ClosureTests methodsFor: 'testing' stamp: 'lr 3/11/2009 17:36'!
testMethodArgument
	| temp block |
	temp := 0.
	block := [ [ temp ] ].
	temp := 1.
	block := block value.
	temp := 2.
	self assert: block value = 2! !

!ClosureTests methodsFor: 'testing' stamp: 'lr 3/11/2009 17:36'!
testMethodTemp
	| block1 block2 |
	block1 := self methodArgument: 1.
	block2 := self methodArgument: 2.
	self assert: block1 value = 1.
	self assert: block2 value = 2! !

!ClosureTests methodsFor: 'testing-todo' stamp: 'lr 3/10/2009 14:51'!
testToDoArgument
	1 to: 5 do: [ :index |
		collection add: [ index ] ].
	self assertValues: #(1 2 3 4 5)! !

!ClosureTests methodsFor: 'testing-todo' stamp: 'lr 3/10/2009 14:51'!
testToDoArgumentNotInlined
	| block |
	block := [ :index |
		collection add: [ index ] ].
	1 to: 5 do: block.
	self assertValues: #(1 2 3 4 5)! !

!ClosureTests methodsFor: 'testing-todo' stamp: 'lr 3/10/2009 14:51'!
testToDoInsideTemp
	1 to: 5 do: [ :index | 
		| temp | 
		temp := index. 
		collection add: [ temp ] ].
	self assertValues: #(1 2 3 4 5)! !

!ClosureTests methodsFor: 'testing-todo' stamp: 'lr 3/10/2009 14:51'!
testToDoInsideTempNotInlined
	| block |
	block := [ :index | 
		| temp | 
		temp := index. 
		collection add: [ temp ] ].
	1 to: 5 do: block.
	self assertValues: #(1 2 3 4 5)! !

!ClosureTests methodsFor: 'testing-todo' stamp: 'lr 3/10/2009 14:51'!
testToDoOutsideTemp
	| temp |
	1 to: 5 do: [ :index | 
		temp := index. 
		collection add: [ temp ] ].
	self assertValues: #(5 5 5 5 5)! !

!ClosureTests methodsFor: 'testing-todo' stamp: 'lr 3/10/2009 14:51'!
testToDoOutsideTempNotInlined
	| block temp |
	block := [ :index | 
		temp := index. 
		collection add: [ temp ] ].
	1 to: 5 do: block.
	self assertValues: #(5 5 5 5 5)! !

!ClosureTests methodsFor: 'testing-while' stamp: 'lr 3/10/2009 14:29'!
testWhileModificationAfter
	| index |
	index := 0.
	[ index < 5 ] whileTrue: [
		collection add: [ index ].
		index := index + 1 ].
	self assertValues: #(5 5 5 5 5)! !

!ClosureTests methodsFor: 'testing-while' stamp: 'lr 3/10/2009 14:29'!
testWhileModificationAfterNotInlined
	| index block |
	index := 0.
	block := [ 
		collection add: [ index ].
		index := index + 1 ].
	[ index < 5 ] whileTrue: block.
	self assertValues: #(5 5 5 5 5)! !

!ClosureTests methodsFor: 'testing-while' stamp: 'lr 3/10/2009 14:29'!
testWhileModificationBefore
	| index |
	index := 0.
	[ index < 5 ] whileTrue: [ 
		index := index + 1.
		collection add: [ index ] ].
	self assertValues: #(5 5 5 5 5)! !

!ClosureTests methodsFor: 'testing-while' stamp: 'lr 3/10/2009 14:29'!
testWhileModificationBeforeNotInlined
	| index block |
	index := 0.
	block := [ 
		index := index + 1.
		collection add: [ index ] ].
	[ index < 5 ] whileTrue: block.
	self assertValues: #(5 5 5 5 5)! !

!ClosureTests methodsFor: 'testing-while' stamp: 'lr 3/10/2009 14:52'!
testWhileWithTemp
	| index |
	index := 0.
	[ index < 5 ] whileTrue: [
		| temp |
		temp := index := index + 1.
		collection add: [ temp ] ].
	self assertValues: #(1 2 3 4 5)! !

!ClosureTests methodsFor: 'testing-while' stamp: 'eem 5/22/2010 09:35'!
testWhileWithTempIsNil
	| index |
	index := 0.
	[ index < 5 ] whileTrue: [
		| temp |
		collection add: temp.
		temp := index := index + 1. 
		collection add: temp].
	self assertValues: #(nil 1 nil 2 nil 3 nil 4 nil 5)! !

!ClosureTests methodsFor: 'testing-while' stamp: 'lr 3/10/2009 14:53'!
testWhileWithTempNotInlined
	| index block |
	index := 0.
	block := [
		| temp |
		temp := index := index + 1.
		collection add: [ temp ] ].
	[ index < 5 ] whileTrue: block.
	self assertValues: #(1 2 3 4 5)! !

TestCase subclass: #CompilerExceptionsTest
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Compiler'!

!CompilerExceptionsTest methodsFor: 'private' stamp: 'ul 1/12/2011 13:43'!
compile: sourceString

	text := sourceString.
	self class
		compileSilently: text
		classified: 'generated'
		notifying: self! !

!CompilerExceptionsTest methodsFor: 'private' stamp: 'ul 1/12/2011 13:50'!
compiling: sourceCode shouldRaise: exceptionClass

	self should: [ self compile: sourceCode ] raise: exceptionClass! !

!CompilerExceptionsTest methodsFor: 'private' stamp: 'ul 1/12/2011 13:48'!
removeGeneratedMethods

	self class removeCategory: 'generated'! !

!CompilerExceptionsTest methodsFor: 'emulating' stamp: 'cwp 8/25/2009 20:23'!
select
	! !

!CompilerExceptionsTest methodsFor: 'emulating' stamp: 'cwp 8/25/2009 20:23'!
selectFrom: start to: end 
	! !

!CompilerExceptionsTest methodsFor: 'emulating' stamp: 'cwp 8/25/2009 20:22'!
selectionInterval
	^ 1 to: 0! !

!CompilerExceptionsTest methodsFor: 'running' stamp: 'ul 1/12/2011 13:49'!
setUp

	self removeGeneratedMethods! !

!CompilerExceptionsTest methodsFor: 'running' stamp: 'ul 1/12/2011 13:49'!
tearDown

	self removeGeneratedMethods! !

!CompilerExceptionsTest methodsFor: 'tests' stamp: 'ul 1/12/2011 13:57'!
testAmbiguousSelector 

	self 
		compiling: 'griffle ^1--1'
		shouldRaise: AmbiguousSelector;
		compiling: 'griffle ^1@-1'
		shouldRaise: AmbiguousSelector;
		compiling: 'griffle ^1+-1'
		shouldRaise: AmbiguousSelector ! !

!CompilerExceptionsTest methodsFor: 'tests' stamp: 'ul 1/12/2011 13:58'!
testUndeclaredVariable

	self 
		compiling: 'griffle ^ goo'
		shouldRaise: UndeclaredVariable;
		compiling: 'griffle ^ [ goo ] value'
		shouldRaise: UndeclaredVariable! !

!CompilerExceptionsTest methodsFor: 'tests' stamp: 'ul 1/12/2011 13:57'!
testUndefinedVariable

	self 
		compiling: 'griffle | goo | ^ goo'
		shouldRaise: UndefinedVariable;
		compiling: 'griffle [ | goo | ^ goo ] value'
		shouldRaise: UndefinedVariable! !

!CompilerExceptionsTest methodsFor: 'tests' stamp: 'ul 1/12/2011 13:59'!
testUnknownSelector
	
	self 
		compiling: 'griffle self reallyHopeThisIsntImplementedAnywhere'
		shouldRaise: UnknownSelector;
		compiling: 'griffle [ self reallyHopeThisIsntImplementedAnywhere ] value'
		shouldRaise: UnknownSelector! !

!CompilerExceptionsTest methodsFor: 'tests' stamp: 'ul 1/12/2011 13:56'!
testUnusedVariable

	self 
		compiling: 'griffle | goo | ^nil'
		shouldRaise: UnusedVariable;
		compiling: 'griffle ^[ | goo | ]'
		shouldRaise: UnusedVariable! !

!CompilerExceptionsTest methodsFor: 'emulating' stamp: 'ul 1/12/2011 13:43'!
text
	
	^text! !

TestCase subclass: #CompilerNotifyingTest
	instanceVariableNames: 'text morph expectedErrors expectedErrorPositions failure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Compiler'!

!CompilerNotifyingTest commentStamp: 'nice 2/21/2012 23:55' prior: 0!
A CompilerNotifyingTest is a TestCase for checking that Compiler/Parser notifications are inserted at the right place in a TextEditor.

Instance Variables
	expectedErrorPositions:		<Array of: Integer>
	expectedErrors:		<Array of: String>
	failure:		<Object>
	morph:		<TextMorph>
	text:		<String>

errorPositions
	- the position where error text should be inserted for each chunk of text evaluated

errors
	- the error text that should be inserted on evaluation of each chunk of text evaluated

failure
	- an object returned in case of evaluation error and whose identity can be uniquely recognized as a failure
	
morph
	- the Morph holding the text
	
text
	- the string containing all the chunks to be evaluated (separated by %)
	  and the expected error messages (`enclosed in back quotes`)
	  this text will be stripped of the error messages before being evaluated.

!

!CompilerNotifyingTest class methodsFor: 'history' stamp: 'nice 2/22/2012 03:53'!
lastStoredRun
	^ ((Dictionary new) add: (#failures->((Set new) add: #testTooManyArguments; add: #testifTrueBlockWithArgument; add: #testMissingArgumentAfterAMessageKey; add: #testTooManyLiterals; add: #testAlltogether; add: #testUnmatchedLocalTempDeclarationInABlock; add: #testUnmatchedExpressionParenthesis; add: #testCaseOtherwiseBlockWithArgument; yourself)); add: (#errors->((Set new) add: #testTooManyTemporaries; yourself)); add: (#passed->((Set new) add: #testUnmatchedBraceArray; add: #testTooLargeAnIntegerInALiteralByteArray; add: #testDigitTooLargeForARadix; add: #testInvalidLiteralCharacter; add: #testAssignmentOfSelf; add: #testInvalidPrimitive; add: #testInvalidExternalFunctionDeclaration; add: #testMissingExpressionAfterAReturn; add: #testInvalidRadix; add: #testMissingArgumentAfterABinaryMessage; add: #testMissingPeriodSeparatorBetweenStatements; add: #testCascadeInASuperSend; add: #testATempShadowingAnotherTemp; add: #testExtraneousStatementAfterAReturnInABlock; add: #testLiteralCharacterMissing; add: #testUnmatchedCommentQuote; add: #testInvalidPattern; add: #testUnmatchedByteArrayBracket; add: #testUnmatchedLiteralParenthesis; add: #testUnmatchedLocalTempDeclaration; add: #testExpectedExpressionInBraceArray; add: #testInvalidPragma; add: #testMissingSeparatorBetweenBlockArgumentAndStatements; add: #testMissingBlockArgumentName; add: #testMissingMessageAfterACascade; add: #testUnmatchedStringQuote; add: #testTempDoubledDefined; add: #testMissingExpression; add: #testUnmatchedBlockBracket; add: #testEmptyCaseStatement; yourself)); add: (#timeStamp->'22 February 2012 3:52:10 am' asTimeStamp); yourself)! !

!CompilerNotifyingTest methodsFor: 'private' stamp: 'nice 2/22/2012 00:56'!
enumerateAllSelections
	1 to: self numberOfSelections do: [:n |
		self assert: (self evaluateSelectionNumber: n) == failure.
		self assert: ((expectedErrors at: n) = morph editor selection asString).
		self assert: ((expectedErrorPositions at: n) = morph editor startIndex).
		morph editor cut].! !

!CompilerNotifyingTest methodsFor: 'private' stamp: 'nice 12/16/2013 14:58'!
evaluateSelection
	^(nil class evaluatorClass new)
		evaluate: morph editor selectionAsStream
		in: nil
		to: nil
		notifying: morph editor
		ifFail: [^failure]
	! !

!CompilerNotifyingTest methodsFor: 'private' stamp: 'nice 2/21/2012 23:58'!
evaluateSelectionNumber: n
	| i start stop |
	i := start := 1.
	[stop := morph text indexOf: $% startingAt: start + 1 ifAbsent: morph text size + 1.
	i = n]
		whileFalse:
			[i := i + 1.
			start := stop + 1].
	morph editor selectFrom: start to: stop - 1.
	^self evaluateSelection
	! !

!CompilerNotifyingTest methodsFor: 'accessing' stamp: 'nice 2/22/2012 21:41'!
expectedFailures
	"For these tests, the Compiler does not insert the notification where it would be most informative."
	
	^#(
		"Notifying before the literal (which can be a message send) would be more informative"
		testTooManyLiterals
		
		"Notifying right before the 16th argument would be informative"
		testTooManyArguments
		
		"Notifying before the extraneous argument in the right block woul be useful"
		testifTrueBlockWithArgument  testCaseOtherwiseBlockWithArgument
		)! !

!CompilerNotifyingTest methodsFor: 'initialize-release' stamp: 'nice 2/21/2012 23:52'!
initializeTextWithoutError
	"Remove the errors from the text to be compiled and answer the text without errors.
	Meanwhile, collect the expected error messages and their expected position."

	| input output errorStream positionStream |
	input := text readStream.
	output := (String new: text size) writeStream.
	errorStream := (Array new: self numberOfSelections) writeStream.
	positionStream := (Array new: self numberOfSelections) writeStream.
	
	[output nextPutAll: (input upTo: $`).
	input atEnd]
		whileFalse:
			[positionStream nextPut: output position + 1.
			errorStream nextPut: (input upTo: $`)].
	expectedErrors := errorStream contents.
	expectedErrorPositions := positionStream contents.
	^output contents! !

!CompilerNotifyingTest methodsFor: 'private' stamp: 'nice 2/21/2012 22:23'!
numberOfSelections
	^(text occurrencesOf: $%) + 1! !

!CompilerNotifyingTest methodsFor: 'initialize-release' stamp: 'nice 2/22/2012 00:54'!
setUp
	failure := Object new.! !

!CompilerNotifyingTest methodsFor: 'initialize-release' stamp: 'nice 2/21/2012 23:41'!
setUpForErrorsIn: aTextWithErrorsEnclosedInBackQuote
	"Extract the expectedErrors, the expectedErrorPositions and set up a TextMorph containing the text without errors.
	each section separated by % in aTextWithErrorsEnclosedInBackQuote will be evaluated separately.
	The expected error message should lie in aTextWithErrorsEnclosedInBackQuote at the expected position, and enclosed in back quotes."
	text := aTextWithErrorsEnclosedInBackQuote.
	morph := TextMorph new contents: self initializeTextWithoutError asText.! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'abc 10/7/2015 16:24'!
testATempShadowingAnotherTemp
	self setUpForErrorsIn: '| x | x := 1. ^[ | ` Name already used in this method ->`x | x ]'.
	self enumerateAllSelections! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'eem 10/8/2012 13:41'!
testAlltogether
	"Initialize for all known error conditions.
	Note that the chunk to be evaluated are separated by %, and expected errors enclosed in back quotes."
	
	self setUpForErrorsIn: '  "First, the senders of #offEnd:"
#` Unmatched bracket ->`[ 1 2 %
#[ 1 2 ` 8-bit integer or right bracket expected ->`256 4]%
$` A Character was expected ->`%
1+2   ` Unmatched comment quote ->`"unfinished comment%
#` Unmatched parenthesis ->`( 1 2%
#` Unmatched parenthesis ->`( 1 2 %
^nil printString ,  ` Unmatched string quote ->`''unfinished string%
	"Then, the senders of #expected:"
2r` a digit between 0 and 1 expected ->`3%
| x | x := ` Expression expected ->`%
[ :x : ` Argument name expected ->`1]%
[ :x ` Vertical bar expected ->`x + 1 ]%
[:x | 1 ` Period or right bracket expected ->`( 1 ) ]%
{ 1. 2` Period or right brace expected ->`%
{ 1. 2 ` Period or right brace expected ->`%
{ 1. 2 ` Period or right brace expected ->`3 %
{ 1. 2. ` Variable or expression or right brace expected ->`| x | %
super yourself` Cascading not expected ->`; yourself%
nil yourself; ` Cascade expected ->`^ 2%
	"#externalFunctionDeclaration is skipped, this cannot be evaluated"
1 to: ` Argument expected ->`:=%
1 +` Argument expected ->`%
1 + ` Argument expected ->`* 2 + 3%
1+(2 ` right parenthesis expected ->`.  %
1 + 2 ` Nothing more expected ->`^nil%
	"#pattern:inContext: skipped, cannot be evaluated"
	"#pragmaLiteral: #pragmaSequence #pragmaStatement skipped, cannot be evaluated"
(  ` expression expected ->`. 2  . )%
( 1  ` right parenthesis expected ->`. 2  . )%
	"#primitive:error: #primitive:module:error: skipped, cannot be evaluated"
^ ` Expression to return expected ->`. 1 + 2%
[ ^1 ` End of block expected ->`2]%
| x y ` Vertical bar expected ->`%
[:z | | x y ` Vertical bar expected ->`]%
1` an integer greater than 1 as valid radix expected ->`r0'.
	self enumerateAllSelections! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'nice 2/22/2012 01:06'!
testAssignmentOfSelf
	self setUpForErrorsIn: '` Cannot store into ->`self := 1. ^self'.
	self enumerateAllSelections.! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'nice 2/22/2012 00:54'!
testCascadeInASuperSend
	self setUpForErrorsIn: 'super yourself` Cascading not expected ->`; yourself'.
	self enumerateAllSelections! !

!CompilerNotifyingTest methodsFor: 'testing-block arguments' stamp: 'nice 2/22/2012 01:15'!
testCaseOtherwiseBlockWithArgument
	self setUpForErrorsIn: 'nil caseOf: { [nil] -> [1] } otherwise: [:x` <- otherwise arg of caseOf:otherwise: has too many arguments ->` | 2 ]. ^nil '.
	self enumerateAllSelections.! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'nice 2/22/2012 00:55'!
testDigitTooLargeForARadix
	self setUpForErrorsIn: '2r` a digit between 0 and 1 expected ->`3'.
	self enumerateAllSelections! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'nice 2/22/2012 01:10'!
testEmptyCaseStatement
	self setUpForErrorsIn: '^ nil caseOf: { ` At least one case required ->`} '.
	self enumerateAllSelections.! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'eem 10/8/2012 13:41'!
testExpectedExpressionInBraceArray
	self setUpForErrorsIn: '{ 1. 2 ` Period or right brace expected ->`3 }'.
	self enumerateAllSelections.
	self setUpForErrorsIn: '{ 1. 2. ` Variable or expression or right brace expected ->`| x | x}'.
	self enumerateAllSelections! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'nice 2/22/2012 00:55'!
testExtraneousStatementAfterAReturnInABlock
	self setUpForErrorsIn: '[ ^1 ` End of block expected ->`2]'.
	self enumerateAllSelections.! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'nice 2/22/2012 00:31'!
testInvalidExternalFunctionDeclaration
	"Not implemented yet.
	#externalFunctionDeclaration skipped, cannot be evaluated"! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'nice 2/22/2012 01:08'!
testInvalidLiteralCharacter
	self setUpForErrorsIn: '^ #yourself , #` Invalid literal character ->`) , #end'.
	self enumerateAllSelections.! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'nice 2/22/2012 00:31'!
testInvalidPattern
	"Not implemented yet.
	#pattern:inContext: skipped, cannot be evaluated"! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'nice 2/22/2012 01:53'!
testInvalidPragma
	"Not implemented yet.
	#pragmaLiteral: #pragmaSequence #pragmaStatement #pragmaPrimitives skipped, cannot be evaluated"! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'nice 2/22/2012 00:31'!
testInvalidPrimitive
	"Not implemented yet.
	##primitive:error: #primitive:module:error: skipped, cannot be evaluated"! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'nice 2/22/2012 00:55'!
testInvalidRadix
	self setUpForErrorsIn: '1` an integer greater than 1 as valid radix expected ->`r0'.
	self enumerateAllSelections.! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'nice 2/22/2012 00:55'!
testLiteralCharacterMissing
	self setUpForErrorsIn: '$` A Character was expected ->`'.
	self enumerateAllSelections! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'nice 2/22/2012 00:55'!
testMissingArgumentAfterABinaryMessage
	self setUpForErrorsIn: '1 +` Argument expected ->`'.
	self enumerateAllSelections.
	self setUpForErrorsIn: '1 + ` Argument expected ->`* 2 + 3'.
	self enumerateAllSelections! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'nice 2/22/2012 00:55'!
testMissingArgumentAfterAMessageKey
	self setUpForErrorsIn: '1 to: ` Argument expected ->`:='.
	self enumerateAllSelections! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'nice 2/22/2012 00:55'!
testMissingBlockArgumentName
	self setUpForErrorsIn: '[ :x : ` Argument name expected ->`1]'.
	self enumerateAllSelections! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'nice 2/22/2012 00:55'!
testMissingExpression
	self setUpForErrorsIn: '| x | x := ` Expression expected ->'.
	self enumerateAllSelections! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'nice 2/22/2012 00:55'!
testMissingExpressionAfterAReturn
	self setUpForErrorsIn: '^ ` Expression to return expected ->`. 1 + 2'.
	self enumerateAllSelections.! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'nice 2/22/2012 00:55'!
testMissingMessageAfterACascade
	self setUpForErrorsIn: 'nil yourself; ` Cascade expected ->`^ 2'.
	self enumerateAllSelections! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'nice 2/22/2012 02:06'!
testMissingPeriodSeparatorBetweenStatements
	self setUpForErrorsIn: '1 + 2 ` Nothing more expected ->`^nil'.
	self enumerateAllSelections.! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'nice 2/22/2012 00:55'!
testMissingSeparatorBetweenBlockArgumentAndStatements
	self setUpForErrorsIn: '[ :x ` Vertical bar expected ->`x + 1 ]'.
	self enumerateAllSelections! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'abc 10/7/2015 16:24'!
testTempDoubledDefined
	self setUpForErrorsIn: '| x ` Name already used in this method ->`x | x := 1. ^x'.
	self enumerateAllSelections! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'nice 2/22/2012 00:55'!
testTooLargeAnIntegerInALiteralByteArray
	self setUpForErrorsIn: '#[ 1 2 ` 8-bit integer or right bracket expected ->`256 4 5]'.
	self enumerateAllSelections! !

!CompilerNotifyingTest methodsFor: 'testing-byteCode limits' stamp: 'nice 2/22/2012 01:34'!
testTooManyArguments
	self setUpForErrorsIn: '^[:x1 :x2 :x3 :x4 :x5 :x6 :x7 :x8 :x9 :x10 :x11 :x12 :x13 :x14 :x15 ` Too many arguments ->`:x16 :x17 | ]'.
	self enumerateAllSelections.! !

!CompilerNotifyingTest methodsFor: 'testing-byteCode limits' stamp: 'nice 2/22/2012 01:49'!
testTooManyLiterals
	self setUpForErrorsIn: '{#(1). #(2). #(3). #(4). #(5). #(6). #(7). #(8). #(9). #(10). #(11). #(12). #(13). #(14). #(15). #(16). #(17). #(18). #(19). #(20). #(21). #(22). #(23). #(24). #(25). #(26). #(27). #(28). #(29). #(30). #(31). #(32). #(33). #(34). #(35). #(36). #(37). #(38). #(39). #(40). #(41). #(42). #(43). #(44). #(45). #(46). #(47). #(48). #(49). #(50). #(51). #(52). #(53). #(54). #(55). #(56). #(57). #(58). #(59). #(60). #(61). #(62). #(63). #(64). #(65). #(66). #(67). #(68). #(69). #(70). #(71). #(72). #(73). #(74). #(75). #(76). #(77). #(78). #(79). #(80). #(81). #(82). #(83). #(84). #(85). #(86). #(87). #(88). #(89). #(90). #(91). #(92). #(93). #(94). #(95). #(96). #(97). #(98). #(99). #(100). #(101). #(102). #(103). #(104). #(105). #(106). #(107). #(108). #(109). #(110). #(111). #(112). #(113). #(114). #(115). #(116). #(117). #(118). #(119). #(120). #(121). #(122). #(123). #(124). #(125). #(126). #(127). #(128). #(129). #(130). #(131). #(132). #(133). #(134). #(135). #(136). #(137). #(138). #(139). #(140). #(141). #(142). #(143). #(144). #(145). #(146). #(147). #(148). #(149). #(150). #(151). #(152). #(153). #(154). #(155). #(156). #(157). #(158). #(159). #(160). #(161). #(162). #(163). #(164). #(165). #(166). #(167). #(168). #(169). #(170). #(171). #(172). #(173). #(174). #(175). #(176). #(177). #(178). #(179). #(180). #(181). #(182). #(183). #(184). #(185). #(186). #(187). #(188). #(189). #(190). #(191). #(192). #(193). #(194). #(195). #(196). #(197). #(198). #(199). #(200). #(201). #(202). #(203). #(204). #(205). #(206). #(207). #(208). #(209). #(210). #(211). #(212). #(213). #(214). #(215). #(216). #(217). #(218). #(219). #(220). #(221). #(222). #(223). #(224). #(225). #(226). #(227). #(228). #(229). #(230). #(231). #(232). #(233). #(234). #(235). #(236). #(237). #(238). #(239). #(240). #(241). #(242). #(243). #(244). #(245). #(246). #(247). #(248). #(249). #(250). #(251). #(252). #(253). #(254). #(255). #(256). `More than 256 literals referenced. 
You must split or otherwise simplify this method.
The 257th literal is: ->`#(257)}'.
	self enumerateAllSelections! !

!CompilerNotifyingTest methodsFor: 'testing-byteCode limits' stamp: 'nice 2/22/2012 21:52'!
testTooManyTemporaries
	"Nope, with Closure Compiler, an Error is raised before the Encoder has a chance to notify"! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'nice 2/22/2012 01:57'!
testUnmatchedBlockBracket
	self setUpForErrorsIn: 'nil yourself. [` Period or right bracket expected ->`'.
	self enumerateAllSelections.! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'nice 2/22/2012 00:55'!
testUnmatchedBraceArray
	self setUpForErrorsIn: '{ 1. 2` Period or right brace expected ->`'.
	self enumerateAllSelections.
	self setUpForErrorsIn: '{ 1. 2 ` Period or right brace expected ->`'.
	self enumerateAllSelections! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'nice 2/22/2012 00:55'!
testUnmatchedByteArrayBracket
	self setUpForErrorsIn: '#` Unmatched bracket ->`[ 1 2 '.
	self enumerateAllSelections! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'nice 2/22/2012 00:55'!
testUnmatchedCommentQuote
	self setUpForErrorsIn: '1+2   ` Unmatched comment quote ->`"unfinished comment'.
	self enumerateAllSelections! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'nice 2/22/2012 02:41'!
testUnmatchedExpressionParenthesis
	self setUpForErrorsIn: '1+(2 ` right parenthesis expected ->`. '.
	self enumerateAllSelections.! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'nice 2/22/2012 00:55'!
testUnmatchedLiteralParenthesis
	self setUpForErrorsIn: '#` Unmatched parenthesis ->`( 1 2'.
	self enumerateAllSelections.
	self setUpForErrorsIn: '#` Unmatched parenthesis ->`( 1 2 '.
	self enumerateAllSelections.! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'nice 2/22/2012 00:55'!
testUnmatchedLocalTempDeclaration
	self setUpForErrorsIn: '| x y ` Vertical bar expected ->`'.
	self enumerateAllSelections.! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'nice 2/22/2012 00:55'!
testUnmatchedLocalTempDeclarationInABlock
	self setUpForErrorsIn: '[:z | | x y ` Vertical bar expected ->`]'.
	self enumerateAllSelections.! !

!CompilerNotifyingTest methodsFor: 'testing' stamp: 'nice 2/22/2012 00:55'!
testUnmatchedStringQuote
	self setUpForErrorsIn: '^nil printString ,  ` Unmatched string quote ->`''unfinished string'.
	self enumerateAllSelections! !

!CompilerNotifyingTest methodsFor: 'testing-block arguments' stamp: 'nice 2/22/2012 01:23'!
testifTrueBlockWithArgument
	self setUpForErrorsIn: 'true ifTrue: [:x` <- argument of ifTrue: has too many arguments ->` | 1 + 1 ]'.
	self enumerateAllSelections.
	self setUpForErrorsIn: 'true ifTrue: [:x` <- argument of ifTrue: has too many arguments ->` :y | 1 + 1 ]'.
	self enumerateAllSelections.! !

CompilerNotifyingTest subclass: #CompilerSyntaxErrorNotifyingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Compiler'!

!CompilerSyntaxErrorNotifyingTest commentStamp: 'nice 2/22/2012 22:37' prior: 0!
A CompilerSyntaxErrorNotifyingTest is a specialization for testing correct handling of non interactive compiler notification.
Non interactive is a very relative notion in Smalltalk...
Here it means that user interaction will not happen directly in the TextEditor holding source code, but rather thru a SyntaxError window that will pop-up.
This test intercept the Notification before the pop-up is raised.
!

!CompilerSyntaxErrorNotifyingTest class methodsFor: 'testing' stamp: 'nice 2/22/2012 22:54'!
shouldInheritSelectors
	"This class can recycle all of super tests, it just has to refine internal Compiler evaluation machinery"
	^true! !

!CompilerSyntaxErrorNotifyingTest methodsFor: 'private' stamp: 'nice 2/22/2012 23:01'!
enumerateAllSelections
	"This method intercepts the SyntaxErrorNotification and prevent the SyntaxError morph to open.
	The notification errorCode hold the source of evaluated sub-selection with inserted error message.
	This can be compared to expected error notification."
	| syntaxErrorProbe |
	syntaxErrorProbe := Object new.
	1 to: self numberOfSelections do: [:n |
		| result |
		result := [self evaluateSelectionNumber: n] on: SyntaxErrorNotification do: [:exc |
			| expectedSourceWithError expectedNotificationLocation |
			expectedNotificationLocation := (expectedErrorPositions at: n) - (morph editor startIndex - 1).
			expectedSourceWithError := morph editor selection
							copyReplaceFrom: expectedNotificationLocation
							to: expectedNotificationLocation - 1
							with: (expectedErrors at: n) allButFirst.
			self assert: expectedSourceWithError = exc errorCode asString.
			exc return: syntaxErrorProbe].
		self assert: result == syntaxErrorProbe].! !

!CompilerSyntaxErrorNotifyingTest methodsFor: 'private' stamp: 'nice 12/16/2013 14:58'!
evaluateSelection
	^(nil class evaluatorClass new)
		evaluate: morph editor selection readStream
		"Note subtle difference versus  (morph editor selectionAsStream). 
		The later does not answer the same contents and would raise a SyntaxErrorNotification with wrong sub-selection"
		in: nil
		to: nil
		notifying: nil
		ifFail: [^failure]! !

TestCase subclass: #CompilerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Compiler'!

!CompilerTest commentStamp: 'nice 12/3/2007 22:15' prior: 0!
CompilerTest is a holder for SUnit test of Compiler!

!CompilerTest methodsFor: 'syntax' stamp: 'nice 9/19/2013 23:07'!
testBinarySelectorWithBar
	"Acknowledge the fact that $| is now allowed at any place in a binary selector"
	
	#(#'||' #'|||' #'|||++' #'<|>') do: [:selector | | source tree |
		source := ('1 ' , selector , ' 2') readStream.
		tree := (Compiler new)
			compileNoPattern: source in: Object notifying: nil ifFail: [nil].
		self assert: tree notNil.
	
		"Hem, this test is really ugly..."
		self assert: tree block statements first expr selector key = selector].! !

!CompilerTest methodsFor: 'syntax' stamp: 'nice 9/19/2013 23:07'!
testBinarySelectorWithMinus
	"Acknowledge the fact that $- is now allowed at any place in a binary selector"
	
	| source tree |
	source := '1 @- 2' readStream.
	tree := (Compiler new)
			compileNoPattern: source in: Object notifying: nil ifFail: [nil].
	self assert: tree notNil.
	
	"Hem, this test is really ugly..."
	self assert: tree block statements first expr selector key = #'@-'.! !

!CompilerTest methodsFor: 'syntax' stamp: 'nice 10/24/2011 18:59'!
testEmptyTemporaries
	self assert: (Compiler evaluate: '||') isNil! !

!CompilerTest methodsFor: 'testing' stamp: 'nice 12/16/2013 14:58'!
testEvaluationOfInlinedToDo
	"Whether inlined or not, #to:do: should return the same value"
	| inlinedResult notInlinedResult |
	inlinedResult := Compiler new
				evaluate: '1+1 to: 0 do: [:i | ]'
				in: nil
				to: nil
				notifying: nil 
				ifFail: [^ #failedDoit].
	notInlinedResult := Compiler new
				evaluate: '| aBlock | aBlock := [:i | ]. 1+1 to: 0 do: aBlock'
				in: nil
				to: nil
				notifying: nil 
				ifFail: [^ #failedDoit].
	self assert: inlinedResult = notInlinedResult! !

!CompilerTest methodsFor: 'syntax' stamp: 'nice 10/24/2011 19:14'!
testInvalidVerticalBarSelector
	self should: [Compiler evaluate: '1 | | 2'] raise: SyntaxErrorNotification.
	self should: [Compiler evaluate: '1 | - 2'] raise: SyntaxErrorNotification.! !

!CompilerTest methodsFor: 'syntax' stamp: 'nice 10/24/2011 18:59'!
testLocalTemporariesInABlock
	self assert: ((Compiler evaluate: '[:x|| tmp | tmp := x]') value: 2) = 2! !

!CompilerTest methodsFor: 'limits' stamp: 'eem 8/25/2015 16:00'!
testMaxLiterals
	"Document the maximum number of literals in a compiled method"

	| maxLiterals stringThatCanBeCompiled stringWithOneTooManyLiterals |
	"Why 6?  It's rather implementation dependent.  But the {... construct is compiled as
		(Array braceStream: size)
			nextPut: expr;
			...;
			braceArray
	 where nextPut: is a special selector.  So one each for Array binding, #braceStream, #braceArray and the size,
	 one for the selector and one for the methodClass makes 6."
	maxLiterals := thisContext method encoderClass new maxNumLiterals - 6.
	stringThatCanBeCompiled := '{ ', (String streamContents: [:strm |
					1 to: maxLiterals do: [:e | strm nextPutAll: '''', e asString, '''', ' . ']]), '}'.
	stringWithOneTooManyLiterals := '{ ', (String streamContents: [:strm |
					1 to: maxLiterals + 1 do: [:e | strm nextPutAll: '''', e asString, '''', ' . ']]), '}'.
	self assert: ((1 to: maxLiterals) collect: #printString) equals: (Compiler evaluate: stringThatCanBeCompiled).
	
	"If the following test fails, it means that the limit has been raised or eliminated,
	and this test should be updated to reflect the improvement."
	self should: [Compiler evaluate: stringWithOneTooManyLiterals] raise: Error.
! !

!CompilerTest methodsFor: 'limits' stamp: 'ul 8/21/2015 01:07'!
testMaxLiteralsWithClassReferenceInClosure
	"Document the maximum number of literals in a compiled method. A class
	reference in a closure reduces the maximum literals."

	| maxLiterals stringThatCanBeCompiled stringWithOneTooManyLiterals |
	maxLiterals := 245.
	stringThatCanBeCompiled := '[ DateAndTime now. Date today. Time ]. { ',
			(String streamContents: [:strm |
					1 to: maxLiterals do: [:e | strm nextPutAll: '''', e asString, '''', ' . ']]), '}'.
	stringWithOneTooManyLiterals := '[ DateAndTime now. Date today. Time ]. { ',
			(String streamContents: [:strm |
					1 to: maxLiterals + 1 do: [:e | strm nextPutAll: '''', e asString, '''', ' . ']]), '}'.
	self assert: maxLiterals equals: (Compiler evaluate: stringThatCanBeCompiled) size.
	
	"If the following test fails, it means that the limit has been raised or eliminated,
	and this test should be updated to reflect the improvement."
	self should: [Compiler evaluate: stringWithOneTooManyLiterals] raise: Error.
! !

!CompilerTest methodsFor: 'syntax' stamp: 'nice 3/6/2010 22:31'!
testNegativeNumbers
	"Acknowledge the fact that (-  2) which was accepted up to Squeak 3.10 is not valid anymore"
	
	self assert: (Compiler evaluate: '-2') = 2 negated.
	self should: [Compiler evaluate: '-  2'] raise: SyntaxErrorNotification description: 'A negative number literal shall not include any separator'! !

!CompilerTest methodsFor: 'literals' stamp: 'nice 12/20/2012 23:37'!
testNegativeZero
	self assert: (Compiler evaluate: '-0.0') hex = Float negativeZero hex.! !

!CompilerTest methodsFor: 'literals' stamp: 'nice 12/3/2007 22:20'!
testScaledDecimalLiterals
	"Equal ScaledDecimal with different scales should use different slots
	This is related to http://bugs.squeak.org/view.php?id=6797"
	
	"This correctly works when evaluated separately"
	self deny: (Compiler evaluate: '0.5s1') scale = (Compiler evaluate: '0.5s2') scale.
	
	"But not when evaluated together if literal reduction is too agressive"
	self deny: (Compiler evaluate: '0.5s1 scale =  0.5s2 scale').! !

!CompilerTest methodsFor: 'testing' stamp: 'fbs 11/5/2013 22:42'!
testToDoModifiesTheLimit
	"This is a non regression test for http://bugs.squeak.org/view.php?id=7093.
	When blocks writes into to:do: loop limit, optimization shall be carried with care."
	
	self
		assert: 4
		equals:
			[ | n |
			n := 2.
			1 to: n do: [:i | (n := n+1)>10 ifTrue: [self error: 'Should not get here']].
			n] value.
	self
		assert: 4
		equals:
			[ | n |
			n := 2.
			1 to: n by: 1 do: [:i | (n := n+1)>10 ifTrue: [self error: 'Should not get here']].
			n] value.
	self
		assert: 4
		equals:
			[ | n inc |
			n := 2.
			inc := 1.
			1 to: n by: inc do: [:i | (n := n+1)>10 ifTrue: [self error: 'Should not get here']].
			n] value.! !

TestCase subclass: #ContextCompilationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Compiler'!

!ContextCompilationTest methodsFor: 'tests' stamp: 'eem 6/19/2008 10:11'!
testVariablesAndOffsetsDo

	"ContextCompilationTest new testVariablesAndOffsetsDo"
	| contextClasses |
	contextClasses := ContextPart withAllSuperclasses, ContextPart allSubclasses asArray.
	contextClasses do:
		[:class|
		class variablesAndOffsetsDo:
			[:var :offset|
			self assert: offset < 0.
			self assert: (class instVarNameForIndex: offset negated) == var]].

	InstructionStream withAllSuperclasses, InstructionStream allSubclasses asArray do:
		[:class|
		(contextClasses includes: class) ifFalse:
			[class variablesAndOffsetsDo:
				[:var :offset|
				(InstructionStream instVarNames includes: var) ifFalse:
					[self assert: offset > 0.
					 self assert: (class instVarNameForIndex: offset) == var]]]]! !

TestCase subclass: #DataStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-System-Object Storage'!

!DataStreamTest methodsFor: 'helper' stamp: 'topa 6/25/2015 09:44'!
get: aSerialized

	^ self streamClass unStream: aSerialized! !

!DataStreamTest methodsFor: 'helper' stamp: 'topa 6/25/2015 09:44'!
put: anObject

	^ self streamClass streamedRepresentationOf: anObject.! !

!DataStreamTest methodsFor: 'constants' stamp: 'topa 6/25/2015 09:23'!
streamClass
	^ DataStream! !

!DataStreamTest methodsFor: 'tests' stamp: 'topa 6/25/2015 09:28'!
testCharacter
	| c |
	c := Character value: 16r271D.
	self assert: c equals: (self testObject: c) description: 'Characters should be serializable'! !

!DataStreamTest methodsFor: 'tests' stamp: 'topa 6/25/2015 09:27'!
testFloat
	| f |
	f := Float pi.
	self assert: f equals: (self testObject: f) description: 'Floats should be serializable'.
! !

!DataStreamTest methodsFor: 'tests' stamp: 'topa 6/25/2015 10:47'!
testLargeIntergers
	| i |
	i := 123456789012345678901234567890.
	self assert: i equals: (self testObject: i) description: 'A large positive integer should be serializable'.
	
	i := -123456789012345678901234567890.
	self assert: i equals: (self testObject: i) description: 'A large negative integer should be serializable'! !

!DataStreamTest methodsFor: 'tests' stamp: 'topa 6/25/2015 10:48'!
testNotTooLargeIntergers
	| i |
	i := 1234567890123.
	self assert: i equals: (self testObject: i) description: 'A larger, but not too large positive integer should be serializable'.
	
	i := -1234567890123.
	self assert: i equals: (self testObject: i) description: 'A  larger, but not too large negative integer should be serializable'! !

!DataStreamTest methodsFor: 'helper' stamp: 'topa 6/25/2015 09:44'!
testObject: anObject
	
	| serialized |
	serialized :=  self put: anObject.
	^ self get: serialized! !

!DataStreamTest methodsFor: 'tests' stamp: 'topa 6/25/2015 09:28'!
testSmallInteger
	| i |
	i := SmallInteger maxVal.
	self assert: i equals: (self testObject: i) description: 'The maximum small integer should be serializable'.
	
	i := SmallInteger minVal.
	self assert: i equals: (self testObject: i) description: 'The minimum small integer should be serializable'! !

DataStreamTest subclass: #ReferenceStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-System-Object Storage'!

!ReferenceStreamTest methodsFor: 'constants' stamp: 'topa 6/25/2015 09:23'!
streamClass
	^ ReferenceStream! !

ReferenceStreamTest subclass: #SmartRefStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-System-Object Storage'!

!SmartRefStreamTest methodsFor: 'helper' stamp: 'topa 6/25/2015 09:54'!
put: anObject
	
	| s |
	s := RWBinaryOrTextStream on: (ByteArray new: 500).
	 (self streamClass on: s)
		nextPutObjOnly: anObject;
		close.
	^ s contents! !

!SmartRefStreamTest methodsFor: 'constants' stamp: 'topa 6/25/2015 09:24'!
streamClass
	^ SmartRefStream! !

TestCase subclass: #DosFileDirectoryTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Files'!

!DosFileDirectoryTests methodsFor: 'as yet unclassified' stamp: 'ar 3/6/2004 04:03'!
testFileDirectoryContainingDirectory
	"Hoping that you have 'C:' of course..."
	| fd |
	FileDirectory activeDirectoryClass == DosFileDirectory ifFalse:[^self].
	fd := FileDirectory on: 'C:'.
	self assert: fd containingDirectory pathName = ''.
! !

!DosFileDirectoryTests methodsFor: 'as yet unclassified' stamp: 'ar 3/6/2004 04:05'!
testFileDirectoryContainingDirectoryExistence
	"Hoping that you have 'C:' of course..."
	| fd |
	FileDirectory activeDirectoryClass == DosFileDirectory ifFalse:[^self].
	fd := FileDirectory on: 'C:'.
	self assert: (fd containingDirectory fileOrDirectoryExists: 'C:').! !

!DosFileDirectoryTests methodsFor: 'as yet unclassified' stamp: 'ar 3/6/2004 04:04'!
testFileDirectoryContainingEntry
	"Hoping that you have 'C:' of course..."
	| fd |
	FileDirectory activeDirectoryClass == DosFileDirectory ifFalse:[^self].
	fd := FileDirectory on: 'C:'.
	self assert: (fd containingDirectory entryAt: fd localName) notNil.
! !

!DosFileDirectoryTests methodsFor: 'as yet unclassified' stamp: 'ar 3/6/2004 04:04'!
testFileDirectoryDirectoryEntry
	"Hoping that you have 'C:' of course..."
	| fd |
	FileDirectory activeDirectoryClass == DosFileDirectory ifFalse:[^self].
	fd := FileDirectory on: 'C:'.
	self assert: fd directoryEntry notNil.! !

!DosFileDirectoryTests methodsFor: 'as yet unclassified' stamp: 'ar 4/27/2004 23:28'!
testFileDirectoryEntryFor
	"Hoping that you have 'C:' of course..."
	| fd |
	FileDirectory activeDirectoryClass == DosFileDirectory ifFalse:[^self].
	fd := FileDirectory root directoryEntryFor: 'C:'.
	self assert: (fd name sameAs: 'C:').! !

!DosFileDirectoryTests methodsFor: 'as yet unclassified' stamp: 'ar 4/27/2004 23:21'!
testFileDirectoryExists
	"Hoping that you have 'C:' of course..."
	FileDirectory activeDirectoryClass == DosFileDirectory ifFalse:[^self].
	self assert: (FileDirectory root directoryExists: 'C:').! !

!DosFileDirectoryTests methodsFor: 'as yet unclassified' stamp: 'ar 3/6/2004 04:04'!
testFileDirectoryLocalName
	"Hoping that you have 'C:' of course..."
	| fd |
	FileDirectory activeDirectoryClass == DosFileDirectory ifFalse:[^self].
	fd := FileDirectory on: 'C:'.
	self assert: fd localName = 'C:'.
! !

!DosFileDirectoryTests methodsFor: 'as yet unclassified' stamp: 'ar 4/27/2004 23:19'!
testFileDirectoryNamed
	"Hoping that you have 'C:' of course..."
	| fd |
	FileDirectory activeDirectoryClass == DosFileDirectory ifFalse:[^self].
	fd := FileDirectory root directoryNamed: 'C:'.
	self assert: fd pathName = 'C:'.! !

!DosFileDirectoryTests methodsFor: 'as yet unclassified' stamp: 'DF 5/26/2006 11:57'!
testFileDirectoryNonExistence

	| inexistentFileName |
	
	"Hoping that you have 'C:' of course..."
	FileDirectory activeDirectoryClass == DosFileDirectory ifFalse:[^self].
	
	inexistentFileName := DosFileDirectory default nextNameFor: 'DosFileDirectoryTest' extension: 'temp'.
	
	"This test can fail if another process creates a file with the same name as inexistentFileName
	(the probability of that is very very remote)"

	self deny: (DosFileDirectory default fileOrDirectoryExists: inexistentFileName)! !

!DosFileDirectoryTests methodsFor: 'as yet unclassified' stamp: 'ar 3/6/2004 04:13'!
testFileDirectoryRootExistence
	"Hoping that you have 'C:' of course..."
	FileDirectory activeDirectoryClass == DosFileDirectory ifFalse:[^self].
	self assert: (FileDirectory root fileOrDirectoryExists: 'C:').! !

!DosFileDirectoryTests methodsFor: 'as yet unclassified' stamp: 'ar 4/27/2004 23:28'!
testFullNameFor
	"Hoping that you have 'C:' of course..."
	FileDirectory activeDirectoryClass == DosFileDirectory ifFalse:[^self].
	self assert: (FileDirectory default fullNameFor: 'C:') = 'C:'.
	self assert: (FileDirectory default fullNameFor: 'C:\test') = 'C:\test'.
	self assert: (FileDirectory default fullNameFor: '\\share') = '\\share'.
	self assert: (FileDirectory default fullNameFor: '\\share\test') = '\\share\test'.
	self assert: (FileDirectory default fullNameFor: '\test') = (FileDirectory default pathParts first, '\test').
! !

!DosFileDirectoryTests methodsFor: 'as yet unclassified' stamp: 'ar 3/6/2004 04:17'!
testIsDriveForDrive
	self assert: (DosFileDirectory isDrive: 'C:').
	self deny: (DosFileDirectory isDrive: 'C:\').
	self deny: (DosFileDirectory isDrive: 'C:\foo').
	self deny: (DosFileDirectory isDrive: 'C:foo').! !

!DosFileDirectoryTests methodsFor: 'as yet unclassified' stamp: 'ar 3/6/2004 04:17'!
testIsDriveForShare
	self assert: (DosFileDirectory isDrive: '\\server').
	self deny: (DosFileDirectory isDrive: '\\server\').
	self deny: (DosFileDirectory isDrive: '\\server\foo').
! !

TestCase subclass: #EnvironmentTest
	instanceVariableNames: 'env value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Environments'!

!EnvironmentTest methodsFor: 'asserting' stamp: 'cwp 12/29/2013 23:32'!
assertExports: aSymbol value: v2
	| other |
	other := Environment withName: #other.
	other import: env.
	self assert: (other bindingOf: aSymbol) value = v2! !

!EnvironmentTest methodsFor: 'support' stamp: 'cwp 3/31/2014 13:05'!
createClass: aSymbol
	| builder |
	builder := ClassBuilder new.
	^ builder
		name: aSymbol
		inEnvironment: env
		subclassOf: Object
		type: #normal
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'Test'.
	! !

!EnvironmentTest methodsFor: 'asserting' stamp: 'cwp 12/31/2013 12:31'!
denyExports: aSymbol
	| other |
	other := Environment withName: #other.
	other import: env.
	self assert: (other bindingOf: aSymbol) isNil! !

!EnvironmentTest methodsFor: 'running' stamp: 'cwp 2/18/2013 15:46'!
setUp
	env := Environment withName: 'test'.
	value := Object new.! !

!EnvironmentTest methodsFor: 'support' stamp: 'cwp 3/31/2014 19:52'!
storeValueMethod
	"Assign an object to the global,
	capture the value of the assignment 
	expression, and answer both
	the object and the result."


	^ 'doStore
	| expr result | 
	expr := Object new.  
	result := Plonk := expr. 
	^ { expr. result }
'! !

!EnvironmentTest methodsFor: 'running' stamp: 'cwp 12/29/2013 13:53'!
tearDown
	env destroy.
	env := nil! !

!EnvironmentTest methodsFor: 'compatibility tests' stamp: 'topa 1/20/2015 09:28'!
testAssociationsDo
	"For compatibility with legacy code, environments 
	should implement the dictionary protocol."

	env at: #Griffle put: value.
	env at: #Plonk put: value.
	env at: #Nurp put: value.
	env associationsDo: [:assoc |
		(#(Smalltalk Undeclared) includes: assoc key)
			ifFalse: ["We're not interested in these default bindings"
				self assert: (#(Griffle Plonk Nurp) includes: assoc key).
				self assert: value equals: assoc value]].
! !

!EnvironmentTest methodsFor: 'binding tests' stamp: 'cwp 3/29/2014 21:57'!
testAtDoesntFindUndeclared
	"It seems reasonable for #bindingOf: to answer either an
	existing binding, or create an undeclared binding and
	answer that. Reasonable, but wrong. The tools expect to 
	receive nil if no binding exists, and explicitly create
	an undeclared binding if that's desirable."
	
	env := Environment withName: #Test.
	env bindingOf: #Griffle.
	self should: [ env at: #Griffle ] raise: KeyNotFound! !

!EnvironmentTest methodsFor: 'compatibility tests' stamp: 'cwp 3/29/2014 22:51'!
testAtIfAbsent
	"For compatibility with legacy code, environments 
	should implement the dictionary protocol."

	| result |
	result := env at: #Griffle ifAbsent: [value].
	self assert: result == value! !

!EnvironmentTest methodsFor: 'compatibility tests' stamp: 'cwp 3/29/2014 22:51'!
testAtIfAbsentNot
	"For compatibility with legacy code, environments 
	should implement the dictionary protocol."

	| result |
	env at: #Griffle put: value.
	result := env at: #Griffle ifAbsent: [self assert: false].
	self assert: result == value! !

!EnvironmentTest methodsFor: 'compatibility tests' stamp: 'cwp 3/29/2014 22:52'!
testAtIfPresent
	"For compatibility with legacy code, environments 
	should implement the dictionary protocol."

	| result |
	env at: #Griffle put: value.
	env at: #Griffle ifPresent: [:v | result := v].
	self assert: result == value! !

!EnvironmentTest methodsFor: 'compatibility tests' stamp: 'cwp 3/29/2014 22:53'!
testAtIfPresentIfAbsentAbsent
	"For compatibility with legacy code, environments 
	should implement the dictionary protocol."

	| answer result |
	result := Object new.
	answer := env 
		at: #Griffle 
		ifPresent: [:v | self fail: 'should not reach here'] 
		ifAbsent: [result].
		
	self
		assert: result 
		identical: answer
		description: 'Method answers the result of the absent block'! !

!EnvironmentTest methodsFor: 'compatibility tests' stamp: 'cwp 3/29/2014 22:52'!
testAtIfPresentIfAbsentPresent
	"For compatibility with legacy code, environments 
	should implement the dictionary protocol."

	| answer argument result |
	result := Object new.
	env at: #Griffle put: value.
	answer := env 
		at: #Griffle 
		ifPresent: [:v | argument := v. result] 
		ifAbsent: [#absent].
		
	self 
		assert: value 
		identical: argument 
		description: 'Value is passed to the ifPresent block'.
	self
		assert: result 
		identical: answer
		description: 'Method answers the result of the block'! !

!EnvironmentTest methodsFor: 'compatibility tests' stamp: 'cwp 3/29/2014 22:55'!
testAtIfPresentNot
	"For compatibility with legacy code, environments 
	should implement the dictionary protocol."
	
	env 
		at: #Griffle 
		ifPresent: [self fail: 'should not reach here'].! !

!EnvironmentTest methodsFor: 'compatibility tests' stamp: 'cwp 3/29/2014 23:00'!
testAtPutDeclared
	"For compatibility with legacy code, environments 
	should implement the dictionary protocol."

	| binding |
	env bind: #Griffle to: Object new.
	binding := env associationAt: #Griffle.
	env at: #Griffle put: value.
	self assert: binding value == value! !

!EnvironmentTest methodsFor: 'compatibility tests' stamp: 'cwp 3/29/2014 23:01'!
testAtPutUndeclared
	"For compatibility with legacy code, environments 
	should implement the dictionary protocol."

	| binding |
	binding := env undeclare: #Griffle.
	env at: #Griffle put: value.
	self assert: binding value == value! !

!EnvironmentTest methodsFor: 'compatibility tests' stamp: 'cwp 3/29/2014 23:08'!
testDeclaredBecomeClassBinding
	"If a global variable is assigned a class as
	its value, its binding will become a class 
	binding."

	| binding class |
	class := Behavior new.
	binding := env 
		bind: #Griffle to: value;
		declarationOf: #Griffle.
	env at: #Griffle put: class.
	self assert: (binding class == ClassBinding).
	self assert: binding value == class.! !

!EnvironmentTest methodsFor: 'compatibility tests' stamp: 'cwp 3/29/2014 23:09'!
testDeclaredBecomeGlobal
	"If a class binding gets assigned a non-
	class value, the binding becomes a global."

	| binding class |
	class := Behavior new.
	binding := env 
		bind: #Griffle to: class;
		declarationOf: #Griffle.
	env at: #Griffle put: value.
	self assert: (binding class == Global).
	self assert: binding value == value.! !

!EnvironmentTest methodsFor: 'observation tests' stamp: 'cwp 3/31/2014 21:31'!
testDestroyRemovesObservers
	"When an imported environment is destroyed,
	the import is destroyed along with it."

	| foreign |
	foreign := Environment withName: #Foreign.
	foreign exportSelf.
	env import: foreign.
	foreign destroy.
	self assert: 0 equals: (env instVarNamed: 'policies') size! !

!EnvironmentTest methodsFor: 'observation tests' stamp: 'cwp 3/31/2014 21:32'!
testDestroyStopsObserving
	"When an environment is destroyed, it removes its self
	from the observers list of other environments."

	| foreign |
	foreign := Environment withName: #Foreign.
	foreign exportSelf.
	env import: foreign.
	env destroy.
	self assert: 0 equals: (foreign instVarNamed: 'observers') size! !

!EnvironmentTest methodsFor: 'observation tests' stamp: 'cwp 3/31/2014 21:33'!
testDestroyedImportIsUndeclared
	"When an imported environment is destroyed, it's
	bindings become undeclared in the importing environment"

	| foreign |
	foreign := Environment withName: #Foreign.
	foreign exportSelf.
	foreign at: #Griffle put: value.
	env from: foreign import: #Griffle.
	foreign destroy.
	self assert: (env bindingOf: #Griffle) isNil.
	self assert: (env isUndeclared: #Griffle).! !

!EnvironmentTest methodsFor: 'export tests' stamp: 'cwp 3/31/2014 20:17'!
testExclusiveExplicitExport
	"Exporting one name shouldn't
	export others."

	env export: #Plonk.
	env at: #Griffle put: Object new.
	self denyExports: #Griffle! !

!EnvironmentTest methodsFor: 'export tests' stamp: 'cwp 3/31/2014 20:18'!
testExclusiveMultiExplicitExport
	"Exporting multiple names shouldn't export
	a name not on the list."

	env export: #(Plonk #Griffle).
	env at: #Nurp put: Object new.
	self denyExports: #Nurp! !

!EnvironmentTest methodsFor: 'export tests' stamp: 'cwp 3/31/2014 20:26'!
testExplicitExport
	"Export a single name"
	
	env export: #Griffle.
	env bind: #Griffle to: value.
	self assertExports: #Griffle value: value! !

!EnvironmentTest methodsFor: 'export tests' stamp: 'cwp 3/31/2014 20:30'!
testExportAddPrefix
	"export all names, adding a prefix."
	
	env exportAddingPrefix: 'XX'.
	env at: #Griffle put: value.
	self assertExports: #XXGriffle value: value! !

!EnvironmentTest methodsFor: 'export tests' stamp: 'cwp 3/31/2014 20:31'!
testExportAddingPrefixPublicizesExistingValue
	"Export, adding prefix, *after* the binding has been created"
	
	env at: #Griffle put: value.
	env exportAddingPrefix: 'XX'.
	self assertExports: #XXGriffle value: value! !

!EnvironmentTest methodsFor: 'export tests' stamp: 'cwp 3/31/2014 20:32'!
testExportPublicizesExistingValue
	"Export a single name, after the binding as been created."
	
	env at: #Griffle put: value.
	env export: #Griffle.
	self assertExports: #Griffle value: value! !

!EnvironmentTest methodsFor: 'export tests' stamp: 'cwp 3/31/2014 20:36'!
testExportRemovingPrefix
	"Export all names, removing a prefix"

	env exportRemovingPrefix: 'XX'.
	env at: #XXGriffle put: value.
	self assertExports: #Griffle value: value! !

!EnvironmentTest methodsFor: 'export tests' stamp: 'cwp 3/31/2014 20:37'!
testExportRemovingPrefixPublicizesExistingValue
	"Export all names, removing a prefix, 
	after a binding has been created."

	env at: #XXGriffle put: value.
	env exportRemovingPrefix: 'XX'.
	self assertExports: #Griffle value: value! !

!EnvironmentTest methodsFor: 'export tests' stamp: 'cwp 3/31/2014 20:39'!
testExportSelfPublicizesExistingValue
	"Export all values, after a binding has been created."
	
	env at: #Griffle put: value.
	env exportSelf.
	self assertExports: #Griffle value: value! !

!EnvironmentTest methodsFor: 'import tests' stamp: 'cwp 3/31/2014 20:48'!
testImportAddingPrefix
	"Import a single name adding a prefix."

	| foreign |
	foreign := Environment withName: #Foreign.
	foreign exportSelf.
	foreign at: #Griffle put: value.
	env import: foreign addingPrefix: 'XX'.
	self assert: (env bindingOf: #XXGriffle) value == value! !

!EnvironmentTest methodsFor: 'import tests' stamp: 'cwp 3/31/2014 21:04'!
testImportAddingPrefixResolvesUndeclared
	"If there's an existing undeclared variable, importing
	a binding with the same (transformed) name creates
	the binding."

	| binding foreign |
	foreign := Environment withName: #Foreign.
	foreign exportSelf.
	foreign bind: #Griffle to: value.
	binding := env undeclare: #XXGriffle.
	env import: foreign addingPrefix: 'XX'.
	self assert: (env bindingOf: #XXGriffle) == binding.
	self assert: (env valueOf: #XXGriffle) == value! !

!EnvironmentTest methodsFor: 'import tests' stamp: 'cwp 12/29/2013 23:24'!
testImportAlias
	| foreign binding |
	foreign := Environment withName: #Foreign.
	foreign exportSelf.
	foreign bind: #Griffle to: value.
	env from: foreign import: #Griffle -> #Plonk.
	binding := env bindingOf: #Plonk.
	self assert: binding key = #Plonk.
	self assert: binding value == value! !

!EnvironmentTest methodsFor: 'import tests' stamp: 'cwp 3/31/2014 21:11'!
testImportAliases
	"Import several specific names, renaming them."

	| foreign v2 v3 |
	foreign := Environment withName: #Foreign.
	foreign exportSelf.
	foreign at: #Griffle put: value.
	foreign at: #Nurp put: (v2 := Object new).
	foreign at: #Ziffy put: (v3 := Object new).
	env from: foreign import: {#Nurp -> #Plonk. #Ziffy -> #Wiffy}.
	self assert: (env bindingOf: #Griffle) isNil.
	self assert: (env bindingOf: #Plonk) value == v2.
	self assert: (env bindingOf: #Wiffy) value == v3! !

!EnvironmentTest methodsFor: 'import tests' stamp: 'cwp 3/31/2014 21:22'!
testImportFromOther
	"Import a whole environment."

	| foreign |
	foreign := Environment withName: #Foreign.
	foreign exportSelf.
	foreign at: #Griffle put: value.
	env import: foreign.
	self assert: (env bindingOf: #Griffle) value == value! !

!EnvironmentTest methodsFor: 'import tests' stamp: 'cwp 3/31/2014 21:22'!
testImportOne
	"import s specific name"

	| foreign |
	foreign := Environment withName: #Foreign.
	foreign exportSelf.
	foreign at: #Griffle put: value.
	env from: foreign import: #Griffle.
	self assert: (env bindingOf: #Griffle) value == value! !

!EnvironmentTest methodsFor: 'import tests' stamp: 'cwp 3/31/2014 21:25'!
testImportRemovingPrefix
	"Import all names, removing a prefix."

	| foreign |
	foreign := Environment withName: #Foreign.
	foreign exportSelf.
	foreign at: #XXGriffle put: value.
	env import: foreign removingPrefix: 'XX'.
	self assert: (env bindingOf: #Griffle) value == value! !

!EnvironmentTest methodsFor: 'import tests' stamp: 'cwp 3/31/2014 21:28'!
testImportRemovingPrefixResolvesUndeclared
	"Import all names, removing a prefix, with undeclared"

	| binding foreign |
	foreign := Environment withName: #Foreign.
	foreign exportSelf.
	foreign at: #XXGriffle put: value.
	binding := env undeclare: #Griffle.
	env import: foreign removingPrefix: 'XX'.
	self assert: (env bindingOf: #Griffle) == binding.
	self assert: (env valueOf: #Griffle) == value! !

!EnvironmentTest methodsFor: 'import tests' stamp: 'cwp 3/31/2014 21:29'!
testImportResolvesUndeclared
	"Import all bindings, with undeclared"

	| binding foreign |
	foreign := Environment withName: #Foreign.
	foreign exportSelf.
	foreign at: #Griffle put: value.
	binding := env undeclare: #Griffle.
	env import: foreign.
	self assert: (env bindingOf: #Griffle) == binding.
	self assert: (env valueOf: #Griffle) == value! !

!EnvironmentTest methodsFor: 'import tests' stamp: 'cwp 3/31/2014 21:30'!
testImportWritable
	"Imported globals, even if renamed, should be writable."

	| foreign binding |
	foreign := Environment withName: #Foreign.
	foreign exportSelf.
	foreign bind: #Griffle to: 'v1'.
	env from: foreign import: #Griffle -> #Plonk.
	binding := env bindingOf: #Plonk.
	binding value: 'v2'.
	self assert: (foreign declarationOf: #Griffle) value = 'v2' ! !

!EnvironmentTest methodsFor: 'compiling tests' stamp: 'cwp 3/31/2014 19:41'!
testInternalVisibility
	"A method on a class in an environment
	can refer to other classes in that environment
	(provided the environment imports its self)"
	
	| griffle plonk |
	env importSelf.
	self createClass: #Griffle.
	self createClass: #Plonk.
	griffle := env at: #Griffle.
	griffle compile: 'plonk ^ Plonk'.
	plonk := griffle new plonk.
	self assert: (env at: #Plonk) == plonk! !

!EnvironmentTest methodsFor: 'compatibility tests' stamp: 'topa 1/20/2015 09:28'!
testKeysAndValuesDo
	"For compatibility with legacy code, environments 
	should implement the dictionary protocol."

	env at: #Griffle put: value.
	env at: #Plonk put: value.
	env at: #Nurp put: value.
	env keysAndValuesDo: [:key :val |
		(#(Smalltalk Undeclared) includes: key)
			ifFalse: ["We're not interested in these default bindings"
				self assert: (#(Griffle Plonk Nurp) includes: key).
				self assert: value equals: val]].! !

!EnvironmentTest methodsFor: 'export tests' stamp: 'cwp 3/31/2014 20:45'!
testMultiExplicitExport
	"Export a list of names"

	| v2 |
	env export: #(#Griffle #Plonk).
	env at: #Griffle put: value.
	env at: #Plonk put: (v2 := Object new).
	self assertExports: #Griffle value: value.
	self assertExports: #Plonk value: v2! !

!EnvironmentTest methodsFor: 'export tests' stamp: 'cwp 3/31/2014 20:46'!
testMultiExportPublicizesExistingValue
	"Export a list of names, with existing binaries."
	
	| v2 |
	env at: #Griffle put: value.
	env at: #Plonk put: (v2 := Object new).
	env export: #(Griffle Plonk).
	self assertExports: #Griffle value: value.
	self assertExports: #Plonk value: v2.! !

!EnvironmentTest methodsFor: 'binding tests' stamp: 'cwp 3/29/2014 21:58'!
testReadOnlyBindings
	"It's almost always a bug to overwrite a class, so 
	all class bindings should be read-only by default."
	
	| binding class |
	class := Behavior new.
	env importSelf.
	env bind: #Griffle to: class.
	binding := env bindingOf: #Griffle.
	self
		should: [binding value: nil]
		raise: AttemptToWriteReadOnlyGlobal! !

!EnvironmentTest methodsFor: 'compatibility tests' stamp: 'cwp 3/31/2014 19:36'!
testRemoveKey
	"For compatibility with legacy code, environments 
	should implement the dictionary protocol."

	self 
		should: [env removeKey: #Griffle] 
		raise: KeyNotFound.! !

!EnvironmentTest methodsFor: 'compatibility tests' stamp: 'cwp 3/31/2014 19:36'!
testRemoveKeyIfAbsent
	"For compatibility with legacy code, environments 
	should implement the dictionary protocol."

	| result |
	result := env removeKey: #Griffle ifAbsent: [#removed].
	self assert: #removed equals: result.
	
	env at: #Griffle put: value.
	result := env removeKey: #Griffle ifAbsent: [#removed].
	self assert: value equals: result.! !

!EnvironmentTest methodsFor: 'class tests' stamp: 'topa 1/21/2015 10:30'!
testRenameContinuity
	"When we rename a class, literal references to it 
	from method bytecode should still work even though
	they are now undeclared."

	| class |
	env importSelf.
	class := self createClass: #Griffle.
	class compileSilently: 'foo ^ Griffle new' classified: ''.
	self shouldnt: [class new foo] raise: Error.
	self assert: class equals: class new foo class description: '<failsafe>'.

	class rename: #Plonk.
	self shouldnt: [class new foo] raise: Error.
	self
		assert: class
		equals: class new foo class
		description: 'The value of the binding should still be intact after a class rename'.
	! !

!EnvironmentTest methodsFor: 'class tests' stamp: 'topa 1/21/2015 10:19'!
testRenameCreatesNewBinding
	"When we rename a class, a completely new 
	binding should be created for the new name.
	The old binding is moved to undeclared."

	| class newBinding oldBinding |
	env importSelf.
	class := self createClass: #Griffle.
	oldBinding := env bindingOf: #Griffle.
	class rename: #Plonk.
	newBinding := env bindingOf: #Plonk.
	self deny: newBinding == oldBinding.
	
	self assert: class identical: oldBinding value.
	self assert: #Griffle equals: oldBinding key.
	
	self assert: #Plonk equals: newBinding key.
	self assert: class identical: newBinding value.
	! !

!EnvironmentTest methodsFor: 'export tests' stamp: 'cwp 3/31/2014 20:47'!
testRequireExplicitExports
	"Names that haven't been exported
	aren't visible, even if a binding exists."

	env bind: #Griffle to: Object new.
	self denyExports: #Griffle.! !

!EnvironmentTest methodsFor: 'compiling tests' stamp: 'nice 10/24/2016 17:14'!
testStoreDomesticValue
	"Create a class that implements #doStore.
	(see the comment in #storeValueMethod.)
	Send the message, then examine the results.
	The two values should be identical."

	| griffle values |
	env importSelf.
	env from: Smalltalk globals import: #Object.
	self createClass: #Griffle.
	env bind: #Plonk to: value.
		
	griffle := env at: #Griffle.
	griffle compile: self storeValueMethod.
	values := griffle new doStore.
	
	self assert: values isArray.
	self assert: values size = 2.
	self assert: values first == values last.
	self assert: (env valueOf: #Plonk) == values first! !

!EnvironmentTest methodsFor: 'compiling tests' stamp: 'nice 10/24/2016 17:15'!
testStoreImportedValue
	"Create a class that implements #doStore.
	Import #Plonk from another environment.
	(see the comment in #storeValueMethod.)
	Send the message, then examine the results.
	The two values should be identical."

	| griffle foreign values |
	self createClass: #Griffle.
	foreign := Environment withName: #Foreign.
	foreign exportSelf.
	foreign at: #Plonk put: 'v1'.
	env from: foreign import: #Plonk.
	env from: Smalltalk globals import: #Object.
	
	griffle := env at: #Griffle.
	griffle compile: self storeValueMethod.
	values := griffle new doStore.
	
	self assert: values isArray.
	self assert: values size = 2.
	self assert: values first == values last.
	self assert: (foreign at: #Plonk) == values first! !

!EnvironmentTest methodsFor: 'binding tests' stamp: 'cwp 3/29/2014 22:07'!
testUndeclare
	"When a symbol is undeclared, it's not visible to methods compiled
	in the environment, so #bindingOf: should answer nil. However, 
	methods that refer to the symbol anyway use a canonical binding.
	That binding should have a nil value and be an instance of Global, 
	rather than a class binding or alias."

	| one two |
	one := env undeclare: #Griffle.
	two := env bindingOf: #Griffle.
	self assert: nil equals: two description: '#bindingOf:'.
	self assert: Global equals: one class description: 'Type of binding'.
	self assert: nil equals: one value description: 'Value of binding'.! !

!EnvironmentTest methodsFor: 'binding tests' stamp: 'cwp 3/29/2014 22:07'!
testUndeclareAgain
	"Multiple 'undeclarations' of the same variable name should
	use the same canonical binding."
	
	| one two |
	one := env undeclare: #Griffle.
	two := env undeclare: #Griffle.
	self assert: one == two.! !

!EnvironmentTest methodsFor: 'binding tests' stamp: 'cwp 3/29/2014 22:15'!
testUndeclareFromConflict
	"When a shared variable is removed from a class pool,
	it gets undeclared in the environment. If that variable
	name is *already* undeclared in the environment, the
	binding in the environment is maintained, and references
	to the pool binding become references to the environment's
	binding. The binding should be a Global."

	| one pool three two |
	pool := IdentityDictionary new.
	pool at: #Griffle put: value.
	one := pool bindingOf: #Griffle.
	two := env undeclare: #Griffle.
	three := env undeclare: #Griffle from: pool.
	self assert: three == two description: 'Existing binding is reused'.
	self assert: three == one description: 'Pool binding is forwarded'.
	self assert: Global equals: three class description: 'Type of binding'.
	! !

!EnvironmentTest methodsFor: 'binding tests' stamp: 'cwp 3/29/2014 22:18'!
testUndeclareFromEmpty
	"When a binding is moved from a pool to an environment, but
	actually doesn't exist in the pool in the first place, a new binding
	with a nil value is created for the environment's undeclared dictionary."

	| binding |
	binding := env undeclare: #Griffle from: IdentityDictionary new.
	self assert: Global equals: binding class description: 'Type of binding'.
	self assert: nil equals: binding value description: 'Value of binding'.! !

!EnvironmentTest methodsFor: 'binding tests' stamp: 'cwp 3/29/2014 22:19'!
testUndeclareFromRemovesOld
	"When a binding is removed from a pool,
	and undeclared in the enviornment, it should
	actually be removed from the pool dictionary."
	
	| pool |
	pool := IdentityDictionary new.
	pool at: #Griffle put: value.
	env undeclare: #Griffle from: pool.
	self 
		assert: false 
		equals: (pool includesKey: #Griffle) 
		description: 'Existing binding is removed'.
	! !

!EnvironmentTest methodsFor: 'compatibility tests' stamp: 'cwp 3/31/2014 19:38'!
testUndeclaredBecomeClassBinding
	"When a undeclared name is bound to a
	class existing bindings are transformed
	into ClassBindings."

	| binding class |
	class := Behavior new.
	binding := env undeclare: #Griffle.
	env at: #Griffle put: class.
	self assert: (binding class == ClassBinding).
	self assert: binding value == class.! !

!EnvironmentTest methodsFor: 'compatibility tests' stamp: 'cwp 3/31/2014 19:39'!
testUndeclaredBecomesGlobal
	"If a class binding is somehow undeclared, 
	it becomes a Global when a non-behavior
	value is bound to the name."

	| binding class |
	class := Behavior new.
	binding := env undeclared
		add: (#Griffle => class);
		associationAt: #Griffle.
	env bind: #Griffle to: value.
	self assert: (binding class == Global).
	self assert: binding value == value.! !

!EnvironmentTest methodsFor: 'binding tests' stamp: 'cwp 3/29/2014 22:30'!
testUndeclaredBindingMoved
	"If a binding is undeclared, and subsequently
	declared, the existing binding is re-used for 
	the declaration."
	
	| binding |
	binding := env undeclare: #Griffle.
	env bind: #Griffle to: value.
	self assert: (env declarationOf: #Griffle) = binding.! !

!EnvironmentTest methodsFor: 'compatibility tests' stamp: 'topa 1/20/2015 09:27'!
testValuesDo
	"For compatibility with legacy code, environments 
	should implement the dictionary protocol."

	| count |
	env at: #Griffle put: value.
	env at: #Plonk put: value.
	env at: #Nurp put: value.
	count := 0.	
	env valuesDo: [:val | count := count + 1].
	self assert: 3 + 2 equals: count description: '#valuesDo: should see all declared vallues plus the ones from Smalltalk and Undeclares'
! !

!EnvironmentTest methodsFor: 'compatibility tests' stamp: 'cwp 3/29/2014 22:35'!
testWriteAndLookup
	"For compatibility with SystemDictionary, #at:put:
	should create a binding which can subsequently
	be found with #associationAt:."
	
	| binding |
	env at: #Griffle put: value.
	binding := env associationAt: #Griffle.
	self assert: binding key == #Griffle.
	self assert: binding value == value.
	! !

!EnvironmentTest methodsFor: 'compatibility tests' stamp: 'cwp 3/29/2014 22:36'!
testWriteAndRead
	"For compatibility with SystemDictionary,
	a value set with #at:put: should be retrievable
	with #at:"

	env at: #Griffle put: value.
	self assert: (env at: #Griffle) == value.! !

TestCase subclass: #ExceptionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Exceptions'!

!ExceptionTests methodsFor: 'private' stamp: 'md 3/25/2003 23:40'!
assertSuccess: anExceptionTester
	self should: [ ( anExceptionTester suiteLog first) endsWith:  'succeeded'].! !

!ExceptionTests methodsFor: 'testing-outer' stamp: 'pre 5/19/2016 17:55'!
expectedFailures
	"This test is a feature request. For more information on this issue visit:
	http://forum.world.st/The-Inbox-Tests-TestRunner-156-mcz-tc4643910.html#a4643987
	http://forum.world.st/ExceptionTests-Wrong-error-handler-tc4848699.html
	http://forum.world.st/ExceptionTests-gt-testHandlerFromAction-fails-tc4872828.html#a4872958"
	
	^ #(testHandlerFromAction).! !

!ExceptionTests methodsFor: 'testing-ExceptionTester' stamp: 'dtl 6/1/2004 21:54'!
testDoubleOuterPass
	self assertSuccess: (ExceptionTester new runTest: #doubleOuterPassTest ) ! !

!ExceptionTests methodsFor: 'testing-ExceptionTester' stamp: 'dtl 6/1/2004 21:54'!
testDoublePassOuter
	self assertSuccess: (ExceptionTester new runTest: #doublePassOuterTest ) ! !

!ExceptionTests methodsFor: 'testing-ExceptionTester' stamp: 'md 3/25/2003 23:43'!
testDoubleResume
	self assertSuccess: (ExceptionTester new runTest: #doubleResumeTest ) ! !

!ExceptionTests methodsFor: 'testing-outer' stamp: 'fbs 1/15/2013 16:10'!
testHandlerFromAction
	"A test ensuring that nested exceptions work as expected."

	| result |
	result := [
		[
			[self error: 'trigger error'] on: ZeroDivide do: [ :ex | 'inner' ]
		] on: Error do: [ :ex | 3 / 0 ]
	] on: ZeroDivide do: [ :ex | 'outer' ].
	self assert: 'outer' equals: result description: 'Incorrect handler'.
! !

!ExceptionTests methodsFor: 'testing' stamp: 'ar 9/1/2010 22:43'!
testHandlerReentrancy

	| callingOrder |
	"Handlers are not re-entrant by default, so inner is not activated twice"
	callingOrder := String streamContents: [:stream |
		[[stream nextPut: $s. Notification signal]
		
			"Inner handler"
			on: Notification do: [:ex |
				stream nextPut: $i.
				ex pass]]
		
			"outer handler"
			on: Notification do: [:ex |
				stream nextPut: $o.
				Notification signal]].
		
	self assert: callingOrder = 'sio'.

	"Now make inner re-entrant"
	callingOrder := String streamContents: [:stream |
		[[stream nextPut: $s. Notification signal]
		
			"Inner handler"
			on: Notification do: [:ex |
				stream nextPut: $i.
				ex rearmHandlerDuring: [ex pass]]]
		
			"outer handler"
			on: Notification do: [:ex |
				stream nextPut: $o.
				Notification signal]].
		
	self assert: callingOrder = 'sioi'.! !

!ExceptionTests methodsFor: 'testing' stamp: 'brp 10/21/2004 16:42'!
testNoTimeout
	self assertSuccess: (ExceptionTester new runTest: #simpleNoTimeoutTest ) ! !

!ExceptionTests methodsFor: 'testing-ExceptionTester' stamp: 'md 3/25/2003 23:44'!
testNonResumableFallOffTheEndHandler
	self assertSuccess: (ExceptionTester new runTest: #nonResumableFallOffTheEndHandler ) ! !

!ExceptionTests methodsFor: 'testing-outer' stamp: 'dtl 6/1/2004 21:59'!
testNonResumableOuter

	self should: [
		[Error signal. 4] 
			on: Error 
			do: [:ex | ex outer. ex return: 5]
		] raise: Error
! !

!ExceptionTests methodsFor: 'testing-outer' stamp: 'dtl 6/1/2004 22:00'!
testNonResumablePass

	self should: [
		[Error signal. 4] 
			on: Error 
			do: [:ex | ex pass. ex return: 5]
		] raise: Error
! !

!ExceptionTests methodsFor: 'testing-outer' stamp: 'eem 8/16/2012 20:38'!
testOuter
	| result |
	result := [[Notification signal. #signal]
					on: Notification
					do: [:ex| ex outer. #inner]]
				on: Notification
				do: [:ex| #outer].
	self assert: result = #outer! !

!ExceptionTests methodsFor: 'testing-ExceptionTester' stamp: 'md 3/25/2003 23:44'!
testResumableFallOffTheEndHandler
	self assertSuccess: (ExceptionTester new runTest: #resumableFallOffTheEndHandler ) ! !

!ExceptionTests methodsFor: 'testing-outer' stamp: 'ul 11/15/2010 11:39'!
testResumableOuter

	| result |
	result := [Notification signal. 4] 
		on: Notification 
		do: [:ex | ex outer. ex return: 5].
	self assert: result = 5
! !

!ExceptionTests methodsFor: 'testing-outer' stamp: 'ul 11/15/2010 11:39'!
testResumablePass

	| result |
	result := [Notification signal. 4] 
		on: Notification 
		do: [:ex | ex pass. ex return: 5].
	self assert: result = 4
! !

!ExceptionTests methodsFor: 'testing-ExceptionTester' stamp: 'md 3/25/2003 23:44'!
testSignalFromHandlerActionTest
	self assertSuccess: (ExceptionTester new runTest: #signalFromHandlerActionTest ) ! !

!ExceptionTests methodsFor: 'testing-ExceptionTester' stamp: 'md 3/25/2003 23:48'!
testSimpleEnsure
	self assertSuccess: (ExceptionTester new runTest: #simpleEnsureTest ) ! !

!ExceptionTests methodsFor: 'testing-ExceptionTester' stamp: 'md 3/25/2003 23:45'!
testSimpleEnsureTestWithError
	self assertSuccess: (ExceptionTester new runTest: #simpleEnsureTestWithError ) ! !

!ExceptionTests methodsFor: 'testing-ExceptionTester' stamp: 'md 3/25/2003 23:46'!
testSimpleEnsureTestWithNotification
	self assertSuccess: (ExceptionTester new runTest: #simpleEnsureTestWithNotification ) ! !

!ExceptionTests methodsFor: 'testing-ExceptionTester' stamp: 'md 3/25/2003 23:45'!
testSimpleEnsureTestWithUparrow
	self assertSuccess: (ExceptionTester new runTest: #simpleEnsureTestWithUparrow ) ! !

!ExceptionTests methodsFor: 'testing-ExceptionTester' stamp: 'md 3/25/2003 23:46'!
testSimpleIsNested
	self assertSuccess: (ExceptionTester new runTest: #simpleIsNestedTest ) ! !

!ExceptionTests methodsFor: 'testing-ExceptionTester' stamp: 'md 3/25/2003 23:41'!
testSimpleOuter
	self assertSuccess: (ExceptionTester new runTest: #simpleOuterTest ) ! !

!ExceptionTests methodsFor: 'testing-ExceptionTester' stamp: 'md 3/25/2003 23:42'!
testSimplePass
	self assertSuccess: (ExceptionTester new runTest: #simplePassTest ) ! !

!ExceptionTests methodsFor: 'testing-ExceptionTester' stamp: 'md 3/25/2003 23:43'!
testSimpleResignalAs
	self assertSuccess: (ExceptionTester new runTest: #simpleResignalAsTest ) ! !

!ExceptionTests methodsFor: 'testing-ExceptionTester' stamp: 'md 3/25/2003 23:48'!
testSimpleResume
	self assertSuccess: (ExceptionTester new runTest: #simpleResumeTest ) ! !

!ExceptionTests methodsFor: 'testing-ExceptionTester' stamp: 'md 3/25/2003 23:48'!
testSimpleRetry
	self assertSuccess: (ExceptionTester new runTest: #simpleRetryTest ) ! !

!ExceptionTests methodsFor: 'testing-ExceptionTester' stamp: 'md 3/25/2003 23:47'!
testSimpleRetryUsing
	self assertSuccess: (ExceptionTester new runTest: #simpleRetryUsingTest ) ! !

!ExceptionTests methodsFor: 'testing-ExceptionTester' stamp: 'md 3/25/2003 23:48'!
testSimpleReturn
	self assertSuccess: (ExceptionTester new runTest: #simpleReturnTest ) ! !

!ExceptionTests methodsFor: 'testing' stamp: 'brp 10/21/2004 16:41'!
testTimeoutWithZeroDuration
	self assertSuccess: (ExceptionTester new runTest: #simpleTimeoutWithZeroDurationTest ) ! !

TestCase subclass: #ExpandedSourceFileArrayTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Files'!

!ExpandedSourceFileArrayTest commentStamp: 'dtl 12/22/2009 23:10' prior: 0!
This test documents the source pointer address conversion methods for ExpandedSourceFileArray.

The available address space for source pointers in a traditional CompiledMethod is 16r1000000 through 16r4FFFFFF. StandardSourceFileArray maps positions in the sources file to address range 16r1000000 through 16r1FFFFFF and 16r3000000 through 16r3FFFFFF, and positions in the changes file to address range 16r2000000 through 16r2FFFFFF and 16r4000000 through 16r4FFFFFF. This permits a maximum file size of 16r2000000 (32MB) for both the sources file and the changes file. 

ExpandedSourceFileArray extends the source pointer address space using bit 25 of the source pointer to identify the external sources and changes files, with the remaining high order bits treated as address extension. This limits the number of external file references to two (the traditional sources and changes files). If additional external file references are needed in the future, some higher order bits in the source pointer address space should be allocated for that purpose.

The use of bit 25 of the source pointer for file references permits backward compatibility with StandardSourceFileArray, with essentially unlimited address space expansion for the sources and changes files.
!

!ExpandedSourceFileArrayTest methodsFor: 'testing' stamp: 'nice 1/16/2010 20:55'!
testAddressRange
	"Test source pointer to file position address translation across a wide address range"
	
	| sf i p a |
	sf := ExpandedSourceFileArray new.
	16r1000000 to: 16r10000000 by: 4093 do: [:e |
		i := sf fileIndexFromSourcePointer: e.
		p := sf filePositionFromSourcePointer: e.
		a := sf sourcePointerFromFileIndex: i andPosition: p.
		self assert: a = e]
! !

!ExpandedSourceFileArrayTest methodsFor: 'testing' stamp: 'ul 11/15/2010 11:39'!
testChangesFileAddressRange
	"Test file position to source pointer address translation for the changes file"
	
	| sf i p a a2 |
	sf := ExpandedSourceFileArray new.
	0 to: 16r1FFFFFFF by: 4093 do: [:e |
		a := sf sourcePointerFromFileIndex: 2 andPosition: e.
		i := sf fileIndexFromSourcePointer: a.
		self assert: i = 2.
		p := sf filePositionFromSourcePointer: a.
		self assert: p = e.
		a2 := sf sourcePointerFromFileIndex: 2 andPosition: p.
		self assert: a2 = a].
	0 to: 16rFFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 2 andPosition: e.
		self assert: (a between: 16r2000000 and: 16r2FFFFFF)].
	16r1000000 to: 16r1FFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 2 andPosition: e.
		self assert: (a between: 16r4000000 and: 16r4FFFFFF)].
	16r2000000 to: 16r2FFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 2 andPosition: e.
		self assert: (a between: 16r6000000 and: 16r6FFFFFF)].
	16r3000000 to: 16r3FFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 2 andPosition: e.
		self assert: (a between: 16r8000000 and: 16r8FFFFFF)].
	16r4000000 to: 16r4FFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 2 andPosition: e.
		self assert: (a between: 16rA000000 and: 16rAFFFFFF)].
	16r5000000 to: 16r5FFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 2 andPosition: e.
		self assert: (a between: 16rC000000 and: 16rCFFFFFF)].
	16r6000000 to: 16r6FFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 2 andPosition: e.
		self assert: (a between: 16rE000000 and: 16rEFFFFFF)].
	16r7000000 to: 16r7FFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 2 andPosition: e.
		self assert: (a between: 16r10000000 and: 16r10FFFFFF)]



! !

!ExpandedSourceFileArrayTest methodsFor: 'testing' stamp: 'nice 1/16/2010 20:56'!
testCompatibilityWithStandardSourceFileArray
	"Test compatibility with StandardSourceFileArray across the address range of
	StandardSourceFileArray, including the unused address space below 16r1000000"
	
	| ssf esf i1 i2 p1 p2 a1 a2 |
	ssf := StandardSourceFileArray new.
	esf := ExpandedSourceFileArray new.
	0 to: 16rFFFFFF by: 811 do: [:e |
		i1 := ssf fileIndexFromSourcePointer: e.
		i2 := esf fileIndexFromSourcePointer: e.
		self assert: i1 = i2.
		self assert: i1 = 0. "This is unused address space"
		p1 := ssf filePositionFromSourcePointer: e.
		p2 := esf filePositionFromSourcePointer: e.
		self assert: p1 = p2].
	16r4FFFFFF to: 16r4FFFFFF by: 811 do: [:e |
		i1 := ssf fileIndexFromSourcePointer: e.
		i2 := esf fileIndexFromSourcePointer: e.
		self assert: i1 = i2.
		p1 := ssf filePositionFromSourcePointer: e.
		p2 := esf filePositionFromSourcePointer: e.
		self assert: p1 = p2.
		a1 := ssf sourcePointerFromFileIndex: i1 andPosition: p1.
		a2 := esf sourcePointerFromFileIndex: i2 andPosition: p2.
		self assert: a1 = a2.
		self assert: a1= e]

! !

!ExpandedSourceFileArrayTest methodsFor: 'testing' stamp: 'dtl 12/26/2009 14:56'!
testFileIndexFromSourcePointer
	"Test derivation of file index for sources or changes file from source pointers"

	| sf |
	sf := ExpandedSourceFileArray new.
	"sources file mapping"
	self assert: 1 = (sf fileIndexFromSourcePointer: 16r1000000).
	self assert: 1 = (sf fileIndexFromSourcePointer: 16r1000013).
	self assert: 1 = (sf fileIndexFromSourcePointer: 16r1FFFFFF).
	self assert: 1 = (sf fileIndexFromSourcePointer: 16r3000000).
	self assert: 1 = (sf fileIndexFromSourcePointer: 16r3000013).
	self assert: 1 = (sf fileIndexFromSourcePointer: 16r3FFFFFF).

	self assert: 1 = (sf fileIndexFromSourcePointer: 16r5000000).
	self assert: 1 = (sf fileIndexFromSourcePointer: 16r5000013).
	self assert: 1 = (sf fileIndexFromSourcePointer: 16r5FFFFFF).

	(16r1000000 to: 16r1FFFFFF by: 811) do: [:e | self assert: 1 = (sf fileIndexFromSourcePointer: e)].
	(16r3000000 to: 16r3FFFFFF by: 811) do: [:e | self assert: 1 = (sf fileIndexFromSourcePointer: e)].
	"changes file mapping"
	self assert: 2 = (sf fileIndexFromSourcePointer: 16r2000000).
	self assert: 2 = (sf fileIndexFromSourcePointer: 16r2000013).
	self assert: 2 = (sf fileIndexFromSourcePointer: 16r2FFFFFF).
	self assert: 2 = (sf fileIndexFromSourcePointer: 16r4000000).
	self assert: 2 = (sf fileIndexFromSourcePointer: 16r4000013).
	self assert: 2 = (sf fileIndexFromSourcePointer: 16r4FFFFFF).

	self assert: 2 = (sf fileIndexFromSourcePointer: 16r6000000).
	self assert: 2 = (sf fileIndexFromSourcePointer: 16r6000013).
	self assert: 2 = (sf fileIndexFromSourcePointer: 16r6FFFFFF).

	(16r2000000 to: 16r2FFFFFF by: 811) do: [:e | self assert: 2 = (sf fileIndexFromSourcePointer: e)].
	(16r4000000 to: 16r4FFFFFF by: 811) do: [:e | self assert: 2 = (sf fileIndexFromSourcePointer: e)].

	"the following numeric ranges are unused but currently produces results as follows"
	self assert: 0 = (sf fileIndexFromSourcePointer: 16r0000000).
	self assert: 0 = (sf fileIndexFromSourcePointer: 16r0000013).
	self assert: 0 = (sf fileIndexFromSourcePointer: 16r0FFFFFF)

! !

!ExpandedSourceFileArrayTest methodsFor: 'testing' stamp: 'dtl 12/26/2009 14:56'!
testFilePositionFromSourcePointer
	"Test derivation of file position for sources or changes file from source pointers"

	| sf |
	sf := ExpandedSourceFileArray new.
	"sources file"
	self assert: 0 = (sf filePositionFromSourcePointer: 16r1000000).
	self assert: 16r13 = (sf filePositionFromSourcePointer: 16r1000013).
	self assert: 16rFFFFFF = (sf filePositionFromSourcePointer: 16r1FFFFFF).
	self assert: 16r1000000 = (sf filePositionFromSourcePointer: 16r3000000).
	self assert: 16r1000013 = (sf filePositionFromSourcePointer: 16r3000013).
	self assert: 16r1FFFFFF = (sf filePositionFromSourcePointer: 16r3FFFFFF).
	"changes file"
	self assert: 0 = (sf filePositionFromSourcePointer: 16r2000000).
	self assert: 16r13 = (sf filePositionFromSourcePointer: 16r2000013).
	self assert: 16rFFFFFF = (sf filePositionFromSourcePointer: 16r2FFFFFF).
	self assert: 16r1000000 = (sf filePositionFromSourcePointer: 16r4000000).
	self assert: 16r1000013 = (sf filePositionFromSourcePointer: 16r4000013).
	self assert: 16r1FFFFFF = (sf filePositionFromSourcePointer: 16r4FFFFFF).
	"the following numeric ranges are unused but currently produces results as follows"
	self assert: 0 = (sf filePositionFromSourcePointer: 16r0000000).
	self assert: 16r13 = (sf filePositionFromSourcePointer: 16r0000013).
	self assert: 16rFFFFFF = (sf filePositionFromSourcePointer: 16r0FFFFFF)
! !

!ExpandedSourceFileArrayTest methodsFor: 'testing' stamp: 'fbs 11/5/2013 22:55'!
testSourcePointerFromFileIndexAndPosition
	"Test valid input ranges"

	| sf |
	sf := ExpandedSourceFileArray new.
	
	self should: [sf sourcePointerFromFileIndex: 0 andPosition: 0] raise: Error.
	self should: [sf sourcePointerFromFileIndex: 0 andPosition: 3] raise: Error.
	self should: [sf sourcePointerFromFileIndex: 1 andPosition: -1] raise: Error.
	self should: [sf sourcePointerFromFileIndex: 3 andPosition: 0] raise: Error.
	self should: [sf sourcePointerFromFileIndex: 4 andPosition: 0] raise: Error.

	self assert: 16r1000000 equals: (sf sourcePointerFromFileIndex: 1 andPosition: 0).
	self assert: 16r1000013 equals: (sf sourcePointerFromFileIndex: 1 andPosition: 16r13).
	self assert: 16r1FFFFFF equals: (sf sourcePointerFromFileIndex: 1 andPosition: 16rFFFFFF).
	self assert: 16r2000000 equals: (sf sourcePointerFromFileIndex: 2 andPosition: 0).
	self assert: 16r2000013 equals: (sf sourcePointerFromFileIndex: 2 andPosition: 16r13).
	self assert: 16r2FFFFFF equals: (sf sourcePointerFromFileIndex: 2 andPosition: 16rFFFFFF).
	self assert: 16r3000000 equals: (sf sourcePointerFromFileIndex: 1 andPosition: 16r1000000).
	self assert: 16r3000013 equals: (sf sourcePointerFromFileIndex: 1 andPosition: 16r1000013).
	self assert: 16r3FFFFFF equals: (sf sourcePointerFromFileIndex: 1 andPosition: 16r1FFFFFF).
	self assert: 16r4000000 equals: (sf sourcePointerFromFileIndex: 2 andPosition: 16r1000000).
	self assert: 16r4000013 equals: (sf sourcePointerFromFileIndex: 2 andPosition: 16r1000013).
	self assert: 16r4FFFFFF equals: (sf sourcePointerFromFileIndex: 2 andPosition: 16r1FFFFFF).
	self assert: 16r5000000 equals: (sf sourcePointerFromFileIndex: 1 andPosition: 16r2000000).! !

!ExpandedSourceFileArrayTest methodsFor: 'testing' stamp: 'ul 11/15/2010 11:39'!
testSourcesFileAddressRange
	"Test file position to source pointer address translation for the sources file"
	
	| sf i p a a2 |
	sf := ExpandedSourceFileArray new.
	0 to: 16r1FFFFFFF by: 4093 do: [:e |
		a := sf sourcePointerFromFileIndex: 1 andPosition: e.
		i := sf fileIndexFromSourcePointer: a.
		self assert: i = 1.
		p := sf filePositionFromSourcePointer: a.
		self assert: p = e.
		a2 := sf sourcePointerFromFileIndex: 1 andPosition: p.
		self assert: a2 = a].
	0 to: 16rFFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 1 andPosition: e.
		self assert: (a between: 16r1000000 and: 16r1FFFFFF)].
	16r1000000 to: 16r1FFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 1 andPosition: e.
		self assert: (a between: 16r3000000 and: 16r3FFFFFF)].

	16r2000000 to: 16r2FFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 1 andPosition: e.
		self assert: (a between: 16r5000000 and: 16r5FFFFFF)].
	16r3000000 to: 16r3FFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 1 andPosition: e.
		self assert: (a between: 16r7000000 and: 16r7FFFFFF)].
	16r4000000 to: 16r4FFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 1 andPosition: e.
		self assert: (a between: 16r9000000 and: 16r9FFFFFF)].
	16r5000000 to: 16r5FFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 1 andPosition: e.
		self assert: (a between: 16rB000000 and: 16rBFFFFFF)].
	16r6000000 to: 16r6FFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 1 andPosition: e.
		self assert: (a between: 16rD000000 and: 16rDFFFFFF)].
	16r7000000 to: 16r7FFFFFF by: 811 do: [:e |
		a := sf sourcePointerFromFileIndex: 1 andPosition: e.
		self assert: (a between: 16rF000000 and: 16rFFFFFFF)]
! !

TestCase subclass: #GlobalTest
	instanceVariableNames: 'key value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Environments'!

!GlobalTest methodsFor: 'running' stamp: 'cwp 3/9/2013 18:21'!
setUp
	key := Object new.
	value := Object new.
	! !

!GlobalTest methodsFor: 'tests' stamp: 'cwp 4/1/2013 21:59'!
testArrowBinding
	| binding |
	binding := #Griffle => value.
	self assert: binding class = Global.
	self assert: binding key = #Griffle.
	self assert: binding value == value! !

!GlobalTest methodsFor: 'tests' stamp: 'cwp 4/28/2013 12:37'!
testAsBindingOriginal
	| global imported |
	global := Global key: #Griffle value: Object new.
	imported := global asBinding: #Griffle.
	self assert: imported == global! !

!GlobalTest methodsFor: 'tests' stamp: 'cwp 4/1/2013 22:01'!
testAsBindingRead
	| global imported |
	global := Global key: key value: value.
	imported := global asBinding: #Griffle.
	self assert: imported key = #Griffle.
	self assert: imported value == value.
	! !

!GlobalTest methodsFor: 'tests' stamp: 'cwp 4/28/2013 12:37'!
testAsBindingWrite
	| global imported |
	global := Global key: key value: Object new.
	imported := global asBinding: #Griffle.
	imported value: value.
	self assert: global value == value.
! !

!GlobalTest methodsFor: 'tests' stamp: 'cwp 4/1/2013 22:02'!
testCanAssign
	| global |
	global := Global key: key value: value.
	self assert: global canAssign! !

!GlobalTest methodsFor: 'tests' stamp: 'cwp 4/1/2013 22:02'!
testIsSpecialRead
	| global |
	global := Global key: key value: value.
	self deny: global isSpecialReadBinding! !

!GlobalTest methodsFor: 'tests' stamp: 'cwp 4/1/2013 22:02'!
testIsSpecialWrite
	| global |
	global := Global key: key value: value.
	self deny: global isSpecialWriteBinding! !

!GlobalTest methodsFor: 'tests' stamp: 'cwp 4/1/2013 22:17'!
testLiteralEqual
	| global |
	global := #Griffle => value.
	self assert: (global literalEqual: global)! !

!GlobalTest methodsFor: 'tests' stamp: 'cwp 4/1/2013 22:17'!
testLiteralUnequal
	| g1 g2 |
	g1 := #Griffle => value.
	g2 := #Griffle => value.
	self deny: (g1 literalEqual: g2)! !

!GlobalTest methodsFor: 'tests' stamp: 'cwp 4/1/2013 22:02'!
testRead
	| global |
	global := Global key: key value: value.
	self assert: global key == key.
	self assert: global value == value.! !

!GlobalTest methodsFor: 'tests' stamp: 'cwp 12/29/2013 17:46'!
testSource
	| global |
	global := Global key: #Griffle value: Object new.
	self assert: global source == global! !

!GlobalTest methodsFor: 'tests' stamp: 'cwp 4/1/2013 22:02'!
testWrite
	| global |
	global := Global key: key value: Object new.
	global value: value.
	self assert: global value == value! !

TestCase subclass: #HandBugs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Bugs'!

!HandBugs methodsFor: 'as yet unclassified' stamp: 'fbs 11/5/2013 22:55'!
testTargetPoint
"self new testTargetPoint"
"self run: #testTargetPoint"

	"This should not throw an exception."
	ActiveHand targetPoint

! !

TestCase subclass: #HashAndEqualsTestCase
	instanceVariableNames: 'prototypes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Utilities'!

!HashAndEqualsTestCase commentStamp: 'mjr 8/20/2003 17:37' prior: 0!
I am a simple TestCase that tests for correct operation of #hash and #=.

Subclasses of me need to fill my prototypes with suitable objects to be tested.!

!HashAndEqualsTestCase methodsFor: 'as yet unclassified' stamp: 'mjr 8/20/2003 18:57'!
setUp
	"subclasses will add their prototypes into this collection"
	prototypes := OrderedCollection new ! !

!HashAndEqualsTestCase methodsFor: 'as yet unclassified' stamp: 'mjr 8/20/2003 18:56'!
testEquality
	"Check that TextFontChanges report equality correctly"
	prototypes
		do: [:p | self
				should: [(EqualityTester with: p) result]] ! !

!HashAndEqualsTestCase methodsFor: 'as yet unclassified' stamp: 'mjr 8/20/2003 18:56'!
testHash
	"test that TextFontChanges hash correctly"
	prototypes
		do: [:p | self
				should: [(HashTester with: p) result]] ! !

TestCase subclass: #HashTesterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Utilities'!

!HashTesterTest commentStamp: 'mjr 8/20/2003 12:48' prior: 0!
I am a simple test case to check that HashTester works correctly!

!HashTesterTest methodsFor: 'as yet unclassified' stamp: 'mjr 8/20/2003 18:56'!
testBasicBehaviour
	self
		should: [(HashTester with: 1)
				resultFor: 100].
	self
		should: [(HashTester with: 'fred')
				resultFor: 100].
	self
		shouldnt: [(HashTester with: BadHasher new)
				resultFor: 100] ! !

TestCase subclass: #HexTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Hex'!

!HexTest commentStamp: 'JPF 6/26/2007 10:15' prior: 0!
Rather than testing a single class, this set of tests looks at the interactions between Character, String, Integer and Color using hex and printStringHex!

!HexTest methodsFor: 'as yet unclassified' stamp: 'JPF 6/26/2007 10:26'!
testCharacterHex
| result |
result := $a hex.
self assert: result = '61'.
result := $A hex.
self assert: result = '41'.


! !

!HexTest methodsFor: 'as yet unclassified' stamp: 'JPF 6/26/2007 10:39'!
testColorPrintHtmlString
self assert: (Color red printHtmlString ) = ( Color red asHTMLColor allButFirst asUppercase).

! !

!HexTest methodsFor: 'as yet unclassified' stamp: 'eem 5/21/2010 11:12'!
testIntegerHex
	| result |
	result := 15 asInteger hex.
	self assert: result = '16rF'.
	result := 0 asInteger hex.
	self assert: result = '16r0'.
	result := 255 asInteger hex.
	self assert: result = '16rFF'.
	result := 90 asInteger hex.
	self assert: result = '16r5A'! !

!HexTest methodsFor: 'as yet unclassified' stamp: 'JPF 6/26/2007 10:44'!
testStringAsHex
| result |
result := 'abc' asHex.
self assert: result = '616263'.


! !

TestCase subclass: #ImageSegmentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-System-Object Storage'!

!ImageSegmentTest class methodsFor: 'testing' stamp: 'topa 10/8/2015 01:19'!
shouldInheritSelectors
	^ false! !

!ImageSegmentTest class methodsFor: 'Accessing' stamp: 'topa 8/21/2015 09:46'!
testSelectors

	Smalltalk isRunningSpur ifTrue: [
		"The ImageSegment Test is known to not work on SPUR VMs
		with the prospect of crashing. #expectedFailure does not cut it here,
		don't even try to run them"
		^ #()].
	^ super testSelectors! !

!ImageSegmentTest methodsFor: 'testing' stamp: 'eem 2/2/2015 17:23'!
testImageSegmentsShouldBeWritableToaFile
	"This should not throw an exception"
	| classes |
	classes := UIManager subclasses reject: [:sc| sc isActiveManager].
	ImageSegment new
		copyFromRoots: classes asArray sizeHint: 100;
		extract;
		writeToFile: 'InactiveUIManagers';
		yourself.
		
	"TODO: write assertions showing that something meaningful actually happened."

	"now bring them back in again"
	classes do: [:ea| ea new]! !

TestCase subclass: #InstallerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Installer-Core'!

!InstallerTest class methodsFor: 'as yet unclassified' stamp: 'cmm 8/8/2013 22:30'!
suiteClass
	^ InstallerTestSuite! !

!InstallerTest methodsFor: 'as yet unclassified' stamp: 'TestRunner 1/28/2013 19:24'!
testPackageAndVersionNameShouldSanitiseInput
	| installer |
	installer := Installer new.
	self assert: {'Foo'. ''} equals: (installer packageAndVersionFrom: 'Foo').
	self assert: {'Foo'. '1'} equals: (installer packageAndVersionFrom: 'Foo(1)').
	self assert: {'Foo'. 'head'} equals: (installer packageAndVersionFrom: ' Foo ( head ) ').! !

TestCase subclass: #InstallerUrlTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Installer-Core'!

!InstallerUrlTest methodsFor: 'as yet unclassified' stamp: 'fbs 5/3/2013 23:15'!
testAddPackageShouldResultInCorrectUrl
	| url |
	url := (Installer url: 'http://seaside.gemstone.com/ss/metacello')
	    addPackage: 'ConfigurationOfMetacello-dkh.754.mcz';
	    urlToDownload.
	"Note the insertion of a / in the URL."
	self
		assert: 'http://seaside.gemstone.com/ss/metacello/ConfigurationOfMetacello-dkh.754.mcz'
		equals: url.! !

TestCase subclass: #IslandVMTweaksTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-VM'!

!IslandVMTweaksTestCase commentStamp: 'ls 7/10/2003 18:59' prior: 0!
Test case for some tweaks to the VM that Islands requires.  These tests are largely for documentation; with an un-tweaked VM, the tests mostly still succeed, albeit with possible memory corruption.!

!IslandVMTweaksTestCase methodsFor: 'primitives' stamp: 'ls 7/10/2003 10:16'!
aaaREADMEaboutPrimitives
	"most of the Islands tweaks allow primitive methods to be located in places other than class Object.  Thus they are copied here for testing."
! !

!IslandVMTweaksTestCase methodsFor: 'primitives' stamp: 'ls 7/10/2003 10:17'!
classOf: anObject
	<primitive: 111>
! !

!IslandVMTweaksTestCase methodsFor: 'primitives' stamp: 'ls 7/10/2003 10:16'!
instVarOf: anObject at: index
	<primitive: 73>
	self primitiveFailed
! !

!IslandVMTweaksTestCase methodsFor: 'primitives' stamp: 'ls 7/10/2003 10:17'!
instVarOf: anObject at: index put: anotherObject
	<primitive: 74>
	self primitiveFailed
! !

!IslandVMTweaksTestCase methodsFor: 'primitives' stamp: 'ls 7/10/2003 10:18'!
nextInstanceAfter: anObject
	<primitive: 78>
! !

!IslandVMTweaksTestCase methodsFor: 'primitives' stamp: 'ls 7/10/2003 10:18'!
nextObjectAfter: anObject
	<primitive: 139>
! !

!IslandVMTweaksTestCase methodsFor: 'primitives' stamp: 'ls 7/10/2003 10:21'!
replaceIn: replacee  from: start  to: stop   with: replacer  startingAt: replStart
	<primitive: 105>
	self primitiveFailed! !

!IslandVMTweaksTestCase methodsFor: 'miscellaneous' stamp: 'ls 7/10/2003 17:42'!
returnTwelve
	"this method is tweaked by testFlagInCompiledMethod"
	^12! !

!IslandVMTweaksTestCase methodsFor: 'primitives' stamp: 'ls 7/10/2003 10:19'!
someInstanceOf: aClass
	<primitive: 77>
	self primitiveFailed! !

!IslandVMTweaksTestCase methodsFor: 'primitives' stamp: 'ls 7/10/2003 10:20'!
someObject
	<primitive: 138>
	self primitiveFailed! !

!IslandVMTweaksTestCase methodsFor: 'testing' stamp: 'ls 7/10/2003 11:03'!
testEmptyReplace
	| array1 array2 |
	array1 := Array with: 1 with: 2 with: 3 with: 4.
	array2 := Array with: 5 with: 6 with: 7.

	self replaceIn: array1 from: 1 to: 0 with: array2 startingAt: 1.
	self should: [ array1 = #(1 2 3 4) ].
! !

!IslandVMTweaksTestCase methodsFor: 'testing' stamp: 'ls 7/10/2003 18:53'!
testFlagInCompiledMethod
	"this tests that the flag in compiled methods is treated correctly"
	| method |
	method := self class compiledMethodAt: #returnTwelve.

	"turn off the flag"
	method objectAt: 1 put: (method header bitAnd: (1 << 29) bitInvert).
	self should: [ method flag not ].

	"turn on the flag"
	method objectAt: 1 put: (method header bitOr: (1 << 29)).
	self should: [ method flag ].

	"try running the method with the flag turned on"
	self should: [ self returnTwelve = 12 ].


	"make sure the flag bit isn't interpreted as a primitive"
	self should: [ method primitive = 0 ].! !

!IslandVMTweaksTestCase methodsFor: 'testing' stamp: 'fbs 7/14/2014 22:45'!
testForgivingPrims
	| aPoint anotherPoint array1 array2 |
	aPoint := Point x: 5 y: 6.
	anotherPoint := Point x: 7 y: 8.  "make sure there are multiple points floating around"
	anotherPoint.  "stop the compiler complaining about no uses"

	self assert: Point equals: (self classOf:  aPoint).
	self assert: 5 equals: (self instVarOf: aPoint at: 1).
	self instVarOf: aPoint at: 2 put: 10.
	self assert: 10 equals: (self instVarOf: aPoint at: 2).

	self someObject.
	self nextObjectAfter: aPoint.

	self assert: Point equals: (self someInstanceOf: Point) class.
	self assert: Point equals: (self nextInstanceAfter: aPoint) class.


	array1 := Array with: 1 with: 2 with: 3.
	array2 := Array with: 4 with: 5 with: 6.

	self replaceIn: array1 from: 2 to: 3 with: array2 startingAt: 1.
	self assert: #(1 4 5) equals: array1.! !

TestCase subclass: #LangEnvBugs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Bugs'!

!LangEnvBugs methodsFor: 'as yet unclassified' stamp: 'pre 8/16/2016 12:12'!
defaultTimeout

	^ 60! !

!LangEnvBugs methodsFor: 'as yet unclassified' stamp: 'wiz 5/19/2008 14:17'!
tearDown

Preferences restoreDefaultFonts! !

!LangEnvBugs methodsFor: 'as yet unclassified' stamp: 'fbs 11/5/2013 22:57'!
testIsFontAvailable
	"self new testIsFontAvailable"
	"self run: #testIsFontAvailable"
	| oldPref |
	oldPref := Preferences valueOfPreference: #tinyDisplay.
	Preferences restoreFontsAfter: [
		[Preferences enable: #tinyDisplay.
		"This should not throw an exception."
		(LanguageEnvironment localeID: 'en' ) isFontAvailable]
			ensure: [Preferences setPreference: #tinyDisplay toValue: oldPref]].! !

TestCase subclass: #LocaleTest
	instanceVariableNames: 'previousID previousKeyboardInterpreter previousClipboardInterpreter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Localization'!

!LocaleTest commentStamp: 'tak 8/3/2005 18:24' prior: 0!
LocaleTest buildSuite run!

!LocaleTest methodsFor: 'testing' stamp: 'pre 7/20/2016 11:26'!
expectedFailures

	^ super expectedFailures,
		((NaturalLanguageTranslator translators isEmpty 
			or: [(NaturalLanguageTranslator translators values collect: [:t | t localeID ]) 
				asSet size = 1])
			ifTrue: [#(testLocaleChanged) "no locale available to switch to"]
			ifFalse: [ #()])
! !

!LocaleTest methodsFor: 'testing' stamp: 'pre 8/16/2016 23:56'!
setUp

	previousID := Locale current localeID.
	previousKeyboardInterpreter := ActiveHand instVarNamed: 'keyboardInterpreter'.
	previousClipboardInterpreter := Clipboard default instVarNamed: 'interpreter'.
	ActiveHand clearKeyboardInterpreter.
	Clipboard default clearInterpreter.
	! !

!LocaleTest methodsFor: 'testing' stamp: 'pre 8/16/2016 23:57'!
tearDown

	ActiveHand instVarNamed: 'keyboardInterpreter' put: previousKeyboardInterpreter.
	Clipboard default instVarNamed: 'interpreter' put: previousClipboardInterpreter.
	Locale switchToID: (LocaleID isoLanguage: previousID).! !

!LocaleTest methodsFor: 'testing' stamp: 'tak 8/4/2005 11:02'!
testEncodingName
	"self debug: #testEncodingName"
	| locale |
	locale := Locale isoLanguage: 'ja'.
	self assert: locale languageEnvironment fontEncodingName = #FontJapaneseEnvironment! !

!LocaleTest methodsFor: 'testing' stamp: 'pre 7/20/2016 13:52'!
testIsFontAvailable
	"self debug: #testIsFontAvailable"
	
	<timeout: 60> "takes quite a while"
	self ensureInternetConnectionTo: 'http://metatoys.org/pub/'.
	
	Preferences restoreFontsAfter: [
		| currentDefaultTextStyle |
		currentDefaultTextStyle := TextStyle default.
		[ 
			TextStyle setDefault: (TextStyle actualTextStyles at: #Accuny).
			(Locale isoLanguage: 'ja') languageEnvironment removeFonts.
			self assert: (Locale isoLanguage: 'en') languageEnvironment isFontAvailable.
			"Next test should fail after installing Japanese font"
			self assert: (Locale isoLanguage: 'ja') languageEnvironment isFontAvailable not.
			(Locale isoLanguage: 'ja') languageEnvironment installFont.
			self assert: (Locale isoLanguage: 'ja') languageEnvironment isFontAvailable ]
				ensure: [ TextStyle setDefault: currentDefaultTextStyle.
						FileDirectory default deleteFileNamed: (Locale isoLanguage: 'ja') languageEnvironment fontFullName. ] ].! !

!LocaleTest methodsFor: 'testing' stamp: 'pre 8/16/2016 23:26'!
testLocaleChanged
	"self debug: #testLocaleChanged"
	"LanguageEnvironment >> startUp is called from Prject >> localeChanged"
	<timeout: 60> "takes quite a while"
	Project current updateLocaleDependents.
	self assert: (ActiveHand instVarNamed: 'keyboardInterpreter') isNil description: 'non-nil keyboardInterpreter'.
	self assert: (Clipboard default instVarNamed: 'interpreter') isNil description: 'non-nil interpreter'.
	Locale switchToID: (LocaleID isoLanguage: 'ja').
	self assert: 'ja' equals: Locale current localeID isoLanguage.
	Locale switchToID: (LocaleID isoLanguage: 'en').
	self assert: 'en' equals: Locale current localeID isoLanguage.! !

TestCase subclass: #MCDependencySorterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello'!

!MCDependencySorterTest methodsFor: 'asserting' stamp: 'avi 10/7/2004 22:32'!
assertItems: anArray orderAs: depOrder withRequired: missingDeps toLoad: unloadableItems
	self assertItems: anArray orderAs: depOrder withRequired: missingDeps  toLoad: unloadableItems  extraProvisions: #()! !

!MCDependencySorterTest methodsFor: 'asserting' stamp: 'avi 10/7/2004 22:47'!
assertItems: anArray orderAs: depOrder withRequired: missingDeps toLoad: unloadableItems extraProvisions: provisions
	| order sorter items missing unloadable |
	items := anArray collect: [:ea | self itemWithSpec: ea].
	sorter := MCDependencySorter items: items.
	sorter addExternalProvisions: provisions.
	order := (sorter orderedItems collect: [:ea | ea name]) asArray.
	self assert: order = depOrder.
	missing := sorter externalRequirements.
	self assert: missing asSet = missingDeps asSet.
	unloadable := (sorter itemsWithMissingRequirements collect: [:ea | ea name]) asArray.
	self assert: unloadable asSet = unloadableItems asSet! !

!MCDependencySorterTest methodsFor: 'building' stamp: 'ab 5/24/2003 14:08'!
itemWithSpec: anArray
	^ MCMockDependentItem new
		name: anArray first;
		provides: anArray second;
		requires: anArray third! !

!MCDependencySorterTest methodsFor: 'tests' stamp: 'ab 5/25/2003 01:11'!
testCascadingUnresolved
	self assertItems: #(
		(a (x) (z))
		(b () (x))
		(c () ()))
	orderAs: #(c)
	withRequired: #(z)
	toLoad: #(a b)	! !

!MCDependencySorterTest methodsFor: 'tests' stamp: 'ab 5/25/2003 01:11'!
testCycle
	self assertItems: #(
		(a (x) (y))
		(b (y) (x)))
	orderAs: #()
	withRequired: #()
	toLoad: #(a b)	! !

!MCDependencySorterTest methodsFor: 'tests' stamp: 'avi 10/7/2004 22:35'!
testExtraProvisions
	self assertItems:
		#((a (x) (z))
		(b () (x)))
	orderAs: #(a b)
	withRequired: #()
	toLoad: #()	
	extraProvisions: #(x z)! !

!MCDependencySorterTest methodsFor: 'tests' stamp: 'ab 5/25/2003 01:11'!
testMultiRequirementOrdering
	self assertItems: #(
		(a (x) (z))
		(b (y) ())
		(c (z) ())
		(d () (x y z)))
		orderAs: #(b c a d)
		withRequired: #()
		toLoad: #()! !

!MCDependencySorterTest methodsFor: 'tests' stamp: 'ab 5/25/2003 01:11'!
testSimpleOrdering
	self assertItems: #((a (x) ())
								 (c () (y))
								 (b (y) (x)))
		orderAs: #(a b c)
		withRequired: #()
		toLoad: #()! !

!MCDependencySorterTest methodsFor: 'tests' stamp: 'ab 5/25/2003 01:12'!
testSimpleUnresolved
	self assertItems: #(
		(a () (z)))
	orderAs: #()
	withRequired: #(z)
	toLoad: #(a)
		! !

!MCDependencySorterTest methodsFor: 'tests' stamp: 'avi 10/7/2004 22:12'!
testUnusedAlternateProvider
	self assertItems: #(
		(a (x) (z))
		(b () (x))
		(c (x) ()))
	orderAs: #(c b)
	withRequired: #(z)
	toLoad: #(a)	! !

TestCase subclass: #MCMcmUpdaterTest
	instanceVariableNames: ''
	classVariableNames: 'SaveRegistry'
	poolDictionaries: ''
	category: 'Tests-Monticello'!

!MCMcmUpdaterTest commentStamp: 'dtl 10/13/2015 20:45' prior: 0!
MCMcmUpdaterTest verifies registry of Monticello based updaters used for update streams, including the Squeak trunk update stream. The default update stream for the image is specified by preferences, and new updaters are created as needed. Existing updaters remain in a registry such that their individual update status is preserved.
!

!MCMcmUpdaterTest methodsFor: 'running' stamp: 'dtl 10/13/2015 19:49'!
setUp
	"Registry will be modified by tests. Safe it here and restore it in tearDown"
	SaveRegistry := MCMcmUpdater registry.
	MCMcmUpdater registry: nil! !

!MCMcmUpdaterTest methodsFor: 'running' stamp: 'dtl 10/13/2015 19:37'!
tearDown

	MCMcmUpdater registry: SaveRegistry
! !

!MCMcmUpdaterTest methodsFor: 'testing' stamp: 'dtl 10/13/2015 19:48'!
testDefault

	| defaultMapFromPreference defaultURLFromPreference defaultUpdater |
	defaultMapFromPreference := MCMcmUpdater updateMapName.
	defaultURLFromPreference := MCMcmUpdater defaultUpdateURL.
	defaultUpdater := MCMcmUpdater default. "create and register"
	self assert: defaultMapFromPreference equals: defaultUpdater updateMapName.
	self assert: defaultURLFromPreference equals: defaultUpdater repository.
	self assert: MCMcmUpdater registry size = 1.
	self assert: (MCMcmUpdater registry at: defaultURLFromPreference) size = 1
! !

!MCMcmUpdaterTest methodsFor: 'testing' stamp: 'dtl 10/13/2015 19:40'!
testRegistryIsBeingSaved
	"setUp and tearDown save and restore the current state"

	self assert: MCMcmUpdater registry isNil! !

!MCMcmUpdaterTest methodsFor: 'testing' stamp: 'dtl 10/13/2015 19:59'!
testTwoUpdatersForOneRepository

	| reg updater1 updater2 |
	reg := MCMcmUpdater registry.
	updater1 := MCMcmUpdater updateMapNamed: 'BAR' repository: 'FOO'.
	self assert: MCMcmUpdater registry size = 1.
	self assert: (MCMcmUpdater registry at: 'FOO') size = 1.
	updater2 := MCMcmUpdater updateMapNamed: 'BAZ' repository: 'FOO'.
	self assert: MCMcmUpdater registry size = 1.
	self assert: (MCMcmUpdater registry at: 'FOO') size = 2.
	updater1 unregister.
	self assert: MCMcmUpdater registry size = 1.
	self assert: (MCMcmUpdater registry at: 'FOO') size = 1.
	updater2 unregister.
	self assert: MCMcmUpdater registry isEmpty.
	self should: [MCMcmUpdater registry at: 'FOO'] raise: Error.
! !

!MCMcmUpdaterTest methodsFor: 'testing' stamp: 'dtl 10/13/2015 20:01'!
testTwoUpdatersInDifferentRepositories

	| reg updater1 updater2 |
	reg := MCMcmUpdater registry.
	updater1 := MCMcmUpdater updateMapNamed: 'BAR' repository: 'FOO'.
	self assert: MCMcmUpdater registry size = 1.
	self assert: (MCMcmUpdater registry at: 'FOO') size = 1.
	updater2 := MCMcmUpdater updateMapNamed: 'BAZ' repository: 'FOO2'.
	self assert: MCMcmUpdater registry size = 2.
	self assert: (MCMcmUpdater registry at: 'FOO') size = 1.
	self assert: (MCMcmUpdater registry at: 'FOO2') size = 1.
	updater1 unregister.
	self assert: MCMcmUpdater registry size = 1.
	self assert: (MCMcmUpdater registry at: 'FOO2') size = 1.
	updater2 unregister.
	self assert: MCMcmUpdater registry isEmpty.
	self should: [MCMcmUpdater registry at: 'FOO'] raise: Error.
	self should: [MCMcmUpdater registry at: 'FOO2'] raise: Error.
! !

!MCMcmUpdaterTest methodsFor: 'testing' stamp: 'dtl 10/13/2015 20:40'!
testUpdatePreferences

	| defaultMapFromPreference defaultURLFromPreference defaultUpdater |
	defaultMapFromPreference := MCMcmUpdater updateMapName.
	defaultURLFromPreference := MCMcmUpdater defaultUpdateURL.
	defaultUpdater := MCMcmUpdater default. "create and register"
	self assert: defaultMapFromPreference equals: defaultUpdater updateMapName.
	self assert: defaultURLFromPreference equals: defaultUpdater repository.
	self assert: MCMcmUpdater registry size = 1.
	self assert: (MCMcmUpdater registry at: defaultURLFromPreference) size = 1.
	[ | newDefault |
		MCMcmUpdater updateMapName: 'NEWMAP'.
		"new instance not yet registered"
		self assert: MCMcmUpdater registry size = 1.
		self assert: (MCMcmUpdater registry at: defaultURLFromPreference) size = 1.
		self shouldnt: [MCMcmUpdater registry at: defaultURLFromPreference] raise: Error.
		self should: [(MCMcmUpdater registry at: defaultURLFromPreference) at: 'NEWMAP'] raise: Error.
		newDefault := MCMcmUpdater default. "create and register new default updater"
		self shouldnt: [(MCMcmUpdater registry at: defaultURLFromPreference) at: 'NEWMAP'] raise: Error.
		self assert: 'NEWMAP' equals: newDefault updateMapName.

		MCMcmUpdater defaultUpdateURL: 'NEWURL'.
		self assert: MCMcmUpdater registry size = 1.
		newDefault := MCMcmUpdater default. "create and register new default updater"
		self assert: MCMcmUpdater registry size = 2.
		self shouldnt: [(MCMcmUpdater registry at: 'NEWURL') at: 'NEWMAP'] raise: Error.
		self assert: 'NEWURL' equals: newDefault repository.
		self assert: 'NEWMAP' equals: newDefault updateMapName.
	] ensure: [ "restore preferences"
		MCMcmUpdater updateMapName: defaultMapFromPreference.
		MCMcmUpdater defaultUpdateURL: defaultURLFromPreference
	]


! !

TestCase subclass: #MCSortingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello'!

!MCSortingTest methodsFor: 'building' stamp: 'ab 4/8/2003 17:56'!
classNamed: aSymbol
	^ MCClassDefinition
		name: aSymbol
		superclassName: #Object
		category: ''
		instVarNames: #()
		comment: ''! !

!MCSortingTest methodsFor: 'building' stamp: 'ab 4/8/2003 18:03'!
methodNamed: aSymbol class: className meta: aBoolean
	^ MCMethodDefinition
		className: className
		classIsMeta: aBoolean
		selector: aSymbol
		category: ''
		timeStamp: ''
		source: ''! !

!MCSortingTest methodsFor: 'actions' stamp: 'ab 7/19/2003 18:01'!
sortDefinitions: aCollection
	^ aCollection asSortedCollection asArray! !

!MCSortingTest methodsFor: 'building' stamp: 'ab 7/19/2003 17:56'!
sortKeyFor: aDefinition
	^ String streamContents:
		[:s |
		aDefinition description
			do: [:ea | s nextPutAll: ea asString]
			separatedBy: [s nextPut: $.]]! !

!MCSortingTest methodsFor: 'tests' stamp: 'ab 7/19/2003 17:57'!
testConsistentSorting
	| definitions shuffledAndSorted|
	definitions :=
		{self methodNamed: #a class: #A meta: false.
		self methodNamed: #a class: #A meta: true.
		self methodNamed: #a class: #B meta: false.
		self methodNamed: #b class: #A meta: false.
		self methodNamed: #b class: #B meta: false.
		self classNamed: #A.
		self classNamed: #B}.
	shuffledAndSorted :=
		(1 to: 100) collect: [:ea | self sortDefinitions: definitions shuffled].
	self assert: shuffledAndSorted asSet size = 1.
! !

!MCSortingTest methodsFor: 'tests' stamp: 'ab 5/6/2003 17:08'!
testSortOrder
	| aA aAm aB bA bB A B cA bAm cAm |
	aA := self methodNamed: #a class: #A meta: false.
	bA := self methodNamed: #b class: #A meta: false.
	cA := self methodNamed: #c class: #A meta: false.
	aAm := self methodNamed: #a class: #A meta: true.
	bAm := self methodNamed: #b class: #A meta: true.
	cAm := self methodNamed: #c class: #A meta: true.
	aB := self methodNamed: #a class: #B meta: false.
	bB := self methodNamed: #b class: #B meta: false.
	A := self classNamed: #A.
	B := self classNamed: #B.
	self assert: (self sortDefinitions: {aA. aAm. cAm. aB. bAm. bA. bB. A. cA. B})
					= {A. aAm. bAm. cAm. aA. bA. cA. B. aB.  bB}! !

TestCase subclass: #MCTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello'!

MCTestCase subclass: #MCAncestryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello'!

!MCAncestryTest methodsFor: 'asserting' stamp: 'stephaneducasse 2/4/2006 20:47'!
assertCommonAncestorOf: leftName and: rightName in: options in: tree
	| left right ancestor |
	left := self versionForName: leftName in: tree.
	right := self versionForName: rightName in: tree.
	
	ancestor := left commonAncestorWith: right.
	
	self assert: (options includes: ancestor name)! !

!MCAncestryTest methodsFor: 'asserting' stamp: 'avi 9/17/2005 21:09'!
assertCommonAncestorOf: leftName and: rightName is: ancestorName in: tree
	self assertCommonAncestorOf: leftName and: rightName in: (Array with: ancestorName) in: tree! !

!MCAncestryTest methodsFor: 'asserting' stamp: 'jf 8/16/2003 20:30'!
assertNamesOf: versionInfoCollection are: nameArray
	| names |
	names := versionInfoCollection collect: [:ea | ea name].
	
	self assert: names asArray = nameArray! !

!MCAncestryTest methodsFor: 'asserting' stamp: 'jf 8/16/2003 23:42'!
assertPathTo: aSymbol is: anArray
	self
		assertNamesOf: (self tree allAncestorsOnPathTo: (self treeFrom: {aSymbol}))
		are: anArray! !

!MCAncestryTest methodsFor: 'tests' stamp: 'avi 9/17/2005 21:08'!
testCommonAncestors
	self assertCommonAncestorOf: #a2 and: #e2 is: #a1 in: self tree.
	self assertCommonAncestorOf: #e2 and: #b3 is: #a1 in: self tree.
	self assertCommonAncestorOf: #b2 and: #e2 is: #'00' in: self tree.
	
	self assertCommonAncestorOf: #a4 and: #b5 in: #(b2 a1) in: self twoPersonTree.
	self assertCommonAncestorOf: #b5 and: #b3 is: #b2 in: self twoPersonTree.
	self assertCommonAncestorOf: #b2 and: #a4 is: #b2 in: self twoPersonTree.
	self assertCommonAncestorOf: #b2 and: #b2 is: #b2 in: self twoPersonTree.
	self assertCommonAncestorOf: #b2 and: #a1 is: #a1 in: self twoPersonTree.
	self assertCommonAncestorOf: #a1 and: #b2 is: #a1 in: self twoPersonTree.! !

!MCAncestryTest methodsFor: 'tests' stamp: 'stephaneducasse 2/4/2006 20:47'!
testDescendants
	| c1 a1 b3 q1 q2 c2 |
	c1 := self tree.
	a1 := self treeFrom: #(a1 (('00'))).
	b3 := self treeFrom: #(b3
				((b2
					((b1
						((b0
							(('00')))))))
				(a1
					(('00'))))).
	q1 := MCWorkingAncestry new addAncestor: a1.
	q2 := MCWorkingAncestry new addAncestor: q1.
	self assert: (q2 commonAncestorWith: b3) = a1.
	self assert: (b3 commonAncestorWith: q2) = a1.
	self assert: (q2 commonAncestorWith: c1) = a1.
	self assert: (c1 commonAncestorWith: q2) = a1.
	q1 addStepChild: c1.
	self assert: (q2 commonAncestorWith: c1) = q1.
	self assert: (c1 commonAncestorWith: q2) = q1.
	c2 := MCWorkingAncestry new addAncestor: c1.
	self assert: (q2 commonAncestorWith: c2) = q1.
	self assert: (c2 commonAncestorWith: q2) = q1.
! !

!MCAncestryTest methodsFor: 'tests' stamp: 'jf 8/16/2003 20:45'!
testLinearPath
	self assertPathTo: #b1 is: #(b3 b2)! !

!MCAncestryTest methodsFor: 'tests' stamp: 'jf 8/16/2003 20:42'!
testPathToMissingAncestor
	self assert: (self tree allAncestorsOnPathTo: MCVersionInfo new) isEmpty! !

!MCAncestryTest methodsFor: 'building' stamp: 'jf 8/16/2003 21:21'!
tree
	^ self treeFrom:
		#(c1
			((e2
				((e1
					((a1
						(('00')))))))
			(a2
				((a1
					(('00')))))
			(b3
				((b2
					((b1
						((b0
							(('00')))))))
				(a1
					(('00')))))
			(d1)))! !

!MCAncestryTest methodsFor: 'building' stamp: 'jf 8/16/2003 22:55'!
twoPersonTree
	^ self treeFrom:
		#(c1
			((a4
				((a1)
				(b3
					((b2
						((a1)))))))
			(b5
				((b2
					((a1)))))))! !

!MCAncestryTest methodsFor: 'building' stamp: 'ul 12/12/2009 14:10'!
versionForName: name in: tree
	(tree name = name) ifTrue: [^ tree].
	
	tree ancestors do: [:ea | (self versionForName: name in: ea) ifNotNil: [:v | ^ v]].
	
	^ nil! !

MCTestCase subclass: #MCChangeNotificationTest
	instanceVariableNames: 'workingCopy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello'!

!MCChangeNotificationTest methodsFor: 'private' stamp: 'bf 5/20/2005 16:19'!
foreignMethod
	"see testForeignMethodModified"! !

!MCChangeNotificationTest methodsFor: 'events' stamp: 'cwp 11/6/2004 22:32'!
modifiedEventFor: aSelector ofClass: aClass
	| method |
	method := aClass compiledMethodAt: aSelector.
	^ ModifiedEvent 
				methodChangedFrom: method
				to: method
				selector: aSelector
				inClass: aClass.
! !

!MCChangeNotificationTest methodsFor: 'running' stamp: 'cmm 1/19/2011 16:01'!
setUp
	super setUp.
	workingCopy := MCWorkingCopy forPackage: self mockPackage! !

!MCChangeNotificationTest methodsFor: 'running' stamp: 'ul 4/26/2011 05:27'!
tearDown

	super tearDown.
	workingCopy unregister! !

!MCChangeNotificationTest methodsFor: 'tests' stamp: 'bf 5/20/2005 19:54'!
testCoreMethodModified
	| event |
	workingCopy modified: false.
	event := self modifiedEventFor: #one ofClass: self mockClassA.
	MCWorkingCopy methodModified: event.
	self assert: workingCopy modified! !

!MCChangeNotificationTest methodsFor: 'tests' stamp: 'bf 5/20/2005 17:05'!
testExtMethodModified
	| event mref |
	workingCopy modified: false.
	mref := workingCopy packageInfo extensionMethods first.
	event := self modifiedEventFor: mref methodSymbol ofClass: mref actualClass.
	MCWorkingCopy methodModified: event.
	self assert: workingCopy modified! !

!MCChangeNotificationTest methodsFor: 'tests' stamp: 'bf 5/20/2005 17:00'!
testForeignMethodModified
	| event |
	workingCopy modified: false.
	event := self modifiedEventFor: #foreignMethod ofClass: self class.
	MCWorkingCopy methodModified: event.
	self deny: workingCopy modified! !

MCTestCase subclass: #MCClassDefinitionTest
	instanceVariableNames: 'previousChangeSet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello'!

!MCClassDefinitionTest class methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 01:20'!
classAComment
	^ 'This is a mock class. The Monticello tests manipulated it to simulate a developer modifying code in the image.'! !

!MCClassDefinitionTest class methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 17:59'!
classACommentStamp
	^  'cwp 8/10/2003 16:43'! !

!MCClassDefinitionTest class methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 18:01'!
restoreClassAComment
	Smalltalk 
		at: #MCMockClassA 
		ifPresent: [:a | a classComment: self classAComment stamp: self classACommentStamp]! !

!MCClassDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 01:20'!
classAComment
	^ self class classAComment! !

!MCClassDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 17:17'!
creationMessage
	^ MessageSend
		receiver: MCClassDefinition
		selector: #name:superclassName:category:instVarNames:classVarNames:poolDictionaryNames:classInstVarNames:type:comment:commentStamp:! !

!MCClassDefinitionTest methodsFor: 'as yet unclassified' stamp: 'ul 4/26/2011 05:27'!
tearDown

	super tearDown.
	Smalltalk at: 'MCMockClassC' ifPresent: [:c | c removeFromSystem]! !

!MCClassDefinitionTest methodsFor: 'as yet unclassified' stamp: 'avi 1/24/2004 20:31'!
testCannotLoad
	| d |
	d :=  self mockClass: 'MCMockClassC' super: 'NotAnObject'.
	self should: [d load] raise: Error.
	self deny: (Smalltalk hasClassNamed: 'MCMockClassC').! !

!MCClassDefinitionTest methodsFor: 'as yet unclassified' stamp: 'ab 1/15/2003 17:53'!
testComparison
	| d1 d2 d3 d4 |
	d1 := self mockClass: 'A' super: 'X'.
	d2 := self mockClass: 'A' super: 'Y'.
	d3 := self mockClass: 'B' super: 'X'.
	d4 := self mockClass: 'B' super: 'X'.
	
	self assert: (d1 isRevisionOf: d2).
	self deny: (d1 isSameRevisionAs: d2).

	self assert: (d3 isRevisionOf: d4).
	self assert: (d3 isSameRevisionAs: d4).
	
	self deny: (d1 isRevisionOf: d3).
	self deny: (d4 isRevisionOf: d2).! !

!MCClassDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 16:39'!
testCreation
	| d |
	d :=  self mockClassA asClassDefinition.
	self assert: d className = #MCMockClassA.
	self assert: d superclassName = #MCMock.
	self assert: d type = #normal.
	self assert: d category = self mockCategoryName.
	self assert: d instVarNames asArray = #('ivar').
	self assert: d classVarNames asArray = #('CVar').
	self assert: d classInstVarNames asArray = #().
	self assert: d comment isString.
	self assert: d comment = self classAComment.
	self assert: d commentStamp = self mockClassA organization commentStamp! !

!MCClassDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 02:06'!
testDefinitionString
	| d |
	d := self mockClassA asClassDefinition.
	self assert: d definitionString = self mockClassA definition.! !

!MCClassDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 17:20'!
testEquals
	| a b |
	a := self mockClass: 'ClassA' super: 'SuperA'.
	b := self mockClass: 'ClassA' super: 'SuperA'.
	self assert: a = b! !

!MCClassDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/12/2003 02:37'!
testEqualsSensitivity
	| message a b defA args defB |
	message := self creationMessage.
	a := #(ClassA SuperA CategoryA #(iVarA) #(CVarA) #(PoolA) #(ciVarA)
			typeA 'A comment' 'A').
	b := #(ClassB SuperB CategoryB #(iVarB) #(CVarB) #(PoolB) #(ciVarB)
			typeB 'B comment' 'B').
	
	defA := message valueWithArguments: a.
	1 to: 8 do: [:index |
				args := a copy.
				args at: index put: (b at: index).
				defB := message valueWithArguments: args.
				self deny: defA = defB.]! !

!MCClassDefinitionTest methodsFor: 'as yet unclassified' stamp: 'nice 12/27/2009 03:11'!
testKindOfSubclass
	| classes |
	classes := {self mockClassA. String. MethodContext. WeakArray. Float}.
	classes do: [:c | | d |
		d :=  c asClassDefinition.
		self assert: d kindOfSubclass = c kindOfSubclass.
	].! !

!MCClassDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 16:54'!
testLoadAndUnload
	| d c |
	d :=  self mockClass: 'MCMockClassC' super: 'Object'.
	d load.
	self assert: (Smalltalk hasClassNamed: 'MCMockClassC').
	c := (Smalltalk classNamed: 'MCMockClassC').
	self assert: (c isKindOf: Class).
	self assert: c superclass = Object.
	self assert: c instVarNames isEmpty.
	self assert: c classVarNames isEmpty.
	self assert: c sharedPools isEmpty.
	self assert: c category = self mockCategoryName.
	self assert: c organization classComment = (self commentForClass: 'MCMockClassC').
	self assert: c organization commentStamp = (self commentStampForClass: 'MCMockClassC').
	d unload.
	self deny: (Smalltalk hasClassNamed: 'MCMockClassC').! !

MCTestCase subclass: #MCEnvironmentLoadTest
	instanceVariableNames: 'environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello'!

!MCEnvironmentLoadTest commentStamp: 'fbs 5/8/2013 20:46' prior: 0!
I demonstrate that you can load MC snapshots into an environment.!

!MCEnvironmentLoadTest methodsFor: 'running' stamp: 'nice 5/27/2014 00:25'!
setUp
	environment := Environment named: 'MCEnvironmentLoadTest'.
	
	"This is required in order to not importSelf more than once"
	environment stopObserving: environment. 
	
	"This is required to make own declarations visible in environment"
	environment importSelf.
	
	"Import the required PoolDictionary used by the package"
	environment bindingOf: #MCMockAPoolDictionary
		ifAbsent: [environment from: Smalltalk globals import: #MCMockAPoolDictionary]

	"Curiously, the superclass MCMock will be used, but does not have to be imported, don't ask why..."! !

!MCEnvironmentLoadTest methodsFor: 'running' stamp: 'nice 5/27/2014 00:10'!
tearDown
	(environment allClassesAndTraits sorted: [:a :b |
		(a allSuperclasses includes: b) or: [a name < b name]])
			do: [:each | each removeFromSystem]! !

!MCEnvironmentLoadTest methodsFor: 'testing' stamp: 'eem 2/6/2015 14:36'!
testLoadIntoEnvironment
	[[MCPackageLoader installSnapshot: self mockSnapshot]
		valueSupplyingAnswers: #(('The pool dictionary*does not exist*automatically created?' true))]
		on: CurrentEnvironment
		do: [:e | e resume: environment].
	self assert: (environment bindingOf: #MCMockClassA) notNil
		description: 'Environment has no binding for MCMockClassA'.! !

MCTestCase subclass: #MCFileInTest
	instanceVariableNames: 'stream expected diff'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello'!

!MCFileInTest methodsFor: 'testing' stamp: 'cwp 8/10/2003 02:08'!
alterInitialState
	self mockClassA touchCVar! !

!MCFileInTest methodsFor: 'testing' stamp: 'avi 2/17/2004 03:21'!
assertFileOutFrom: writerClass canBeFiledInWith: aBlock
	(writerClass on: stream) writeSnapshot: self mockSnapshot.
	self alterInitialState.
	self assertSuccessfulLoadWith: aBlock.
	self mockPackage unload.
	self assertSuccessfulLoadWith: aBlock.
! !

!MCFileInTest methodsFor: 'testing' stamp: 'cwp 8/10/2003 02:08'!
assertInitializersCalled
	| cvar |
	cvar := self mockClassA cVar.
	self assert: cvar = #initialized! !

!MCFileInTest methodsFor: 'asserting' stamp: 'cwp 8/2/2003 13:02'!
assertNoChange
	| actual |
	actual := MCSnapshotResource takeSnapshot.
	diff := actual patchRelativeToBase: expected.
	self assert: diff isEmpty! !

!MCFileInTest methodsFor: 'testing' stamp: 'cwp 8/10/2003 02:30'!
assertSuccessfulLoadWith: aBlock
	stream reset.
	aBlock value.
	self assertNoChange.
	self assertInitializersCalled.! !

!MCFileInTest methodsFor: 'running' stamp: 'cwp 8/2/2003 13:01'!
setUp
	expected := self mockSnapshot.
	stream := RWBinaryOrTextStream on: String new.! !

!MCFileInTest methodsFor: 'running' stamp: 'ul 4/7/2016 20:25'!
tearDown

	super tearDown.
	(diff isNil or: [diff isEmpty not])
		 ifTrue: [expected updatePackage: self mockPackage].
	SystemOrganizer default removeEmptyCategories! !

!MCFileInTest methodsFor: 'testing' stamp: 'ar 5/10/2010 20:53'!
testStWriter
	<timeout: 30> "takes a little longer"
	self
		assertFileOutFrom: MCStWriter
		canBeFiledInWith: [stream fileIn].
! !

MCTestCase subclass: #MCInitializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello'!

!MCInitializationTest class methodsFor: 'as yet unclassified' stamp: 'cwp 8/13/2003 12:11'!
isAbstract
	^ (Smalltalk hasClassNamed: #MczInstaller) not
		! !

!MCInitializationTest methodsFor: 'as yet unclassified' stamp: 'ul 4/26/2011 05:28'!
tearDown

	super tearDown.
	(MCWorkingCopy forPackage: self mockPackage) unregister! !

!MCInitializationTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/11/2003 23:50'!
testWorkingCopy
	MczInstaller storeVersionInfo: self mockVersion.
	MCWorkingCopy initialize.
	MCWorkingCopy allManagers
						detect: [:man | man package name = self mockPackage name]
						ifNone: [self assert: false]! !

MCTestCase subclass: #MCMczInstallerTest
	instanceVariableNames: 'expected diff'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello'!

!MCMczInstallerTest class methodsFor: 'as yet unclassified' stamp: 'cwp 8/13/2003 12:11'!
isAbstract
	^ (Smalltalk hasClassNamed: #MczInstaller) not
		! !

!MCMczInstallerTest class methodsFor: 'as yet unclassified' stamp: 'cwp 8/13/2003 11:56'!
suite
	^ (Smalltalk hasClassNamed: #MczInstaller)
		ifTrue: [super suite]
		ifFalse: [TestSuite new name: self name asString]! !

!MCMczInstallerTest methodsFor: 'as yet unclassified' stamp: 'ul 12/12/2009 14:10'!
assertDict: dict matchesInfo: info
	#(name id message date time author)
		do: [:sel |  (info perform: sel) ifNotNil: [:i | dict at: sel ifPresent: [:d | self assert: i = d]]].
	info ancestors 
			with: (dict at: #ancestors) 
			do: [:i :d | self assertDict: d matchesInfo: i]! !

!MCMczInstallerTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/7/2003 19:38'!
assertNoChange
	| actual |
	actual := MCSnapshotResource takeSnapshot.
	diff := actual patchRelativeToBase: expected snapshot.
	self assert: diff isEmpty! !

!MCMczInstallerTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 16:25'!
assertVersionInfoPresent
	| dict info |
	dict := MczInstaller versionInfo at: self mockPackage name.
	info := expected info.
	self assertDict: dict matchesInfo: info.! !

!MCMczInstallerTest methodsFor: 'as yet unclassified' stamp: 'pre 8/16/2016 21:47'!
defaultTimeout

	^ 60! !

!MCMczInstallerTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/7/2003 18:18'!
deleteFile
	(FileDirectory default fileExists: self fileName)
		ifTrue: [FileDirectory default deleteFileNamed: self fileName]! !

!MCMczInstallerTest methodsFor: 'as yet unclassified' stamp: 'cmm 3/3/2011 14:59'!
fileName
	^ 'InstallerTest.mcz' asMCVersionName! !

!MCMczInstallerTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/7/2003 18:16'!
fileStream
	^ FileStream forceNewFileNamed: self fileName.! !

!MCMczInstallerTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/7/2003 19:31'!
setUp
	expected := self mockVersion.
	self change: #one toReturn: 2.! !

!MCMczInstallerTest methodsFor: 'as yet unclassified' stamp: 'ul 4/26/2011 05:28'!
tearDown

	super tearDown.
	expected snapshot updatePackage: self mockPackage.
	self deleteFile.! !

!MCMczInstallerTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 16:25'!
testInstallFromFile
	MCMczWriter fileOut: expected on: self fileStream.
	MczInstaller installFileNamed: self fileName.
	self assertNoChange.! !

!MCMczInstallerTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 16:25'!
testInstallFromStream
	| stream |
	stream := RWBinaryOrTextStream on: String new.
	MCMczWriter fileOut: expected on: stream.
	MczInstaller installStream: stream reset.
	self assertNoChange.
	self assertVersionInfoPresent.
	! !

MCTestCase subclass: #MCMergingTest
	instanceVariableNames: 'conflictBlock conflicts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello'!

!MCMergingTest methodsFor: 'asserting' stamp: 'ab 1/15/2003 16:46'!
assert: aCollection hasElements: anArray
	self assert: (aCollection collect: [:ea | ea token]) asSet = anArray asSet! !

!MCMergingTest methodsFor: 'asserting' stamp: 'ab 6/2/2003 01:25'!
assertMerge: local with: remote base: ancestor gives: result conflicts: conflictResult
	| merger |
	conflicts := #().
	merger := MCThreeWayMerger
				base: (self snapshotWithElements: local)
				target: (self snapshotWithElements: remote)
				ancestor: (self snapshotWithElements: ancestor).
	merger conflicts do: [:ea | self handleConflict: ea].
	self assert: merger mergedSnapshot definitions hasElements: result.
	self assert: conflicts asSet = conflictResult asSet.! !

!MCMergingTest methodsFor: 'emulating' stamp: 'ul 12/12/2009 14:12'!
handleConflict: aConflict	
	|l r|
	l := #removed.
	r := #removed.
	aConflict localDefinition ifNotNil: [:d | l := d token].
	aConflict remoteDefinition ifNotNil: [:d | r := d token].	
	conflicts := conflicts copyWith: (Array with: r with: l).
	(l = #removed or: [r = #removed])
		ifTrue: [aConflict chooseRemote]
		ifFalse:
			[l > r
				ifTrue: [aConflict chooseLocal]
				ifFalse: [aConflict chooseRemote]]
		! !

!MCMergingTest methodsFor: 'emulating' stamp: 'ab 7/6/2003 23:48'!
snapshotWithElements: anArray
	^ MCSnapshot
		fromDefinitions: (anArray collect: [:t | self mockToken: t])! !

!MCMergingTest methodsFor: 'tests' stamp: 'ab 12/5/2002 00:28'!
testAdditiveConflictlessMerge
	self
		assertMerge: #(a1 b1)
				with: #(a1 c1)
				base: #(a1)
			
				gives: #(a1 b1 c1)
				conflicts: #()! !

!MCMergingTest methodsFor: 'tests' stamp: 'ab 12/5/2002 00:27'!
testComplexConflictlessMerge
	self 
		assertMerge: #(a1 b1 d1)
				with: #(a2 c1)
				base: #(a1 c1 d1)
				
				gives: #(a2 b1)
				conflicts: #()! !

!MCMergingTest methodsFor: 'tests' stamp: 'ab 12/5/2002 00:28'!
testIdenticalModification
	self
		assertMerge: #(a2 b1)
				with: #(a2 b1)
				base: #(a1 b1)
				
				gives: #(a2 b1)
				conflicts: #()! !

!MCMergingTest methodsFor: 'tests' stamp: 'ab 6/2/2003 01:44'!
testLocalModifyRemoteRemove
	self assertMerge: #(a2 b1)
				with: #(b1)
				base: #(a1 b1)
				
				gives: #(b1)
				conflicts: #((removed a2)).
				
	self assertMerge: #(a1 b1)
				with: #(b1)
				base: #(a2 b1)
				
				gives: #(b1)
				conflicts: #((removed a1)).! !

!MCMergingTest methodsFor: 'tests' stamp: 'ab 6/2/2003 01:43'!
testLocalRemoveRemoteModify
	self assertMerge: #(b1)
				with: #(a1 b1)
				base: #(a2 b1)
				
				gives: #(a1 b1)
				conflicts: #((a1 removed)).

	self assertMerge: #(b1)
				with: #(a2 b1)
				base: #(a1 b1)
				
				gives: #(a2 b1)
				conflicts: #((a2 removed)).! !

!MCMergingTest methodsFor: 'tests' stamp: 'stephaneducasse 2/4/2006 20:47'!
testMultiPackageMerge
	| merger |
	conflicts := #().
	merger := MCThreeWayMerger new.
	merger addBaseSnapshot: (self snapshotWithElements: #(a1 b1)).
	merger applyPatch: ((self snapshotWithElements: #()) patchRelativeToBase: (self snapshotWithElements: #(a1))).
	merger applyPatch: ((self snapshotWithElements: #(a2 b1)) patchRelativeToBase: (self snapshotWithElements: #(b1))).
	merger conflicts do: [:ea | self handleConflict: ea].
	self assert: merger mergedSnapshot definitions hasElements: #(a2 b1).
	self assert: conflicts isEmpty! !

!MCMergingTest methodsFor: 'tests' stamp: 'stephaneducasse 2/4/2006 20:47'!
testMultiPackageMerge2
	| merger |
	conflicts := #().
	merger := MCThreeWayMerger new.
	merger addBaseSnapshot: (self snapshotWithElements: #(a1 b1)).
	merger applyPatch: ((self snapshotWithElements: #()) patchRelativeToBase: (self snapshotWithElements: #(a1))).
	merger applyPatch: ((self snapshotWithElements: #(a1 b1)) patchRelativeToBase: (self snapshotWithElements: #(b1))).
	merger conflicts do: [:ea | self handleConflict: ea].
	self assert: merger mergedSnapshot definitions hasElements: #(a1 b1).
	self assert: conflicts isEmpty! !

!MCMergingTest methodsFor: 'tests' stamp: 'stephaneducasse 2/4/2006 20:47'!
testMultiPackageMerge3
	| merger |
	conflicts := #().
	merger := MCThreeWayMerger new.
	merger addBaseSnapshot: (self snapshotWithElements: #(a1 b1)).
	merger applyPatch: ((self snapshotWithElements: #(a1 b1)) patchRelativeToBase: (self snapshotWithElements: #(b1))).
	merger applyPatch: ((self snapshotWithElements: #()) patchRelativeToBase: (self snapshotWithElements: #(a1))).
	merger conflicts do: [:ea | self handleConflict: ea].
	self assert: merger mergedSnapshot definitions hasElements: #(a1 b1).
	self assert: conflicts isEmpty! !

!MCMergingTest methodsFor: 'tests' stamp: 'ab 6/2/2003 01:38'!
testMultipleConflicts
	self assertMerge: #(a1 b3 c1)
				with: #(a1 b2 d1)
				base: #(a1 b1 c2)
				
				gives: #(a1 b3 d1)
				conflicts: #((removed c1) (b2 b3))
! !

!MCMergingTest methodsFor: 'tests' stamp: 'ab 6/2/2003 01:38'!
testSimultaneousModification
	self assertMerge: #(a2)
				with: #(a3)
				base: #(a1)
				
				gives: #(a3)
				conflicts: #((a3 a2)).! !

!MCMergingTest methodsFor: 'tests' stamp: 'ab 12/5/2002 01:27'!
testSimultaneousRemove
	self assertMerge: #(a1)
				with: #(a1)
				base: #(a1 b1)
				
				gives: #(a1)
				conflicts: #()! !

!MCMergingTest methodsFor: 'tests' stamp: 'ab 12/5/2002 01:31'!
testSubtractiveConflictlessMerge
	self assertMerge: #(a1 b1)
				with: #()
				base: #(a1)
				
				gives: #(b1)
				conflicts: #()! !

MCTestCase subclass: #MCMethodDefinitionTest
	instanceVariableNames: 'navigation isModified overrideTimestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello'!

!MCMethodDefinitionTest methodsFor: 'mocks' stamp: 'cwp 11/7/2004 17:09'!
override ^ 1! !

!MCMethodDefinitionTest methodsFor: 'running' stamp: 'ul 9/11/2012 18:04'!
ownPackage
	^ MCWorkingCopy forPackage: (MCPackage named: 'Tests')! !

!MCMethodDefinitionTest methodsFor: 'running' stamp: 'ul 9/11/2012 18:09'!
setUp

	navigation := (Smalltalk hasClassNamed: #SystemNavigation)
		ifTrue: [(Smalltalk at: #SystemNavigation) new]
		ifFalse: [Smalltalk].
	isModified := self ownPackage modified.
	overrideTimestamp := (self class >> #override) timeStamp! !

!MCMethodDefinitionTest methodsFor: 'running' stamp: 'ul 9/11/2012 18:10'!
tearDown

	self restoreMocks.
	(MCWorkingCopy forPackage: (MCPackage named: 'FooBarBaz')) unregister.
	MCMockPackageInfo new mcPackage workingCopy unregister.
	self class
		compile: 'override ^ 1'
		classified: 'mocks'
		withStamp: overrideTimestamp
		notifying: nil.
	SystemOrganizer default removeEmptyCategories.
	self ownPackage modified: isModified.
	super tearDown
! !

!MCMethodDefinitionTest methodsFor: 'testing' stamp: 'avi 1/24/2004 20:31'!
testCannotLoad
	| definition |
	definition := self mockMethod: #kjahs87 class: 'NoSuchClass' source: 'kjahs87 ^self' meta: false.
	self should: [definition load] raise: Error.
	self assert: (navigation allImplementorsOf: #kjahs87) isEmpty! !

!MCMethodDefinitionTest methodsFor: 'testing' stamp: 'ab 1/15/2003 17:52'!
testComparison
	|d1 d2 d3 d4 d5 |
	d1 := self mockMethod: #one class: 'A' source: '1' meta: false.
	d2 := self mockMethod: #one class: 'A' source: '2' meta: false.
	d3 := self mockMethod: #one class: 'A' source: '1' meta: true.
	d4 := self mockMethod: #two class: 'A' source: '1' meta: false.
	d5 := self mockMethod: #two class: 'A' source: '1' meta: false.
	
	self assert: (d1 isRevisionOf: d2).
	self deny: (d1 isSameRevisionAs: d2).
	
	self deny: (d1 isRevisionOf: d3).
	self deny: (d1 isRevisionOf: d4).
	
	self assert: (d4 isSameRevisionAs: d5).! !

!MCMethodDefinitionTest methodsFor: 'testing' stamp: 'cwp 8/10/2003 02:09'!
testLoadAndUnload
	|definition|
	definition := self mockMethod: #one class: 'MCMockClassA' source: 'one ^2' meta: false.
	self assert: self mockInstanceA one = 1.
	definition load.
	self assert: self mockInstanceA one = 2.
	definition unload.
	self deny: (self mockInstanceA respondsTo: #one)! !

!MCMethodDefinitionTest methodsFor: 'testing' stamp: 'cwp 11/13/2003 13:28'!
testPartiallyRevertOverrideMethod
	| definition |
	self class compile: 'override ^ 2' classified: '*foobarbaz'.
	self class compile: 'override ^ 3' classified: self mockOverrideMethodCategory.
	self class compile: 'override ^ 4' classified: self mockOverrideMethodCategory.
	definition := (MethodReference class: self class selector: #override) asMethodDefinition.
	self assert: definition isOverrideMethod.
	self assert: self override = 4.
	definition unload.
	self assert: self override = 2.
	self assert: (MethodReference class: self class selector: #override) category = '*foobarbaz'.
	! !

!MCMethodDefinitionTest methodsFor: 'testing' stamp: 'bf 5/4/2012 17:00'!
testRevertOldMethod
	| definition changeRecord |
	Object compile: 'yourself ^ self' classified: self mockOverrideMethodCategory.
	definition := (MethodReference class: Object selector: #yourself) asMethodDefinition.
	changeRecord := definition scanForPreviousVersions first.
	self assert: changeRecord notNil.
	self assert: changeRecord category = 'accessing'.
	changeRecord fileIn.! !

!MCMethodDefinitionTest methodsFor: 'testing' stamp: 'fbs 11/6/2013 18:53'!
testRevertOverrideMethod
	| definition |
	self class compile: 'override ^ 2' classified:  '*foobarbaz-override'.
	definition := (MethodReference class: self class selector: #override) asMethodDefinition.
	self assert: definition isOverrideMethod description: 'Method not marked as an override'.
	self assert: 2 equals: self override description: 'Method not overridden'.
	definition unload.
	self assert: 1 equals: self override description: 'Unload didn''t revert method'.
	self assert: 'mocks' equals: (MethodReference class: self class selector: #override) category  description: 'Unload didn''t revert. method classification'.
	! !

MCTestCase subclass: #MCOrganizationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello'!

!MCOrganizationTest methodsFor: 'as yet unclassified' stamp: 'avi 2/17/2004 13:25'!
testReordering
	|dec cats newCats |
	dec := MCOrganizationDefinition categories: #(A B C).
	cats := #(X Y B Z C A Q).
	newCats := dec reorderCategories: cats original: #(B C A).
	self assert: newCats asArray = #(X Y A B C Z Q).! !

!MCOrganizationTest methodsFor: 'as yet unclassified' stamp: 'avi 2/17/2004 13:21'!
testReorderingWithNoCategoriesInVersion
	|dec cats newCats |
	dec := MCOrganizationDefinition categories: #().
	cats := #(X Y B Z C A Q).
	newCats := dec reorderCategories: cats original: #().
	self assert: newCats asArray = cats.! !

!MCOrganizationTest methodsFor: 'as yet unclassified' stamp: 'avi 2/17/2004 13:22'!
testReorderingWithRemovals
	|dec cats newCats |
	dec := MCOrganizationDefinition categories: #(A B C).
	cats := #(X Y B Z C A Q).
	newCats := dec reorderCategories: cats original: #(Y B C A Q).
	self assert: newCats asArray = #(X A B C Z).! !

MCTestCase subclass: #MCPackageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello'!

!MCPackageTest methodsFor: 'running' stamp: 'ul 4/26/2011 05:28'!
tearDown

	super tearDown.
	self mockSnapshot install! !

!MCPackageTest methodsFor: 'tests' stamp: 'fbs 1/12/2014 13:21'!
testUnload
	| mock |
	self mockPackage unload.
	self deny: (Smalltalk hasClassNamed: #MCMockClassA) description: 'Class not removed'.
	self deny: (MCSnapshotTest includesSelector: #mockClassExtension) description: 'Extension method not removed'.

	mock := Smalltalk classNamed: #MCMock.
	self assert: (mock subclasses noneSatisfy: [:c | c name = #MCMockClassA]) description: 'Can still find the "removed" subclass'.! !

MCTestCase subclass: #MCPatchTest
	instanceVariableNames: 'patch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello'!

!MCPatchTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/2/2003 17:24'!
setUp
	|rev1 rev2|
	rev1 :=  MCSnapshotResource takeSnapshot.
	self change: #one toReturn: 2.
	rev2 :=  MCSnapshotResource takeSnapshot.
	patch := rev2 patchRelativeToBase: rev1.
	self change: #one toReturn: 1.! !

!MCPatchTest methodsFor: 'as yet unclassified' stamp: 'ul 4/26/2011 05:28'!
tearDown

	super tearDown.
	self restoreMocks! !

!MCPatchTest methodsFor: 'as yet unclassified' stamp: 'cwp 7/14/2003 15:31'!
testPatchContents
	self assert: patch operations size = 1.
	self assert: patch operations first isModification.
	self assert: patch operations first definition selector = #one.
! !

MCTestCase subclass: #MCRepositoryTest
	instanceVariableNames: 'repository ancestors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello'!

MCRepositoryTest subclass: #MCDictionaryRepositoryTest
	instanceVariableNames: 'dict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello'!

!MCDictionaryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'ab 8/16/2003 17:53'!
addVersion: aVersion
	dict at: aVersion info put: aVersion! !

!MCDictionaryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'ab 7/19/2003 16:06'!
deleteNode: aNode
	dict removeKey: aNode! !

!MCDictionaryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'ab 7/19/2003 16:06'!
dictionary
	^ dict ifNil: [dict := Dictionary new]! !

!MCDictionaryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'ab 7/26/2003 02:49'!
setUp
	repository :=  MCDictionaryRepository new dictionary: self dictionary! !

MCRepositoryTest subclass: #MCDirectoryRepositoryTest
	instanceVariableNames: 'directory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello'!

!MCDirectoryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'avi 1/22/2004 12:41'!
addVersion: aVersion
	| file |
	file := FileStream newFileNamed: (directory fullNameFor: aVersion fileName).
	aVersion fileOutOn: file.
	file close.! !

!MCDirectoryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'ab 7/6/2003 12:48'!
directory
	directory ifNil:
		[directory := FileDirectory default directoryNamed: 'mctest'.
		directory assureExistence].
	^ directory! !

!MCDirectoryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cmm 4/22/2011 16:54'!
setUp
	repository := MCDirectoryRepository directory: self directory! !

!MCDirectoryRepositoryTest methodsFor: 'as yet unclassified' stamp: 'ul 4/26/2011 05:28'!
tearDown

	super tearDown.
	self directory recursiveDelete! !

!MCRepositoryTest class methodsFor: 'as yet unclassified' stamp: 'ab 7/6/2003 12:45'!
isAbstract
	^ self = MCRepositoryTest! !

!MCRepositoryTest methodsFor: 'actions' stamp: 'ab 8/16/2003 17:46'!
addVersion: aVersion
	self subclassResponsibility ! !

!MCRepositoryTest methodsFor: 'actions' stamp: 'ab 8/16/2003 17:46'!
addVersionWithSnapshot: aSnapshot name: aString
	| version |
	version := self versionWithSnapshot: aSnapshot name: aString.
	self addVersion: version.
	^ version info! !

!MCRepositoryTest methodsFor: 'asserting' stamp: 'ab 7/19/2003 23:59'!
assertMissing: aVersionInfo
	self assert: (repository versionWithInfo: aVersionInfo) isNil! !

!MCRepositoryTest methodsFor: 'asserting' stamp: 'ab 8/16/2003 18:07'!
assertVersionInfos: aCollection
	self assert: repository allVersionInfos asSet = aCollection asSet! !

!MCRepositoryTest methodsFor: 'actions' stamp: 'ab 7/19/2003 16:20'!
saveSnapshot1
	^ self saveSnapshot: self snapshot1 named: 'rev1'! !

!MCRepositoryTest methodsFor: 'actions' stamp: 'ab 7/19/2003 16:20'!
saveSnapshot2
	^ self saveSnapshot: self snapshot2 named: 'rev2'! !

!MCRepositoryTest methodsFor: 'actions' stamp: 'ab 8/16/2003 17:45'!
saveSnapshot: aSnapshot named: aString
	| version |
	version := self versionWithSnapshot: aSnapshot name: aString.
	repository storeVersion: version.
	^ version info
	! !

!MCRepositoryTest methodsFor: 'building' stamp: 'ab 7/10/2003 01:03'!
snapshot1
	^ (MCSnapshot fromDefinitions: (Array with: (MCOrganizationDefinition categories: #('y'))))! !

!MCRepositoryTest methodsFor: 'building' stamp: 'ab 7/10/2003 01:03'!
snapshot2
	^ (MCSnapshot fromDefinitions: (Array with: (MCOrganizationDefinition categories: #('x'))))! !

!MCRepositoryTest methodsFor: 'accessing' stamp: 'ab 7/7/2003 14:32'!
snapshotAt: aVersionInfo
	^ (repository versionWithInfo: aVersionInfo) snapshot! !

!MCRepositoryTest methodsFor: 'tests' stamp: 'ab 8/16/2003 17:52'!
testAddAndLoad
	| node |
	node := self addVersionWithSnapshot: self snapshot1 name: 'rev1'.
	self assert: (self snapshotAt: node) = self snapshot1.
! !

!MCRepositoryTest methodsFor: 'tests' stamp: 'ul 3/24/2011 08:51'!
testCreationMethods
	"Tests creation via MCRepository>>location:"

	| repo |

	repo := MCRepository location: FileDirectory default pathName.
	self assert: (repo isKindOf: MCDirectoryRepository).
	self assert: (repo description = FileDirectory default pathName).

	repo := MCRepository location: (FileDirectory default pathName, FileDirectory slash, '*').
	self assert: (repo isKindOf: MCSubDirectoryRepository).
	"XXXX: MCSubDirectoryRepo prints wrongly on Windows"
	self assert: (repo description = (FileDirectory default pathName, FileDirectory slash, '*')).

	repo := MCRepository location: 'http://source.squeak.org/trunk'.
	self assert: (repo isKindOf: MCHttpRepository).
	self assert: (repo description = 'http://source.squeak.org/trunk').

	repo := MCRepository 
		location: 'ftp://source.squeak.org/trunk' 
		username: 'foo' 
		password: 'bar'.
	self assert: (repo isKindOf: MCFtpRepository).
	self assert: (repo description = 'ftp://foo@source.squeak.org/trunk').
! !

!MCRepositoryTest methodsFor: 'tests' stamp: 'avi 2/17/2004 03:24'!
testIncludesName
	self deny: (repository includesVersionNamed: 'MonticelloTest-xxx.1-rev1').
	self saveSnapshot1.
	self assert: (repository includesVersionNamed: 'MonticelloTest-xxx.1-rev1').
	self deny: (repository includesVersionNamed: 'MonticelloTest-xxx.1-rev2').
	self saveSnapshot2.
	self assert:  (repository includesVersionNamed: 'MonticelloTest-xxx.1-rev2').! !

!MCRepositoryTest methodsFor: 'tests' stamp: 'ab 7/19/2003 23:59'!
testLoadMissingNode
	| node |
	node := MCVersionInfo new.
	self assertMissing: node! !

!MCRepositoryTest methodsFor: 'tests' stamp: 'ab 7/7/2003 14:22'!
testStoreAndLoad
	| node node2 |
	node := self saveSnapshot1.
	node2 := self saveSnapshot2.
	self assert: (self snapshotAt: node) = self snapshot1.
	self assert: (self snapshotAt: node2) = self snapshot2.! !

!MCRepositoryTest methodsFor: 'building' stamp: 'avi 2/12/2004 21:01'!
versionWithSnapshot: aSnapshot name: aString
	| info |
	info := self mockVersionInfo: aString. 
	^ MCVersion 
		package: (MCPackage new name: aString)
		info: info
		snapshot: aSnapshot! !

MCTestCase subclass: #MCScannerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello'!

!MCScannerTest methodsFor: 'asserting' stamp: 'avi 1/22/2004 20:23'!
assertScans: anArray
	self assert: (MCScanner scan: anArray printString readStream) = anArray! !

!MCScannerTest methodsFor: 'tests' stamp: 'avi 1/22/2004 20:19'!
test1
	self assertScans: #(a '23' (x))! !

!MCScannerTest methodsFor: 'tests' stamp: 'avi 1/22/2004 20:22'!
test2
	self assertScans: 'it''s alive'! !

!MCScannerTest methodsFor: 'tests' stamp: 'avi 1/22/2004 20:23'!
test3
	self assert: (MCScanner scan: '(a #b c)' readStream) = #(a #b c)! !

!MCScannerTest methodsFor: 'tests' stamp: 'avi 1/22/2004 20:23'!
test4
	self assertScans: #(a '23' (x () ')''q' y12)).! !

!MCScannerTest methodsFor: 'tests' stamp: 'avi 1/22/2004 20:26'!
test5
	self assertScans: #((a) b)! !

!MCScannerTest methodsFor: 'tests' stamp: 'avi 1/22/2004 20:28'!
test6
	self should: [MCScanner scan: '(a b' readStream] raise: Error! !

MCTestCase subclass: #MCSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello'!

!MCSerializationTest methodsFor: 'asserting' stamp: 'cwp 8/8/2003 23:01'!
assertClass: readerClass providesServices: labels
	| services suffix |
	suffix := readerClass extension.
	self assert: (FileList isReaderNamedRegistered: readerClass name).
	services := readerClass fileReaderServicesForFile: 'foo' suffix: suffix.
	self assert: ((services collect: [:service | service buttonLabel]) includesAllOf: labels)! !

!MCSerializationTest methodsFor: 'asserting' stamp: 'avi 1/21/2004 22:57'!
assertDependenciesMatchWith: writerClass
	| stream readerClass expected actual |
	readerClass := writerClass readerClass.
	expected := self mockVersionWithDependencies.
	stream := RWBinaryOrTextStream on: String new.
	writerClass fileOut: expected on: stream.
	actual := (readerClass on: stream reset) dependencies.
	self assert: actual = expected dependencies.! !

!MCSerializationTest methodsFor: 'asserting' stamp: 'fbs 11/5/2013 22:58'!
assertExtensionProvidedBy: aClass
	"This shouldn't raise an exception."
	aClass readerClass extension.! !

!MCSerializationTest methodsFor: 'asserting' stamp: 'avi 2/17/2004 02:00'!
assertSnapshotsMatchWith: writerClass
	| readerClass expected stream actual |
	readerClass := writerClass readerClass.
	expected := self mockSnapshot.
	stream := RWBinaryOrTextStream on: String new.
	(writerClass on: stream) writeSnapshot: expected.
	actual := readerClass snapshotFromStream: stream reset.
	self assertSnapshot: actual matches: expected.! !

!MCSerializationTest methodsFor: 'asserting' stamp: 'ab 8/20/2003 20:22'!
assertVersionInfosMatchWith: writerClass
	| stream readerClass expected actual |
	readerClass := writerClass readerClass.
	expected := self mockVersion.
	stream := RWBinaryOrTextStream on: String new.
	writerClass fileOut: expected on: stream.
	actual := readerClass versionInfoFromStream: stream reset.
	self assert: actual = expected info.! !

!MCSerializationTest methodsFor: 'asserting' stamp: 'cwp 8/8/2003 15:02'!
assertVersionsMatchWith: writerClass
	| stream readerClass expected actual |
	readerClass := writerClass readerClass.
	expected := self mockVersion.
	stream := RWBinaryOrTextStream on: String new.
	writerClass fileOut: expected on: stream.
	actual := readerClass versionFromStream: stream reset.
	self assertVersion: actual matches: expected.! !

!MCSerializationTest methodsFor: 'mocks' stamp: 'cwp 11/6/2004 16:00'!
mockDiffyVersion
	| repos workingCopy base next |
	repos := MCDictionaryRepository new.
	workingCopy := MCWorkingCopy forPackage: self mockPackage.
	workingCopy repositoryGroup addRepository: repos.
	MCRepositoryGroup default removeRepository: repos.
	base := self mockVersion.
	repos storeVersion: base.
	self change: #a toReturn: 'a2'.
	next := self mockVersionWithAncestor: base.
	^ next asDiffAgainst: base	! !

!MCSerializationTest methodsFor: 'running' stamp: 'nice 5/25/2014 17:48'!
tearDown
	self restoreMocks.
	super tearDown.! !

!MCSerializationTest methodsFor: 'testing' stamp: 'nice 5/25/2014 16:39'!
testMcdSerialization
	| stream expected actual |
	<timeout: 30>
	expected := self mockDiffyVersion.
	stream := RWBinaryOrTextStream on: String new.
	MCMcdWriter fileOut: expected on: stream.
	actual := MCMcdReader versionFromStream: stream reset.
	self assertVersion: actual matches: expected.! !

!MCSerializationTest methodsFor: 'testing' stamp: 'nice 5/25/2014 16:14'!
testMczSerialization
	<timeout: 30>
	self assertVersionsMatchWith: MCMczWriter.
	self assertExtensionProvidedBy: MCMczWriter.
	self assertVersionInfosMatchWith: MCMczWriter.
	self assertDependenciesMatchWith: MCMczWriter.! !

!MCSerializationTest methodsFor: 'testing' stamp: 'cwp 8/3/2003 18:43'!
testStSerialization
	self assertSnapshotsMatchWith: MCStWriter.! !

MCTestCase subclass: #MCSnapshotBrowserTest
	instanceVariableNames: 'model morph originalAnnotationPanePref'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello'!

!MCSnapshotBrowserTest methodsFor: 'private' stamp: 'ul 9/14/2012 16:30'!
allCategories
	
	^{ 
		model extensionsCategory.
		self mockCategoryName },
		MCSnapshotResource mockPackage packageInfo systemCategories! !

!MCSnapshotBrowserTest methodsFor: 'private' stamp: 'cwp 7/14/2003 14:58'!
allMethods
	^ MCSnapshotResource current definitions
		select: [:def | def isMethodDefinition]
		thenCollect: [:def | def selector]		! !

!MCSnapshotBrowserTest methodsFor: 'private' stamp: 'cwp 7/14/2003 14:58'!
allProtocols
	^ MCSnapshotResource current definitions
		select: [:def | def isMethodDefinition]
		thenCollect: [:def | def category]		! !

!MCSnapshotBrowserTest methodsFor: 'morphic' stamp: 'cwp 7/28/2003 22:21'!
annotationTextMorph
	^ (self morphsOfClass: TextMorph) first! !

!MCSnapshotBrowserTest methodsFor: 'asserting' stamp: 'nice 5/8/2011 10:41'!
assertAListIncludes: anArrayOfStrings
	self assert: (self listMorphs 
			anySatisfy: [:m | m getList includesAllOf: anArrayOfStrings]).! !

!MCSnapshotBrowserTest methodsFor: 'asserting' stamp: 'nice 5/8/2011 10:42'!
assertAListMatches: strings
	| listMorphs |
	listMorphs := self listMorphs.
	self assert: (listMorphs 
		anySatisfy: [:m | | list |
			list := m getList. (list size = strings size) and: [list includesAllOf: strings]])! !

!MCSnapshotBrowserTest methodsFor: 'asserting' stamp: 'nice 5/8/2011 10:42'!
assertButtonExists: aString
	self assert: (self buttonMorphs anySatisfy: [:m | m label = aString])! !

!MCSnapshotBrowserTest methodsFor: 'asserting' stamp: 'cwp 7/13/2003 09:26'!
assertButtonOn: aString
	self assert: (self findButtonWithLabel: aString) getModelState.
	! !

!MCSnapshotBrowserTest methodsFor: 'asserting' stamp: 'cwp 7/13/2003 02:38'!
assertTextIs: aString
	self assert: self textMorph contents = aString.! !

!MCSnapshotBrowserTest methodsFor: 'morphic' stamp: 'kb 2/24/2010 21:57'!
buildWindow

	Smalltalk at: #ToolBuilder ifPresent: [:tb | 
		morph := tb build: model. 
		^self ].
	morph := model buildWindow.! !

!MCSnapshotBrowserTest methodsFor: 'morphic' stamp: 'cwp 7/13/2003 09:12'!
buttonMorphs
	^ self morphsOfClass: PluggableButtonMorph! !

!MCSnapshotBrowserTest methodsFor: 'private' stamp: 'cwp 7/13/2003 02:23'!
classABooleanMethods
	^ #(falsehood moreTruth truth)! !

!MCSnapshotBrowserTest methodsFor: 'private' stamp: 'cwp 8/10/2003 02:10'!
classAClassProtocols
	^ self protocolsForClass: self mockClassA class.! !

!MCSnapshotBrowserTest methodsFor: 'private' stamp: 'cwp 8/10/2003 02:10'!
classAComment
	^ self mockClassA organization classComment.! !

!MCSnapshotBrowserTest methodsFor: 'private' stamp: 'cwp 8/10/2003 02:10'!
classADefinitionString
	^ self mockClassA definition! !

!MCSnapshotBrowserTest methodsFor: 'private' stamp: 'cwp 8/10/2003 02:10'!
classAProtocols
	^ self protocolsForClass: self mockClassA.! !

!MCSnapshotBrowserTest methodsFor: 'simulating' stamp: 'cwp 7/13/2003 09:22'!
clickOnButton: aString
	(self findButtonWithLabel: aString) performAction.! !

!MCSnapshotBrowserTest methodsFor: 'simulating' stamp: 'cwp 7/13/2003 01:53'!
clickOnListItem: aString
	| listMorph |
	listMorph := self findListContaining: aString.
	listMorph changeModelSelection: (listMorph getList indexOf: aString).! !

!MCSnapshotBrowserTest methodsFor: 'private' stamp: 'cwp 7/14/2003 14:59'!
definedClasses
	^ MCSnapshotResource current definitions 
		select: [:def | def isClassDefinition] 
		thenCollect: [:def | def className].! !

!MCSnapshotBrowserTest methodsFor: 'asserting' stamp: 'nice 5/8/2011 10:40'!
denyAListHasSelection: aString
	self deny: (self listMorphs 
			anySatisfy: [:m | m selection = aString])! !

!MCSnapshotBrowserTest methodsFor: 'asserting' stamp: 'nice 5/8/2011 10:41'!
denyAListIncludesAnyOf: anArrayOfStrings
	self deny: (self listMorphs 
			anySatisfy: [:m | m getList includesAnyOf: anArrayOfStrings])! !

!MCSnapshotBrowserTest methodsFor: 'asserting' stamp: 'cwp 7/13/2003 09:27'!
denyButtonOn: aString
	self deny: (self findButtonWithLabel: aString) getModelState.
	! !

!MCSnapshotBrowserTest methodsFor: 'private' stamp: 'cwp 7/13/2003 02:53'!
falsehoodMethodSource
	^ 'falsehood
	^ false'! !

!MCSnapshotBrowserTest methodsFor: 'morphic' stamp: 'cwp 7/13/2003 09:19'!
findButtonWithLabel: aString
	^ self buttonMorphs detect: [:m | m label = aString]! !

!MCSnapshotBrowserTest methodsFor: 'morphic' stamp: 'cwp 7/13/2003 01:28'!
findListContaining: aString
	^ self listMorphs detect: [:m | m getList includes: aString]! !

!MCSnapshotBrowserTest methodsFor: 'morphic' stamp: 'cwp 7/13/2003 02:34'!
listMorphs
	^ self morphsOfClass: PluggableListMorph! !

!MCSnapshotBrowserTest methodsFor: 'morphic' stamp: 'cwp 7/14/2003 14:44'!
morphsOfClass: aMorphClass
	| morphs |
	morphs := OrderedCollection new.
	morph allMorphsDo: [:m | (m isKindOf: aMorphClass) ifTrue: [morphs add: m]].
	^ morphs! !

!MCSnapshotBrowserTest methodsFor: 'private' stamp: 'cwp 7/13/2003 13:15'!
protocolsForClass: aClass
	| protocols |
	protocols := aClass organization categories.
	protocols size > 1 ifTrue: [protocols := protocols copyWith: '-- all --'].
	^ protocols.! !

!MCSnapshotBrowserTest methodsFor: 'selecting' stamp: 'cwp 7/13/2003 13:04'!
selectMockClassA
	self clickOnListItem: self mockCategoryName.
	self clickOnListItem: 'MCMockClassA'.
	! !

!MCSnapshotBrowserTest methodsFor: 'running' stamp: 'topa 9/8/2015 00:25'!
setUp
	"to not disturb the tests"
	originalAnnotationPanePref := Preferences annotationPanes.
	Preferences disable: #annotationPanes.
	model := MCSnapshotBrowser forSnapshot: MCSnapshotResource current snapshot.
	self buildWindow! !

!MCSnapshotBrowserTest methodsFor: 'running' stamp: 'topa 9/8/2015 00:26'!
tearDown
	originalAnnotationPanePref ifTrue: [Preferences enable: #annotationPanes].
	super tearDown.! !

!MCSnapshotBrowserTest methodsFor: 'testing' stamp: 'kb 2/24/2010 21:58'!
testAnnotationPane
	| oldPref |
	oldPref := Preferences annotationPanes.

	Preferences disable: #annotationPanes.
	self buildWindow.
	self assert: (self morphsOfClass: TextMorph) size = 1.

	Preferences enable: #annotationPanes.
	self buildWindow.
	self assert: (self morphsOfClass: TextMorph) size = 2.

	Preferences setPreference: #annotationPanes toValue: oldPref! !

!MCSnapshotBrowserTest methodsFor: 'testing' stamp: 'cwp 7/13/2003 02:40'!
testCategorySelected
	self clickOnListItem: self mockCategoryName.
	
	self assertAListMatches: self allCategories.
	self assertAListMatches: self definedClasses.
	self denyAListIncludesAnyOf: self allProtocols.
	self denyAListIncludesAnyOf: self allMethods.
	self assertTextIs: ''.! !

!MCSnapshotBrowserTest methodsFor: 'testing' stamp: 'cwp 7/13/2003 13:04'!
testClassSelected
	self selectMockClassA.
	
	self assertAListMatches: self allCategories.
	self assertAListMatches: self definedClasses.
	self assertAListMatches: self classAProtocols.
	self denyAListIncludesAnyOf: self allMethods.
	self assertTextIs: self classADefinitionString.! !

!MCSnapshotBrowserTest methodsFor: 'testing' stamp: 'cwp 7/13/2003 13:06'!
testClassSideClassSelected
	self clickOnButton: 'class'.
	self selectMockClassA.
	
	self assertAListMatches: self allCategories.
	self assertAListMatches: self definedClasses.
	self assertAListMatches: self classAClassProtocols.
	self denyAListIncludesAnyOf: self allMethods.
	self assertTextIs: self classADefinitionString.! !

!MCSnapshotBrowserTest methodsFor: 'testing' stamp: 'cwp 7/13/2003 12:52'!
testComment
	self clickOnButton: '?'.
	self assertTextIs: ''.
	
	self clickOnListItem: self mockCategoryName.
	self assertTextIs: ''.
	
	self clickOnListItem: 'MCMockClassA'.
	self assertTextIs: self classAComment.! !

!MCSnapshotBrowserTest methodsFor: 'testing' stamp: 'cwp 7/13/2003 02:30'!
testFourColumns
	self assert: self listMorphs size = 4.! !

!MCSnapshotBrowserTest methodsFor: 'testing' stamp: 'cwp 7/13/2003 09:00'!
testMethodIsCleared
	self clickOnListItem: self mockCategoryName.
	self clickOnListItem: 'MCMockClassA'.
	self clickOnListItem: 'boolean'.
	self clickOnListItem: 'falsehood'.
	self clickOnListItem: '-- all --'.
	
	self denyAListHasSelection: 'falsehood'.! !

!MCSnapshotBrowserTest methodsFor: 'testing' stamp: 'cwp 7/13/2003 02:50'!
testMethodSelected
	self clickOnListItem: self mockCategoryName.
	self clickOnListItem: 'MCMockClassA'.
	self clickOnListItem: 'boolean'.
	self clickOnListItem: 'falsehood'.
	
	self assertAListMatches: self allCategories.
	self assertAListMatches: self definedClasses.
	self assertAListMatches: self classAProtocols.
	self assertAListMatches: self classABooleanMethods.
	self assertTextIs: self falsehoodMethodSource.! !

!MCSnapshotBrowserTest methodsFor: 'testing' stamp: 'tfel 8/28/2009 20:43'!
testNoSelection
	self assertAListMatches: self allCategories.
	self denyAListIncludesAnyOf: self definedClasses.
	self denyAListIncludesAnyOf: self allProtocols.
	self denyAListIncludesAnyOf: self allMethods.
	"and if there I need to see the packages scripts (or none)"
	self assertTextIs: '(package defines no scripts)'.! !

!MCSnapshotBrowserTest methodsFor: 'testing' stamp: 'cwp 7/13/2003 08:46'!
testProtocolIsCleared
	self clickOnListItem: self mockCategoryName.
	self clickOnListItem: 'MCMockASubclass'.
	self clickOnListItem: 'as yet unclassified'.
	self clickOnListItem: 'MCMockClassA'.
	
	self denyAListHasSelection: 'as yet unclassified'.! !

!MCSnapshotBrowserTest methodsFor: 'testing' stamp: 'cwp 7/13/2003 08:52'!
testProtocolSelected
	self clickOnListItem: self mockCategoryName.
	self clickOnListItem: 'MCMockClassA'.
	self clickOnListItem: 'boolean'.
	
	self assertAListMatches: self allCategories.
	self assertAListMatches: self definedClasses.
	self assertAListMatches: self classAProtocols.
	self assertAListMatches: self classABooleanMethods.
	self assertTextIs: ''.		! !

!MCSnapshotBrowserTest methodsFor: 'testing' stamp: 'fbs 11/5/2013 22:58'!
testTextPane
	"This shouldn't raise an exception."
	self textMorph.! !

!MCSnapshotBrowserTest methodsFor: 'testing' stamp: 'cwp 7/13/2003 09:14'!
testThreeButtons
	self assertButtonExists: 'instance'.
	self assertButtonExists: '?'.
	self assertButtonExists: 'class'.! !

!MCSnapshotBrowserTest methodsFor: 'morphic' stamp: 'cwp 7/28/2003 22:21'!
textMorph
	^ (self morphsOfClass: TextMorph) last! !

MCTestCase subclass: #MCSnapshotTest
	instanceVariableNames: 'snapshot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello'!

!MCSnapshotTest methodsFor: '*Tests-MonticelloMocks' stamp: 'ab 7/7/2003 23:21'!
mockClassExtension! !

!MCSnapshotTest methodsFor: 'running' stamp: 'ab 7/7/2003 13:38'!
setUp
	snapshot :=  self mockSnapshot.! !

!MCSnapshotTest methodsFor: 'tests' stamp: 'ab 7/7/2003 13:38'!
testCreation
	|d|
	d :=  self mockSnapshot definitions.
	self assert: (d anySatisfy: [:ea | ea isClassDefinition and: [ea className = #MCMockClassA]]).
	self assert: (d anySatisfy: [:ea | ea isMethodDefinition and: [ea selector = #mockClassExtension]]).
	self assert: (d allSatisfy: [:ea | ea isClassDefinition not or: [ea category endsWith: 'Mocks']]).
	! !

!MCSnapshotTest methodsFor: 'tests' stamp: 'ab 7/26/2003 02:14'!
testInstanceReuse
	| x m n y |
	x := (MCPackage new name: self mockCategoryName) snapshot.
	Smalltalk garbageCollect.
	n := MCDefinition allSubInstances size.
	y := (MCPackage new name: self mockCategoryName) snapshot.
	Smalltalk garbageCollect.
	m := MCDefinition allSubInstances size.
	self assert: m = n! !

MCTestCase subclass: #MCStReaderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello'!

!MCStReaderTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2003 23:35'!
commentWithStyle
	^ '!!AEDesc commentStamp: ''<historical>'' prior: 0!!
I represent an Apple Event Descriptor.  I am a low-level representation of Apple Event (and hence Applescript) information.  For further Information, see Apple''s Inside Macintosh: Interapplication Communications, at

	http://developer.apple.com/techpubs/mac/IAC/IAC-2.html.

Essentially, I represent a record comprising a one-word "string" (treating the word as fourbyte characters) representing a data type, followed by a pointer to a pointer (a handle) to the data I represent.  Care must be taken to assure that the Handle data is disposed after use, or memory leaks result.  At this time, I make no effort to do this automatically through finalization.!!
]style[(218 54 384)f1,f1Rhttp://developer.apple.com/techpubs/mac/IAC/IAC-2.html;,f1!!
'! !

!MCStReaderTest methodsFor: 'as yet unclassified' stamp: 'ab 8/17/2003 16:52'!
commentWithoutStyle
	^ '
CharacterScanner subclass: #CanvasCharacterScanner
	instanceVariableNames: ''canvas fillBlt foregroundColor runX lineY ''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''Morphic-Support''!!

!!CanvasCharacterScanner commentStamp: ''<historical>'' prior: 0!!
A displaying scanner which draws its output to a Morphic canvas.!!

!!CanvasCharacterScanner methodsFor: ''stop conditions'' stamp: ''ar 12/15/2001 23:27''!!
setStopConditions
	"Set the font and the stop conditions for the current run."

	self setFont.
	stopConditions
		at: Space asciiValue + 1
		put: (alignment = Justified ifTrue: [#paddedSpace])!! !!'! !

!MCStReaderTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2003 23:07'!
methodWithStyle
	^ '!!EventHandler methodsFor: ''copying'' stamp: ''tk 1/22/2001 17:39''!!
veryDeepInner: deepCopier
	"ALL fields are weakly copied.  Can''t duplicate an object by duplicating a button that activates it.  See DeepCopier."

	super veryDeepInner: deepCopier.
	"just keep old pointers to all fields"
	clickRecipient := clickRecipient.!!
]style[(25 108 10 111)f1b,f1,f1LDeepCopier Comment;,f1!! !!

'! !

!MCStReaderTest methodsFor: 'as yet unclassified' stamp: 'avi 1/20/2004 00:16'!
testCommentWithStyle
	| reader |
	reader := MCStReader on: self commentWithStyle readStream.
	reader definitions! !

!MCStReaderTest methodsFor: 'as yet unclassified' stamp: 'avi 1/20/2004 00:16'!
testCommentWithoutStyle
	| reader |
	reader := MCStReader on: self commentWithoutStyle readStream.
	self assert: (reader definitions anySatisfy: [:ea | ea isMethodDefinition]).! !

!MCStReaderTest methodsFor: 'as yet unclassified' stamp: 'avi 1/20/2004 00:16'!
testMethodWithStyle
	| reader |
	reader := MCStReader on: self methodWithStyle readStream.
	self assert: reader definitions first isMethodDefinition.! !

MCTestCase subclass: #MCStWriterTest
	instanceVariableNames: 'stream writer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello'!

!MCStWriterTest methodsFor: 'asserting' stamp: 'cwp 8/2/2003 12:13'!
assertAllChunksAreWellFormed
	stream reset.
	stream 
		untilEnd: [self assertChunkIsWellFormed: stream nextChunk]
		displayingProgress: 'Checking syntax...'! !

!MCStWriterTest methodsFor: 'asserting' stamp: 'nice 9/19/2013 23:15'!
assertChunkIsWellFormed: chunk
	self class newParser
		parse: chunk readStream 
		class: UndefinedObject 
		noPattern: true
		notifying: nil
		ifFail: [self assert: false]! !

!MCStWriterTest methodsFor: 'asserting' stamp: 'nk 2/22/2005 21:17'!
assertContentsOf: strm match: expected 
	| actual |
	actual := strm contents.
	self assert: actual size = expected size.
	actual with: expected do: [:a :e | self assert: a = e]! !

!MCStWriterTest methodsFor: 'asserting' stamp: 'nice 9/19/2013 23:15'!
assertMethodChunkIsWellFormed: chunk
	self class newParser
		parse: chunk readStream 
		class: UndefinedObject 
		noPattern: false
		notifying: nil
		ifFail: [self assert: false]! !

!MCStWriterTest methodsFor: 'data' stamp: 'ar 1/4/2010 18:03'!
expectedClassDefinitionA
 ^ '
MCMock subclass: #MCMockClassA
	instanceVariableNames: ''ivar''
	classVariableNames: ''CVar''
	poolDictionaries: ''''
	category: ''Tests-Monticello-Mocks''!!

!!MCMockClassA commentStamp: ''cwp 8/10/2003 16:43'' prior: 0!!
This is a mock class. The Monticello tests manipulated it to simulate a developer modifying code in the image.!!
'! !

!MCStWriterTest methodsFor: 'data' stamp: 'ar 1/4/2010 18:03'!
expectedClassDefinitionB
 ^ '
MCMock subclass: #MCMockClassB
	instanceVariableNames: ''ivarb''
	classVariableNames: ''CVar''
	poolDictionaries: ''MCMockAPoolDictionary''
	category: ''Tests-Monticello-Mocks''!!

MCMockClassB class
	instanceVariableNames: ''ciVar''!!

!!MCMockClassB commentStamp: '''' prior: 0!!
This comment has a bang!!!! Bang!!!! Bang!!!!!!
'! !

!MCStWriterTest methodsFor: 'data' stamp: 'cwp 8/2/2003 14:43'!
expectedClassMethodDefinition
	^ '
!!MCMockClassA class methodsFor: ''as yet unclassified'' stamp: ''ab 7/7/2003 23:21''!!
one

	^ 1!! !!
'! !

!MCStWriterTest methodsFor: 'testing' stamp: 'ab 8/8/2003 17:01'!
expectedInitializerA
	^ 'MCMockClassA initialize'! !

!MCStWriterTest methodsFor: 'data' stamp: 'cwp 8/2/2003 17:27'!
expectedMethodDefinition
	^ '
!!MCMockClassA methodsFor: ''numeric'' stamp: ''cwp 8/2/2003 17:26''!!
one
	^ 1!! !!
'! !

!MCStWriterTest methodsFor: 'data' stamp: 'ar 1/4/2010 18:09'!
expectedMethodDefinitionWithBangs
	^'
!!MCStWriterTest methodsFor: ''testing'' stamp: ''ar 1/4/2010 18:03''!!
methodWithBangs
	^ ''
	^ ReadStream on: 
''''MCRevisionInfo packageName: ''''MonticelloCompatibilityTest''''!!!!!!!!
MCOrganizationDeclaration categories: 
  #(
  ''''Tests-Monticello-Mocks'''')!!!!!!!!

MCClassDeclaration
  name: #MCMockClassD
  superclassName: #Object
  category: #''''Tests-Monticello-Mocks''''
  instVarNames: #()
  comment: ''''''''!!!!!!!!

MCMethodDeclaration className: #MCMockClassD selector: #one category: #''''as yet unclassified'''' timeStamp: ''''cwp 7/8/2003 21:21'''' source: 
''''one
	^ 1''''!!!!!!!!
''''
''
!! !!
'! !

!MCStWriterTest methodsFor: 'data' stamp: 'ul 9/11/2012 16:53'!
expectedOrganizationDefinition
	^ 'SystemOrganization addCategory: ''Tests-MonticelloMocks''!!
'! !

!MCStWriterTest methodsFor: 'testing' stamp: 'ar 1/4/2010 18:03'!
methodWithBangs
	^ '
	^ ReadStream on: 
''MCRevisionInfo packageName: ''MonticelloCompatibilityTest''!!!!
MCOrganizationDeclaration categories: 
  #(
  ''Tests-Monticello-Mocks'')!!!!

MCClassDeclaration
  name: #MCMockClassD
  superclassName: #Object
  category: #''Tests-Monticello-Mocks''
  instVarNames: #()
  comment: ''''!!!!

MCMethodDeclaration className: #MCMockClassD selector: #one category: #''as yet unclassified'' timeStamp: ''cwp 7/8/2003 21:21'' source: 
''one
	^ 1''!!!!
''
'
! !

!MCStWriterTest methodsFor: 'testing' stamp: 'cwp 8/2/2003 12:03'!
setUp
	stream := RWBinaryOrTextStream on: String new.
	writer := MCStWriter on: stream.
! !

!MCStWriterTest methodsFor: 'testing' stamp: 'ul 9/11/2012 16:55'!
tearDown

	SystemOrganizer default removeEmptyCategories.
	super tearDown	! !

!MCStWriterTest methodsFor: 'testing' stamp: 'cwp 8/10/2003 02:11'!
testClassDefinitionA
	writer visitClassDefinition: (self mockClassA asClassDefinition).
	self assertContentsOf: stream match: self expectedClassDefinitionA.
	stream reset.
	2 timesRepeat: [self assertChunkIsWellFormed: stream nextChunk]! !

!MCStWriterTest methodsFor: 'testing' stamp: 'cwp 9/14/2003 19:39'!
testClassDefinitionB
	writer visitClassDefinition: (self mockClassB asClassDefinition).
	self assertContentsOf: stream match: self expectedClassDefinitionB.
	! !

!MCStWriterTest methodsFor: 'testing' stamp: 'cwp 8/10/2003 02:11'!
testClassMethodDefinition
	writer visitMethodDefinition: (MethodReference class: self mockClassA class selector: #one) 									asMethodDefinition.
	self assertContentsOf: stream match: self expectedClassMethodDefinition.
	stream reset.
	self assert: stream nextChunk isAllSeparators.
	self assertChunkIsWellFormed: stream nextChunk.
	self assertMethodChunkIsWellFormed: stream nextChunk.
	self assert: stream nextChunk isAllSeparators ! !

!MCStWriterTest methodsFor: 'testing' stamp: 'avi 2/17/2004 01:50'!
testInitializerDefinition
	|chunk lastChunk|
	writer writeSnapshot: self mockSnapshot.
	stream reset.
	[stream atEnd] whileFalse:
		[chunk := stream nextChunk.
		chunk isAllSeparators ifFalse: [lastChunk := chunk]].
	self assertContentsOf: lastChunk readStream match: self expectedInitializerA! !

!MCStWriterTest methodsFor: 'testing' stamp: 'cwp 8/10/2003 02:11'!
testMethodDefinition
	writer visitMethodDefinition: (MethodReference class: self mockClassA selector: #one) 									asMethodDefinition.
	self assertContentsOf: stream match: self expectedMethodDefinition.
	stream reset.
	self assert: stream nextChunk isAllSeparators.
	self assertChunkIsWellFormed: stream nextChunk.
	self assertMethodChunkIsWellFormed: stream nextChunk.
	self assert: stream nextChunk isAllSeparators ! !

!MCStWriterTest methodsFor: 'testing' stamp: 'cwp 8/9/2003 14:52'!
testMethodDefinitionWithBangs
	writer visitMethodDefinition: (MethodReference 
									class: self class 
									selector: #methodWithBangs) asMethodDefinition.
	self assertContentsOf: stream match: self expectedMethodDefinitionWithBangs.
	stream reset.
	self assert: stream nextChunk isAllSeparators.
	self assertChunkIsWellFormed: stream nextChunk.
	self assertMethodChunkIsWellFormed: stream nextChunk.
	self assert: stream nextChunk isAllSeparators ! !

!MCStWriterTest methodsFor: 'testing' stamp: 'cwp 8/2/2003 12:13'!
testOrganizationDefinition
	| definition |
	definition := MCOrganizationDefinition categories: 
					(self mockPackage packageInfo systemCategories).
	writer visitOrganizationDefinition: definition.
	self assertContentsOf: stream match: self expectedOrganizationDefinition.
	self assertAllChunksAreWellFormed.! !

!MCTestCase class methodsFor: 'testing' stamp: 'cwp 7/14/2003 15:12'!
isAbstract
	^ self = MCTestCase! !

!MCTestCase class methodsFor: 'accessing' stamp: 'cwp 7/14/2003 15:05'!
resources
	^ Array with: MCSnapshotResource! !

!MCTestCase methodsFor: 'asserting' stamp: 'cwp 8/8/2003 14:58'!
assertPackage: actual matches: expected
	self assert: actual = expected
! !

!MCTestCase methodsFor: 'asserting' stamp: 'cwp 8/8/2003 23:25'!
assertSnapshot: actual matches: expected
	| diff |
	diff := actual patchRelativeToBase: expected.
	self assert: diff isEmpty
! !

!MCTestCase methodsFor: 'asserting' stamp: 'cwp 8/8/2003 14:58'!
assertVersion: actual matches: expected
	self assertPackage: actual package matches: expected package.	
	self assertVersionInfo: actual info matches: expected info.
	self assertSnapshot: actual snapshot matches: expected snapshot.! !

!MCTestCase methodsFor: 'asserting' stamp: 'cwp 8/8/2003 15:50'!
assertVersionInfo: actual matches: expected
	self assert: actual name = expected name.
	self assert: actual message = expected message.
	self assert: actual ancestors size = expected ancestors size.
	actual ancestors with: expected ancestors do: [:a :e | self assertVersionInfo: a matches: e]
	! !

!MCTestCase methodsFor: 'compiling' stamp: 'cwp 8/10/2003 02:12'!
change: aSelector toReturn: anObject
	self 
		compileClass: self mockClassA 
		source: aSelector, ' ^ ', anObject printString 
		category: 'numeric'! !

!MCTestCase methodsFor: 'running' stamp: 'ul 4/26/2011 05:26'!
clearPackageCache
	"Remove all mock packages created during the tests from the package cache."

	| directory |
	directory := MCCacheRepository default directory.
	(directory fileNamesMatching: self mockVersionName, '*') do: [ :each |
		directory deleteFileNamed: each ]! !

!MCTestCase methodsFor: 'mocks' stamp: 'cwp 8/10/2003 16:51'!
commentForClass: name
	^ 'This is a comment for ', name! !

!MCTestCase methodsFor: 'mocks' stamp: 'cwp 8/10/2003 16:53'!
commentStampForClass: name
	^ 'tester-', name,  ' 1/1/2000 00:00'! !

!MCTestCase methodsFor: 'compiling' stamp: 'abc 2/16/2006 09:24'!
compileClass: aClass source: source category: category
	aClass compileSilently: source classified: category! !

!MCTestCase methodsFor: 'mocks' stamp: 'ar 1/4/2010 18:02'!
mockCategoryName
	^ 'Tests-Monticello-Mocks'! !

!MCTestCase methodsFor: 'mocks' stamp: 'cwp 8/10/2003 16:50'!
mockClass: className super: superclassName
	^ MCClassDefinition
		name:  className
		superclassName:  superclassName
		category: self mockCategoryName
		instVarNames: #()
		classVarNames: #()
		poolDictionaryNames: #()
		classInstVarNames: #()
		type: #normal
		comment: (self commentForClass: className)
		commentStamp: (self commentStampForClass: className)! !

!MCTestCase methodsFor: 'mocks' stamp: 'cwp 8/10/2003 02:05'!
mockClassA
	^ Smalltalk at: #MCMockClassA! !

!MCTestCase methodsFor: 'mocks' stamp: 'cwp 9/14/2003 19:39'!
mockClassB
	^ Smalltalk at: #MCMockClassB! !

!MCTestCase methodsFor: 'mocks' stamp: 'avi 1/19/2004 15:54'!
mockDependencies
	^ Array with: (MCVersionDependency package: self mockEmptyPackage info: (self mockVersionInfo: 'x'))! !

!MCTestCase methodsFor: 'mocks' stamp: 'avi 2/22/2004 14:08'!
mockEmptyPackage
	^ MCPackage named: (MCEmptyPackageInfo new packageName)! !

!MCTestCase methodsFor: 'mocks' stamp: 'avi 2/22/2004 13:56'!
mockExtensionMethodCategory
	^ MCMockPackageInfo new methodCategoryPrefix.! !

!MCTestCase methodsFor: 'mocks' stamp: 'cwp 8/10/2003 02:06'!
mockInstanceA
	^ self mockClassA new! !

!MCTestCase methodsFor: 'mocks' stamp: 'cwp 7/30/2003 19:24'!
mockMessageString
	^ 'A version generated for testing purposes.'! !

!MCTestCase methodsFor: 'mocks' stamp: 'ab 4/1/2003 02:02'!
mockMethod: aSymbol class: className source: sourceString meta: aBoolean
	^ MCMethodDefinition
		className: className
		classIsMeta: aBoolean
		selector:  aSymbol
		category: 'as yet unclassified'
		timeStamp: ''
		source: sourceString! !

!MCTestCase methodsFor: 'mocks' stamp: 'cwp 11/13/2003 13:24'!
mockOverrideMethodCategory
	^ self mockExtensionMethodCategory, '-override'! !

!MCTestCase methodsFor: 'mocks' stamp: 'cwp 8/1/2003 20:27'!
mockPackage
	^ MCSnapshotResource mockPackage! !

!MCTestCase methodsFor: 'mocks' stamp: 'cwp 7/14/2003 15:07'!
mockSnapshot
	^ MCSnapshotResource current snapshot! !

!MCTestCase methodsFor: 'mocks' stamp: 'ab 1/15/2003 17:55'!
mockToken: aSymbol
	^ MCMockDefinition token: aSymbol! !

!MCTestCase methodsFor: 'mocks' stamp: 'cwp 7/30/2003 19:23'!
mockVersion
	^ MCVersion 
		package: self mockPackage
		info: self mockVersionInfo
		snapshot: self mockSnapshot! !

!MCTestCase methodsFor: 'mocks' stamp: 'avi 2/12/2004 19:58'!
mockVersionInfo
	^ self treeFrom: #(d ((b ((a))) (c)))! !

!MCTestCase methodsFor: 'mocks' stamp: 'avi 2/12/2004 21:01'!
mockVersionInfo: tag 
	^ MCVersionInfo
		name: self mockVersionName, '-', tag asString
		id: UUID new
		message: self mockMessageString, '-', tag asString
		date: Date today
		time: Time now
		author: Utilities authorInitials 
		ancestors: #()
! !

!MCTestCase methodsFor: 'mocks' stamp: 'cwp 11/6/2004 16:06'!
mockVersionInfoWithAncestor: aVersionInfo 
	^ MCVersionInfo
		name: aVersionInfo name, '-child'
		id: UUID new
		message: self mockMessageString
		date: Date today
		time: Time now
		author: Utilities authorInitials 
		ancestors: {aVersionInfo}
! !

!MCTestCase methodsFor: 'mocks' stamp: 'cwp 7/30/2003 19:25'!
mockVersionName
	^ 'MonticelloTest-xxx.1'! !

!MCTestCase methodsFor: 'mocks' stamp: 'nice 5/25/2014 17:05'!
mockVersionWithAncestor: aMCVersion 
	^ MCVersion
		package: self mockPackage
		info: (self mockVersionInfoWithAncestor: aMCVersion info)
		snapshot: self mockPackage snapshot! !

!MCTestCase methodsFor: 'mocks' stamp: 'avi 1/19/2004 15:15'!
mockVersionWithDependencies
	^ MCVersion 
		package: self mockPackage
		info: self mockVersionInfo
		snapshot: self mockSnapshot
		dependencies: self mockDependencies! !

!MCTestCase methodsFor: 'compiling' stamp: 'cwp 8/2/2003 15:05'!
restoreMocks
	self mockSnapshot updatePackage: self mockPackage! !

!MCTestCase methodsFor: 'running' stamp: 'ul 4/26/2011 05:25'!
tearDown

	self clearPackageCache! !

!MCTestCase methodsFor: 'mocks' stamp: 'avi 2/12/2004 20:00'!
treeFrom: anArray
	| name id |
	name := anArray first.
	id := '00000000-0000-0000-0000-0000000000', (name asString size = 1 ifTrue: [name asString, '0'] ifFalse: [name asString]).
	^ MCVersionInfo
		name: name
		id: (UUID fromString: id)
		message: ''
		date: nil
		time: nil
		author: ''
		ancestors: (anArray size > 1 ifTrue: [(anArray second collect: [:ea | self treeFrom: ea])] ifFalse: [#()])! !

MCTestCase subclass: #MCVersionNameTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello'!

!MCVersionNameTest methodsFor: 'as yet unclassified' stamp: 'bf 2/24/2012 15:30'!
allValidFixtures
	^ self standardFixtures , (self diffyFixtures pairsCollect: [:diffy :base | diffy])! !

!MCVersionNameTest methodsFor: 'as yet unclassified' stamp: 'bf 2/24/2012 16:17'!
diffyBranchFixtures
	^ #( 'Package.branch-author.123(origAuthor.122)' 'Package.branch-origAuthor.122'
		 'Package.branch-author.123(origAuthor.122).mcd' 'Package.branch-origAuthor.122.mcd'
		 'Package.branch-author.123(122)' 'Package.branch-author.122'
		 'Package.branch-author.123(@origPackage-origAuthor.122)' 'origPackage-origAuthor.122'
		 'Package-author.123(@origPackage.branch-origAuthor.122)' 'origPackage.branch-origAuthor.122'
	 ) collect:
		[ : each | each asMCVersionName ]! !

!MCVersionNameTest methodsFor: 'as yet unclassified' stamp: 'bf 2/24/2012 15:59'!
diffyFixtures
	^ #( 'Package-author.123(origAuthor.122)' 'Package-origAuthor.122'
		 'Package-author.123(origAuthor.122).mcd' 'Package-origAuthor.122.mcd'
		 'Package-author.123(122)' 'Package-author.122'
		 'Package-author.123(@origPackage-origAuthor.122)' 'origPackage-origAuthor.122'
	 ) collect:
		[ : each | each asMCVersionName ]! !

!MCVersionNameTest methodsFor: 'as yet unclassified' stamp: 'cmm 3/4/2011 13:13'!
invalidFixtures
	^ {String empty. 'abc'. '123' } collect: [ : each | each asMCVersionName ]! !

!MCVersionNameTest methodsFor: 'as yet unclassified' stamp: 'cmm 3/3/2011 14:33'!
standardFixtures
	^ #('Package-author.123' 'Package-author.123.mcz' ) collect:
		[ : each | each asMCVersionName ]! !

!MCVersionNameTest methodsFor: 'tests' stamp: 'cmm 3/4/2011 13:12'!
testAttributeAccess
	self allValidFixtures do: [ : each | self verifyPackageAuthorVersion: each ]! !

!MCVersionNameTest methodsFor: 'tests' stamp: 'bf 2/24/2012 16:22'!
testBranches
	| noBranch otherBranch withBranch |
	noBranch :=  'Package-author.123.mcz' asMCVersionName.
	withBranch := 'Package.branch-author.123.mcz' asMCVersionName.
	otherBranch := 'Package.other-author.123.mcz' asMCVersionName.
	self
		assert: 'Package' equals: noBranch packageName;
		assert: 'Package'  equals: withBranch packageName;
		assert: 'Package-author.123' equals: noBranch versionName;
		assert: 'Package.branch-author.123'  equals: withBranch versionName;
		assert: 'Package' equals: noBranch packageAndBranchName;
		assert: 'Package.branch' equals: withBranch packageAndBranchName;
		deny: noBranch = withBranch;
		deny: withBranch = noBranch;
		deny: withBranch = otherBranch.

! !

!MCVersionNameTest methodsFor: 'tests' stamp: 'bf 2/24/2012 16:16'!
testDiffyNames
	self diffyFixtures, self diffyBranchFixtures pairsDo: [ :diffy :base |
		self verifyDiffy: diffy base: base ]! !

!MCVersionNameTest methodsFor: 'tests' stamp: 'cmm 3/4/2011 13:12'!
testEquality
	| standard mc |
	standard := 'Package-author.123.mcz'.
	mc := standard asMCVersionName.
	self
		 assert: standard = mc ;
		 assert: mc = standard.
	self assert: self allValidFixtures asSet size = 1! !

!MCVersionNameTest methodsFor: 'tests' stamp: 'cmm 3/4/2011 13:13'!
testInvalid
	self assert: (self invalidFixtures noneSatisfy: [ : each | each isValid ])! !

!MCVersionNameTest methodsFor: 'tests' stamp: 'ul 3/28/2011 20:16'!
testSpecies

	self
		assert: ByteString equals: 'Package-author.123.mcz' asMCVersionName versionName class;
		assert: ByteString equals: 'Package-author.123' asMCVersionName versionName class! !

!MCVersionNameTest methodsFor: 'tests' stamp: 'ul 3/28/2011 20:26'!
testVersionNameReturnsAByteString

	#(
		'Package-author.123.mcz'
		'Package-author.123'
		'Package-author.123(122).mcd'
		'Package-author.123(author2.122).mcd') do: [ :each |
			self assert: ByteString equals: each asMCVersionName versionName class ]! !

!MCVersionNameTest methodsFor: 'as yet unclassified' stamp: 'bf 2/24/2012 15:36'!
verifyDiffy: diffyMCVersionName base: expectedBaseMCVersionName 
	self
		 assert: diffyMCVersionName baseVersionName = expectedBaseMCVersionName! !

!MCVersionNameTest methodsFor: 'as yet unclassified' stamp: 'bf 2/24/2012 15:14'!
verifyPackageAuthorVersion: aMCFileName 
	self
		 assert: aMCFileName versionName = 'Package-author.123';
		 assert: aMCFileName packageName = 'Package' ;
		 assert: aMCFileName versionNumber = 123 ;
		 assert: aMCFileName author = 'author' ;
		 assert: aMCFileName isValid! !

MCTestCase subclass: #MCVersionTest
	instanceVariableNames: 'version visited'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello'!

!MCVersionTest methodsFor: 'asserting' stamp: 'cwp 11/7/2004 14:32'!
assert: aSelector orders: sexpr as: array
	| expected |
	expected := OrderedCollection new.
	version := self versionFromTree: sexpr.
	version perform: aSelector with: [:ea | expected add: ea info name].
	self assert: expected asArray = array! !

!MCVersionTest methodsFor: 'asserting' stamp: 'md 9/6/2005 18:41'!
assert: aSelector orders: sexpr as: expected unresolved: unresolved
	| missing |
	missing := OrderedCollection new.
	version := self versionFromTree: sexpr.
	version 
		perform: aSelector 
		with: [:ea | visited add: ea info name]
		with: [:ea | missing add: ea name].
	self assert: visited asArray = expected.
	self assert: missing asArray = unresolved.! !

!MCVersionTest methodsFor: 'building' stamp: 'cwp 11/7/2004 12:29'!
dependencyFromTree: sexpr
	^ MCMockDependency fromTree: sexpr! !

!MCVersionTest methodsFor: 'running' stamp: 'cwp 11/7/2004 13:49'!
setUp
	visited := OrderedCollection new.! !

!MCVersionTest methodsFor: 'tests' stamp: 'cwp 11/7/2004 14:53'!
testAllAvailablePostOrder
	self 
		assert: #allAvailableDependenciesDo: 
		orders: #(a ((b (d e)) c)) 
		as: #(d e b c)! !

!MCVersionTest methodsFor: 'tests' stamp: 'cwp 11/7/2004 14:50'!
testAllMissing
	self 
		assert: #allDependenciesDo: 
		orders: #(a ((b (d e)) (c missing))) 
		as: #(d e b)! !

!MCVersionTest methodsFor: 'tests' stamp: 'cwp 11/7/2004 14:47'!
testAllUnresolved
	self 
		assert: #allDependenciesDo:ifUnresolved: 
		orders: #(a ((b (d e)) (c missing)))
		as: #(d e b)
		unresolved: #(c)! !

!MCVersionTest methodsFor: 'tests' stamp: 'cwp 11/7/2004 13:55'!
testDependencyOrder
	self 
		assert: #allDependenciesDo: 
		orders: #(a (b c)) 
		as: #(b c)! !

!MCVersionTest methodsFor: 'tests' stamp: 'cwp 11/7/2004 14:25'!
testPostOrder
	self 
		assert: #allDependenciesDo: 
		orders: #(a ((b (d e)) c)) 
		as: #(d e b c)! !

!MCVersionTest methodsFor: 'tests' stamp: 'cwp 11/7/2004 14:22'!
testWithAll
	self 
		assert: #withAllDependenciesDo: 
		orders: #(a ((b (d e)) c)) 
		as: #(d e b c a)! !

!MCVersionTest methodsFor: 'tests' stamp: 'cwp 11/7/2004 14:56'!
testWithAllMissing
	self 
		assert: #withAllDependenciesDo: 
		orders: #(a ((b (d e)) (c missing))) 
		as: #(d e b a)! !

!MCVersionTest methodsFor: 'tests' stamp: 'cwp 11/7/2004 14:29'!
testWithAllUnresolved
	self 
		assert: #withAllDependenciesDo:ifUnresolved: 
		orders: #(a ((b (d e)) (c missing)))
		as: #(d e b a)
		unresolved: #(c)! !

!MCVersionTest methodsFor: 'building' stamp: 'cwp 11/7/2004 12:40'!
versionFromTree: sexpr
	^ (self dependencyFromTree: sexpr) resolve! !

MCTestCase subclass: #MCWorkingCopyRenameTest
	instanceVariableNames: 'savedInitials workingCopy repositoryGroup versions versions2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello'!

!MCWorkingCopyRenameTest methodsFor: 'running' stamp: 'kb 9/14/2012 14:30'!
mockPackage

	^MCPackage new name: self mockCategoryName! !

!MCWorkingCopyRenameTest methodsFor: 'running' stamp: 'kb 9/14/2012 14:32'!
setUp
	| repos1 repos2 |
	repositoryGroup := MCRepositoryGroup new.
	workingCopy := MCWorkingCopy forPackage: self mockPackage.
	versions := Dictionary new.
	versions2 := Dictionary new.
	repos1 := MCDictionaryRepository new dictionary: versions.
	repos2 := MCDictionaryRepository new dictionary: versions2.
	repositoryGroup addRepository: repos1.
	repositoryGroup addRepository: repos2.
	MCRepositoryGroup default removeRepository: repos1; removeRepository: repos2.
	workingCopy repositoryGroup: repositoryGroup.
	savedInitials := Utilities authorInitialsPerSe.
	Utilities setAuthorInitials: 'abc'.! !

!MCWorkingCopyRenameTest methodsFor: 'running' stamp: 'abc 9/14/2012 15:02'!
tearDown
	super tearDown.
	workingCopy unregister.
	SystemOrganizer default removeEmptyCategories.
	MCSnapshotTest organization removeEmptyCategories.
	Utilities setAuthorInitials: savedInitials! !

!MCWorkingCopyRenameTest methodsFor: 'tests' stamp: 'kb 9/14/2012 14:26'!
testRenamePrefix

	self verifyRenameTo: 'Renamed-' , workingCopy packageName! !

!MCWorkingCopyRenameTest methodsFor: 'tests' stamp: 'kb 9/14/2012 14:26'!
testRenameSuffix

	self verifyRenameTo: workingCopy packageName, '-Renamed'! !

!MCWorkingCopyRenameTest methodsFor: 'tests' stamp: 'kb 9/14/2012 15:19'!
verifyRenameTo: newName 
	
	| oldWorkingCopy oldDefinitions newWorkingCopy |
	oldWorkingCopy := workingCopy.
	oldDefinitions := workingCopy package snapshot definitions.
	[ 
		newWorkingCopy := workingCopy renameToBe: newName.
		self
			 assert: oldWorkingCopy ancestors = newWorkingCopy ancestors ;
			 assert: newWorkingCopy needsSaving ;
			 assert: newWorkingCopy requiredPackages = oldWorkingCopy requiredPackages ;
			 assert: newWorkingCopy repositoryGroup repositories = oldWorkingCopy repositoryGroup repositories ;
			 assert: newWorkingCopy package snapshot definitions size = oldDefinitions size ;
			 assert: (MCWorkingCopy registry includesKey: newWorkingCopy package) ;
			 assert: (MCWorkingCopy registry includes: newWorkingCopy) ;
			 deny: (MCWorkingCopy registry includes: oldWorkingCopy).
		workingCopy := newWorkingCopy ] ensure: [ 
			" ensure that we rename the category back to the original name "
			(SystemOrganizer default categories includes: newName) ifTrue: [
				SystemOrganizer default
					renameCategory: newName
					toBe: oldWorkingCopy packageName ] ]! !

MCTestCase subclass: #MCWorkingCopyTest
	instanceVariableNames: 'savedInitials workingCopy repositoryGroup versions versions2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello'!

!MCWorkingCopyTest methodsFor: 'asserting' stamp: 'abc 9/5/2014 21:05'!
assertNameWhenSavingTo: aRepository is: aString
	| name |
	name := nil.
	[aRepository storeVersion: workingCopy newVersion]
		on: MCVersionNameAndMessageRequest
		do: [:n | 
			n patchBlock value.
			name := n suggestedName. n resume: (Array with: name with: '' with: Set new)].
	self assert: name = aString! !

!MCWorkingCopyTest methodsFor: 'asserting' stamp: 'abc 9/5/2014 21:05'!
assertNumberWhenSavingTo: aRepository is: aNumber
	| name |
	name := nil.
	[aRepository storeVersion: workingCopy newVersion]
		on: MCVersionNameAndMessageRequest
		do: [:n | 
			n patchBlock value.
			name := n suggestedName. n resume: (Array with: name with: '' with: Set new)].
	self assert: name = (self packageName, '-', Utilities authorInitials, '.', aNumber asString)! !

!MCWorkingCopyTest methodsFor: 'actions' stamp: 'avi 2/13/2004 14:30'!
basicMerge: aVersion
	aVersion merge! !

!MCWorkingCopyTest methodsFor: 'running' stamp: 'ul 4/26/2011 05:27'!
clearPackageCache
	"Remove all mock packages created during the tests from the package cache."

	| directory |
	super clearPackageCache.
	directory := MCCacheRepository default directory.
	(directory fileNamesMatching: self packageName, '*') do: [ :each |
		directory deleteFileNamed: each ]! !

!MCWorkingCopyTest methodsFor: 'accessing' stamp: 'ab 7/7/2003 18:02'!
description
	^ self class name! !

!MCWorkingCopyTest methodsFor: 'actions' stamp: 'avi 1/24/2004 20:13'!
load: aVersion
	aVersion load! !

!MCWorkingCopyTest methodsFor: 'actions' stamp: 'jf 8/21/2003 20:22'!
merge: aVersion
	[[self basicMerge: aVersion]
		on: MCMergeResolutionRequest do: [:n | n resume: true]]
			on: MCNoChangesException do: [:n | ]! !

!MCWorkingCopyTest methodsFor: 'private' stamp: 'cwp 8/2/2003 15:03'!
packageName
	^ self mockPackage name! !

!MCWorkingCopyTest methodsFor: 'running' stamp: 'cmm 6/8/2011 13:12'!
setUp
	| repos1 repos2 |
	self clearPackageCache.
	repositoryGroup := MCRepositoryGroup new.
	workingCopy := MCWorkingCopy forPackage: self mockPackage.
	versions := Dictionary new.
	versions2 := Dictionary new.
	repos1 := MCDictionaryRepository new dictionary: versions.
	repos2 := MCDictionaryRepository new dictionary: versions2.
	repositoryGroup addRepository: repos1.
	repositoryGroup addRepository: repos2.
	MCRepositoryGroup default removeRepository: repos1; removeRepository: repos2.
	workingCopy repositoryGroup: repositoryGroup.
	savedInitials := Utilities authorInitialsPerSe.
	Utilities setAuthorInitials: 'abc'.! !

!MCWorkingCopyTest methodsFor: 'actions' stamp: 'abc 9/5/2014 21:05'!
snapshot
	| version |
	[version := workingCopy newVersion]
		on: MCVersionNameAndMessageRequest
		do: [:n | 
			n patchBlock value.
			n resume: (Array with: n suggestedName with: '' with: Set new)].
	versions at: version info put: version.
	^ version! !

!MCWorkingCopyTest methodsFor: 'running' stamp: 'cmm 6/8/2011 14:33'!
tearDown
	super tearDown.
	workingCopy unregister.
	self restoreMocks.
	SystemOrganizer default removeEmptyCategories.
	MCSnapshotTest organization removeEmptyCategories.
	Utilities setAuthorInitials: savedInitials! !

!MCWorkingCopyTest methodsFor: 'tests' stamp: 'abc 3/14/2015 23:38'!
testAncestorMerge
	<timeout: 30 "seconds">
	| base revA revB revC |

	base := self snapshot.
	self change: #a toReturn: 'a1'.
	revA :=  self snapshot.
	self change: #b toReturn: 'b1'.
	revB :=  self snapshot.	
	self change: #c toReturn: 'c1'.
	revC :=  self snapshot.	

	self should: [self basicMerge: revA] raise: MCNoChangesException.
	! !

!MCWorkingCopyTest methodsFor: 'tests' stamp: 'abc 3/14/2015 23:38'!
testBackport
	<timeout: 30 "seconds">
	| inst base final backported |
	inst := self mockInstanceA.
	base :=  self snapshot.
	self assert: inst one = 1.
	self change: #one toReturn: 2.
	self change: #two toReturn: 3.
	final := self snapshot.
	[workingCopy backportChangesTo: base info]
		on: MCChangeSelectionRequest
		do: [:e | e resume: e patch].
	self assert: inst one = 2.
	self assert: inst two = 3.
	self assert: workingCopy ancestry ancestors size = 1.
	self assert: workingCopy ancestry ancestors first = base info.
	self assert: workingCopy ancestry stepChildren size = 1.
	self assert: workingCopy ancestry stepChildren first = final info.
	backported := self snapshot.
	[workingCopy backportChangesTo: base info]
		on: MCChangeSelectionRequest
		do: [:e | e resume: e patch].
	self assert: workingCopy ancestry ancestors size = 1.
	self assert: workingCopy ancestry ancestors first = base info.
	self assert: workingCopy ancestry stepChildren size = 1.
	self assert: workingCopy ancestry stepChildren first = backported info.
	! !

!MCWorkingCopyTest methodsFor: 'tests' stamp: 'fbs 11/5/2013 22:58'!
testDoubleRepeatedMerge
	| base motherA1 motherA2 motherB1 motherB2 inst |
	<timeout: 30> "takes a little longer"
	base := self snapshot.
	self change: #a toReturn: 'a1'.
	motherA1 :=  self snapshot.
	self change: #c toReturn: 'c1'.
	motherA2 :=  self snapshot.	
	
	self load: base.
	self change: #b toReturn: 'b1'.
	motherB1 :=  self snapshot.
	self change: #d toReturn: 'd1'.
	motherB2 :=  self snapshot.
	
	self load: base.
	self merge: motherA1.
	self merge: motherB1.
	self change: #a toReturn: 'a2'.
	self change: #b toReturn: 'b2'.
	self snapshot.

	self merge: motherA2.
	self merge: motherB2.
	
	inst := self mockInstanceA.
	self assert: inst a = 'a2'.
	self assert: inst b = 'b2'.
	self assert: inst c = 'c1'.
	self assert: inst d = 'd1'.
	! !

!MCWorkingCopyTest methodsFor: 'tests' stamp: 'abc 3/14/2015 23:37'!
testMergeIntoImageWithNoChanges
	<timeout: 30 "seconds">
	| base revB revA1 |

	self change: #a toReturn: 'a'.
	base := self snapshot.
	self change: #b toReturn: 'b'.
	revB := self snapshot.
	
	self load: base.
	self change: #a toReturn: 'a1'.
	revA1 := self snapshot.

	self change: #a toReturn: 'a'.
	self snapshot.
	self merge: revB.

	self assert: (workingCopy ancestors size = 2)
	! !

!MCWorkingCopyTest methodsFor: 'tests' stamp: 'abc 3/14/2015 23:37'!
testMergeIntoUnmodifiedImage
	| base revA |

	<timeout: 30 "seconds">
	base := self snapshot.
	self change: #a toReturn: 'a1'.
	revA := self snapshot.
	
	self load: base.

	self merge: revA.

	self assert: (workingCopy ancestors size = 1)
	! !

!MCWorkingCopyTest methodsFor: 'tests' stamp: 'abc 3/14/2015 23:39'!
testOptimizedLoad
	<timeout: 30 "seconds">
	| inst base diffy |
	inst := self mockInstanceA.
	base := self snapshot.
	self change: #one toReturn: 2.
	self assert: inst one = 2.
	diffy := self snapshot asDiffAgainst: base.
	self deny: diffy canOptimizeLoading.
	self load: base.
	self assert: inst one = 1.
	self assert: diffy canOptimizeLoading.
	self load: diffy.
	self assert: inst one = 2.
! !

!MCWorkingCopyTest methodsFor: 'tests' stamp: 'fbs 11/5/2013 22:59'!
testRedundantMerge
	| base |
	base :=  self snapshot.
	self merge: base.
	
	"This shouldn't throw an exception"
	self merge: base.! !

!MCWorkingCopyTest methodsFor: 'tests' stamp: 'fbs 11/5/2013 22:59'!
testRepeatedMerge
	| base mother1 mother2 inst |
	<timeout: 30> "takes a little longer"
	base :=  self snapshot.
	self change: #one toReturn: 2.
	mother1 :=  self snapshot.
	self change: #two toReturn: 3.
	mother2 :=  self snapshot.	
	
	self load: base.
	self change: #truth toReturn: false.
	self snapshot.

	inst := self mockInstanceA.
	self assert: inst one = 1.
	self assert: inst two = 2.	

	self merge: mother1.
	self assert: inst one = 2.
	self assert: inst two = 2.	
	
	self change: #one toReturn: 7.
	self assert: inst one = 7.
	self assert: inst two = 2.
	
	"This shouldn't raise an exception"
	self merge: mother2.
	self assert: inst one = 7.
	self assert: inst two = 3.! !

!MCWorkingCopyTest methodsFor: 'tests' stamp: 'abc 3/14/2015 23:40'!
testSelectiveBackport
	<timeout: 30 "seconds">
	| inst base intermediate final |
	inst := self mockInstanceA.
	base :=  self snapshot.
	self assert: inst one = 1.
	self change: #one toReturn: 2.
	intermediate := self snapshot.
	self change: #two toReturn: 3.
	final := self snapshot.
	[workingCopy backportChangesTo: base info]
		on: MCChangeSelectionRequest
		do: [:e | | selected patch |
			patch := e patch.
			selected := patch operations select: [:ea | ea definition selector = #two].
			e resume: (MCPatch operations: selected)]. 
	self assert: inst one = 1.
	self assert: inst two = 3.
	self assert: workingCopy ancestry ancestors size = 1.
	self assert: workingCopy ancestry ancestors first = base info.
	self assert: workingCopy ancestry stepChildren size = 1.
	self assert: workingCopy ancestry stepChildren first = final info! !

!MCWorkingCopyTest methodsFor: 'tests' stamp: 'abc 3/14/2015 23:40'!
testSimpleMerge
	<timeout: 30 "seconds">
	| mother base inst |
	inst := self mockInstanceA.
	base :=  self snapshot.
	self change: #one toReturn: 2.
	mother :=  self snapshot.
	self load: base.
	self change: #two toReturn: 3.
	self snapshot.
	self assert: inst one = 1.
	self assert: inst two = 3.
	
	self merge: mother.
	self assert: inst one = 2.
	self assert: inst two = 3.! !

!MCWorkingCopyTest methodsFor: 'tests' stamp: 'cwp 8/10/2003 02:14'!
testSnapshotAndLoad
	| base inst |
	inst := self mockInstanceA.
	base :=  self snapshot.
	self change: #one toReturn: 2.
	self assert: inst one = 2.
	self load: base.
	self assert: inst one = 1.! !

TestCase subclass: #MacFileDirectoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Files'!

!MacFileDirectoryTest methodsFor: 'test' stamp: 'sd 10/27/2003 18:05'!
testMacFileDirectory
	"(self run: #testMacFileDirectory)"
	
	"This fails before the the fix if the Squeak directory is on the root
	directory like: 'HardDisk:Squeak'
	But should work both before and after the fix of John if there is several
	directories in the hieracry: HardDisk:User:Squeak"
	"If somebody can find a way to make the test failed all the time when the fix is not 
	present we should replace it"

	self assert: (FileDirectory default fullName) = (FileDirectory default fullNameFor: (FileDirectory default fullName))! !

!MacFileDirectoryTest methodsFor: 'test' stamp: 'kfr 7/28/2004 15:06'!
testMacIsAbsolute
	"(self selector: #testMacIsAbsolute) run"
	
	
	self deny: (MacFileDirectory isAbsolute: 'Volumes').
	self assert: (MacFileDirectory isAbsolute: 'Volumes:Data:Stef').
	self deny: (MacFileDirectory isAbsolute: ':Desktop:test.st')! !

!MacFileDirectoryTest methodsFor: 'test' stamp: 'sd 10/27/2003 18:02'!
testMakeAbsolute

	self assert: (MacFileDirectory isAbsolute: (MacFileDirectory makeAbsolute: 'Data')).
	self assert: (MacFileDirectory isAbsolute: (MacFileDirectory makeAbsolute: ':Data')).
! !

TestCase subclass: #MirrorPrimitiveTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Compiler'!

!MirrorPrimitiveTests methodsFor: 'testing' stamp: 'dtl 9/23/2012 09:47'!
expectedFailures
	"All versions of Cog provide mirror primitive support. For the interpreter VM,
	support was added in version 4.7.19. Identify expected failures for older versions
	of the interpreter VM."

	^Smalltalk isRunningCog
		ifTrue: [#()]
		ifFalse: [ | ver |
			[ver := VersionNumber fromString: Smalltalk vm interpreterSourceVersion.
			((ver numbers first * 1000) + ver numbers second) >= 4008
				ifTrue: [^#() "version 4.7.19 or greater with mirror primitive support"]]
					on: Warning
					do: ["primitiveInterpreterSourceVersion not available"].
			^#(testMirrorEqEq testMirrorPerform testMirrorSize) "older interpreter VMs"]
! !

!MirrorPrimitiveTests methodsFor: 'tests' stamp: 'eem 5/8/2009 09:52'!
testMirrorAt
	| stackpBefore stackpAfter array byteArray |
	stackpBefore := thisContext stackPtr.
	array := { 1. 2. 3 }.
	byteArray := ByteArray with: 1 with: 2 with: 3.
	self assert: (thisContext object: array basicAt: 1) = 1.
	self assert: (thisContext object: byteArray basicAt: 2) = 2.
	thisContext object: array basicAt: 2 put: #two.
	self assert: array = #(1 #two 3).
	thisContext object: byteArray basicAt: 2 put: 222.
	self assert: byteArray asArray = #(1 222 3).
	stackpAfter := thisContext stackPtr.
	self assert: stackpBefore = stackpAfter. "Make sure primitives pop all their arguments"
	self should: [thisContext object: array basicAt: 4] raise: Error.
	self should: [thisContext object: byteArray basicAt: 0] raise: Error.
	self should: [thisContext object: byteArray basicAt: 1 put: -1] raise: Error! !

!MirrorPrimitiveTests methodsFor: 'tests' stamp: 'eem 4/8/2009 19:44'!
testMirrorClass
	| stackpBefore stackpAfter |
	stackpBefore := thisContext stackPtr.
	self assert: (thisContext objectClass: Array new) = Array.
	self assert: (thisContext objectClass: 1) = 1 class.
	self assert: (thisContext objectClass: ProtoObject new) = ProtoObject.
	stackpAfter := thisContext stackPtr.
	self assert: stackpBefore = stackpAfter "Make sure primitives pop all their arguments"! !

!MirrorPrimitiveTests methodsFor: 'tests' stamp: 'eem 5/8/2009 09:54'!
testMirrorEqEq
	| stackpBefore stackpAfter |
	stackpBefore := thisContext stackPtr.
	self assert: (thisContext object: Array new eqeq: Array new) == false.
	self assert: (thisContext object: Array eqeq: Array) == true.
	stackpAfter := thisContext stackPtr.
	self assert: stackpBefore = stackpAfter "Make sure primitives pop all their arguments"! !

!MirrorPrimitiveTests methodsFor: 'tests' stamp: 'eem 4/8/2009 22:45'!
testMirrorInstVarAt
	| stackpBefore stackpAfter array point |
	stackpBefore := thisContext stackPtr.
	array := { 1. 2. 3 }.
	point := Point x: 1 y: 2.
	self assert: (thisContext object: array instVarAt: 1) = 1.
	self assert: (thisContext object: point instVarAt: 2) = 2.
	thisContext object: array instVarAt: 2 put: #two.
	self assert: array = #(1 #two 3).
	thisContext object: point instVarAt: 1 put: 1/2.
	self assert: point = (Point x: 1 / 2 y: 2).
	stackpAfter := thisContext stackPtr.
	self assert: stackpBefore = stackpAfter. "Make sure primitives pop all their arguments"
	self should: [thisContext object: array instVarAt: 4] raise: Error.
	self should: [thisContext object: point instVarAt: 3] raise: Error! !

!MirrorPrimitiveTests methodsFor: 'tests' stamp: 'eem 5/12/2009 21:17'!
testMirrorPerform
	| stackpBefore stackpAfter anInterval |
	stackpBefore := thisContext stackPtr.
	anInterval := 1 to: 2.
	self assert: (thisContext object: anInterval perform:# species withArguments: #() inClass: Interval) == Array.
	self assert: (thisContext object: anInterval perform:# species withArguments: #() inClass: Interval superclass) == Interval.
	self should: [thisContext object: anInterval perform:# species withArguments: #() inClass: Point]
		raise: Error.
	self should: [thisContext object: anInterval perform:# species withArguments: OrderedCollection new inClass: Interval]
		raise: Error.
	stackpAfter := thisContext stackPtr.
	self assert: stackpBefore = stackpAfter "Make sure primitives pop all their arguments"! !

!MirrorPrimitiveTests methodsFor: 'tests' stamp: 'eem 4/8/2009 22:50'!
testMirrorSize
	| stackpBefore stackpAfter |
	stackpBefore := thisContext stackPtr.
	self assert: (thisContext objectSize: #(1 2 3)) = 3.
	self assert: (thisContext objectSize: '123') = 3.
	self assert: (thisContext objectSize: nil) = 0.
	self assert: (thisContext objectSize: 1) = 0.
	stackpAfter := thisContext stackPtr.
	self assert: stackpBefore = stackpAfter. "Make sure primitives pop all their arguments"! !

TestCase subclass: #NamePolicyTest
	instanceVariableNames: 'policy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Environments'!

NamePolicyTest subclass: #AddPrefixNamePolicyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Environments'!

!AddPrefixNamePolicyTest methodsFor: 'running' stamp: 'cwp 3/3/2013 13:20'!
createPolicy
	^ AddPrefixNamePolicy prefix: 'XX'! !

!AddPrefixNamePolicyTest methodsFor: 'tests' stamp: 'cwp 3/3/2013 14:13'!
testAddsPrefix
	self assertIncludes: #Griffle as: #XXGriffle.
	! !

!AddPrefixNamePolicyTest methodsFor: 'tests' stamp: 'cwp 3/3/2013 14:19'!
testDoesntDuplicatePrefix
	self denyIncludes: #XXGriffle! !

NamePolicyTest subclass: #AllNamePolicyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Environments'!

!AllNamePolicyTest methodsFor: 'running' stamp: 'cwp 2/19/2013 21:14'!
createPolicy
	^ AllNamePolicy new! !

!AllNamePolicyTest methodsFor: 'tests' stamp: 'cwp 2/24/2013 20:29'!
testPassesName
	self assertIncludes: #Griffle ! !

NamePolicyTest subclass: #ExplicitNamePolicyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Environments'!

!ExplicitNamePolicyTest methodsFor: 'running' stamp: 'cwp 3/1/2013 10:11'!
createPolicy
	^ ExplicitNamePolicy spec: #Griffle -> #Plonk! !

!ExplicitNamePolicyTest methodsFor: 'tests' stamp: 'cwp 3/3/2013 13:28'!
testAssociationSpec
	policy := ExplicitNamePolicy spec: #Griffle -> #Plonk.
	self assertIncludes: #Griffle as: #Plonk! !

!ExplicitNamePolicyTest methodsFor: 'tests' stamp: 'cwp 3/3/2013 13:28'!
testDictionarySpec
	| aliases |
	aliases := IdentityDictionary new
		at: #Griffle put: #Plonk;
		yourself.
	policy := ExplicitNamePolicy spec: aliases.
	self assertIncludes: #Griffle as: #Plonk! !

!ExplicitNamePolicyTest methodsFor: 'tests' stamp: 'cwp 2/19/2013 21:34'!
testDoesntIncludeOriginal
	self denyIncludes: #Plonk ! !

!ExplicitNamePolicyTest methodsFor: 'tests' stamp: 'cwp 2/19/2013 21:34'!
testDoesntIncludeOther
	self denyIncludes: #Nurp ! !

!ExplicitNamePolicyTest methodsFor: 'tests' stamp: 'cwp 3/3/2013 13:28'!
testMixedSpec
	policy := ExplicitNamePolicy spec: {#Nurp. #Griffle->#Plonk. #(Ziffy)}.
	self assertIncludes: #Griffle as: #Plonk.
	self assertIncludes: #Nurp.
	self assertIncludes: #Ziffy.! !

!ExplicitNamePolicyTest methodsFor: 'tests' stamp: 'cwp 3/1/2013 10:07'!
testPolicySpec
	| again |
	policy := ExplicitNamePolicy spec: #Griffle.
	again := ExplicitNamePolicy spec: policy.
	self assert: policy == again! !

!ExplicitNamePolicyTest methodsFor: 'tests' stamp: 'cwp 3/1/2013 10:12'!
testSymbolSpec
	policy := ExplicitNamePolicy spec: #Griffle.
	self assertIncludes: #Griffle! !

!ExplicitNamePolicyTest methodsFor: 'tests' stamp: 'cwp 3/3/2013 13:28'!
testTransformsName
	self assertIncludes: #Griffle as: #Plonk.! !

!NamePolicyTest class methodsFor: 'as yet unclassified' stamp: 'cwp 4/1/2013 22:06'!
isAbstract
	^ self name = #NamePolicyTest! !

!NamePolicyTest methodsFor: 'asserting' stamp: 'cwp 3/3/2013 13:27'!
assertIncludes: foreignName 
	^ self assertIncludes: foreignName as: foreignName! !

!NamePolicyTest methodsFor: 'asserting' stamp: 'cwp 3/3/2013 13:28'!
assertIncludes: localName as: foreignName
	| actual |
	policy name: localName do: [:foreign | actual := foreign].
	self assert: actual = foreignName! !

!NamePolicyTest methodsFor: 'asserting' stamp: 'cwp 2/19/2013 21:17'!
denyIncludes: localName 
	| actual |
	policy name: localName do: [:foreign | actual := foreign].
	self assert: actual isNil! !

!NamePolicyTest methodsFor: 'running' stamp: 'cwp 2/19/2013 21:14'!
setUp
	policy := self createPolicy! !

NamePolicyTest subclass: #RemovePrefixNamePolicyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Environments'!

!RemovePrefixNamePolicyTest methodsFor: 'running' stamp: 'cwp 3/3/2013 14:17'!
createPolicy
	^ RemovePrefixNamePolicy prefix: 'XX'! !

!RemovePrefixNamePolicyTest methodsFor: 'tests' stamp: 'cwp 3/3/2013 14:21'!
testOnlyRemovesPrefix
	self denyIncludes: #XAGriffle! !

!RemovePrefixNamePolicyTest methodsFor: 'tests' stamp: 'cwp 3/3/2013 14:19'!
testRemovesPrefix
	self assertIncludes: #XXGriffle as: #Griffle! !

TestCase subclass: #ObjectFinalizerTests
	instanceVariableNames: 'log'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Finalization'!

!ObjectFinalizerTests methodsFor: 'finalization handling' stamp: 'apb 9/14/2005 08:33'!
finalize: anObject
	log addLast: anObject asString, ' ', 'finalized'.! !

!ObjectFinalizerTests methodsFor: 'running' stamp: 'apb 9/14/2005 08:39'!
setUp
	super setUp.
	log := OrderedCollection new.! !

!ObjectFinalizerTests methodsFor: 'tests' stamp: 'stephaneducasse 10/28/2005 21:15'!
testFinalization
	"self run: #testFinalization"
	
	| repetitions |
	repetitions := 100.
	1 to: repetitions
		do: [:i | 
			log addLast: 'o' , i asString , ' created'.
			Object new
				toFinalizeSend: #finalize:
				to: self
				with: 'o' , i asString].
	Smalltalk garbageCollect.
	self finalizationRegistry finalizeValues.
	1 to: repetitions
		do: [:i | 
			self assert: (log includes: 'o' , i asString , ' created').
			self assert: (log includes: 'o' , i asString , ' finalized')]! !

TestCase subclass: #PackageDependencyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Dependencies'!

!PackageDependencyTest commentStamp: 'bp 3/12/2012 22:29' prior: 0!
PackageDependencyTest helps to avoid the introduction of unwanted package dependencies. There is a test for each package in the trunk image that asserts the current dependencies.

If new dependencies are introduced or existing dependencies are removed deliberately for a package, the test for that package needs to be changed in order not to fail.

As the current dependency structure is suboptimal some of the asserted dependencies are unwanted in fact. Kernel should probably not depend on MorphicExtras. In a way a green PackageDependencyTest does not mean the dependencies are good, just that they have not become worse.!

!PackageDependencyTest methodsFor: 'tests' stamp: 'ul 4/3/2016 03:50'!
testBalloon
	self testPackage: 'Balloon' dependsExactlyOn: #(
		Collections
		Graphics
		Kernel
	)! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ul 4/3/2016 03:46'!
testChronologyCore
	self testPackage: #'Chronology-Core' dependsExactlyOn: #(
		Collections
		Kernel
	)! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ul 4/3/2016 03:47'!
testCollections
	self testPackage: #Collections dependsExactlyOn: #(
		#'Chronology-Core'
		Compiler
		Kernel
		Files
		Graphics
		Multilingual
		#'ToolBuilder-Kernel'
		Tools
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ul 4/3/2016 03:47'!
testCompiler
	self testPackage: #Compiler dependsExactlyOn: #(
		Collections
		Graphics
		Kernel
		System
		#'ToolBuilder-Kernel'
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ul 4/3/2016 03:47'!
testCompression
	self testPackage: #Compression dependsExactlyOn: #(
		#'Chronology-Core'
		Collections
		Files
		Graphics
		Kernel
		Multilingual
		System
		#'ToolBuilder-Kernel'
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ul 4/3/2016 03:47'!
testEtoys
	self testPackage: #EToys dependsExactlyOn: #(
		Balloon
		#'Chronology-Core'
		Collections
		Compiler
		Compression
		Files
		Graphics
		Kernel
		Morphic
		MorphicExtras
		Multilingual
		Network
		Protocols
		SUnit
		System
		#'ToolBuilder-Kernel'
		Tools
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ul 4/3/2016 03:47'!
testFiles
	self testPackage: #Files dependsExactlyOn: #(
		#'Chronology-Core'
		Collections
		Kernel
		Multilingual
		System
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ul 4/3/2016 03:47'!
testGraphics
	self testPackage: #Graphics dependsExactlyOn: #(
		#'Chronology-Core'
		Collections
		Compression
		Files
		Kernel
		Multilingual
		System
		#'ToolBuilder-Kernel'
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ul 4/3/2016 03:47'!
testInstaller
	self testPackage: #Installer dependsExactlyOn: #(
		Collections
		Compression
		Exceptions
		Files
		Kernel
		Monticello
		MonticelloConfigurations
		Multilingual
		Network
		System
		#'ToolBuilder-Kernel'
		Tools
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ul 4/3/2016 03:48'!
testKernel
	self testPackage: #Kernel dependsExactlyOn: #(
		#'Chronology-Core'
		Collections
		Compiler
		Environments
		Files
		Multilingual
		System
		#'ToolBuilder-Kernel'
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ul 4/3/2016 03:48'!
testMonticello
	self testPackage: #Monticello dependsExactlyOn: #(
		#'Chronology-Core'
		Collections
		Compiler
		Compression
		Environments
		Files
		Graphics
		Kernel
		Morphic
		Multilingual
		Network
		#'PackageInfo-Base'
		#'Services-Base'
		System
		#'ToolBuilder-Kernel'
		Tools
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ul 4/3/2016 03:48'!
testMorphic
	self testPackage: #Morphic dependsExactlyOn: #(
		Balloon
		#'Chronology-Core'
		Collections
		Compiler
		EToys
		Files
		Graphics
		Kernel
		Monticello
		MonticelloConfigurations
		MorphicExtras
		Multilingual
		Network
		Sound
		System
		SystemReporter
		#'ToolBuilder-Kernel'
		#'ToolBuilder-Morphic'
		Tools
		TrueType
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ul 4/3/2016 03:48'!
testMorphicExtras
	self testPackage: #MorphicExtras dependsExactlyOn: #(
		Balloon
		#'Chronology-Core'
		Collections
		Compiler
		Files
		Graphics
		Kernel
		MonticelloConfigurations
		Morphic
		Multilingual
		Network
		Protocols
		Sound
		System
		#'ToolBuilder-Kernel'
		Tools
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ul 4/3/2016 03:48'!
testMultilingual
	self testPackage: #Multilingual dependsExactlyOn: #(
		#'Chronology-Core'
		Collections
		Files
		Graphics
		Kernel
		Network
		System
		#'ToolBuilder-Kernel'
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ul 4/3/2016 03:48'!
testNetwork
	self testPackage: #Network dependsExactlyOn: #(
		#'Chronology-Core'
		Collections
		Compiler
		Compression
		Files
		Graphics
		Kernel
		Morphic
		System
		#'ToolBuilder-Kernel'
		#'WebClient-Core'
	).! !

!PackageDependencyTest methodsFor: 'utilities' stamp: 'ar 9/5/2010 11:36'!
testPackage: pkgName dependsExactlyOn: pkgList
	"Ensure that the package with the given name depends only on the packages in pkgList.
	NOTE: If you use this for fixing dependencies, classDeps includes the classes
	and users from the package(s) not declared as dependents. Basically, you need
	to fix all the references in classDeps to make the test pass."
	| classDeps pi pkgDeps |
	classDeps := IdentityDictionary new.
	pi := PackageOrganizer default packageNamed: pkgName ifAbsent:[^self]. "unloaded"
	pi classes do:[:pkgClass| 
		(classDeps at: (pkgClass superclass ifNil:[ProtoObject]) 
			ifAbsentPut:[OrderedCollection new]) add: pkgClass name, ' superclass'.
	].
	pi methods do:[:mref| | cm |
		cm := mref compiledMethod.
		1 to: cm numLiterals do:[:i| | lit |
			((lit := cm literalAt: i) isVariableBinding 
				and:[lit value isBehavior]) ifTrue:[(classDeps at: lit value ifAbsentPut:[OrderedCollection new]) add: cm methodClass asString, '>>', cm selector]]].
	pkgDeps := Dictionary new.
	classDeps keys do:[:aClass| | pkg |
		pkg := PackageOrganizer default packageOfClass: aClass ifNone:[nil].
		pkg ifNil:[
			Transcript cr; show: 'WARNING: No package for ', aClass.
			(classDeps removeKey: aClass) do:[:each| Transcript crtab; show: each].
		] ifNotNil:[
			(pkgDeps at: pkg name ifAbsentPut:[OrderedCollection new]) add: aClass.
		].
	].
	(pkgDeps removeKey: pkgName ifAbsent:[#()]) 
		do:[:aClass| classDeps removeKey: aClass ifAbsent:[]].
	pkgList do:[:pkg|
		self assert: (pkgDeps includesKey: pkg)
			description: pkgName, ' no longer depends on ', pkg.
		(pkgDeps removeKey: pkg ifAbsent: [#()]) 
			do:[:aClass| classDeps removeKey: aClass ifAbsent:[]].
	].
	classDeps keysAndValuesDo:[:class :deps|
		Transcript cr; show: class name, ' dependencies:'.
		deps do:[:each| Transcript crtab; show: each].
	].
	self assert: pkgDeps isEmpty
		description: pkgName, ' now depends on ', pkgDeps.
! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ul 4/3/2016 03:48'!
testPackageInfo
	self testPackage: #PackageInfo dependsExactlyOn: #(
		Collections
		Compiler
		Graphics
		Kernel
		Morphic
		System
		#'ToolBuilder-Kernel'
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'pre 5/20/2016 09:46'!
testPreferenceBrowser
	self testPackage: #PreferenceBrowser dependsExactlyOn: #(
		#'Chronology-Core'
		Collections
		Graphics
		Kernel
		Morphic
		MorphicExtras
		System
		Tools
		#'ToolBuilder-Morphic' "Work in progress. Should become ToolBuilder --pre"
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ul 4/3/2016 03:48'!
testProtocols
	self testPackage: #Protocols dependsExactlyOn: #(
		#'Chronology-Core'
		Collections
		Graphics
		Kernel
		Morphic
		MorphicExtras
		System
		#'ToolBuilder-Kernel'
		Tools
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ul 4/3/2016 03:48'!
testSUnit
	self testPackage: #SUnit dependsExactlyOn: #(
		#'Chronology-Core'
		Collections
		Kernel
		System
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ul 4/3/2016 03:48'!
testSUnitGUI
	self testPackage: #SUnitGUI dependsExactlyOn: #(
		#'Chronology-Core'
		Collections
		Graphics
		Kernel
		#'PackageInfo-Base'
		SUnit
		System
		#'ToolBuilder-Kernel'
		Tools
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ul 4/3/2016 03:49'!
testServices
	self testPackage: #'Services-Base' dependsExactlyOn: #(
		Collections
		Compiler
		Graphics
		Kernel
		Morphic
		#'PackageInfo-Base'
		PreferenceBrowser
		System
		#'ToolBuilder-Kernel'
		Tools
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ul 4/3/2016 03:49'!
testShoutCore
	self testPackage: #ShoutCore dependsExactlyOn: #(
		Collections
		Environments
		Graphics
		Kernel
		Monticello
		System
		Compiler
		Tools
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ul 4/3/2016 03:49'!
testSound
	self testPackage: #Sound dependsExactlyOn: #(
		#'Chronology-Core'
		Collections
		Balloon
		Files
		Graphics
		Kernel
		Network
		System
		#'ToolBuilder-Kernel'
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ul 4/3/2016 03:49'!
testSystem
	self testPackage: #System dependsExactlyOn: #(
		#'Chronology-Core'
		Collections
		Compiler
		Compression
		Environments
		Files
		Graphics
		#'Installer-Core'
		Kernel
		MonticelloConfigurations
		Morphic
		MorphicExtras
		Multilingual
		Network
		#'PackageInfo-Base'
		Sound
		#'ToolBuilder-Kernel'
		TrueType
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ul 4/3/2016 03:49'!
testToolBuilder
	self testPackage: #'ToolBuilder-Kernel' dependsExactlyOn: #(
		Collections
		Files
		Kernel
		System
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ul 4/3/2016 03:49'!
testTools
	self testPackage: #Tools dependsExactlyOn: #(
		#'Chronology-Core'
		Collections
		Compiler
		Compression
		Files
		Graphics
		Kernel
		Morphic
		MorphicExtras
		Multilingual
		Network
		#'PackageInfo-Base'
		System
		#'ToolBuilder-Kernel'
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ul 4/3/2016 03:49'!
testTraits
	self testPackage: #Traits dependsExactlyOn: #(
		Collections
		Compiler
		Files
		Kernel
		Monticello
		System
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ul 4/3/2016 03:49'!
testTrueType
	self testPackage: #TrueType dependsExactlyOn: #(
		Collections
		Balloon
		Files
		Graphics
		Kernel
		Multilingual
		System
		#'ToolBuilder-Kernel'
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ul 4/3/2016 03:49'!
testVersionNumber
	self testPackage: #VersionNumber dependsExactlyOn: #(
		Collections
		Kernel
	).! !

!PackageDependencyTest methodsFor: 'tests' stamp: 'ul 4/3/2016 03:49'!
testXML
	self testPackage: #XML dependsExactlyOn: #(
		Collections
		Exceptions
		Files
		Kernel
		Multilingual
		System
		Tests
	).! !

TestCase subclass: #ParserEditingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Compiler'!

!ParserEditingTest methodsFor: 'support' stamp: 'eem 3/19/2015 11:12'!
parse: aString into: aTrinaryBlock
	| parser code |
	parser := self class newParser.
	code := aString withCRs.
	^aTrinaryBlock
		value: (parser parse: code class: self class; yourself)
		value: parser tempsMark
		value: code! !

!ParserEditingTest methodsFor: 'tests' stamp: 'eem 3/19/2015 11:47'!
testTempsMarkBinary
	self parse: '+ arg false' into:
		[:parser :tempsMark :code|
		 self assert: tempsMark = (code indexOf: $f)].
	self parse: '+ arg\	false' into:
		[:parser :tempsMark :code|
		 self assert: tempsMark = (code indexOf: $f)].
	self parse: '+ arg\	<pragma>\	false' into:
		[:parser :tempsMark :code|
		 self assert: (tempsMark = (code indexOf: $f) or: [tempsMark = (code indexOf: $<)])].
	self parse: '+ arg | foo | false' into:
		[:parser :tempsMark :code|
		 self assert: tempsMark = (code lastIndexOf: $|)].
	self parse: '+ arg\ | foo | false' into:
		[:parser :tempsMark :code|
		 self assert: tempsMark = (code lastIndexOf: $|)].
	self parse: '+ arg\	<pragma>\ | foo | false' into:
		[:parser :tempsMark :code|
		 self assert: tempsMark = (code lastIndexOf: $|)].
	self parse: '+ arg\	| foo |\	<pragma>\	false' into:
		[:parser :tempsMark :code|
		 self assert: tempsMark = (code lastIndexOf: $|)]! !

!ParserEditingTest methodsFor: 'tests' stamp: 'eem 3/19/2015 11:47'!
testTempsMarkKeyword
	self parse: 'key: word false' into:
		[:parser :tempsMark :code|
		 self assert: tempsMark = (code indexOf: $f)].
	self parse: 'key: word\	false' into:
		[:parser :tempsMark :code|
		 self assert: tempsMark = (code indexOf: $f)].
	self parse: 'key: word\	<pragma>\	false' into:
		[:parser :tempsMark :code|
		 self assert: (tempsMark = (code indexOf: $f) or: [tempsMark = (code indexOf: $<)])].
	self parse: 'key: word | foo | false' into:
		[:parser :tempsMark :code|
		 self assert: tempsMark = (code lastIndexOf: $|)].
	self parse: 'key: word\ | foo | false' into:
		[:parser :tempsMark :code|
		 self assert: tempsMark = (code lastIndexOf: $|)].
	self parse: 'key: word\	<pragma>\ | foo | false' into:
		[:parser :tempsMark :code|
		 self assert: tempsMark = (code lastIndexOf: $|)].
	self parse: 'key: word\	| foo |\	<pragma>\	false' into:
		[:parser :tempsMark :code|
		 self assert: tempsMark = (code lastIndexOf: $|)]! !

!ParserEditingTest methodsFor: 'tests' stamp: 'eem 3/19/2015 11:47'!
testTempsMarkUnary
	self parse: 'unary false' into:
		[:parser :tempsMark :code|
		 self assert: tempsMark = (code indexOf: $f)].
	self parse: 'unary\	false' into:
		[:parser :tempsMark :code|
		 self assert: tempsMark = (code indexOf: $f)].
	self parse: 'unary\	<pragma>\	false' into:
		[:parser :tempsMark :code|
		 self assert: (tempsMark = (code indexOf: $f) or: [tempsMark = (code indexOf: $<)])].
	self parse: 'unary | foo | false' into:
		[:parser :tempsMark :code|
		 self assert: tempsMark = (code lastIndexOf: $|)].
	self parse: 'unary\ | foo | false' into:
		[:parser :tempsMark :code|
		 self assert: tempsMark = (code lastIndexOf: $|)].
	self parse: 'unary\	<pragma>\ | foo | false' into:
		[:parser :tempsMark :code|
		 self assert: tempsMark = (code lastIndexOf: $|)].
	self parse: 'unary\	| foo |\	<pragma>\	false' into:
		[:parser :tempsMark :code|
		 self assert: tempsMark = (code lastIndexOf: $|)]! !

TestCase subclass: #PreferencesTest
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-System-Preferences'!

!PreferencesTest methodsFor: 'running' stamp: 'mt 8/26/2015 15:30'!
setUp

	super setUp.
	sut := PreferencesTestPreferences.! !

!PreferencesTest methodsFor: 'running' stamp: 'mt 8/27/2015 10:43'!
tearDown

	sut allPreferences do: [:pref | sut removePreference: pref id].
	sut class organization removeEmptyCategories.
	
	super tearDown.! !

!PreferencesTest methodsFor: 'tests' stamp: 'mt 8/26/2015 15:31'!
test01Empty

	self assert: sut dictionaryOfPreferences isEmpty.! !

!PreferencesTest methodsFor: 'tests' stamp: 'mt 8/26/2015 16:51'!
test02AddSetRemovePreference

	self assert: (sut valueOfPreference: #foo ifAbsent: []) isNil.
	self assert: (sut respondsTo: #foo) not. "auto-generated accessor"

	sut addPreference: #foo category: #bar default: false.
	self assert: (sut valueOfPreference: #foo ifAbsent: []) = false.
	self assert: (sut perform: #foo) = false.

	sut setPreference: #foo toValue: true.
	self assert: (sut valueOfPreference: #foo ifAbsent: []) = true.
	self assert: (sut perform: #foo) = true.

	sut removePreference: #foo.
	self assert: (sut valueOfPreference: #foo ifAbsent: []) isNil.
	self assert: (sut respondsTo: #foo) not.! !

!PreferencesTest methodsFor: 'tests' stamp: 'mt 8/26/2015 17:09'!
test03Type

	sut addPreference: #foo default: true.
	self assert: (sut preferenceAt: #foo) type == #Boolean.

	sut addPreference: #foo default: 123.
	self assert: (sut preferenceAt: #foo) type == #Number.

	sut addPreference: #foo default: 'Hello, World'.
	self assert: (sut preferenceAt: #foo) type == #String.

	sut addPreference: #foo default: Color red.
	self assert: (sut preferenceAt: #foo) type == #Color.

	sut addPreference: #foo default: 1@5.
	self assert: (sut preferenceAt: #foo) type == #Object.
! !

!PreferencesTest methodsFor: 'tests' stamp: 'mt 8/26/2015 17:15'!
test04TypeNoUpdate

	sut addPreference: #foo default: true.
	sut setPreference: #foo toValue: 123.

	self assert: (sut preferenceAt: #foo) type == #Boolean.! !

!PreferencesTest methodsFor: 'tests' stamp: 'mt 8/26/2015 17:24'!
test05AutoAdd

	| pref |
	self assert: (sut valueOfPreference: #foo ifAbsent: []) isNil.
	pref := sut setPreference: #foo toValue: 123.

	self assert: pref preferenceValue = 123.! !

!PreferencesTest methodsFor: 'tests' stamp: 'mt 8/26/2015 17:45'!
test06Flags
	"Flags are boolean preferences."
	
	self assert: (sut valueOfFlag: #isHappy) == false. "Not known but false for default."
	
	sut setFlag: #isHappy toValue: true.
	self assert: (sut valueOfFlag: #isHappy) == true.
	self assert: (sut perform: #isHappy) == true.
	
	sut disable: #useIt.
	self assert: (sut valueOfFlag: #useIt) == false.
	self assert: (sut perform: #useIt) == false.
	
	sut enable: #useIt.
	self assert: (sut valueOfFlag: #useIt) == true.
	self assert: (sut perform: #useIt) == true.
	
	sut toggle: #useIt.
	self assert: (sut valueOfFlag: #useIt) == false.	! !

!PreferencesTest methodsFor: 'tests' stamp: 'mt 8/26/2015 17:45'!
test07UnknownPreference

	self assert: (sut valueOfPreference: #notKnown) isNil.
	self assert: (sut valueOfPreference: #notKnown ifAbsent: [#default]) = #default.! !

!PreferencesTest methodsFor: 'tests' stamp: 'topa 10/7/2015 23:35'!
test08DNUFallback

	sut setPreference: #foo toValue: 123.
	sut class removeSelectorSilently: #foo.

	self assert: (sut perform: #foo) = 123.
	self should: [sut perform: #'_unlikelyAndUnknownSelector'] raise: MessageNotUnderstood.! !

!PreferencesTest methodsFor: 'tests' stamp: 'mt 8/27/2015 08:49'!
test09AddSetRemovePragmaPreference

	| id pref |
	id := PreferencesTestExample name, '>>', #textPref.
	pref := sut addPragmaPreference: (PreferencesTestExample class >> #textPref) pragmas first.

	self assert: id equals: pref id.
	self assert: (sut preferenceAt: pref id) == pref.

	"Reset the preference explicitely."
	PreferencesTestExample textPref: ''.
	self assert: '' equals: PreferencesTestExample textPref.	
	
	sut setPreference: pref id toValue: 'foo'.
	self assert: 'foo' equals: (sut valueOfPreference: pref id).
	self assert: 'foo' equals: PreferencesTestExample textPref.
	
	sut removePreference: pref id.
	self assert: (sut preferenceAt: pref id ifAbsent: []) isNil.! !

!PreferencesTest methodsFor: 'tests' stamp: 'mt 8/27/2015 09:04'!
test10Unclassified

	| pref |
	pref := sut addPreference: #foobar default: 123.
	self assert: sut unclassifiedCategory equals: pref categoryList first.! !

!PreferencesTest methodsFor: 'tests' stamp: 'mt 8/27/2015 09:11'!
test11CategoryList

	sut addPreference: #foo category: #blubb default: 123.
	self assert: #(blubb) equals: (sut categoryListOfPreference: #foo). ! !

!PreferencesTest methodsFor: 'tests' stamp: 'mt 8/27/2015 09:35'!
test12HardCodedPreference

	self assert: (sut respondsTo: #someStaticFoo) not.
	sut compileAccessorForPreferenceNamed: #someStaticFoo value: 42.
	self assert: 42 equals: (sut perform: #someStaticFoo).
	self assert: (sut valueOfPreference: #someStaticFoo ifAbsent: []) isNil.

	"Hard-coded preferences have their value only in the source code. We must leave them in the same package."
	self deny: ((sut class organization categoryOfElement: #someStaticFoo) beginsWith: '*').

	sut class removeSelectorSilently: #someStaticFoo.! !

TestCase subclass: #ProcessTerminateBug
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Exceptions'!

!ProcessTerminateBug methodsFor: 'tests' stamp: 'm 7/28/2003 19:10'!
testSchedulerTermination
   | process sema gotHere sema2 |
   gotHere := false.
   sema := Semaphore new.
   sema2 := Semaphore new.
   process := [
       sema signal.
       sema2 wait.
       "will be suspended here"
       gotHere := true. "e.g., we must *never* get here"
   ] forkAt: Processor activeProcess priority.
   sema wait. "until process gets scheduled"
   process terminate.
   sema2 signal.
   Processor yield. "will give process a chance to continue and
horribly screw up"
   self assert: gotHere not.
! !

!ProcessTerminateBug methodsFor: 'tests' stamp: 'ar 3/3/2010 21:39'!
testTerminationDuringUnwind
	"An illustration of the issue of process termination during unwind.
	This uses a well-behaved unwind block that we should allow to complete
	if at all possible."
	| unwindStarted unwindFinished p |
	unwindStarted := unwindFinished := false.
	p := [[] ensure:[
			unwindStarted := true.
			Processor yield.
			unwindFinished := true.
		]] fork.
	self deny: unwindStarted.
	Processor yield.
	self assert: unwindStarted.
	self deny: unwindFinished.
	p terminate.
	self assert: unwindFinished.! !

!ProcessTerminateBug methodsFor: 'tests' stamp: 'ar 7/27/2003 19:44'!
testUnwindFromActiveProcess
	| sema process |
	sema := Semaphore forMutualExclusion.
	self assert:(sema isSignaled).
	process := [
		sema critical:[
			self deny: sema isSignaled.
			Processor activeProcess terminate.
		]
	] forkAt: Processor userInterruptPriority.
	self assert: sema isSignaled.! !

!ProcessTerminateBug methodsFor: 'tests' stamp: 'ar 7/27/2003 19:49'!
testUnwindFromForeignProcess
	| sema process |
	sema := Semaphore forMutualExclusion.
	self assert: sema isSignaled.
	process := [
		sema critical:[
			self deny: sema isSignaled.
			sema wait. "deadlock"
		]
	] forkAt: Processor userInterruptPriority.
	self deny: sema isSignaled.
	"This is for illustration only - the BlockCannotReturn cannot 
	be handled here (it's truncated already)"
	self shouldnt: [process terminate] raise: BlockCannotReturn.
	self assert: sema isSignaled.
	! !

TestCase subclass: #RecentMessagesTest
	instanceVariableNames: 'rm env'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-System-Support'!

!RecentMessagesTest methodsFor: 'private' stamp: 'fbs 9/5/2013 08:58'!
createClass: aSymbol
	| builder |
	builder := ClassBuilder new.
	builder
		name: aSymbol
		inEnvironment: env
		subclassOf: Object
		type: #normal
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'Test'.
	^ env at: aSymbol.! !

!RecentMessagesTest methodsFor: 'running' stamp: 'fbs 9/5/2013 08:57'!
setUp
	rm := RecentMessages new.
	env := Environment withName: 'EnvironmentForRecentMessagesTest'.
	env at: #FakeObjectOut put: FakeObjectOut new.! !

!RecentMessagesTest methodsFor: 'running' stamp: 'nice 10/28/2016 09:09'!
tearDown
	env destroy.
	env := nil! !

!RecentMessagesTest methodsFor: 'testing' stamp: 'fbs 9/2/2013 10:43'!
testIsEmpty
	self assert: rm isEmpty description: 'Initially, must be empty'.
	rm recordSelector: #foo forClass: Utilities inEnvironment: Smalltalk globals.
	self deny: rm isEmpty description: 'After submission, must not be empty'.! !

!RecentMessagesTest methodsFor: 'testing' stamp: 'fbs 9/2/2013 10:12'!
testMaximumSubmissionCountCanReduceNumberOfReferences
	rm maximumSubmissionCount: 2.
	rm recordSelector: #foo forClass: Utilities inEnvironment: Smalltalk globals.
	rm recordSelector: #bar forClass: Utilities inEnvironment: Smalltalk globals.
	rm maximumSubmissionCount: 1.
	self assert: 1 equals: rm size.! !

!RecentMessagesTest methodsFor: 'testing' stamp: 'cmm 10/3/2013 14:24'!
testMaximumSubmissionCountCapsReferenceCount
	rm maximumSubmissionCount: 2.
	rm recordSelector: #foo forClass: Utilities inEnvironment: Smalltalk globals.
	rm recordSelector: #bar forClass: Utilities inEnvironment: Smalltalk globals.
	rm recordSelector: #baz forClass: Utilities inEnvironment: Smalltalk globals.
	self assert: #bar equals: rm leastRecent selector.! !

!RecentMessagesTest methodsFor: 'testing' stamp: 'cmm 10/24/2013 19:51'!
testMaximumSubmissionCountDefaultsToTen
	self assert: 30 equals: rm maximumSubmissionCount.! !

!RecentMessagesTest methodsFor: 'testing' stamp: 'fbs 9/2/2013 10:13'!
testMaximumSubmissionCountReturnsMaximumNumberOfRecordedMethodSubmissions
	rm maximumSubmissionCount: 0.
	self assert: 0 equals: rm maximumSubmissionCount.
	rm maximumSubmissionCount: 1.
	self assert: 1 equals: rm maximumSubmissionCount.! !

!RecentMessagesTest methodsFor: 'testing' stamp: 'cmm 10/24/2013 19:52'!
testMethodReferencesReturnsAllSubmissions
	| expected |
	expected := {
		MethodReference class: Utilities selector: #bar environment: env.
		MethodReference class: Utilities selector: #foo environment: env }.
	rm recordSelector: #foo forClass: Utilities inEnvironment: env.
	rm recordSelector: #bar forClass: Utilities inEnvironment: env.
	self assert: expected equals: rm methodReferences! !

!RecentMessagesTest methodsFor: 'testing' stamp: 'fbs 9/3/2013 08:44'!
testMethodReferencesReturnsaCopy
	| expected original |
	rm recordSelector: #foo forClass: Utilities inEnvironment: env.
	original := rm methodReferences.
	expected := original copy.
	rm recordSelector: #bar forClass: Utilities inEnvironment: env.
	self assert: expected equals: original.! !

!RecentMessagesTest methodsFor: 'testing' stamp: 'fbs 9/9/2013 20:13'!
testMostRecentReturnsLastAddedReference
	| victim |
	victim := self createClass: #Victim.
	victim compile: 'foo ^ 1'.
	victim compile: 'bar ^ 1'.
	rm recordSelector: #foo forClass: victim inEnvironment: env.
	self assert: #foo equals: rm mostRecent selector.
	rm recordSelector: #bar forClass: victim inEnvironment: env.
	self assert: #bar equals: rm mostRecent selector.! !

!RecentMessagesTest methodsFor: 'testing' stamp: 'cmm 10/24/2013 20:11'!
testMostRecentReturnsRemovedReference
	| victim |
	victim := self createClass: #Victim.
	victim compile: 'foo ^ 1'.
	victim compile: 'bar ^ 1'.
	rm recordSelector: #foo forClass: victim inEnvironment: env.
	rm recordSelector: #bar forClass: victim inEnvironment: env.
	victim removeSelector: #bar.
	self assert: #bar equals: rm mostRecent selector.! !

!RecentMessagesTest methodsFor: 'testing' stamp: 'cmm 10/3/2013 14:24'!
testOldestReturnsOldestSubmission
	self assert: nil equals: rm leastRecent description: 'Return nil if no submissions yet'.
	rm recordSelector: #foo forClass: Utilities inEnvironment: Smalltalk globals.
	self assert: #foo equals: rm leastRecent selector.
	rm recordSelector: #baz forClass: Utilities inEnvironment: Smalltalk globals.
	self assert: #foo equals: rm leastRecent selector.! !

!RecentMessagesTest methodsFor: 'testing' stamp: 'fbs 9/2/2013 10:55'!
testPurgeMissingMethodsKeepsComments
	rm recordSelector: #Comment forClass: Utilities inEnvironment: Smalltalk globals.
	self deny: rm isEmpty.! !

!RecentMessagesTest methodsFor: 'testing' stamp: 'fbs 8/23/2013 08:13'!
testReferencesAreUnique
	rm recordSelector: #foo forClass: Utilities inEnvironment: Smalltalk globals.
	rm recordSelector: #foo forClass: Utilities inEnvironment: Smalltalk globals.
	self assert: 1 equals: rm size description: 'After duplicate'.! !

!RecentMessagesTest methodsFor: 'testing' stamp: 'cmm 10/15/2013 14:03'!
testRevertMostRecentRemovesLatestVersion
	| victim |
	victim := self createClass: #Victim.
	victim compile: 'foo ^ 1'.
	victim compile: 'foo ^ 2'.
	rm recordSelector: #foo forClass: victim inEnvironment: env.
	rm revertMostRecent.
	self assert: 1 equals: victim new foo description: 'Version not removed'.! !

!RecentMessagesTest methodsFor: 'testing' stamp: 'cmm 10/15/2013 14:03'!
testRevertMostRecentRemovesNewMethod
	| victim |
	victim := self createClass: #Victim.
	victim compile: 'foo ^ 1'.
	rm recordSelector: #foo forClass: victim inEnvironment: env.
	rm revertMostRecent.
	self deny: (victim includesSelector: #foo) description: 'Method not removed'.! !

!RecentMessagesTest methodsFor: 'testing' stamp: 'fbs 8/23/2013 08:15'!
testSizeReturnsNumberOfRecordedMethodSubmissions
	self assert: 0 equals: rm size description: 'Initial state'.
	rm recordSelector: #foo forClass: Utilities inEnvironment: Smalltalk globals.
	self assert: 1 equals: rm size description: 'After 1 submission'.
	rm recordSelector: #bar forClass: Utilities inEnvironment: Smalltalk globals.
	self assert: 2 equals: rm size description: 'After 2 submissions'.! !

!RecentMessagesTest methodsFor: 'testing' stamp: 'fbs 9/2/2013 10:28'!
testSubmissionClassControlsLogging
	WantsChangeSetLogging yes.
	rm recordSelector: #foo forClass: WantsChangeSetLogging inEnvironment: Smalltalk globals.
	WantsChangeSetLogging no.
	rm recordSelector: #bar forClass: WantsChangeSetLogging inEnvironment: Smalltalk globals.
	self assert: 1 equals: rm size description: 'Class asked for logging not to happen'.! !

TestCase subclass: #ReleaseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Release'!

!ReleaseTest methodsFor: 'testing' stamp: 'fbs 12/20/2013 13:16'!
testClassesSystemCategory
"Find cases where classes have nil system categories.
This test will tell you the classes.
This is inspired by the proposed fix of a bug in release of 3.10.1 
see Mantis #7070" 
| rejectClasses | 

rejectClasses := 
 nil systemNavigation allClasses reject: [ :each |
	each category notNil ] .

self assert: rejectClasses isEmpty description: ('Classes with nil system categories: {1}' format: {rejectClasses asCommaString}).! !

!ReleaseTest methodsFor: 'testing' stamp: 'ul 4/26/2013 16:43'!
testMethodsWithUnboundGlobals
	| unbound |
	unbound := SystemNavigation default methodsWithUnboundGlobals.
	Smalltalk cleanOutUndeclared. 
	self assert: unbound isEmpty description: 'Unbound: ', unbound asCommaString! !

!ReleaseTest methodsFor: 'testing' stamp: 'ul 9/5/2012 02:11'!
testNoObsoleteClasses

	| obsoleteClasses |
	obsoleteClasses := self systemNavigation obsoleteClasses.
	self 
		assert: obsoleteClasses isEmpty
		description: ('{1} {2} obsolete' format: {
			obsoleteClasses asCommaStringAnd.
			obsoleteClasses size = 1
				ifTrue: [ 'is' ]
				ifFalse: [ 'are' ] })
			
	! !

!ReleaseTest methodsFor: 'testing' stamp: 'pre 12/21/2016 14:17'!
testSqueakThemeFonts
	"Check whether the fonts installed in the active theme in the release are correct"
	
	"preference selector - font family name - font size" 
	{	#(standardDefaultTextFont 'Bitmap DejaVu Sans' 9).
		#(standardListFont 'Bitmap DejaVu Sans' 9).
		#(standardFlapFont 'Bitmap DejaVu Sans' 7).
		#(standardMenuFont 'Bitmap DejaVu Sans' 9).
		#(windowTitleFont 'Bitmap DejaVu Sans' 9).
		#(standardBalloonHelpFont 'Bitmap DejaVu Sans' 7).
		#(standardCodeFont 'Bitmap DejaVu Sans' 9).
		#(standardButtonFont 'Bitmap DejaVu Sans' 7) }
			do: [:triple | | font |
				font := Preferences perform: triple first.
				self assert: triple second equals: font familyName.
				self assert: triple third equals: font pointSize ]
		
	
	! !

!ReleaseTest methodsFor: 'testing' stamp: 'fbs 12/20/2013 13:15'!
testSuperSubclassReferences
	"see mantis bug 7090 for more info on this"
	"If the reason for this test to fail is above bug, the following might fix the system"
	"(ProtoObject subclasses reject: [:each | each isMeta or: [each environment includes: each]]) do: [:each | ProtoObject removeSubclass: each]"

	| strangeClasses |
	strangeClasses := ProtoObject allSubclasses reject: [:each | each isMeta or: [each environment includes: each]].
	self assert: strangeClasses isEmpty description: ('Not expecting to find any of {1}' format: {strangeClasses asCommaString}).! !

!ReleaseTest methodsFor: 'testing' stamp: 'mtf 12/16/2010 11:36'!
testSwapMouseButtonsPreference
	"Swap mouse buttons should be enabled"
	self assert: Preferences swapMouseButtons! !

!ReleaseTest methodsFor: 'testing' stamp: 'fbs 12/20/2013 13:15'!
testSystemCategoryClasses
"Find cases where system categories name absent classes.
This test will tell you the classes.
This is inspired by a bug in release of 3.10.1 
see Mantis #7070" 
|  rejectCats rejectClasses | 
rejectCats := 
SystemOrganization categories reject: [ :catName |
	(SystemOrganization listAtCategoryNamed: catName) 
		allSatisfy: [ :className | 
			( Smalltalk includesKey: className ) ] ] .
"self assert: rejectCats isEmpty ."

rejectCats isEmpty ifTrue: [ ^ true ] . 


rejectClasses :=
rejectCats collect: [ :each |
	each ->
	( (SystemOrganization listAtCategoryNamed: each) 
		reject: [ :eachOne | 
			( Smalltalk includesKey: eachOne )  ] ) ] .

self assert: rejectCats isEmpty description: ('Not expecting any of {1}' format: { rejectClasses asCommaString}).
! !

!ReleaseTest methodsFor: 'testing' stamp: 'ul 9/5/2012 02:08'!
testUndeclared
	
	Smalltalk cleanOutUndeclared. 
	self
		assert: Undeclared isEmpty
		description: ('{1} {2} in Undeclared'
			format: {
				Undeclared keys asCommaStringAnd.
				Undeclared keys size = 1
					ifTrue: [ 'is' ]
					ifFalse: [ 'are' ] })! !

TestCase subclass: #ScannerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Compiler'!

!ScannerTest methodsFor: 'testing' stamp: 'jmv 2/24/2010 10:03'!
testLiteralSymbols

	self assert: ('*+-/\~=<>&@%,|' allSatisfy: [:char | Scanner isLiteralSymbol: (String with: char) asSymbol])
		description: 'single letter binary symbols can be printed without string quotes'.
		
	self assert: (#('x' 'x:' 'x:y:' 'from:to:by:' 'yourself') allSatisfy: [:str | Scanner isLiteralSymbol: str asSymbol])
		description: 'valid ascii selector symbols can be printed without string quotes'.
		
	((32 to: 126) collect: [:ascii | Character value: ascii]) ,
	#(':x:yourself' '::' 'x:yourself' '123' 'x0:1:2:' 'x.y.z' '1abc' 'a1b0c2' ' x' 'x ' '+x-y' '||' '--' '++' '+-' '+/-' '-/+' '<|>' '#x' '()' '[]' '{}' '')
		do: [:str |
			self assert: (Compiler evaluate: str asSymbol printString) = str asSymbol
				description: 'in all case, a Symbol must be printed in an interpretable fashion']! !

TestCase subclass: #SmalltalkImageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-System-Support'!

!SmalltalkImageTest methodsFor: 'testing' stamp: 'fbs 7/25/2013 07:19'!
testImageName
	"Non regression test for http://bugs.squeak.org/view.php?id=7351"
	| shortImgName fullImgName fullChgName |
	shortImgName := 'Squeak3.10.2-7179-basic'.
	fullImgName := Smalltalk fullNameForImageNamed: shortImgName.
	fullChgName := Smalltalk fullNameForChangesNamed: shortImgName.
	FileDirectory splitName: fullImgName to: [:path :name |
		self assert: path = Smalltalk imagePath.
		self assert: name = 'Squeak3.10.2-7179-basic.image'.].
	FileDirectory splitName: fullChgName to: [:path :name |
		self assert: path = Smalltalk imagePath.
		self assert: name = 'Squeak3.10.2-7179-basic.changes'.].! !

TestCase subclass: #StandardSourceFileArrayTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Files'!

!StandardSourceFileArrayTest commentStamp: 'dtl 12/13/2009 23:42' prior: 0!
This test documents the source pointer address conversion methods for StandardSourceFileArray.

The available address space for source pointers in CompiledMethod is 16r1000000 through 16r4FFFFFF. StandardSourceFileArray maps positions in the sources file to address range 16r1000000 through 16r1FFFFFF and 16r3000000 through 16r3FFFFFF, and positions in the changes file to address range 16r2000000 through 16r2FFFFFF and 16r4000000 through 16r4FFFFFF. This permits a maximum file size of 16r2000000 (32MB) for both the sources file and the changes file. 
!

!StandardSourceFileArrayTest methodsFor: 'testing' stamp: 'nice 12/27/2009 03:11'!
testAddressRange
	"Test source pointer to file position address translation across the full address range"
	
	| sf |
	sf := StandardSourceFileArray new.
	(16r1000000 to: 16r4FFFFFF by: 811) do: [:e | | i a p |
		i := sf fileIndexFromSourcePointer: e.
		p := sf filePositionFromSourcePointer: e.
		a := sf sourcePointerFromFileIndex: i andPosition: p.
		self assert: a = e]
! !

!StandardSourceFileArrayTest methodsFor: 'testing' stamp: 'ul 11/15/2010 12:05'!
testChangesFileAddressRange
	"Test file position to source pointer address translation for the changes file"
	
	| sf a |
	sf := StandardSourceFileArray new.
	(0 to: 16r1FFFFFF by: 811) do: [:e | | a2 i p |
		a := sf sourcePointerFromFileIndex: 2 andPosition: e.
		i := sf fileIndexFromSourcePointer: a.
		self assert: i = 2.
		p := sf filePositionFromSourcePointer: a.
		self assert: p = e.
		a2 := sf sourcePointerFromFileIndex: 2 andPosition: p.
		self assert: a2 = a].
	(0 to: 16rFFFFFF by: 811) do: [:e |
		a := sf sourcePointerFromFileIndex: 2 andPosition: e.
		self assert: (a between: 16r2000000 and: 16r2FFFFFF)].
	(16r1000000 to: 16r1FFFFFF by: 811) do: [:e |
		a := sf sourcePointerFromFileIndex: 2 andPosition: e.
		self assert: (a between: 16r4000000 and: 16r4FFFFFF)]


! !

!StandardSourceFileArrayTest methodsFor: 'testing' stamp: 'dtl 12/14/2009 00:05'!
testFileIndexFromSourcePointer
	"Test derivation of file index for sources or changes file from source pointers"

	| sf |
	sf := StandardSourceFileArray new.
	"sources file mapping"
	self assert: 1 = (sf fileIndexFromSourcePointer: 16r1000000).
	self assert: 1 = (sf fileIndexFromSourcePointer: 16r1000013).
	self assert: 1 = (sf fileIndexFromSourcePointer: 16r1FFFFFF).
	self assert: 1 = (sf fileIndexFromSourcePointer: 16r3000000).
	self assert: 1 = (sf fileIndexFromSourcePointer: 16r3000013).
	self assert: 1 = (sf fileIndexFromSourcePointer: 16r3FFFFFF).
	(16r1000000 to: 16r1FFFFFF by: 811) do: [:e | self assert: 1 = (sf fileIndexFromSourcePointer: e)].
	(16r3000000 to: 16r3FFFFFF by: 811) do: [:e | self assert: 1 = (sf fileIndexFromSourcePointer: e)].
	"changes file mapping"
	self assert: 2 = (sf fileIndexFromSourcePointer: 16r2000000).
	self assert: 2 = (sf fileIndexFromSourcePointer: 16r2000013).
	self assert: 2 = (sf fileIndexFromSourcePointer: 16r2FFFFFF).
	self assert: 2 = (sf fileIndexFromSourcePointer: 16r4000000).
	self assert: 2 = (sf fileIndexFromSourcePointer: 16r4000013).
	self assert: 2 = (sf fileIndexFromSourcePointer: 16r4FFFFFF).
	(16r2000000 to: 16r2FFFFFF by: 811) do: [:e | self assert: 2 = (sf fileIndexFromSourcePointer: e)].
	(16r4000000 to: 16r4FFFFFF by: 811) do: [:e | self assert: 2 = (sf fileIndexFromSourcePointer: e)].
	"the following numeric ranges are unused but currently produces results as follows"
	self assert: 0 = (sf fileIndexFromSourcePointer: 16r0000000).
	self assert: 0 = (sf fileIndexFromSourcePointer: 16r0000013).
	self assert: 0 = (sf fileIndexFromSourcePointer: 16r0FFFFFF)


! !

!StandardSourceFileArrayTest methodsFor: 'testing' stamp: 'dtl 12/14/2009 00:10'!
testFilePositionFromSourcePointer
	"Test derivation of file position for sources or changes file from source pointers"

	| sf |
	sf := StandardSourceFileArray new.
	"sources file"
	self assert: 0 = (sf filePositionFromSourcePointer: 16r1000000).
	self assert: 16r13 = (sf filePositionFromSourcePointer: 16r1000013).
	self assert: 16rFFFFFF = (sf filePositionFromSourcePointer: 16r1FFFFFF).
	self assert: 16r1000000 = (sf filePositionFromSourcePointer: 16r3000000).
	self assert: 16r1000013 = (sf filePositionFromSourcePointer: 16r3000013).
	self assert: 16r1FFFFFF = (sf filePositionFromSourcePointer: 16r3FFFFFF).
	"changes file"
	self assert: 0 = (sf filePositionFromSourcePointer: 16r2000000).
	self assert: 16r13 = (sf filePositionFromSourcePointer: 16r2000013).
	self assert: 16rFFFFFF = (sf filePositionFromSourcePointer: 16r2FFFFFF).
	self assert: 16r1000000 = (sf filePositionFromSourcePointer: 16r4000000).
	self assert: 16r1000013 = (sf filePositionFromSourcePointer: 16r4000013).
	self assert: 16r1FFFFFF = (sf filePositionFromSourcePointer: 16r4FFFFFF).
	"the following numeric ranges are unused but currently produces results as follows"
	self assert: 0 = (sf filePositionFromSourcePointer: 16r0000000).
	self assert: 16r13 = (sf filePositionFromSourcePointer: 16r0000013).
	self assert: 16rFFFFFF = (sf filePositionFromSourcePointer: 16r0FFFFFF)
! !

!StandardSourceFileArrayTest methodsFor: 'testing' stamp: 'fbs 11/5/2013 23:02'!
testSourcePointerFromFileIndexAndPosition
	"Test valid input ranges"

	| sf |
	sf := StandardSourceFileArray new.
	self should: [sf sourcePointerFromFileIndex: 0 andPosition: 0] raise: Error.
	self should: [sf sourcePointerFromFileIndex: 0 andPosition: 3] raise: Error.
	self should: [sf sourcePointerFromFileIndex: 1 andPosition: -1] raise: Error.
	self should: [sf sourcePointerFromFileIndex: 1 andPosition: 16r2000000] raise: Error.
	self should: [sf sourcePointerFromFileIndex: 3 andPosition: 0] raise: Error.
	self should: [sf sourcePointerFromFileIndex: 4 andPosition: 0] raise: Error.
	
	self assert: 16r1000000 equals: (sf sourcePointerFromFileIndex: 1 andPosition: 0).
	self assert: 16r1000013 equals: (sf sourcePointerFromFileIndex: 1 andPosition: 16r13).
	self assert: 16r1FFFFFF equals: (sf sourcePointerFromFileIndex: 1 andPosition: 16rFFFFFF).
	self assert: 16r2000000 equals: (sf sourcePointerFromFileIndex: 2 andPosition: 0).
	self assert: 16r2000013 equals: (sf sourcePointerFromFileIndex: 2 andPosition: 16r13).
	self assert: 16r2FFFFFF equals: (sf sourcePointerFromFileIndex: 2 andPosition: 16rFFFFFF).
	self assert: 16r3000000 equals: (sf sourcePointerFromFileIndex: 1 andPosition: 16r1000000).
	self assert: 16r3000013 equals: (sf sourcePointerFromFileIndex: 1 andPosition: 16r1000013).
	self assert: 16r3FFFFFF equals: (sf sourcePointerFromFileIndex: 1 andPosition: 16r1FFFFFF).
	self assert: 16r4000000 equals: (sf sourcePointerFromFileIndex: 2 andPosition: 16r1000000).
	self assert: 16r4000013 equals: (sf sourcePointerFromFileIndex: 2 andPosition: 16r1000013).
	self assert: 16r4FFFFFF equals: (sf sourcePointerFromFileIndex: 2 andPosition: 16r1FFFFFF).! !

!StandardSourceFileArrayTest methodsFor: 'testing' stamp: 'ul 11/15/2010 12:05'!
testSourcesFileAddressRange
	"Test file position to source pointer address translation for the sources file"
	
	| sf a |
	sf := StandardSourceFileArray new.
	(0 to: 16r1FFFFFF by: 811) do: [:e | | a2 p i |
		a := sf sourcePointerFromFileIndex: 1 andPosition: e.
		i := sf fileIndexFromSourcePointer: a.
		self assert: i = 1.
		p := sf filePositionFromSourcePointer: a.
		self assert: p = e.
		a2 := sf sourcePointerFromFileIndex: 1 andPosition: p.
		self assert: a2 = a].
	(0 to: 16rFFFFFF by: 811) do: [:e |
		a := sf sourcePointerFromFileIndex: 1 andPosition: e.
		self assert: (a between: 16r1000000 and: 16r1FFFFFF)].
	(16r1000000 to: 16r1FFFFFF by: 811) do: [:e |
		a := sf sourcePointerFromFileIndex: 1 andPosition: e.
		self assert: (a between: 16r3000000 and: 16r3FFFFFF)]

! !

TestCase subclass: #SumBugs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Bugs'!

!SumBugs methodsFor: 'as yet unclassified' stamp: 'ar 5/4/2010 08:42'!
testSummingColors
	"self run: #testSummingColors"
	| cases |
	cases := { 
		Color black.
		Color red.
		Color green.
		Color blue.
		Color cyan.
		Color magenta.
		Color yellow.
		Color white.
	}.

	cases do: [ :each |
		self assert: ((Array with: each) sum = each) 
	].
! !

!SumBugs methodsFor: 'as yet unclassified' stamp: 'ar 5/4/2010 08:42'!
testSummingToTen
	"self run: #testSummingToTen"

	| cases |
	cases :={ 
		{ 1 . 2 . 3 . 4 }.
		{ 2.0 . 2.0 . 2.0 . 2.0 . 2.0  }.
		{ 2/5 . 5/2 . 5/2 . 3/5 . 4 } 
	} .

	cases do: [ :each |
		self assert: (each  sum = 10 )
	] .! !

!SumBugs methodsFor: 'as yet unclassified' stamp: 'ar 5/4/2010 08:43'!
testSummingToWhite
	"self run: #testSummingToWhite"

	| cases |
	cases := { 
		{ Color black . Color white }.
		{ Color red . Color green. Color blue }.
		{ Color gray . Color gray }.
		{ Color cyan. Color magenta. Color yellow }.
		{ Color cyan. Color magenta.  }.
		{  Color magenta. Color yellow }.
		{ Color cyan.  Color yellow }.
		{ Color cyan. Color red }.
		{ Color green .Color magenta.  }.
		{ Color blue. Color yellow }.
	} .

	cases do: [ :each |
		self assert: (each  sum = Color white) 
	] .



! !

!SumBugs methodsFor: 'as yet unclassified' stamp: 'ar 5/4/2010 08:44'!
testSummingWithBlack
	"self run: #testSummingWithBlack"

	| cases |
	cases := { 
		Color black.
		Color red.
		Color green.
		Color blue.
		Color cyan.
		Color magenta.
		Color yellow.
		Color white.
	}.

	cases do: [ :each |
		self assert: ((Array with: each with: Color black) sum = each) 
	] .



! !

!SumBugs methodsFor: 'as yet unclassified' stamp: 'ar 5/4/2010 08:45'!
testSummingWithWhite
	"self run: #testSummingWithWhite"

	| cases |
	cases := { 
		Color black.
		Color red.
		Color green.
		Color blue.
		Color cyan.
		Color magenta.
		Color yellow.
		Color white.
	} .

	cases do: [ :each |
		self assert: ((Array with: Color white with: each ) sum = Color white) 
	] .



! !

TestCase subclass: #SystemDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-System-Support'!

!SystemDictionaryTest methodsFor: 'testing - classes and traits' stamp: 'fbs 1/9/2011 16:53'!
testClassOrTraitNamedReturnsClassForClasses
	self assert: Object ==  (Smalltalk globals classOrTraitNamed: 'Object').
	self assert: Object ==  (Smalltalk globals classOrTraitNamed: #Object).! !

!SystemDictionaryTest methodsFor: 'testing - classes and traits' stamp: 'fbs 1/9/2011 16:53'!
testClassOrTraitNamedReturnsNilForGlobals
	self assert: nil = (Smalltalk globals classOrTraitNamed: 'Undeclared').
	self assert: nil = (Smalltalk globals classOrTraitNamed: #Undeclared).! !

TestCase subclass: #SystemNavigationTest
	instanceVariableNames: 'sysNav env'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-System-Support'!

!SystemNavigationTest methodsFor: 'as yet unclassified' stamp: 'fbs 5/10/2013 17:03'!
createClass: aSymbol
	| builder |
	builder := ClassBuilder new.
	^ builder
		name: aSymbol
		inEnvironment: env
		subclassOf: Object
		type: #normal
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'Test'.! !

!SystemNavigationTest methodsFor: 'as yet unclassified' stamp: 'fbs 5/10/2013 17:30'!
createTrait: aSymbol
	^ Trait
		named: aSymbol
		uses: #()
		category: 'Traits'
		env: env.! !

!SystemNavigationTest methodsFor: 'as yet unclassified' stamp: 'fbs 5/21/2013 17:50'!
setUp
	| g p t |
	env := Environment named: 'test'.
	g := self createClass: #Griffle.
	p := self createClass: #Plonk.
	g compile: 'foo ^ 1'.
	g class compile: 'classFoo ^ 1'.
	g compile: 'bar ^ 1'.
	p compile: 'foo ^ 2'.
	t := self createTrait: #TGriffle.
	t compile: 'baz ^ Griffle new foo + Plonk new bar'.
	self createClass: #Unused.
	sysNav := SystemNavigation for: env.! !

!SystemNavigationTest methodsFor: 'as yet unclassified' stamp: 'fbs 5/10/2013 08:52'!
testAllClassesDoShouldIterateOverClassesInAnEnvironment
	| classes |
	classes := OrderedCollection new.
	sysNav allClassesDo: [:cls |
		classes add: cls].
	self assert: env allClasses equals: classes asArray.! !

!SystemNavigationTest methodsFor: 'as yet unclassified' stamp: 'fbs 5/10/2013 08:50'!
testAllClassesShouldReturnEnvironmentsClasses
	self assert: env allClasses equals: sysNav allClasses.! !

!SystemNavigationTest methodsFor: 'as yet unclassified' stamp: 'ul 11/2/2015 04:53'!
testAllImplementedMessagesWithout

	self assert: #(bar baz classFoo) asIdentitySet
		equals: (sysNav allImplementedMessagesWithout: {{env at: #Griffle}. {#foo}}).! !

!SystemNavigationTest methodsFor: 'as yet unclassified' stamp: 'fbs 5/10/2013 17:15'!
testAllImplementorsOf
	self assert: (OrderedCollection
			with: (MethodReference class: (env at: #Griffle) selector: #foo)
			with: (MethodReference class: (env at: #Plonk) selector: #foo))
		equals: (sysNav allImplementorsOf: #foo).! !

!SystemNavigationTest methodsFor: 'as yet unclassified' stamp: 'fbs 5/21/2013 18:59'!
testAllImplementorsOfClassSide
	self assert: (OrderedCollection
			with: (MethodReference class: (env at: #Griffle) class selector: #classFoo))
		equals: (sysNav allImplementorsOf: #classFoo).! !

!SystemNavigationTest methodsFor: 'as yet unclassified' stamp: 'ul 11/2/2015 04:51'!
testAllSentMessagesWithout

	self 
		assert: (#(foo bar) asIdentitySet
			addAll: Smalltalk presumedSentMessages;
			addAll: Smalltalk specialSelectors;
			yourself)
		equals: (sysNav allSentMessagesWithout: {{env at: #Griffle}. {#+}}).! !

!SystemNavigationTest methodsFor: 'as yet unclassified' stamp: 'fbs 5/12/2013 11:01'!
testAllUnusedClassesWithout
	self assert: (IdentitySet with: #Unused) equals: ((SystemNavigation for: env) allUnusedClassesWithout: {{}. {}}).
"The classes passed to #allUnusedClassesWithout: are not filtered from the list. They're classes whose methods are not examined for global references."
	self deny: ((SystemNavigation for: env) allUnusedClassesWithout: {{#Unused}. {}}) isEmpty description: 'Where did Unused go?'.! !

!SystemNavigationTest methodsFor: 'as yet unclassified' stamp: 'fbs 5/10/2013 08:50'!
testDefaultAllClassesAndTraitsShouldReturnTopEnvironmentClassesAndTraits
	self assert: Smalltalk allClassesAndTraits equals: SystemNavigation default allClassesAndTraits.! !

!SystemNavigationTest methodsFor: 'as yet unclassified' stamp: 'fbs 5/10/2013 08:49'!
testDefaultAllClassesShouldReturnTopEnvironmentClasses
	self assert: Smalltalk allClasses equals: SystemNavigation default allClasses.! !

TestCase subclass: #SystemOrganizerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-System-Support'!

!SystemOrganizerTest methodsFor: 'tests' stamp: 'spd 5/19/2010 15:53'!
testAccessGlobalDirectly
	"
	SystemOrganizerTest run: #testAccessGlobalDirectly
	"
	
	self assert: (SystemOrganization isKindOf: SystemOrganizer).	
			
	"It really lives in Smalltalk (another global)"
	self assert: ((Smalltalk at: #SystemOrganization) == SystemOrganization).! !

!SystemOrganizerTest methodsFor: 'tests' stamp: 'spd 5/19/2010 15:53'!
testAccessGlobalThroughClass
	"
	SystemOrganizerTest run: #testAccessGlobalThroughClass
	"
		
	"In case someone stumbles upon the SystemOrganizer class, and does not know
	about the SystemNavigation global, it can be accessed from there, too."
	self assert: (SystemOrganizer default == SystemOrganization).
! !

TestCase subclass: #SystemVersionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-System-Support'!

!SystemVersionTest commentStamp: 'tlk 11/14/2004 10:47' prior: 0!
I am an sunit test for SystemVersion.  Originally created to test SqueakMapSystemVersionFix change set.
I have no test fixtures.!

!SystemVersionTest methodsFor: 'as yet unclassified' stamp: 'tlk 11/14/2004 10:55'!
testMajorMinorVersion
	"
	SystemVersionTest run: #testMajorMinorVersion
	"
	self assert: (SystemVersion new version: 'Squeak3.7alpha') majorMinorVersion = 'Squeak3.7'.
	self assert: (SystemVersion new version: 'Squeak3.7') majorMinorVersion = 'Squeak3.7'.
	self assert: (SystemVersion new version: 'Squeak3') majorMinorVersion = 'Squeak3'.
	self assert: (SystemVersion new version: '') majorMinorVersion = ''.
! !

TestCase subclass: #TestObjectsAsMethods
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-ObjectsAsMethods'!

!TestObjectsAsMethods methodsFor: 'running' stamp: 'al 2/9/2009 20:19'!
setUp
	SystemChangeNotifier uniqueInstance doSilently: [
		self class addSelector: #add:with: withMethod: ObjectsAsMethodsExample new.
		self class addSelector: #answer42 withMethod: ObjectsAsMethodsExample new.
		self class addSelector: #foo withMethod: AbstractObjectsAsMethod new ]! !

!TestObjectsAsMethods methodsFor: 'running' stamp: 'al 2/9/2009 20:19'!
tearDown
	SystemChangeNotifier uniqueInstance doSilently: [
		self class removeSelector: #add:with:.
		self class removeSelector: #answer42.
		self class removeSelector: #foo ]! !

!TestObjectsAsMethods methodsFor: 'testing' stamp: 'al 2/9/2009 19:55'!
testAddNumbers
	self assert: (self add: 3 with: 4) = 7.
	self assert: (self perform: #add:with: withArguments: #(3 4)) = 7.! !

!TestObjectsAsMethods methodsFor: 'testing' stamp: 'al 2/9/2009 19:52'!
testAnswer42 
	self assert: self answer42 = 42! !

!TestObjectsAsMethods methodsFor: 'testing' stamp: 'al 2/9/2009 19:52'!
testDNU 
	self should: [self foo] raise: MessageNotUnderstood! !

TestCase subclass: #TestVMStatistics
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Bugs'!

!TestVMStatistics commentStamp: 'dtl 12/14/2014 10:43' prior: 0!
The VM statistics array is provided by the VM. Its size and contents vary for different VM implementations. This test should pass on any VM.!

!TestVMStatistics methodsFor: 'testing' stamp: 'dtl 12/14/2014 10:42'!
testVmStatisticsReportString
	"Results of this test vary by VM implementation. Failure usually indicates
	an unchecked assumption about the array size."

	self shouldnt: [Smalltalk vmStatisticsReportString]
		raise: Error
		description: 'probable unchecked VM statistics array size'
! !

TestCase subclass: #TestValueWithinFix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Bugs'!

!TestValueWithinFix methodsFor: 'tests' stamp: 'nice 12/27/2009 03:11'!
testValueWithinNonLocalReturnFixReal
	"self run: #testValueWithinNonLocalReturnFixReal"
	"The real test for the fix is just as obscure as the original problem"
	| startTime |
	self valueWithinNonLocalReturn.
	startTime := Time millisecondClockValue.
	[[] repeat] valueWithin: 100 milliSeconds onTimeout:[ | deltaTime |
		"This *should* timeout after 100 msecs but the pending process from
		the previous invokation will signal timeout after 20 msecs already
		which will in turn cut this invokation short."
		deltaTime := Time millisecondClockValue - startTime.
		self deny: deltaTime < 90.
	].
! !

!TestValueWithinFix methodsFor: 'tests' stamp: 'ar 8/17/2007 13:38'!
testValueWithinNonLocalReturnFixSimply
	"self run: #testValueWithinNonLocalReturnFixSimply"
	"The simple version to test the fix"
	self valueWithinNonLocalReturn.
	self shouldnt:[(Delay forMilliseconds: 50) wait] raise: TimedOut.! !

!TestValueWithinFix methodsFor: 'tests' stamp: 'ar 12/4/2012 20:35'!
testValueWithinTimingBasic
	"Test timing of valueWithin:onTimeout:"
	| time |
	time := [
		[1000 milliSeconds asDelay wait]
			valueWithin: 100 milliSeconds onTimeout: []
	] durationToRun.
	self assert: time < 150 milliSeconds.! !

!TestValueWithinFix methodsFor: 'tests' stamp: 'ar 12/4/2012 20:35'!
testValueWithinTimingNestedInner
	"Test nested timing of valueWithin:onTimeout:"
	| time |
	time := [
		[
			[5 seconds asDelay wait]
				valueWithin: 100 milliSeconds onTimeout: []
		] valueWithin: 500 milliSeconds onTimeout: []
	] durationToRun.
	self assert: time < 150 milliSeconds.
! !

!TestValueWithinFix methodsFor: 'tests' stamp: 'ar 12/4/2012 20:35'!
testValueWithinTimingNestedOuter
	"Test nested timing of valueWithin:onTimeout:"
	| time |
	time := [
		[
			3 timesRepeat: [
				[5 seconds asDelay wait]
					valueWithin: 100 milliSeconds onTimeout: []]
		] valueWithin: 150 milliSeconds onTimeout: []
	] durationToRun.
	self assert: time > 100 milliSeconds.
	self assert: time < 200 milliSeconds.
	! !

!TestValueWithinFix methodsFor: 'tests' stamp: 'ul 11/23/2013 22:34'!
testValueWithinTimingRepeat
	"Test timing of valueWithin:onTimeout:"
	| time |
	time := [
		3 timesRepeat: [
			[500 milliSeconds asDelay wait]
				valueWithin: 100 milliSeconds onTimeout: []]
	] durationToRun.

	self assert: time < 350 milliSeconds description: 'Took ', time printString.! !

!TestValueWithinFix methodsFor: 'tests' stamp: 'ar 8/17/2007 13:37'!
valueWithinNonLocalReturn
	"Do a non-local return from a valueWithin: block"
	[^self] valueWithin: 20 milliSeconds onTimeout:[].
! !

TestCase subclass: #TextDiffBuilderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-FilePackage'!

!TextDiffBuilderTest methodsFor: 'private' stamp: 'ul 9/11/2013 01:07'!
convertToString: anArray lineEndingSelector: aSymbol

	^String streamContents: [ :stream |
		anArray do: [ :each |
			stream nextPutAll: each asString; perform: aSymbol ] ]! !

!TextDiffBuilderTest methodsFor: 'private' stamp: 'ul 9/11/2013 01:16'!
patchSequenceFor: x and: y

	^self 
		patchSequenceFor: x
		lineEnding: #cr
		and: y
		lineEnding: #cr
		ignoreLineEndings: false! !

!TextDiffBuilderTest methodsFor: 'private' stamp: 'ul 9/11/2013 01:15'!
patchSequenceFor: x lineEnding: xLineEnding and: y lineEnding: yLineEnding ignoreLineEndings: ignoreLineEndings

	^(TextDiffBuilder
		from: (self convertToString: x lineEndingSelector: xLineEnding)
		to:  (self convertToString: y lineEndingSelector: yLineEnding)
		ignoreLineEndings: ignoreLineEndings) buildPatchSequence! !

!TextDiffBuilderTest methodsFor: 'tests' stamp: 'ul 9/11/2013 17:05'!
testEmptyLcs1

	| patch |
	patch := self patchSequenceFor: #(a b c) and: #().
	self validatePatch: patch matches: 0 insertions: 0 removals: 3! !

!TextDiffBuilderTest methodsFor: 'tests' stamp: 'ul 9/11/2013 17:06'!
testEmptyLcs2

	| patch |
	patch := self patchSequenceFor: #() and: #(a b c).
	self validatePatch: patch matches: 0 insertions: 3 removals: 0! !

!TextDiffBuilderTest methodsFor: 'tests' stamp: 'ul 9/11/2013 17:06'!
testEmptyLcs3

	| patch |
	patch := self patchSequenceFor: #(a b c) and: #(d e f g).
	self validatePatch: patch matches: 0 insertions: 4 removals: 3.
	patch do: [ :each |
		each key = #remove ifTrue: [ self assert: ('abc' includes: each value first) ].
		each key = #insert ifTrue: [ self assert: ('defg' includes: each value first) ] ]! !

!TextDiffBuilderTest methodsFor: 'tests' stamp: 'ul 9/11/2013 17:06'!
testEmptySequences

	| patch |
	patch := self patchSequenceFor: #() and: #().
	self validatePatch: patch matches: 0 insertions: 0 removals: 0! !

!TextDiffBuilderTest methodsFor: 'tests' stamp: 'ul 9/11/2013 17:12'!
testIfPatchIsMinimal

	| patch |
	patch := self patchSequenceFor: #(a a a b) and: #(a b a a).
	self validatePatch: patch matches: 3 insertions: 1 removals: 1. "lcs is aaa"
	patch do: [ :each | 
		each key = #match 
			ifTrue: [ self assert: $a equals: each value first ]
			ifFalse: [ self assert: $b equals: each value first ] ]! !

!TextDiffBuilderTest methodsFor: 'tests' stamp: 'ul 9/11/2013 17:08'!
testIfSequence1
	"lcs is any one letter sequence"
	
	| patch |
	patch := self patchSequenceFor: #(a b c d) and: #(d c b a).
	self validatePatch: patch matches: 1 insertions: 3 removals: 3. "lcs is any one letter sequence"! !

!TextDiffBuilderTest methodsFor: 'tests' stamp: 'ul 9/11/2013 17:08'!
testIfSequence2

	| patch |
	patch := self patchSequenceFor: #(a b c d) and: #(c d b a).
	self validatePatch: patch matches: 2 insertions: 2 removals: 2. "lcs is cd"
	patch do: [ :each | 
		each key = #match 
			ifTrue: [ self assert: ('cd' includes: each value first) ]
			ifFalse: [ self assert: ('ab' includes: each value first) ] ]! !

!TextDiffBuilderTest methodsFor: 'tests' stamp: 'ul 9/11/2013 17:10'!
testIfSequence3

	| patch |
	patch := self patchSequenceFor: #(a b c d) and: #(b d c a).
	self validatePatch: patch matches: 2 insertions: 2 removals: 2. "lcs is bd"
	patch do: [ :each | 
		each key = #match 
			ifTrue: [ self assert: ('bd' includes: each value first) ]
			ifFalse: [ self assert: ('ac' includes: each value first) ] ]! !

!TextDiffBuilderTest methodsFor: 'tests' stamp: 'ul 9/11/2013 17:10'!
testIfSequence4

	| patch |
	patch := self patchSequenceFor: #(a b c d) and: #(d b c a).
	self validatePatch: patch matches: 2 insertions: 2 removals: 2. "lcs is bc"
	patch do: [ :each | 
		each key = #match 
			ifTrue: [ self assert: ('bc' includes: each value first) ]
			ifFalse: [ self assert: ('ad' includes: each value first) ] ]! !

!TextDiffBuilderTest methodsFor: 'tests' stamp: 'ul 9/11/2013 17:11'!
testIfSequence5

	| patch matches nonMatches |
	patch := self patchSequenceFor: #(a b c d) and: #(c d a b).
	self validatePatch: patch matches: 2 insertions: 2 removals: 2. "lcs is ab or cd"
	matches := (patch select: [ :each | each key = #match ])
		collect: [ :each | each value first ] as: String.
	self assert: (#('ab' 'cd') includes: matches).
	nonMatches := #('ab' 'cd') detect: [ :each | each ~= matches ].
	patch do: [ :each | 
		each key = #match 
			ifTrue: [ self assert: (matches includes: each value first) ]
			ifFalse: [ self assert: (nonMatches includes: each value first) ] ]! !

!TextDiffBuilderTest methodsFor: 'tests' stamp: 'ul 9/11/2013 17:11'!
testIfSequence6

	| patch |
	patch := self patchSequenceFor: #(a b c d) and: #(d a b c).
	self validatePatch: patch matches: 3 insertions: 1 removals: 1. "lcs is abc"
	patch do: [ :each | 
		each key = #match 
			ifTrue: [ self assert: ('abc' includes: each value first) ]
			ifFalse: [ self assert: $d equals: each value first ] ]! !

!TextDiffBuilderTest methodsFor: 'tests' stamp: 'ul 9/11/2013 17:13'!
testIgnoreLineEndings1

	#(cr lf crlf) do: [ :firstLineEnding |
		#(cr lf crlf) do: [ :secondLineEnding |
			| patch |
			patch := self 
				patchSequenceFor: #(a b c d)
				lineEnding: firstLineEnding
				and: #(d c b a)
				lineEnding: secondLineEnding
				ignoreLineEndings: true.
			self validatePatch: patch matches: 1 insertions: 3 removals: 3. "lcs is any one letter sequence" ] ]! !

!TextDiffBuilderTest methodsFor: 'tests' stamp: 'ul 9/11/2013 17:13'!
testIgnoreLineEndings2

	#(cr lf crlf) do: [ :firstLineEnding |
		#(cr lf crlf) do: [ :secondLineEnding |
			| patch |
			patch := self 
				patchSequenceFor: #(a b)
				lineEnding: firstLineEnding
				and: #(a b)
				lineEnding: secondLineEnding
				ignoreLineEndings: false.
			firstLineEnding = secondLineEnding
				ifTrue: [ self validatePatch: patch matches: 2 insertions: 0 removals: 0 ]
				ifFalse: [ self validatePatch: patch matches: 0 insertions: 2 removals: 2 ] ] ]! !

!TextDiffBuilderTest methodsFor: 'tests' stamp: 'ul 9/11/2013 17:14'!
testSameSequence

	| patch |
	patch := self patchSequenceFor: #(a b c) and: #(a b c).
	self validatePatch: patch matches: 3 insertions: 0 removals: 0! !

!TextDiffBuilderTest methodsFor: 'tests' stamp: 'ul 9/11/2013 17:14'!
testSameSequenceWithRepetitions

	| patch |
	patch := self patchSequenceFor: #(a a b a) and: #(a a b a).
	self validatePatch: patch matches: 4 insertions: 0 removals: 0! !

!TextDiffBuilderTest methodsFor: 'private' stamp: 'ul 9/11/2013 17:05'!
validatePatch: patch matches: matches insertions: insertions removals: removals

	self 
		assert: matches equals: (patch count: [ :each | each key = #match ]);
		assert: insertions equals: (patch count: [ :each | each key = #insert ]);
		assert: removals equals: (patch count: [ :each | each key = #remove ]);
		assert: matches + insertions + removals equals: patch size! !

TestCase subclass: #ThirtyTwoBitRegisterTest
	instanceVariableNames: 'random'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-System-Digital Signatures'!

!ThirtyTwoBitRegisterTest methodsFor: 'helpers' stamp: 'ul 4/11/2015 04:21'!
assertBinaryRegisterOperation: registerOperationBlock gives: integerOperationBlock times: n

	| rx ry |
	rx := ThirtyTwoBitRegister new.
	ry := rx copy.
	n timesRepeat: [
		| x y expectedResult |
		x := self nextRandom.
		y := self nextRandom.
		expectedResult := integerOperationBlock value: x value: y .
		rx load: x.
		ry load: y.
		registerOperationBlock value: rx value: ry.
		self assert: expectedResult equals: rx asInteger ]! !

!ThirtyTwoBitRegisterTest methodsFor: 'helpers' stamp: 'ul 4/11/2015 04:48'!
assertComparisonRegisterOperation: registerOperationBlock gives: integerOperationBlock times: n

	| rx ry |
	rx := ThirtyTwoBitRegister new.
	ry := rx copy.
	n timesRepeat: [
		| x y expectedResult actualResult |
		x := self nextRandom.
		y := self nextRandom.
		expectedResult := integerOperationBlock value: x value: y .
		rx load: x.
		ry load: y.
		actualResult := registerOperationBlock value: rx value: ry.
		self assert: expectedResult equals: actualResult ]! !

!ThirtyTwoBitRegisterTest methodsFor: 'helpers' stamp: 'ul 4/11/2015 04:22'!
assertUnaryRegisterOperation: registerOperationBlock gives: integerOperationBlock times: n

	| rx |
	rx := ThirtyTwoBitRegister new.
	n timesRepeat: [
		| x expectedResult |
		x := self nextRandom.
		expectedResult := integerOperationBlock value: x.
		rx load: x.
		registerOperationBlock value: rx.
		self assert: expectedResult equals: rx asInteger ]! !

!ThirtyTwoBitRegisterTest methodsFor: 'helpers' stamp: 'ul 4/11/2015 04:08'!
nextRandom
	"Return the next random 32-bit unsigned integer value."

	^(random nextInt: 4294967296) - 1! !

!ThirtyTwoBitRegisterTest methodsFor: 'running' stamp: 'ul 4/11/2015 04:40'!
setUp

	random := Random seed: 36rSqueak! !

!ThirtyTwoBitRegisterTest methodsFor: 'tests - accumulator ops' stamp: 'ul 4/11/2015 04:19'!
testAddition

	self
		assertBinaryRegisterOperation: [ :rx :ry | rx += ry ]
		gives: [ :x :y | x + y bitAnd: 16rFFFFFFFF ]
		times: 10000! !

!ThirtyTwoBitRegisterTest methodsFor: 'tests - accumulator ops' stamp: 'ul 4/11/2015 04:19'!
testBitAnd

	self
		assertBinaryRegisterOperation: [ :rx :ry | rx bitAnd: ry ]
		gives: [ :x :y | x bitAnd: y ]
		times: 10000! !

!ThirtyTwoBitRegisterTest methodsFor: 'tests - accumulator ops' stamp: 'ul 4/11/2015 04:26'!
testBitInvert

	self
		assertUnaryRegisterOperation: [ :rx | rx bitInvert ]
		gives: [ :x | x bitInvert32 ]
		times: 10000! !

!ThirtyTwoBitRegisterTest methodsFor: 'tests - accumulator ops' stamp: 'ul 4/11/2015 04:20'!
testBitOr

	self
		assertBinaryRegisterOperation: [ :rx :ry | rx bitOr: ry ]
		gives: [ :x :y | x bitOr: y ]
		times: 10000! !

!ThirtyTwoBitRegisterTest methodsFor: 'tests - accumulator ops' stamp: 'ul 4/11/2015 04:20'!
testBitXor

	self
		assertBinaryRegisterOperation: [ :rx :ry | rx bitXor: ry ]
		gives: [ :x :y | x bitXor: y ]
		times: 10000! !

!ThirtyTwoBitRegisterTest methodsFor: 'tests - comparison' stamp: 'ul 4/11/2015 04:50'!
testEquals

	self
		assertComparisonRegisterOperation: [ :rx :ry | rx = ry ]
		gives: [ :x :y | x = y ]
		times: 1000! !

!ThirtyTwoBitRegisterTest methodsFor: 'tests - comparison' stamp: 'ul 4/11/2015 04:51'!
testGreater

	self
		assertComparisonRegisterOperation: [ :rx :ry | rx > ry ]
		gives: [ :x :y | x > y ]
		times: 1000! !

!ThirtyTwoBitRegisterTest methodsFor: 'tests - comparison' stamp: 'ul 4/11/2015 04:51'!
testGreaterOrEqual

	self
		assertComparisonRegisterOperation: [ :rx :ry | rx >= ry ]
		gives: [ :x :y | x >= y ]
		times: 1000! !

!ThirtyTwoBitRegisterTest methodsFor: 'tests' stamp: 'ul 4/11/2015 04:32'!
testHi

	self
		assertUnaryRegisterOperation: [ :rx | rx load: rx hi ]
		gives: [ :x | x bitShift: -16 ]
		times: 1000! !

!ThirtyTwoBitRegisterTest methodsFor: 'tests - accumulator ops' stamp: 'ul 4/11/2015 04:36'!
testLeftRotateBy

	0 to: 33 do: [ :shift |
		self
			assertUnaryRegisterOperation: [ :rx | rx leftRotateBy: shift ]
			gives: [ :x | 
				| actualShift |
				actualShift := shift \\ 32.
				(x << actualShift bitOr: x >> (32 - actualShift)) bitAnd: 16rFFFFFFFF ]
			times: 1000 ]! !

!ThirtyTwoBitRegisterTest methodsFor: 'tests - accumulator ops' stamp: 'ul 4/11/2015 04:25'!
testLeftShift

	0 to: 33 do: [ :shift |
		self
			assertUnaryRegisterOperation: [ :rx | rx << shift ]
			gives: [ :x | x << shift bitAnd: 16rFFFFFFFF ]
			times: 1000 ]! !

!ThirtyTwoBitRegisterTest methodsFor: 'tests - comparison' stamp: 'ul 4/11/2015 04:49'!
testLess

	self
		assertComparisonRegisterOperation: [ :rx :ry | rx < ry ]
		gives: [ :x :y | x < y ]
		times: 1000! !

!ThirtyTwoBitRegisterTest methodsFor: 'tests - comparison' stamp: 'ul 4/11/2015 04:50'!
testLessOrEqual

	self
		assertComparisonRegisterOperation: [ :rx :ry | rx <= ry ]
		gives: [ :x :y | x <= y ]
		times: 1000! !

!ThirtyTwoBitRegisterTest methodsFor: 'tests' stamp: 'ul 4/11/2015 04:29'!
testLoad

	1000 timesRepeat: [
		| value |
		value := self nextRandom.
		self
			assertUnaryRegisterOperation: [ :rx | rx load: value ]
			gives: [ :x | value ]
			times: 1 ]! !

!ThirtyTwoBitRegisterTest methodsFor: 'tests' stamp: 'ul 4/11/2015 04:29'!
testLoadFrom

	self
		assertBinaryRegisterOperation: [ :rx :ry | rx loadFrom: ry ]
		gives: [ :x :y | y ]
		times: 10000! !

!ThirtyTwoBitRegisterTest methodsFor: 'tests' stamp: 'ul 4/11/2015 04:32'!
testLow

	self
		assertUnaryRegisterOperation: [ :rx | rx load: rx low ]
		gives: [ :x | x bitAnd: 16rFFFF ]
		times: 1000! !

!ThirtyTwoBitRegisterTest methodsFor: 'tests - accumulator ops' stamp: 'ul 4/11/2015 04:20'!
testMultiplication

	self
		assertBinaryRegisterOperation: [ :rx :ry | rx *= ry ]
		gives: [ :x :y | x * y bitAnd: 16rFFFFFFFF ]
		times: 10000! !

!ThirtyTwoBitRegisterTest methodsFor: 'tests - accumulator ops' stamp: 'ul 4/11/2015 04:25'!
testRightShift

	0 to: 33 do: [ :shift |
		self
			assertUnaryRegisterOperation: [ :rx | rx >> shift ]
			gives: [ :x | x >> shift bitAnd: 16rFFFFFFFF ]
			times: 1000 ]! !

TestCase subclass: #UnderscoreSelectorsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Compiler'!

!UnderscoreSelectorsTest methodsFor: 'support' stamp: 'cwp 8/13/2012 23:07'!
assertSelector: aSymbol hasPrecedence: expected
	| actual |
	actual := aSymbol precedence.
	self assert: actual = expected! !

!UnderscoreSelectorsTest methodsFor: 'support' stamp: 'cwp 10/21/2012 09:24'!
assertString: aString hasNumArgs: anInteger
	| num |
	num := aString numArgs.
	self assert: num = anInteger! !

!UnderscoreSelectorsTest methodsFor: 'support' stamp: 'cwp 8/13/2012 16:10'!
pref: aBoolean during: aBlock
	| tmp |
	tmp := Scanner prefAllowUnderscoreSelectors.
	[Scanner prefAllowUnderscoreSelectors: aBoolean.
	aBlock value] ensure: 
		[Scanner prefAllowUnderscoreSelectors: tmp].! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 09:33'!
testA0NoUnderscoreAllowed
	self pref: true during: [self assertString: 'ab' hasNumArgs: 0]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 09:33'!
testA0NoUnderscoreForbidden
	self pref: false during: [self assertString: 'ab' hasNumArgs: 0]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 09:29'!
testA0UnderscoreAllowed
	self pref: true during: [self assertString: 'a_b' hasNumArgs: 0]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 09:58'!
testA0UnderscoreForbidden
	self pref: false during: [self assertString: 'a_b' hasNumArgs: -1]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 09:33'!
testA1NoUnderscoreAllowed
	self pref: true during: [self assertString: 'ab:' hasNumArgs: 1]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 09:34'!
testA1NoUnderscoreForbidden
	self pref: false during: [self assertString: 'ab:' hasNumArgs: 1]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 09:34'!
testA1UnderscoreAllowed
	self pref: true during: [self assertString: 'a_b:' hasNumArgs: 1]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 09:58'!
testA1UnderscoreForbidden
	self pref: false during: [self assertString: 'a_b:' hasNumArgs: -1]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 09:35'!
testA2NoUnderscoreAllowed
	self pref: true during: [self assertString: 'ab:cd:' hasNumArgs: 2]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 09:35'!
testA2NoUnderscoreForbidden
	self pref: false during: [self assertString: 'ab:cd:' hasNumArgs: 2]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 09:36'!
testA2UnderscoreAllowed
	self pref: true during: [self assertString: 'a_b:cd:' hasNumArgs: 2]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 09:58'!
testA2UnderscoreForbidden
	self pref: false during: [self assertString: 'a_b:cd:' hasNumArgs: -1]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 11:03'!
testB1Allowed
	self pref: true during: [self assertString: '+' hasNumArgs: 1]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 11:05'!
testB1Forbidden
	self pref: false during: [self assertString: '+' hasNumArgs: 1]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 11:06'!
testB2Allowed
	self pref: true during: [self assertString: '++' hasNumArgs: 1]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 11:06'!
testB2Forbidden
	self pref: false during: [self assertString: '++' hasNumArgs: 1]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 09:24'!
testEmpty
	self assertString: '' hasNumArgs: -1! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/24/2012 14:14'!
testInvalidUnderscoreAllowed
	self pref: true during: [self assertString: '3' hasNumArgs: -1]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/24/2012 14:14'!
testInvalidUnderscoreForbidden
	self pref: false during: [self assertString: '3' hasNumArgs: -1]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/24/2012 14:16'!
testLeadingColonAllowed
	self pref: true during: [self assertString: ':if:then:else:' hasNumArgs: -1]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/24/2012 14:27'!
testLeadingColonForbidden
	self pref: false during: [self assertString: #':if:then:else:' hasNumArgs: -1]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/24/2012 14:22'!
testNoTrailingColonAllowed
	self pref: true during: [self assertString: 'nextPut:andCR' hasNumArgs: -1]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/24/2012 14:22'!
testNoTrailingColonForbidden
	self pref: false during: [self assertString: 'nextPut:andCR' hasNumArgs: -1]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 8/13/2012 23:21'!
testP1InternalUnderscore
	
	self 
		assertSelector: #'is_symbol' 
		hasPrecedence: 1.
! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 8/13/2012 23:21'!
testP1LeadingUnderscore
	self 
		assertSelector: #'_isSymbol' 
		hasPrecedence: 1.
! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 8/14/2012 10:19'!
testP1SingleUnderscore
	self
		assertSelector: #'_'
		hasPrecedence: 1! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 8/13/2012 23:22'!
testP1Traditional
	self
		assertSelector: #isSymbol
		hasPrecedence: 1! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 8/13/2012 23:22'!
testP1TrailingUnderscore
	self
		assertSelector: #'isSymbol_'
		hasPrecedence: 1! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 8/13/2012 23:23'!
testP2Traditional
	self
		assertSelector: #+
		hasPrecedence: 2! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 8/13/2012 23:24'!
testP3InternalUnderscore
	self
		assertSelector: #'with_value:'
		hasPrecedence: 3! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 8/13/2012 23:24'!
testP3LeadingUnderscore
	self
		assertSelector: #'_value:'
		hasPrecedence: 3! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 8/13/2012 23:25'!
testP3Traditional
	self
		assertSelector: #value:
		hasPrecedence: 3! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 8/13/2012 23:25'!
testP3TrailingUnderscore
	self
		assertSelector: #'value_:'
		hasPrecedence: 3! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 10:49'!
testSelA0NoUnderscoreAllowed
	self pref: true during: [self assertString: #'ab' hasNumArgs: 0]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 10:49'!
testSelA0NoUnderscoreForbidden
	self pref: false during: [self assertString: #'ab' hasNumArgs: 0]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 10:50'!
testSelA0UnderscoreAllowed
	self pref: true during: [self assertString: #'a_b' hasNumArgs: 0]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 11:01'!
testSelA0UnderscoreForbidden
	self pref: false during: [self assertString: #'a_b' hasNumArgs: 0]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 10:51'!
testSelA1NoUnderscoreAllowed
	self pref: true during: [self assertString: #'ab:' hasNumArgs: 1]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 10:51'!
testSelA1NoUnderscoreForbidden
	self pref: false during: [self assertString: #'ab:' hasNumArgs: 1]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 10:51'!
testSelA1UnderscoreAllowed
	self pref: true during: [self assertString: #'a_b:' hasNumArgs: 1]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 11:01'!
testSelA1UnderscoreForbidden
	self pref: false during: [self assertString: #'a_b:' hasNumArgs: 1]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 10:52'!
testSelA2NoUnderscoreAllowed
	self pref: true during: [self assertString: #'ab:cd:' hasNumArgs: 2]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 10:52'!
testSelA2NoUnderscoreForbidden
	self pref: false during: [self assertString: #'ab:cd:' hasNumArgs: 2]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 10:52'!
testSelA2UnderscoreAllowed
	self pref: true during: [self assertString: #'a_b:cd:' hasNumArgs: 2]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 10:53'!
testSelA2UnderscoreForbidden
	self pref: false during: [self assertString: #'a_b:cd:' hasNumArgs: 2]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 11:02'!
testSelB1Allowed
	self pref: true during: [self assertString: #'+' hasNumArgs: 1]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 11:03'!
testSelB1Forbidden
	self pref: false during: [self assertString: #'+' hasNumArgs: 1]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 11:03'!
testSelB2Allowed
	self pref: true during: [self assertString: #'++' hasNumArgs: 1]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/21/2012 11:05'!
testSelB2Forbidden
	self pref: false during: [self assertString: #'++' hasNumArgs: 1]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/24/2012 14:26'!
testSelEmpty
	self assertString: #'' hasNumArgs: -1! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/24/2012 14:25'!
testSelInvalidUnderscoreAllowed
	self pref: true during: [self assertString: #'3' hasNumArgs: -1]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/24/2012 14:26'!
testSelInvalidUnderscoreForbidden
	self pref: false during: [self assertString: #'3' hasNumArgs: -1]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/24/2012 14:26'!
testSelLeadingColonAllowed
	self pref: true during: [self assertString: #':if:then:else:' hasNumArgs: -1]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/24/2012 14:27'!
testSelNoTrailingColonAllowed
	self pref: true during: [self assertString: #'nextPut:andCR' hasNumArgs: -1]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 10/24/2012 14:28'!
testSelNoTrailingColonForbidden
	self pref: false during: [self assertString: #'nextPut:andCR' hasNumArgs: -1]! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 8/13/2012 23:06'!
testTokenishFalse
	self pref: false during: [self deny: $_ tokenish].! !

!UnderscoreSelectorsTest methodsFor: 'tests' stamp: 'cwp 8/13/2012 23:25'!
testTokenishTrue
	self pref: true during: [self assert: $_ tokenish].! !

TestCase subclass: #UserInterfaceThemeTest
	instanceVariableNames: 'theme previous'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-System-Preferences'!

!UserInterfaceThemeTest methodsFor: 'running' stamp: 'mt 7/1/2016 14:55'!
setUp

	super setUp.
	previous := UserInterfaceTheme current.
	theme := UserInterfaceTheme new name: 'ui theme test'.! !

!UserInterfaceThemeTest methodsFor: 'running' stamp: 'mt 7/3/2016 13:26'!
tearDown

	previous
		ifNil: [UserInterfaceTheme reset]
		ifNotNil: [UserInterfaceTheme current == previous
			ifFalse: [previous apply]].
		
	super tearDown.! !

!UserInterfaceThemeTest methodsFor: 'tests' stamp: 'mt 7/1/2016 14:35'!
test01ImplementationHooks
	"Any class which implements themeProperties must implement #applyUserInterfaceTheme on the instance side."
	
	| problematicClasses |
	problematicClasses := OrderedCollection new.
	Smalltalk allClassesDo: [ : each | ((each theMetaClass includesSelector: #themeProperties) not
		or: [each theNonMetaClass includesSelector: #applyUserInterfaceTheme])
			ifFalse: [problematicClasses add: each]].
	self assert: problematicClasses isEmpty description: ('UI Theme Violations: {1}' format: {(problematicClasses collect: [:ea | ea name]) joinSeparatedBy: ' '})! !

!UserInterfaceThemeTest methodsFor: 'tests' stamp: 'mt 7/3/2016 13:28'!
test02SetProperty

	| m |
	m := UserInterfaceThemeTestObject new.

	theme set: #testColor for: UserInterfaceThemeTestObject to: Color white.
	self assert: m testColor isNil.

	theme apply.
	self assert: Color white equals: m testColor.
! !

!UserInterfaceThemeTest methodsFor: 'tests' stamp: 'mt 7/1/2016 14:54'!
test03RegisterAndName

	self deny: (UserInterfaceTheme allThemes includes: theme).
	theme register.
	self assert: (UserInterfaceTheme allThemes includes: theme).
	theme unregister.
	self deny: (UserInterfaceTheme allThemes includes: theme).
	
	theme name: 'test03'.
	theme register.
	self assert: theme == (UserInterfaceTheme named: 'test03').
	theme unregister.
	
	self assert: theme ~~ (UserInterfaceTheme named: 'testXX').
	self assert:  (UserInterfaceTheme named: 'testXX') == (UserInterfaceTheme named: 'testXX').
	(UserInterfaceTheme named: 'testXX') unregister.
	self deny: (UserInterfaceTheme allThemes anySatisfy: [:ea | ea name = 'testXX']).! !

!UserInterfaceThemeTest methodsFor: 'tests' stamp: 'mt 7/3/2016 13:28'!
test04SuperClassLookup

	| m |
	m := UserInterfaceThemeTestObject new.

	theme set: #testColor for: Object to: Color white.
	self assert: m testColor isNil.

	theme apply.
	self assert: Color white equals: m testColor.
! !

!UserInterfaceThemeTest methodsFor: 'tests' stamp: 'mt 7/3/2016 13:29'!
test05ClearProperty

	| m |
	m := UserInterfaceThemeTestObject new.
	theme set: #testColor for: UserInterfaceThemeTestObject to: Color white.
	theme apply.

	self assert: Color white equals: m testColor.
	theme clear: #testColor for: UserInterfaceThemeTestObject.
	self assert: Color white equals: m testColor.
	theme apply.
	
	self assert: m testColor isNil.
! !

!UserInterfaceThemeTest methodsFor: 'tests' stamp: 'mt 7/3/2016 13:29'!
test06SetAndClearUnkownProperty
	"Unknown means not defined in #themeProperties und used in code such as #applyUserInterfaceTheme."
	
	| m |
	m := UserInterfaceThemeTestObject new.
	theme set: #unknownProperty for: UserInterfaceThemeTestObject to: #blubb.
	theme apply.

	self assert:#blubb equals: m unknownProperty.
	theme clear: #unknownProperty for: UserInterfaceThemeTestObject.
	self assert:#blubb equals: m unknownProperty.
	theme apply.
	
	self assert: m unknownProperty isNil.
! !

!UserInterfaceThemeTest methodsFor: 'tests' stamp: 'mt 7/1/2016 15:27'!
test07Merge

	| anotherTheme |
	anotherTheme := UserInterfaceTheme new.
	anotherTheme set: #someColor for: Morph to: Color red.
	anotherTheme set: #thirdColor for: Morph to: Color blue.

	theme set: #myColor for: Morph to: Color white.
	theme set: #thirdColor for: Morph to: Color yellow.
	
	self assert: (theme get: #someColor for: Morph) isNil.
	self assert: (anotherTheme get: #myColor for: Morph) isNil.
	
	theme merge: anotherTheme.
	
	self assert: Color red equals: (theme get: #someColor for: Morph).
	self assert: (anotherTheme get: #myColor for: Morph) isNil.

	"No overwrite."
	self assert: Color yellow equals: (theme get: #thirdColor for: Morph).
	self assert: Color blue equals: (anotherTheme get: #thirdColor for: Morph).
! !

!UserInterfaceThemeTest methodsFor: 'tests' stamp: 'mt 7/1/2016 15:28'!
test08MergeAndOverwrite

	| anotherTheme |
	anotherTheme := UserInterfaceTheme new.
	anotherTheme set: #thirdColor for: Morph to: Color blue.
	theme set: #thirdColor for: Morph to: Color yellow.
	
	self assert: Color yellow equals: (theme get: #thirdColor for: Morph).
	self assert: Color blue equals: (anotherTheme get: #thirdColor for: Morph).

	theme merge: anotherTheme overwrite: true.

	self assert: Color blue equals: (theme get: #thirdColor for: Morph).
	self assert: Color blue equals: (anotherTheme get: #thirdColor for: Morph).! !

!UserInterfaceThemeTest methodsFor: 'tests' stamp: 'mt 7/3/2016 13:31'!
test09Link

	| anotherTheme |
	anotherTheme := UserInterfaceTheme new.
	
	anotherTheme set: #testColor for: Object to: Color white.	
	self assert: (theme get: #testColor for: Object) isNil.

	theme link: anotherTheme.
	self assert: theme next == anotherTheme.
	self assert: Color white equals: (theme get: #testColor for: Object).
! !

!UserInterfaceThemeTest methodsFor: 'tests' stamp: 'mt 7/3/2016 13:54'!
test10Blocks

	theme set: #testColor for: Object to: [Color r: 1 g: 1 b: 1].
	self assert: (theme get: #testColor for: Object) ~~ (theme get: #testColor for: Object).
	
! !

!UserInterfaceThemeTest methodsFor: 'tests' stamp: 'mt 7/3/2016 13:56'!
test11LinkAgain

	| anotherTheme yetAnotherTheme |
	anotherTheme := UserInterfaceTheme new.
	yetAnotherTheme := UserInterfaceTheme new.
	
	yetAnotherTheme set: #testColor for: Object to: Color white.
	self assert: (theme get: #testColor for: Object) isNil.

	theme link: anotherTheme.
	anotherTheme link: yetAnotherTheme.
	
	self assert: Color white equals: (theme get: #testColor for: Object).! !

!UserInterfaceThemeTest methodsFor: 'tests' stamp: 'mt 7/1/2016 15:57'!
test12RealDNU
	"If we forgot to push a scope, it is a real DNU and not stack is empty."
	self should: [theme perform: #undefinedMessage] raise: MessageNotUnderstood! !

!UserInterfaceThemeTest methodsFor: 'tests' stamp: 'mt 7/3/2016 13:58'!
test13ClassName
	
	self assert: (theme get: #testColor for: #Object) isNil.

	theme set: #testColor for: #Object to: Color white.
	self assert: Color white equals: (theme get: #testColor for: #Object).
	
	theme clear: #testColor for: #Object.
	self assert: (theme get: #testColor for: #Object) isNil.

	self shouldnt: [theme set: #testColor for: #SomeNonExistentClass to: Color white] raise: Error.
	self assert: (theme get: #testColor for: nil) isNil.! !

!UserInterfaceThemeTest methodsFor: 'tests' stamp: 'mt 7/3/2016 12:07'!
test14Perform
	
	| m |
	m := UserInterfaceThemeTestObject new.
	theme apply.

	self assert: m getTestColor isNil.
	self assert: m getTestColorViaPerform isNil.

	theme set: #testColor for: #UserInterfaceThemeTestObject to: Color white.

	self assert: Color white equals: m getTestColor.
	self assert: Color white equals: m getTestColorViaPerform.! !

!UserInterfaceThemeTest methodsFor: 'tests' stamp: 'mt 7/3/2016 13:08'!
test15DerivedProperties
	
	theme set: #fanciness for: Point to: 42.
	theme derive: #fanciness for: Rectangle from: Point at: #fanciness.

	self assert: 42 equals: (theme get: #fanciness for: Point).
	self assert: 42 equals: (theme get: #fanciness for: Rectangle).! !

!UserInterfaceThemeTest methodsFor: 'tests' stamp: 'mt 7/3/2016 12:55'!
test16ArraysAsProperties
	"Used, for example, by Shout styling. There might be many reasons for storing arrays as properties."
	
	theme set: #complexSpec for: UserInterfaceThemeTestObject to: {#foo. 42. #(a b c)}.
	
	self assert: {#foo. 42. #(a b c)} equals: (theme get: #complexSpec for: UserInterfaceThemeTestObject).! !

!UserInterfaceThemeTest methodsFor: 'tests' stamp: 'mt 7/3/2016 13:13'!
test17DerivedPropertiesWithBlock
	
	theme set: #fanciness for: Point to: 42.
	theme derive: #fanciness for: Rectangle from: Point at: #fanciness do: [:f | f + 1].

	self assert: 42 equals: (theme get: #fanciness for: Point).
	self assert: 43 equals: (theme get: #fanciness for: Rectangle).! !

!UserInterfaceThemeTest methodsFor: 'tests' stamp: 'mt 7/3/2016 13:22'!
test18MergeWithDerivedProperties
	
	| anotherTheme |
	anotherTheme := UserInterfaceTheme new.
	
	theme set: #fanciness for: Point to: 42.
	theme derive: #fanciness for: Rectangle from: Point at: #fanciness do: [:f | f + 1].

	anotherTheme merge: theme.
	theme set: #fanciness for: Point to: 21.

	self assert: 22 equals: (theme get: #fanciness for: Rectangle).
	self assert: 43 equals: (anotherTheme get: #fanciness for: Rectangle).! !

!UserInterfaceThemeTest methodsFor: 'tests' stamp: 'mt 7/3/2016 13:18'!
test19MergeWithCopy
	
	| anotherTheme |
	anotherTheme := UserInterfaceTheme new.
	
	theme set: #someColor for: Object to: Color red.
	anotherTheme merge: theme.

	self assert: (theme get: #someColor for: Object) ~~ (anotherTheme get: #someColor for: Object).! !

!UserInterfaceThemeTest methodsFor: 'tests' stamp: 'mt 7/3/2016 15:14'!
test20ClassSideApply
	
	UserInterfaceThemeTestObject resetApplyCounter.
	self assert: 0 equals: UserInterfaceThemeTestObject applyCounter.
	theme apply.
	self assert: 1 equals: UserInterfaceThemeTestObject applyCounter.
! !

!UserInterfaceThemeTest methodsFor: 'tests' stamp: 'mt 7/9/2016 11:23'!
test21BlocksNoDuplicateEvaluation
	
	| anotherTheme |
	anotherTheme := UserInterfaceTheme new.
	anotherTheme set: #modifier for: Object to: [ [:color | color darker] ].
	
	theme link: anotherTheme.
	self shouldnt: [theme get: #modifier for: Color] raise: Error.	
	self assert: Color yellow darker equals: ((theme get: #modifier for: Color) value: Color yellow).! !

!UserInterfaceThemeTest methodsFor: 'tests' stamp: 'mt 7/25/2016 14:56'!
test22SetAndClearConveniently

	self assert: (theme get: #foo22) isNil.
	theme set: #foo22 to: 22.
	self assert: 22 equals: (theme get: #foo22).
	theme clear: #foo22.
	self assert: (theme get: #foo22) isNil.! !

!UserInterfaceThemeTest methodsFor: 'tests' stamp: 'mt 7/25/2016 17:46'!
test23LookUpReset
	"When nothing is found in the super-class hierarchy, try linked themes. However, start at with the original class again."

	| anotherTheme |
	anotherTheme := UserInterfaceTheme new.
	

	theme set: #fanciness for: Object to: 42.
	theme set: #fanciness for: Point to: 43.
	
	anotherTheme link: theme.

	self assert: 43 equals: (theme get: #fanciness for: Point).
	self assert: 43 equals: (anotherTheme get: #fanciness for: Point).! !

!UserInterfaceThemeTest methodsFor: 'tests' stamp: 'mt 7/25/2016 18:01'!
test24GetSimplePropertiesViaLink

	| anotherTheme |
	anotherTheme := UserInterfaceTheme new.
	
	theme set: #fanciness to: 42.	
	anotherTheme link: theme.

	self assert: 42 equals: (anotherTheme get: #fanciness).! !

!UserInterfaceThemeTest methodsFor: 'tests' stamp: 'mt 7/26/2016 10:07'!
test25DerivedPropertiesViaLink
	"It is not (yet?) possible to reset the look-up for derived properties. You should merge themes if you need it."
	
	| anotherTheme |
	anotherTheme := UserInterfaceTheme new.
	
	theme set: #fanciness for: Point to: 42.
	theme derive: #fanciness for: Rectangle from: Point at: #fanciness do: [:f | f + 1].
	
	anotherTheme set: #fanciness for: Point to: 21.
	anotherTheme link: theme.
	
	self assert: 43 equals: (theme get: #fanciness for: Rectangle).
	"self assert: 22 equals: (anotherTheme get: #fanciness for: Rectangle)."
	self assert: 43 equals: (anotherTheme get: #fanciness for: Rectangle).! !

!UserInterfaceThemeTest methodsFor: 'tests' stamp: 'mt 7/29/2016 14:44'!
test26ApplyTo

	| m |
	m := UserInterfaceThemeTestObject new.

	theme set: #testColor for: UserInterfaceThemeTestObject to: Color white.
	self assert: m testColor isNil.

	theme applyTo: {m}.
	self assert: Color white equals: m testColor.
! !

TestCase subclass: #Win32VMTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-VM'!

!Win32VMTest methodsFor: 'tests' stamp: 'mtf 12/16/2010 11:30'!
testWinVM3ButtonMousePreference
	"Ensure that 3ButtonMouse preference is enabled, so that the Win32 VM sends mouse clicks the same way other VMs do"
	| iniData iniPref exePath |
	Smalltalk platformName = 'Win32' ifFalse:[^self].
	exePath := Smalltalk vmFileName.
	iniData := [
		(FileStream readOnlyFileNamed: (exePath copyUpToLast: $.), '.ini')
			 contentsOfEntireFile
	] on: Error do:[:ex| ex return: ''].
	iniPref := false. "default is OFF"
	iniData linesDo:[:line|
		(line beginsWith: '3ButtonMouse') ifTrue:[
			iniPref := (line copyAfter: $=) withBlanksTrimmed ~= '0'.
		].
	].
	self assert: iniPref = true.
! !

PackageInfo subclass: #MCDirtyPackageInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello-Utils'!

!MCDirtyPackageInfo class methodsFor: 'as yet unclassified' stamp: 'avi 2/22/2004 14:04'!
initialize
	[self new register] on: MessageNotUnderstood do: []! !

!MCDirtyPackageInfo class methodsFor: 'as yet unclassified' stamp: 'cwp 7/21/2003 19:45'!
wantsChangeSetLogging
	^ false! !

!MCDirtyPackageInfo methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
classes
	^ Array new: 0.! !

!MCDirtyPackageInfo methodsFor: 'as yet unclassified' stamp: 'fbs 5/21/2013 22:28'!
methods
	^ MCMockClassA selectors
		select: [:ea | ea beginsWith: 'ordinal']
		thenCollect:
			[:ea | 
				MethodReference 
					class: MCMockClassA 
					selector: ea].! !

!MCDirtyPackageInfo methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
packageName
	^ 'MCDirtyPackage'! !

PackageInfo subclass: #MCEmptyPackageInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello-Utils'!

!MCEmptyPackageInfo class methodsFor: 'as yet unclassified' stamp: 'avi 2/22/2004 14:04'!
initialize
	[self new register] on: MessageNotUnderstood do: []! !

!MCEmptyPackageInfo class methodsFor: 'as yet unclassified' stamp: 'cwp 7/21/2003 19:45'!
wantsChangeSetLogging
	^ false! !

!MCEmptyPackageInfo methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
classes
	^ #()! !

!MCEmptyPackageInfo methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
methods
	^ #()! !

!MCEmptyPackageInfo methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2003 23:21'!
packageName
	^ 'MCEmptyPackage'! !

PackageInfo subclass: #MCMockPackageInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Monticello-Utils'!

!MCMockPackageInfo class methodsFor: 'as yet unclassified' stamp: 'fbs 5/7/2013 15:02'!
cleanUp: aggressive
	aggressive ifTrue: [self initialize].! !

!MCMockPackageInfo class methodsFor: 'as yet unclassified' stamp: 'avi 2/22/2004 14:04'!
initialize
	[self new register] on: MessageNotUnderstood do: []! !

!MCMockPackageInfo methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 01:09'!
classNames
	^ #(	MCMockClassA
		 	MCMockASubclass
			MCMockClassB
			MCMockClassD
			MCMockClassE
			MCMockClassF
			MCMockClassG
			MCMockClassH
			MCMockClassI
		)! !

!MCMockPackageInfo methodsFor: 'as yet unclassified' stamp: 'cwp 8/10/2003 01:12'!
classes
	^ self classNames 
		select: [:name | Smalltalk hasClassNamed: name]
		thenCollect: [:name | Smalltalk at: name]! !

!MCMockPackageInfo methodsFor: 'as yet unclassified' stamp: 'fbs 5/21/2013 22:29'!
extensionMethods
	^ Array with: (MethodReference 
					class: MCSnapshotTest 
					selector: #mockClassExtension)! !

!MCMockPackageInfo methodsFor: 'as yet unclassified' stamp: 'bf 5/20/2005 16:54'!
includesClass: aClass
	^self classes includes: aClass! !

!MCMockPackageInfo methodsFor: 'as yet unclassified' stamp: 'bf 5/20/2005 17:18'!
includesSystemCategory: categoryName
	^self systemCategories anySatisfy: [:cat | cat sameAs: categoryName]! !

!MCMockPackageInfo methodsFor: 'as yet unclassified' stamp: 'cwp 8/1/2003 20:31'!
packageName
	^ 'MonticelloMocks'! !

!MCMockPackageInfo methodsFor: 'as yet unclassified' stamp: 'ul 9/11/2012 16:51'!
systemCategories
	^ Array with: 'Tests-MonticelloMocks'! !

Error subclass: #MyResumableTestError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Exceptions'!

!MyResumableTestError methodsFor: 'exceptionDescription' stamp: 'tfei 6/13/1999 00:46'!
isResumable

	^true! !

Error subclass: #MyTestError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tests-Exceptions'!
MCMockClassA initialize!
PreferencesTestExample initialize!
PreferencesTestPreferences initialize!
MCDirtyPackageInfo initialize!
MCEmptyPackageInfo initialize!
MCMockPackageInfo initialize!
